$LARGE
C
C Conrec.for - Main contouring subroutine for CONREC
C
C----------------------------------------------------------------------
C conrec.for - main contouring subroutine for program CONREC
C
      SUBROUTINE CONREC (Z, L, M, N, FLO, FHI, FINC, NSET, NHI, 
     +           DASHPAT, CLABEL, CL, NCL, CUTOFF, ISKIP, IFIRST,
     +           CLABOPT, CLABSIZ, SIZMINMAX, NDASHREP, TENSION)

      PARAMETER (MAXC = 40)

      EXTERNAL        CONBD
      DIMENSION       LNGTHS(5)  ,HOLD(5)    ,IENCSCR(7)
      DIMENSION       Z (L,N)     ,CL (MAXC)   

      CHARACTER*16    CLABEL (MAXC)
      CHARACTER       STRING*255,  DASHPAT*12, DASHSEG*12, SOLID*12
      REAL*4	      CLABSIZ, SIZMINMAX, DVALSIZ, CUTOFF
      REAL*4	      FLO, FHI, FINC, TENSION  
      INTEGER*4	      CLABOPT, NDASHREP, ISKIP, IFIRST
      INTEGER*4	      NCL, NSET, NHI
 
      COMMON /SMFLAG/ IOFFS
      COMMON/INTPR/IPAU,FPART,TENSN,NP,SMALL,L1,ADDLR,ADDTB,MLLINE,
     1    ICLOSE
      COMMON /CONRE1/ IOFFP      ,SPVAL
      COMMON /CONRE3/ IXBITS     ,IYBITS
      COMMON /CONRE4/ SIZEL      ,SIZEM      ,SIZEP      ,NREP       ,
     1                NCRT       ,ILAB       ,NULBLL     ,IOFFD      ,
     2                EXT        ,IOFFM      ,ISOLID     ,NLA        ,
     3                NLM        ,XLT        ,YBT        ,SIDE

      DATA  LNGTHS(1),LNGTHS(2),LNGTHS(3),LNGTHS(4),LNGTHS(5)
     1      /  12,       3,        20,       9,        17       /

      DATA SOLID /'$$$$$$$$$$$$'/
      
      NLM	= 16
      NREP 	= NDASHREP
      SIZEL	= CLABSIZ
      SIZEM	= SIZMINMAX
      ILAB	= CLABOPT
      TENSN	= TENSION	
      IF (TENSION .GE. 29.999) THEN
	 IOFFS = 1
      ELSE
	 IOFFS = 0
      ENDIF
C
C ISOL AND IGAP (DOLLAR-SIGN AND APOSTROPHE) ARE USED TO CONSTRUCT PAT-
C TERNS PASSED TO ROUTINE DASHD IN THE SOFTWARE DASHED-LINE PACKAGE.
C
C  CALL RESET FOR COMPATIBILITY WITH ALL DASH ROUTINES(EXCEPT DASHLINE)
C
      CALL RESET
C
C  GET NUMBER OF BITS IN INTEGER ARITHMETIC
C
      IARTH = 31
      IXBITS = 0
      DO 101 I=1,IARTH
         IF (M .LE. (2**I-1)) GO TO 102
         IXBITS = I+1
  101 CONTINUE
  102 IYBITS = 0
      DO 103 I=1,IARTH
         IF (N .LE. (2**I-1)) GO TO 104
         IYBITS = I+1
  103 CONTINUE
  104 IF ((IXBITS*IYBITS).GT.0 .AND. (IXBITS+IYBITS).LE.24) GO TO 105
      WRITE (*, *) 'CONREC DIMENSION ERROR - M,N MUST BE SUCH THAT: 
     1 0.LT.(M*N).LT.(2**IARTH) M=',M,' N=',N
      STOP
      RETURN

  105 CONTINUE
      GL = FLO
      HA = FHI
      GP = FINC
      MX = L
      NX = M
      NY = N
C
C FIND MAJOR AND MINOR LINES
C
C SET UP SCALING
C
      IF (NSET) 106,107,111
  106 CALL SET (0.2, 0.8, 0.2, 0.8, 1.,FLOAT(NX),1.,FLOAT(NY),1)
      GO TO 111
  107 X1 = XLT
      X2 = XLT+SIDE
      Y1 = YBT
      Y2 = YBT+SIDE
      X3 = NX
      Y3 = NY
      IF (AMIN1(X3,Y3)/AMAX1(X3,Y3) .LT. EXT) GO TO 110
      IF (NX-NY) 108,110,109
  108 X2 = SIDE*X3/Y3+XLT
      GO TO 110
  109 Y2 = SIDE*Y3/X3+YBT
  110 CALL SET (X1,X2,Y1,Y2,1.,X3,1.,Y3,1)
      CALL PERIM (NX-1,1,NY-1,1)
C
C SET UP LABEL SCALING
C
 111  IOFFDT = IOFFD
      IF (GL.NE.0.0 .AND. (ABS(GL).LT.0.1 .OR. ABS(GL).GE.1.E5))
     1    IOFFDT = 1
      IF (HA.NE.0.0 .AND. (ABS(HA).LT.0.1 .OR. ABS(HA).GE.1.E5))
     1    IOFFDT = 1
      ASH = 10.**(3-IFIX(ALOG10(AMAX1(ABS(GL),ABS(HA),ABS(GP)))-5000.)-
     1                                                             5000)
      IF (IOFFDT .EQ. 0) ASH = 1.
  114 CONTINUE
      CALL OPTION (0,0,0,0)
C
C PROCESS EACH LEVEL
C
  115 FPART = .5
      DO 123 I=1,NCL
         CONTR = CL(I)
	 DASHSEG (1:12) = SOLID (1:12)
         IF (CONTR .LT. CUTOFF) DASHSEG (1:12) = DASHPAT (1:12)
	 STRING (1:12) = DASHSEG (1:12)

C CHECK IF LINE IS LABELLED OR NOT
	 IF (ILAB .NE. 0 .AND. (MOD (I-IFIRST, ISKIP) .EQ. 0)) THEN
C
C SET UP MAJOR LINE (LABELED) WITH NREP REPITITIONS OF PATTERN PER LABEL.
C
            CALL OPTION (0,1,0,0)
	    IF (NREP .LE. 0 ) NREP = 1
	    IF (NREP .GT. 20) NREP = 20
            IF (NREP .GE. 2) THEN
	       DO 118 K = 1, NREP-1
                 IPOS1 = 12*K+1
	         IPOS2 = IPOS1+11
	         STRING (IPOS1:IPOS2) = DASHSEG (1:12)
 118	       CONTINUE
	    ENDIF
	    IPOS1  = 12*(NREP)+1
	    L      = LENSTR (CLABEL (I))
	    NCHAR  = NREP*12+L
	    STRING (IPOS1:NCHAR) = CLABEL (I) (1:L)
	 ELSE
C
C SET UP MINOR LINE (UNLABELED).
C
            CALL OPTION (0,0,0,0)
            NCHAR = 10
	 ENDIF

C CALL DASHD TO SET UP DASHED LINE PATTERN
         CALL DASHD (STRING, NCHAR, NCRT, SIZEL)

C DRAW ALL LINES AT THIS LEVEL.
C
         CALL STLINE (Z,MX,NX,NY,CONTR)
  123 CONTINUE
C
C FIND RELATIVE MINIMUMS AND MAXIMUMS IF WANTED, AND MARK VALUES IF
C WANTED.
C
      IF (NHI .EQ. 0) CALL MINMAX (Z,MX,NX,NY,SIZEM,ASH,IOFFDT)
      IF (NHI .GT. 0) CALL MINMAX (Z,MX,NX,NY,SIZEP,-ASH,IOFFDT)
      FPART = 1.
      CALL WRITEB
      RETURN
      END


