$LARGE
C Process.for
C----------------------------------------------------------------------
C Perform Process - perform application-specific functions for CONREC
C
	SUBROUTINE Perform Process (Field Name)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (Alpha Field     = 0)
	PARAMETER (Integer Field   = 1)
	PARAMETER (Real Field      = 2)
	PARAMETER (Toggle Field    = 5)

$INCLUDE: 'conrec.dec'
$INCLUDE: 'screen.str'

	CHARACTER	Field Name*10, Message*75
	CHARACTER	Field Name1*10, Field Name2*10, Scratch*10
	CHARACTER	File Name*65
	CHARACTER	Blanks*14, Return Field*10, Dummy*10
	CHARACTER*10	EditMenu, MainMenu, ConMenu, BackMenu
	CHARACTER*14    Tdata File
	INTEGER*4	Fld Index, Index of Field, Position, I, J
	INTEGER*4	LENSTR, Field Type, Pos
	LOGICAL		Error, Exit, FExist
        LOGICAL*1       GetYesNo, OverWrite, BuildGrid, Defaults
	REAL*4		OldLevel, Temp

	DATA EditMenu	/'EDITMENU  '/
	DATA MainMenu   /'MAINMENU  '/
	DATA ConMenu	/'CP MENU   '/
	DATA BackMenu   /'BG MENU   '/

C initialize flags
	Error		= .FALSE.
	FExist		= .FALSE.
	Index of Field	= Fld Index (Field Name)
	Return Field	= SC Field Name (Next Field)
	Field Type	= SC Field Type (Index of Field)

C Get a real value, or toggle position
	IF (Field Type .EQ. Real Field) THEN
	   CALL Get 4 Floating Point Value (Field Name, Temp)
	ELSE IF (Field Type .EQ. Toggle Field) THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
	ENDIF

C *** Identify fields, check for errors,  perform process (if needed)

C read parameter file, check for errors
	IF     (Field Name .EQ. 'IPARFILE  ') THEN
	  CALL Get Character Value (Field Name, IParm File)
	  CALL Read Parameters (Error)
	  IF (Error) THEN
C error messages already put out in read paramaters
C so set up return field, and RETURN
	     CALL Blank File (Field Name, Iparm File)
	     CALL Display One Field (Field Name)
	     Next Field = Fld Index (Main Menu)
	     GOTO 1001
	  ELSE
	      Oparmfile = IParmFile
	      CALL Set Character Value ('OPARFILE  ', OparmFile)
	      CALL Display One Field ('OPARFILE  ')
	      CALL Display Grid Limits (2)
	  ENDIF

	ELSEIF (Field Name .EQ. 'FILEPREFIX') THEN
	  CALL Get Character Value (Field Name, File Prefix)
	  CALL Left Justify (File Prefix)

C save parameters in file
	ELSEIF (Field Name .EQ. 'OPARFILE  ') THEN
	  CALL Get Character Value (Field Name, OParmFile)
	  CALL Save Parameters (Error)
	  IF (Error) THEN
C error messages already put out in save paramaters
C so set up return field, and RETURN
	     CALL Blank File (Field Name, OparmFile)
	     Message = 'Parameters NOT saved (press any key)'
	  ELSE
	     CALL Flash (20, 2, 'Parameters saved (press any key)')
	  ENDIF

C open data file, read in header information
	ELSEIF (Field Name .EQ. 'DATAFILE  ') THEN
C The following line was added 11/21/89.
	  Tdata File = Data File
	  CALL Get Character Value (Field Name, Data File)
	  CALL Get File Name (File Name, File Prefix,
     +			          Data File, Fexist)
	  IF (.NOT. Fexist) THEN
	     CALL Blank File (Field Name, Data File)
	     Error = .TRUE.
	     Message = 'ERROR - data file not found'
C The following line was added 11/21/89.
             Data File = Tdata File
	  ELSE
	     CALL Read Header Data (Error)
	     IF (Error) THEN
	        Message = 'ERROR - error reading data file'
	        CALL Blank File (Field Name, Data File)
                Return Field = Edit Menu 
             ELSE
	        Return Field = 'XVARIABLE '
             ENDIF
	  ENDIF

C Set the internal value of Xvar, and the default label
	ELSEIF (Field Name .EQ. 'XVARIABLE ') THEN
	   IF (Nvar .EQ. 0) THEN
	      Error = .TRUE.
	      Message = 'No variables available - press any key'
	      Return Field = 'MAINMENU  '
	   ELSE  
              Xvar = Position + 1
	      N2 = LENSTR (Units (Xvar))
	      N1 = LENSTR (VarName (Xvar))  
	      Title (5) = VarName (Xvar) (1:N1)
     +                               // '('//Units (Xvar) (1:N2)//')'
	   ENDIF
C Check that X and Y variable are not the same, set Yvar
	ELSEIF (Field Name .EQ. 'YVARIABLE ') THEN
           Yvar = Position + 1
	   IF (Xvar .EQ. Yvar) THEN
              Error   = .TRUE.
	      Message = 'ERROR - X and Y must be different variables '
              Return Field = 'XVARIABLE '
	   ELSE	   
	      N2 = LENSTR (Units (Yvar))
	      N1 = LENSTR (VarName (Yvar))  
	      Title (6) = VarName (Yvar) (1:N1)
     +                               // '('//Units (Yvar) (1:N2)//')'
	   ENDIF 

C All variables names were chosen - Try to read a grid from the data file
	ELSEIF (Field Name .EQ. 'CVARIABLE ') THEN
           Cvar = Position + 1
	   CALL Read Grid  (Error)
	   IF (Error) THEN
              Message = 'ERROR - cannot form a grid with these data'
C 	      Data File = ' '
	      IparmFile = ' '
	      OparmFile = ' '
	      CALL Set Character Value ('DATAFILE  ', '              ')
	      CALL Set Character Value ('IPARFILE  ', IParmFile)
	      CALL Set Character Value ('OPARFILE  ', OParmFile)
 	      CALL Display One Field ('DATAFILE  ')
	      CALL Display One Field ('IPARFILE  ')
	      CALL Display One Field ('OPARFILE  ')
 	      GOTO 1010
           ELSE
	      CALL Build File Name (Data File, OparmFile, '.cpf')
	      CALL Set Character Value ('OPARFILE  ', OparmFile)
	      CALL Display Grid Limits (2)
	      Defaults = GetYesNo (20, 2, 
     +'Press <Y> to calculate defaults for ticmarks, titles, levels ')
	      IF (Defaults) THEN
	          CALL AutoCalc
	      ELSE
	         IF (NcLevel .LE. 0) THEN
	CALL PutStr ('      NO CONTOUR LEVELS SET      ',33,13,3,0)
		 ENDIF
	CALL PutStr ('Contouring options may be chosen ',33,14,3,0)
	CALL PutStr ('  from the Contour screen in the ',33,15,3,0)
	CALL PutStr ('  lower menu level.  Other graph ',33,16,3,0)
	CALL PutStr ('  options may be specified in the',33,17,3,0)
	CALL PutStr ('  Background screen (lower level)',33,18,3,0)
	      ENDIF
              CALL Flash (20, 2, 'Press any key to continue')    
	   ENDIF

C Spline Tension
	ELSEIF (Field Name .EQ. 'SPLINETENS') THEN
	   IF (Temp .LE. 0. .OR. Temp .GT. 30.0) THEN
	      SplineTension = 2.5
	      CALL Set4FloatingPointValue('SPLINETENS',SplineTension,1)
	      Error = .TRUE.
	      Message = 'Spline Tension out of range, (forced to 2.5) '
	   ELSE
	      SplineTension = Temp
	   ENDIF
	      
C Contour Levels
	ELSEIF (Field Name .EQ. 'STARTLEVEL') THEN
	   IF (NxGrid .LE. 0 .OR. NyGrid .LE. 0 .OR.
     +	      Nvar .LE. 0   .OR. Ndata  .LE. 0) THEN
	      Error = .TRUE.
	      Message = 'No grid has been built yet - (press any key)' 
	      Return Field = Main Menu
	   ELSE
	      OldMin = ContourMin
	      ContourMin = Temp
	      IF (ABS(ContourMin-OldMin) .GE. 1.E-6) CALL Reset Levels
	   ENDIF
	
	ELSEIF (Field Name .EQ. 'LASTLEVEL ') THEN
	   OldMax = ContourMax
	   ContourMax = Temp
	   IF (ABS(ContourMax-OldMax) .GE. 1.E-6) CALL Reset Levels
	   IF (ContourMin .GE. ContourMax) THEN
              Message = 'ERROR - Contour MIN >= Contour MAX '
              Return Field = 'STARTLEVEL'
              Error   = .TRUE.
	   ENDIF

	ELSEIF (Field Name .EQ. 'INCLEVEL  ') THEN
	   IF (ContourInc .GE. 0.0) OldInc = ContourInc
	   ContourInc = Temp
	   IF (ContourInc .LE. 0.0) THEN
              Message = 'ERROR - Contour increment must be >= 0.0'
              Return Field = 'STARTLEVEL'
              Error   = .TRUE.
	      ContourInc = OldInc
	      CALL Set 4FloatingPoint Value (Field Name, ContourInc, 3)
	   ELSE
	      IF (ABS(ContourInc-OldInc) .GE. 1.E-6) CALL Reset Levels
	      IF (OldMax .NE. ContourMax .OR. 
     +            OldMin .NE. ContourMin .OR.
     +            OldInc .NE. ContourInc) CALL Set Up Levels 
	   ENDIF

	ELSEIF (Field Name .EQ. 'CLABOPT   ') THEN
	   ClabOpt = Position
  
	ELSEIF (Field Name .EQ. 'CLABSKIP  ') THEN
	   SkipFactor = Position + 1

	ELSEIF (Field Name .EQ. 'CLABFRST   ') THEN
	   First Contour = Position + 1

	ELSEIF (Field Name .EQ. 'CLABSIZE   ') THEN
	   SizeL = Position + 1
	
	ELSEIF (Field Name .EQ. 'DASHPAT   ') THEN
           CALL Get Character Value (Field Name, Dash Pattern)       
	   IF (Dash Pattern .EQ. '            ') THEN
	      Error = .TRUE.
	      Message = 'ERROR - Dash Pattern cannot be Blank '
	      DashPattern = '- - - - - - '
              CALL Set Character Value (Field Name, Dash Pattern)       
	      Return Field = 'CP MENU   '
	   ELSE
	     DO 10 I = 1, 12
                IF (Dash Pattern (I:I) .EQ. ' ') THEN
                   DashSeg (I:I) = CHAR (39) 
		ELSE
	           DashSeg (I:I) = '$'
	        ENDIF
 10	     CONTINUE
	   ENDIF

	ELSEIF (Field Name .EQ. 'DASHCUTOFF') THEN
	   DashCutoff = Temp
	   
	ELSEIF (Field Name .EQ. 'NDASHREP  ') THEN
	   NDashRep = Position + 1

	ELSEIF (Field Name .EQ. 'ANOTFLAG  ') THEN
	   AnotFlag = Position - 1

	ELSEIF (Field Name .EQ. 'MINMAXSIZ ') THEN
	   SizeM = Position + 1

	ELSEIF (Field Name (1:6) .EQ. 'CLEVEL') THEN
	   IF (Field Name (8:8) .EQ. ' ') THEN
              READ (Field Name (7:7), '(I1)') I
	   ELSE
              READ (Field Name (7:8), '(I2)') I
	   ENDIF  
	   OldLevel = Clevel (I)
	   Clevel (I) = Temp
	   IF (ABS (OldLevel-Clevel (I)) .GE. 1.E-6) THEN
	     Field Name1 = 'CLABEL'//Field Name (7:8)
	     WRITE (CLabel (I), '(F6.1)')   Clevel (I) / ScaleFactor 
	     CALL LeftJustify (Clabel (I))
	     CALL Set Character Value (Field Name1, Clabel (I))	   	  
	     CALL Display One Field (Field Name1)	  
           ENDIF
	ELSEIF (Field Name (1:6) .EQ. 'CLABEL') THEN
	   IF (Field Name (8:8) .EQ. ' ') THEN
              READ (Field Name (7:7), '(I1)') I
	   ELSE
              READ (Field Name (7:8), '(I2)') I
	   ENDIF  
	   CALL Get Character Value (Field Name, Clabel (I))

	ELSEIF (Field Name .EQ. 'BACKFLAG  ') THEN
	  CALL Erase (20, 2, 75)
	  BackGround = (Position .EQ. 0)

	ELSEIF (Field Name .EQ. 'MAINTITLE ') THEN
	   CALL Get Character Value (Field Name, Title (1))

	ELSEIF (Field Name .EQ. 'MAINJUST  ') THEN
	   MainJust = Position - 1

	ELSEIF (Field Name .EQ. 'SUBTJUST  ') THEN
	   SubTJust = Position - 1

	ELSEIF (Field Name (1:8) .EQ. 'SUBTITLE') THEN
	   READ (Field Name (9:9), '(I1)') I
	   CALL Get Character Value (Field Name, Title (I+1))

	ELSEIF (Field Name .EQ. 'MAINTSIZE ') THEN
	   Tsize (1) = Position + 1
	   
	ELSEIF (Field Name (1:8) .EQ. 'SUBTSIZE') THEN
	   READ (Field Name (9:9), '(I1)') I
	   Tsize (I+1) = Position + 1

	ELSEIF (Field Name  (2:10) .EQ. 'TICFORMAT') THEN
	    CALL Get Character Value (Field Name, Dummy)
	    IF (Field Name (1:1) .EQ. 'X') THEN
	        WRITE (Scratch, Dummy, ERR = 111) Xmin
	        WRITE (Scratch, Dummy, ERR = 111) Xmax
	        WRITE (Scratch, Dummy, ERR = 111) Xcellsize
	        IF (Dummy (1:1) .EQ. '*') GOTO 111
	        XticFmt = Dummy
	        GOTO 333
	    ELSE IF (Field Name (1:1) .EQ. 'Y') THEN
	        WRITE (Scratch, Dummy, ERR = 111) Xmin
	        WRITE (Scratch, Dummy, ERR = 111) Xmax
	        WRITE (Scratch, Dummy, ERR = 111) Xcellsize
	        IF (Dummy (1:1) .EQ. '*') GOTO 111
	        YticFmt = Dummy
	        GOTO 333
	    ENDIF
C Error using given format
 111	    Error = .TRUE.
	    Message = 'This format will not work for the chosen data'
	    Return Field = Field Name
 333	    CONTINUE 

	ELSE IF (Field Name (1:6) .EQ. 'NMAJOR') THEN
       	    CALL Get Integer Value (Field Name (1:10), Position)
	    IF (Field Name (7:7) .EQ. 'X') THEN
		NmajorX = Position
	    ELSE IF (Field Name (7:7) .EQ. 'Y') THEN
		NmajorY = Position
	    ENDIF

	ELSE IF (Field Name (1:6) .EQ. 'NMINOR') THEN
       	    CALL Get Integer Value (Field Name (1:10), Position)
	    IF (Field Name (7:7) .EQ. 'X') THEN
		NminorX = Position 
	    ELSE IF (Field Name (7:7) .EQ. 'Y') THEN
		NminorY = Position 
	    ENDIF

	ELSE IF (Field Name (2:9) .EQ. 'AXISTYPE') THEN
	    IF (Field Name (1:1) .EQ. 'X') THEN
		XaxisType = Position + 1
	    ELSE IF (Field Name (1:1) .EQ. 'Y') THEN
		YAxisType = Position + 1
	    ENDIF

	ELSE IF (Field Name (2:8) .EQ. 'TICSIZE') THEN
	    IF (Field Name (1:1) .EQ. 'X') THEN
		XticLsize = Position + 1
	    ELSEIF (Field Name (1:1) .EQ. 'Y') THEN
		YTicLsize = Position + 1
	    ENDIF
C End of Cases
	ENDIF	

C write out field, in case an error caused it to be blanked out
	CALL Display One Field (Field Name)

C if an error occurred, put out the message
 1010	IF (Error) CALL Flash (20, 2, Message)

C Set up Next Field to be processed
  	Next Field = Fld Index (Return Field)

C Erase screen message area
 1001	IF (Current Screen .EQ. 2) THEN
	   DO 444 I = 11, 18
	     CALL Erase (I, 3, 33)
 444 	   CONTINUE
	ENDIF

	Error = .FALSE.
	RETURN
	END

C---------------------------------------------------------------------
C AutoCalc - Automatic calculation of contour parameters

	SUBROUTINE Autocalc
	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'conrec.dec'

	CHARACTER 	Dummy*80, Field Name*10
	CHARACTER	Field Name1*10, Field Name2*10
	CHARACTER	Scratch*10, Fmt*10
	LOGICAL		Error, Normalize, Even
	REAL*4		DeltaX, DeltaY, X1, X2, Y1, Y2, Temp
	INTEGER*4	Fld Index, Constant Field, Ninterval, Fwidth

C Set Default axis ticmark and label parameters
C  set # major and minor ticmark divisions such that there are as many
C  minor ticmarks as grid cell intersections
C
C
	Ninterval = NxGrid - 1
	IF (Offset) Ninterval = NxGrid
   	DO 80 NmajorX = Ninterval-1, 1, -1
	  K = MOD (Ninterval, NmajorX)
 	  IF (K .EQ. 0 .AND. NmajorX .LE. 7) GOTO 85 
 80	CONTINUE
 85	NMinorX = Ninterval / NMajorX
   	CALL Set Integer Value ('NMAJORXTIC', NMajorX)
	CALL Set Integer Value ('NMINORXTIC', NMinorX)
	
	Ninterval = NyGrid - 1
	IF (Offset) Ninterval = NyGrid
   	DO 90 NmajorY = Ninterval-1 , 1, -1
	  K = MOD (Ninterval, NmajorY)
 	  IF (K .EQ. 0 .AND. NmajorY .LE. 7) GOTO 95 
 90	CONTINUE
 95	NMinorY = Ninterval / NmajorY
   	CALL Set Integer Value  ('NMAJORYTIC', NMajorY)
	CALL Set Integer Value  ('NMINORYTIC', NMinorY)

C Calculate format for ticmark labels
	Ix = 10  
	X1 = Xmin
	X2 = Xmax
	Y1 = Ymin
	Y2 = Ymax
	IF (Offset) THEN
	  X1 = X1 - XcellSize * .5
	  Y1 = Y1 - YcellSize * .5
	  X2 = X2 + XcellSize * .5
	  Y2 = Y2 + YcellSize * .5
	ENDIF
	CALL SetFmt (XCellSize, XticFmt, Ix)
	CALL SetFmt (YCellSize, YTicFmt, Ix) 
  	CALL Set Character Value ('XTICFORMAT', XticFmt)
 	CALL Set Character Value ('YTICFORMAT', YticFmt)

C Set Default Contour Values and Labels
C     (Call CONREC subroutine CLGEN)

	NContour 	= 8
	Constant Field 	= 0
	ContourMin	= 0.0
        ContourMax	= 0.0
        ContourInc	= 0.0
	CALL Clgen (Zcontour, MAXGRID, NxGrid, NyGrid, 
     +              ContourMin, ContourMax, ContourInc,
     +              Ncontour, MAXCONTOUR, Clevel, Nclevel,
     +	            Constant Field)

	IF (Constant Field .NE. 0) THEN
	   CALL PutStr ('  CONSTANT field found  ',24,11,3,0)
	   CALL PutStr (' ERROR - no grid formed ',24,13,3,0)
	   GOTO 999
	ENDIF  

C calculate format for contour labels, determine scalefactor
	Fwidth = 10                                     
	CALL SetFmt (ContourInc, Fmt, Fwidth)

C Build default contour labels, title for scalefactor, store in screen

	CALL Set 4 Floating Point Value ('STARTLEVEL', ContourMin, 3)
	CALL Set 4 Floating Point Value ('LASTLEVEL ', ContourMax, 3)
	CALL Set 4 Floating Point Value ('INCLEVEL  ', ContourInc, 3)
	DO 100 I = 1, MAXCONTOUR
	   Temp = Clevel (I)
	   CLABEL (I) 	  = '                '
	   IF (I .LT. 10) THEN
	      WRITE (Field Name1, '(A6,I1,3X)') 'CLEVEL',I
	      WRITE (Field Name2, '(A6,I1,3X)') 'CLABEL',I
	   ELSE
	      WRITE (Field Name1, '(A6,I2,2X)') 'CLEVEL',I
	      WRITE (Field Name2, '(A6,I2,2X)') 'CLABEL',I
	   ENDIF
	   IF (I .LE. NcLevel) THEN
	     WRITE (CLabel (I), Fmt)   Clevel (I)
	     CALL LeftJustify (Clabel (I))	   	  
             CALL Set 4 Floating Point Value (FieldName1, Clevel(I), 3)
	   ELSE
	     CALL Set Character Value (FieldName1, Clabel (I))
	   ENDIF
	   CALL Set Character Value (Field Name2, Clabel (I))
 100	CONTINUE  	

	Title (1) = Header
	CALL Set Character Value ('MAINTITLE ', Title (1))

	N1 = LENSTR (VarName (Cvar))  
	Title (2) = 'Contours for '//
     +    VarName (Cvar) (1:N1)
        CALL Set Character Value ('SUBTITLE1 ',Title (2))       

	N1 = LENSTR (VarName (Xvar))  
	Title (5) = VarName (Xvar) (1:N1)
        CALL Set Character Value ('SUBTITLE4 ',Title (5))       

	N1 = LENSTR (VarName (Yvar))  
	Title (6) = VarName (Yvar) (1:N1)
        CALL Set Character Value ('SUBTITLE5 ',Title (6))       

	OldMax = ContourMax
	OldMin = ContourMin
	OldInc = ContourInc
	CALL PutStr ('Default values have been chosen  ',33,13,3,0)
	CALL PutStr ('  for contour levels, titles, and',33,14,3,0)
	CALL PutStr ('  axes parameters.               ',33,15,3,0)
	CALL PutStr ('View the plot with the Execute   ',33,16,3,0)
	CALL PutStr ('option, or change parameters in  ',33,17,3,0)
	CALL PutStr ('the Contour or Background screens',33,18,3,0)
	RETURN

 999	CONTINUE
	NxGrid		= 0
	NyGrid		= 0
	XCellSize 	= 0.0
	YCellSize 	= 0.0
	ContourMin	= 0.0
        ContourMax	= 0.0
        ContourInc	= 0.0
	CALL Erase (20, 2, 75)
	RETURN
	END

