$LARGE
c**********************************************************************
c*** File name: PREP11.FOR (Source code for the program DATAPREP)
c**********************************************************************
c        R e p o r t   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Report Prompts

c***  This routine constructs the Report screen and displays
c***  the Report menu.  The user is prompted for a menu 
c***  selection which is then processed.  The 'Report' subroutine
c***  which constructs the 'Report' listing is called from this 
c***  routine.
c***  
c***  VARIABLES:
c***  Menu        - contains the field name of the Report menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Tinfile     - contains the incoming Geo-EAS data output file name.  
c***                This file name then replaces the 'Report' output 
c***                file(which is not a Geo-EAS data output file name). 
c***  Yes         - logical variable used to indicate if the user 
c***                wishes to add another variable to the 'Report' 
c***                listing. 
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***  Vardone     - logical variable set to .true. if the 'Variables'
c***                menu option has been selected.
c***  Nvar        - global variable that contains the number of variables.


$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'
		   
      CHARACTER   Menu Choice*20, Menu*10, Blank*14, File*8
      CHARACTER   Tinfile*14, Prompt*46
      CHARACTER   Toggle Field*8, Label0*16,Oldfile*14,Readmess*17
      CHARACTER   Label1*11,Label2*12,Label3*18, Label4*16
      CHARACTER   Label5*30, Choice*10, Label6*15, Label7*17
      REAL*4      Get Element, Value
      INTEGER*4   FLD Index, Var, Index, Toggle, Key
      LOGICAL*1   Yes, Get Yes No, Error, Option, Vardone

c***  Erase the File Operations screen.
      CALL Erase Message Divider
      CALL ClearRows(1,18)
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
      Blank = '              '
      Menu  = 'RT MENU   '
      Vardone = .FALSE.
      Error = .TRUE.
ccc      Error2 = .TRUE.

c***  Initialize and display labels upon the screen.
      Readmess = ' Processing data '
      Label0 = 'Output Variables'
      Label1 = 'Input File:'
      Label2 = 'Output File:'
      Label3 = 'Variable to print:'
      Label4 = 'Sequence Option:'
      Label5 = 'Total Variables in input file:'
      Label6 = 'REPORT FUNCTION'
      Label7 = 'Data File Prefix:'
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Put Str (Label0, 16, 10, 31, 0)
      CALL Put Str (Label1, 11,  5,  2, 0)
      CALL Put Str (Label2, 12,  5, 39, 0)
      CALL Put Str (Label3, 18,  8, 39, 0)
      CALL Put Str (Label4, 16,  7,  2, 0)
      CALL Put Str (Label5, 30,  8,  2, 0)
      CALL Put Str (Label6, 15,  2, 32, 0)
      CALL Put Str (Label7, 17,  3,  2, 0)
c***  Initialize and display file names.
      CALL Set Character Value ('INFIL1C ', Infil)
      CALL Set Character Value ('OUTFIL1C ', Outfil)
      Tinfile = Outfil
cccc      CALL Display One Field('INFIL1C ')
cccc      CALL Display One Field('OUTFIL1C')
c***  Display Sorting menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
c***    Erase the Report screen.
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
	CALL Clear Rows(1,18)
c***    Retain Geo-EAS input file as the standard output file. 
	Outfil = Tinfile
c***    Erase the variables heading.
	CALL Erase (1, 35, 9)
  	RETURN
      ELSE IF (Menu Choice .EQ. 'Files               ') THEN
        CALL Erase Variable List
c***    Set number of variables to zero and display this field
c***    on the screen.
	Nvar = 0
	Choice = 'VAR TOTAL '
        CALL Set Integer Value (Choice, Nvar)
        CALL Display One Field (Choice)
c***    Initialized Vardone to false to be used later in determining if
c***    variable list option was accessed before execution option.
	Vardone = .FALSE.
c***    Prompt user for input file.
  	File = 'INFIL1C '
	CALL Get Name of File(File,Infil,Error,1)
c***    If error return to menu.
	IF (Error) GOTO 10
c***    Prompt user for outfile.
	File = 'OUTFIL1C'
	CALL Get Name of File(File, Outfil, Error,2)
c***    If error return to menu.
	IF (Error) GOTO 10
c***    Prompt user sequence option. 
	Toggle Field = 'SEQUENCE'
	Var = Toggle (Toggle Field) 
c***    Set option to true if sequence option is true.
	IF (Var .EQ. 0) THEN
	  Option = .TRUE.
	ELSE
	  Option = .FALSE.
	ENDIF
	Error = .FALSE.
      ELSE IF (Menu Choice .EQ. 'Variables           ') THEN
c***    Prompt user for the list of variables to be extracted 
c***    and the format.
	IF (.NOT. Error) THEN
c***      Indicate the variable list has been accessed before 
c***      the execution option.
	  Vardone = .TRUE.
	  Oldfile = Infil
c***      Read in variable names, number of variables, and measurements
c***      descriptions from the Geo-EAS input data file.
	  CALL File Set Up (Error, Nvar)
c***      Set the global variable 'Recskip' to the record number at
c***      which sample data begins.
	  Recskip = Nvar + 3
	  IF (.NOT. Error) THEN
c***        Display number of variables from the input file onto the
c***        screen.
	    Choice = 'VAR TOTAL '
            CALL Set Integer Value (Choice, Nvar)
            CALL Display One Field (Choice)
 	    CALL Load All Toggle Fields (Nvar)
	    CALL Erase Variable List
	    Yes = .TRUE.
	    Index = 0
c***        If Yes=.true. then prompt the user for a variable from the 
c***        toggle field.  This variable will be added to the 'Report' 
c***        listing.
  15	    IF (Yes) THEN
c***          Assign field name of toggle field.
	      Toggle Field = 'VTOGGLE4'
c***          Get user's choice of variable and assign column number of
c***          that variable to Var.  Since first position of toggle is zero,
c***          must add a one, since first variable column number is one.
	      Var = Toggle (Toggle Field) + 1
c*** Added next line on 11/9/89 to check for blank variable name in toggle
c*** field.
              IF (Var .EQ. (Nvar+1)) GOTO 25
c***          Build variable list and store column numbers in global 
c***          matrix Startcol.
	      Index = Index + 1
	      Startcol(Index) = Var
	      CALL Display Chosen Variables(Index)
c***          Check if maxmimum number of variables has been reached, 
c***          if so then inform user and proceed and continue with next 
c***          menu option, else continue with next menu option.
	      IF (Index .EQ. MAXVAR) THEN
	        CALL Flash(20, 2, 
     +  'WARNING - Variable maximum has been reached...(press any key)')
	      ELSE
C Changed 9/22/89 to require am explicit "N" answer to exit the option
C	        Yes = Get Yes No
C     +	      (20, 2, 'Do you wish to include another variable? <Y/N>')
  25          Prompt = 'Do you wish to include another variable? <Y/N>'
                 CALL Put Str (Prompt, 46, 20, 2, 0)
                 CALL Get Key (Key)
                 IF (Key .NE. 110 .AND. Key .NE. 78) THEN
                    Yes = .TRUE.
                 ELSE
                    Yes = .FALSE.
                 ENDIF 
                 CALL Erase (20, 2, 46)
                CALL Increment Variable Toggle Position (Toggle Field,
CCCC     +                                                   Var,Nvar)
     +                                                   Var,Nvar+1)
	        GOTO 15
	      ENDIF
	    ENDIF
	  ENDIF
	ELSE
	  CALL Beep
	  CALL Flash(20, 2, 
     +     'ERROR - Filenames must be entered...(press any key)')
	ENDIF
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
c***    If filenames have not been entered then inform the user 
c***    and return to the menu.
	IF (Error) THEN
	  CALL Beep
	  CALL Flash(20, 2, 
     +       'ERROR - Filenames must be entered...(press any key)')
	  GOTO 10
c***    Check if variable list option's infile is same as 
c***    file option's infile.  This check is to determine if the
c***    variable list option has been opted before the execution process.
	ELSE IF ((Oldfile .NE. Infil).OR.(.NOT. Vardone)) THEN
	  CALL Beep
	  CALL Flash(20, 2, 
     +     'ERROR - Choice of variables not provided...(press any key)')
	  GOTO 10
	ENDIF
        CALL Put Str (Readmess, 17, 20, 2, 2)
        Vardone = .FALSE.
c***    Open scratch file to contain 'Data1' 'structure'. 
        CALL Open Scratch Files
c***    Read the samples of the input file.
        CALL Read Numerical Data(1,Infil,Nvar,Nvar,Error,Recskip)
c***    If filenames have not been entered then display error, else
c***    proceed with processing by calling 'Report'.
	IF (.NOT. Error) THEN
          CALL Put Str (Readmess, 17, 20, 2, 2)
          CALL Report (Index, Option)
        ENDIF
        CALL Close Scratch Files
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        R e p o r t     (subroutine)  
c**********************************************************************
      SUBROUTINE Report (Tnvar, Option)

c***  This routine determines the number of variables to be printed on
c***  one page (maximum: 4) as well as the number of records (maximum: 50)
c***  based on the information obtained in the subtroutine 'Report Prompts'.
c***  A call to 'Print Report' is made where the 'Report' listing is then
c***  written to the output file using a specified format.
c***  
c***  VARIABLES:
c***  Tnvar	  - contains number of variables in the 'Report' listing.
c***  Option	  - logical which is true is sequence option is 'on'.
c***  Columns	  - maximum number of variables(4) permitted on one page.
c***  Remainder	  - contains the remainder of Tnvar/Columns and is used to
c***                determine if a partial row of variables(<4) exits.
c***  Result	  - contains the result of Tnvar/Columns and is used to 
c***                determine if a full row of variables(4) exists.
c***  Count	  - counter that reflects the index of the first variable
c***                that appears on a page of the 'Report' listing.
c***  Full Row	  - logical that is true if four variables are to appear
c***                on a page.
c***  Partial Row - logical that is true if less than four variables are to
c***                appear on a page.
c***  Page	  - contains the current page number of the 'Report' listing.
c***  End Var	  - contains the column number of the variable to appear
c***                last on the variable names line. 

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      INTEGER*4 I, Tnvar, Columns, Remainder, Result
      INTEGER*4 Count, End Var, Page
      LOGICAL*1 Error, Option, Full Row, Partial Row
      LOGICAL*1 Get Yes No, Exist
      CHARACTER	Writemess*16

      Error = .FALSE.
      Writemess = 'Writing data ...'
      Exist = .FALSE.
c***  Concantenate prefix to filename.
      CALL Build Prefix Filename (Outfil)
CCCC      INQUIRE (FILE = Prefile, EXIST = Exist)
CCCC      IF (Exist) THEN
cccc	Overwrite = .TRUE.
cccc	IF (Overwrite) THEN
CCCC	   OPEN (UNIT = 11, FILE = Prefile, ERR = 999, STATUS = 'OLD')
cccc	ELSE
cccc	   RETURN
cccc	ENDIF
CCCC      ELSE
CCCC        OPEN (UNIT = 11, FILE = Prefile, ERR = 999, STATUS = 'NEW')
CCCC        CALL Put Str (Writemess, 16, 20, 2, 2)
CCCC      ENDIF
c***  Open either a new or old file depending on the status.
      OPEN (UNIT = 11, FILE = Prefile, ERR = 999, STATUS = 'UNKNOWN')
      CALL Put Str (Writemess, 16, 20, 2, 2)
      Page = 0
      Count = 1
      End Var = 0
      Columns = 4
c***  Determine if the number of variables to be included in the 'Report'
c***  listing requires a full row(4), a partial row(<4) or both.
      Remainder = MOD (Tnvar,Columns)
      Result = Tnvar/Columns
      IF (Result .GT. 0) THEN
	Full Row = .TRUE.
      ELSE
	Full Row = .FALSE.
      ENDIF

      IF (Remainder .GT. 0) THEN
	Partial Row = .TRUE.
      ELSE
	Partial Row = .FALSE.
      ENDIF

c***  Process all the variables using full rows(4 variables).  If 
c***  less than four variables remain then the next IF THEN statement
c***  will process the remaining variables.
      IF (Full Row) THEN
	DO 10 I = 1, Result
	  Page = 1
	  End Var = End Var + Columns
	  CALL Print Report (Count, End Var, Option, Page, Result,
     +                       Remainder)
	  Count = Count + 4
  10	CONTINUE
      ENDIF
c***  Process the remaining number of variables ie., less than four
c***  variables.
      IF (Partial Row) THEN
	Result = 0
        Page =  1
	End Var = Tnvar
 	CALL Print Report (Count, End Var, Option, Page, Result,
     +                       Remainder)
      ENDIF

      CALL Erase (20, 1, 78)
      CLOSE (11)
      CALL Flash(20,2,
     +	 'Data has been sent to output file...(press any key)')
      RETURN

  999 CALL Beep
      CLOSE (11)
      CALL Flash (20, 2,
     +   'ERROR - writing data file ... (Press any key)')
      RETURN

      END
c**********************************************************************
c        P r i n t  R e p o r t     (subroutine)  
c**********************************************************************
      SUBROUTINE Print Report (Count, End Col, Option, Page, Result,
     +                         Remainder)

c***  This routine writes the 'Report' listing to the output file
c***  using a specified format.
c***  
c***  VARIABLES:
c***  Count     - index of global array Startcol (which contains the indices 
c***              of the global arrays Varnam and Units) indicating
c***              first element on a variable line.
c***  End Col   - index of global array Startcol (which contains the indices
c***              of the global arrays Varnam and Units) indicating
c***              last element on a variable line.
c***  Option    - logical which is true is sequence option is 'on'.
c***  Page	- contains the current page number.
c***  Result    - contains the result of (the number of variables to be
c***              included in the 'Report' listing divided by 4) and is
c***              used to determine if a full row of variables(4) exists.
c***  Remainder	- contains the remainder of (the number of variables to be
c***              included in the 'Report' listing divided by 4) and is 
c***              used to determine if a partial row of variables(<4) exits.
c***  Varnam    - global array containing the variable names.
c***  Startcol  - global array containing index numbers relating to 
c***              Varnam or Units elements that are to be in the 'Report'
c***              listing.
c***  Units     - global array containing the measurement description of 
c***              each variable.
c***  Tlnct	- contains the total number of lines(sample data) thus
c***              processed. 
c***  Lncount	- contains the current line number(sample data) of the 
c***              page of the 'Report' listing.
c***  Lines	- maximum number of records permitted on a 'Report' page.
c***  Fmt	- global character array that contains the output format
c***              used in the 'WRITE' statement.
c***  V1        - logical that is true if Varnam element is to be right 
c***              justified, false if Units element is to be justified.
c***  Centerln  - global variable that contains either the right justified 
c***              variable names or measurement descriptions. 

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'

      INTEGER*4  Result, Remainder, Count, Page
      INTEGER*4  End Col, Lines, Tlnct, Lncount,I,J,K,L,M,N
      LOGICAL*1  Option, V1
      REAL*4     Get Element, Vector4(4)
      CHARACTER*10  Centerln(4)

      Lines = 50
      Tlnct = 1
      Lncount = 1

c***  Skip four lines.
  10  DO 19 I = 1, 4
	WRITE(11,*) ' '
  19  CONTINUE
c***  Construct the fmt specifier for the Page heading.
      Fmt = '(66X,''Page'',I7)'
      WRITE(11,Fmt) Page
c***  Construct the fmt specifier for the Title heading.
      Fmt = '(3X,A66)'
      Write(11,Fmt) Title
c***  Construct the fmt specifier for the variable names description line. 
      IF (Result .NE. 0) THEN
c***    Fmt for four variable names.
	Fmt = '(11X,A10,6X,A10,6X,A10,6X,A10)'
      ELSE
c***    Fmt for three variable names.
        IF (Remainder .EQ. 3) THEN
          Fmt = '(11X,A10,6X,A10,6X,A10)'
c***    Fmt for two variable names.
        ELSE IF (Remainder .EQ. 2) THEN
          Fmt = '(11X,A10,6X,A10)'
c***    Fmt for one variable name.
        ELSE 
          Fmt = '(11X,A10)'
        ENDIF
      ENDIF

c***  Right justify the variable names contained in the array 'Varnam'.
      V1 = .TRUE.
      CALL Center Fmt(Count, End Col, V1, Centerln)
c***  I represents the index of the element in the array Startcol.  This 
c***  element is the index of the first variable on the variable name
c***  line.   
      I = End Col - Count + 1
c***  Write the entire variable name line to the output file.
      WRITE(11,Fmt) (Centerln(J),J = 1, I)
c***  If sequence option is on then insert the Obs. label and the
c***  the units description line.
      IF (Option) THEN
c***    Four variables.
        IF (Result .NE. 0) THEN
	  Fmt = '(4X,''Obs.'',3X,A10,6X,A10,6X,A10,6X,A10)'
        ELSE
c***    Three variables.
          IF (Remainder .EQ. 3) THEN
            Fmt = '(4X,''Obs.'',3X,A10,6X,A10,6X,A10)'
c***    Two variables.
          ELSE IF (Remainder .EQ. 2) THEN
            Fmt = '(4X,''Obs.'',3X,A10,6X,A10)'
c***    One variable.
          ELSE 
            Fmt = '(4X,''Obs.'',3X,A10)'
          ENDIF
        ENDIF
c***  If sequence option is off then insert only the units description
c***  line.
      ELSE
        IF (Result .NE. 0) THEN
	  Fmt = '(11X,A10,6X,A10,6X,A10,6X,A10)'
        ELSE
          IF (Remainder .EQ. 3) THEN
            Fmt = '(11X,A10,6X,A10,6X,A10)'
          ELSE IF (Remainder .EQ. 2) THEN
            Fmt = '(11X,A10,6X,A10)'
          ELSE 
            Fmt = '(11X,A10)'
          ENDIF
        ENDIF
      ENDIF

c***  Right justify the measurement descriptions contained in the
c***  array 'Units'.
      V1 = .FALSE.
      CALL Center Fmt(Count, End Col, V1, Centerln)
c***  Write the justified descriptions to the output file. 
      WRITE(11,Fmt) (Centerln(J),J = 1, I)
c***  Construct the fmt specifier for the sample data.
      CALL Fmt Builder (Count, Option, End Col)
c***  If end of page reached and sample data for the variables
c***  on the header line still exist then increment
c***  page counter and start new page.
  20  IF((Lncount .GT. Lines) .AND. (Tlnct .LE. Ndata)) THEN
	Lncount = 1
c***    Insert form feed 
	WRITE(11,*) CHAR(12)
	Page = Page + 1
	GOTO 10
c***  If end of page not yet reached and sample data for the variables
c***  on the header line still exist then get another row of samples
c***  from the scratch file, increment counters and list this row.
      ELSEIF ((Lncount .LE. Lines) .AND. (Tlnct .LE. Ndata)) THEN
	DO 45 J = Count, End Col
	  Vector4(J) = Get Element(1,Startcol(J),Tlnct,Nvar)
  45	CONTINUE
	IF (Option) THEN
	  WRITE(11,Fmt)Tlnct,(Vector4(J),J=Count,End Col)
	ELSE
	  WRITE(11,Fmt) (Vector4(J),J=Count,End Col)
	ENDIF
	Lncount = Lncount + 1
	Tlnct = Tlnct + 1
	GOTO 20
c***  If end of page not yet reached and sample data for the variables
c***  on the header line have all been listed then skip lines to end
c***  of page and return to calling program. 
      ELSEIF ((Lncount .LT. Lines) .AND. (Tlnct .GT. Ndata)) THEN
c*** 4/17/90 Commented the following lines.
c	K = Lines - Lncount + 1
c	DO 30 J = 1, K
c	  WRITE(11,*) ' '
c  30	CONTINUE
      ENDIF
c***  Insert form feed 
      WRITE(11,*) CHAR(12)
 
      RETURN
      END
c**********************************************************************
c        Increment Variable Toggle Position     (subroutine)  
c**********************************************************************
      SUBROUTINE Increment Variable Toggle Position (Name, Var, Maxtog)

c***  This subroutine increments the toggle position of the toggle field
c***  whose field name is stored in 'Name'.
c***
c***  VARIABLES:
c***  Name     - Name of the variable toggle field.
c***  Var      - Variable column number.  Must be reduced by 1 to 
c***             reflect the position of that variable in the toggle 
c***             field. 
c***  Maxtog   - Variable indicating the number of variables in 
c***             infile.
c***  Position - The position of that the toggle field is to be set.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'
      
      CHARACTER Name*(*)
      INTEGER*4 Var, Position, Maxtog

c***  Reduce 'Var' by 1 to reflect the current toggle position of 
c***  the 'Name' toggle field.
      Var = Var - 1
c***  If the next toggle position exceeds the toggle position   
c***  assigned to 'Maxtog' then set 'Position' to zero; else 
c***  set 'Position' to the current position plus one.  
      IF (Var + 1 .GE. Maxtog) THEN
	Position = 0
	CALL Set Toggle Position(Name, Position)
      ELSE
	Position = Var + 1
	CALL Set Toggle Position(Name, Position)
      ENDIF

      RETURN
      END
c**********************************************************************

