$LARGE
c**********************************************************************
c*** File name: PREP2.FOR (Source code for the program DATAPREP)
cC**********************************************************************
cC	E r a s e  O p t i o n  B o x      (subroutine)
cC**********************************************************************
c      SUBROUTINE Erase Option Box
c
cc***  This routine erases the options listed in the DOS Utilities
cc***  and File Operations menus. 
c
c$INCLUDE:'Screen.str'
c
c      INTEGER I*4
c
c      DO 10 I = 1 ,15
c        CALL Erase(I,  2, 16)
c  10  CONTINUE
c
c      RETURN
c      END
c**********************************************************************
C	 D r a w  M e s s a g e  D i v i d e r    (subroutine)
C**********************************************************************
      SUBROUTINE Draw Message Divider

c***  This routine draws the vertical message divider line directly  
c***  after the options listed on the screen for the DOS Utilities and
c***  File Operations menu.
c***  
c***  VARIABLES:
c***  page    -	this variable is always zero.
c***  middle  -	column number in which the divider line appears.
c***  svert   -	decimal code for the 'vertical line' character.
c***  stdown  -	decimal code for the lines that intersect similar
c***            to a 'T'.
c***  dbot    -	decimal code for the lines that intersect similar
c***            to an inverted 'T' with two lines on the bottom.
c***  frcolor -	code for the color of the frame.

      IMPLICIT INTEGER*2 (A-Z)

      page     = 0
      middle   = 20
      svert    = 179
      stdown   = 194
      dbot     = 207
      frcolor  = 7

c***  Draw the top T with a double top.
      term4 = 1
      irow = 4
      call putcur(page, irow, middle)
      call putvch(page, stdown, frcolor, term4)
c***  Draw the vertical line.
      do 10 irow = 5, 18
        call putcur(page, irow, middle)
        call putvch(page, svert, frcolor, term4)
  10  continue
c***  Draw the bottom inverted T.
      irow = 19
      call putcur(page,irow,middle)
      call putvch(page, dbot, frcolor, term4)
 

      RETURN
      END
c**********************************************************************
c	 E r a s e  M e s s a g e  D i v i d e r    (subroutine)
C**********************************************************************
      SUBROUTINE Erase Message Divider

c***  This routine erases the vertical message divider line directly  
c***  after the options listed on the screen for the DOS Utilities and
c***  File Operations menu.

c***  VARIABLES:
c***  page    -	this variable is always zero.
c***  middle  -	column number in which the divider line appears.
c***  svert   -	decimal code for the 'vertical line' character.
c***  stdown  -	decimal code for the lines that intersect similar
c***            to a 'T'.
c***  dbot    -	decimal code for the lines that intersect similar
c***            to an inverted 'T' with two lines on the bottom.
c***  frcolor -	code for the color of the frame.

      IMPLICIT INTEGER*2 (A-Z)

      page     = 0
      middle   = 20
      horiz    = 205
      shoriz   = 196
      blank    = 32
      frcolor  = 7

c***  Erase the option description line. 
      term4 = 1
      irow = 4
c***  Replace top line with double horizontal.
      call putcur(page, irow, middle)
      call putvch(page, shoriz, frcolor, term4)
c***  Replace vertical message divider with blanks.
      do 10 irow = 5, 18
        call putcur(page, irow, middle)
        call putvch(page, blank, frcolor, term4)
  10  continue
c***  Replace top of horizontal message line with a double horizontal.
      irow = 19
      call putcur(page,irow,middle)
      call putvch(page, horiz, frcolor, term4)
 
      RETURN
      END
c**********************************************************************
c	 D r a w  M i d d l e  H o r i z o n t a l  L i n e  (subroutine)
c**********************************************************************
      SUBROUTINE Draw Middle Horizontal Line(middle)

c***  This routine draws a horizontal line from the left side of the
c***  main frame to the right side of the main frame.
c***
c***  VARIABLES:
c***  middle  - this variable contains the row number of where the 
c***            line is to be drawn.
c***  page    -	this variable is always zero.
c***  shoriz  -	decimal code for the 'horizontal line' character.
c***  cleft   -	decimal code for a character.
c***  cright  -	decimal code for a character. 
c***  frcolor -	code for the color of the frame.


      IMPLICIT INTEGER*2 (A-Z)

      page     = 0
      shoriz   = 196
      cleft    = 199
      cright   = 182
      frcolor  = 7
      right    = 79
      left     = 0
      k        = right - left - 1

c *** left side
      call putcur (page, middle, left)
      term4 = 1
      call putvch (page, cleft, frcolor, term4)

c *** middle horizontal line
      term3 = left + 1
      call putcur (page, middle, term3)
      call putvch (page, shoriz, frcolor, k)

c *** right side
      call putcur (page, middle, right)
      term4 = 1
      call putvch (page, cright, frcolor, term4)

      RETURN
      END
c**********************************************************************
c	 E r a s e   M i d d l e  H o r i z o n t a l  L i n e  (subroutine)
c**********************************************************************
      SUBROUTINE Erase Middle Horizontal Line(middle)

c***  This routine erases a horizontal line from the left side of the
c***  main frame to the right side of the main frame.
c***
c***  VARIABLES:
c***  middle  - this variable contains the row number of where the 
c***            line is to be drawn.
c***  page    -	this variable is always zero.
c***  shoriz  -	decimal code for the 'horizontal line' character.
c***  cleft   -	decimal code for a character.
c***  cright  -	decimal code for a character. 
c***  frcolor -	code for the color of the frame.



      IMPLICIT INTEGER*2 (A-Z)

      page     = 0
      vert     = 186
      blank    = 32
      frcolor  = 7
      right    = 79
      left     = 0
      k        = right - left - 1

c *** left side
      call putcur (page, middle, left)
      term4 = 1
      call putvch (page, vert, frcolor, term4)

c *** middle horizontal line
      term3 = left + 1
      call putcur (page, middle, term3)
      call putvch (page, blank, frcolor, k)

c *** right side
      call putcur (page, middle, right)
      term4 = 1
      call putvch (page, vert, frcolor, term4)

      RETURN
      END

C**********************************************************************
c        E r a s e  V a r i a b l e  L i s t   (subroutine)
C**********************************************************************
      SUBROUTINE Erase Variable List

c***  This routine erases the variable display.

$INCLUDE:'Screen.str'

      INTEGER*4 I

      DO 10 I = 11, 18
	 CALL Erase (I, 1, 78)
  10  CONTINUE
      RETURN
      END
c**********************************************************************
c        C l e a r  R o w s        (subroutine)
c**********************************************************************
      SUBROUTINE Clear Rows (first, last)

c***  This routine clears rows first through last but leaves the 
c***  frame intact.
c***
c***  VARIABLES:
c***  first - Variable contains the row to start clearing.
c***  last  - Variable contains the row to end clearing.

$INCLUDE:'Dataprep.dec'
$INCLUDE:'Screen.str'
	
      INTEGER I, first, last

      DO 10 I = first,last
	 CALL Erase(I, 1, 78)
  10  CONTINUE

      RETURN
      END
C**********************************************************************
