$LARGE
C*********************************************************************
C*** File Name: PROCESS.FOR (Source code for the program HPPLOT)
C*********************************************************************
C SUBROUTINE GET SCREEN FLD
C
C Local Variable:
C  Main Screen    - Stores the screen number for the main screen.
C  Main Menu      - Stores the name of the main menu.
C  Menu Choice    - Stores the user's menu selection.
C  Exit           - Logical variable that is set to true when the user
C                   wants to exit the program. 
C
C  This routine displays the screen, accesses the  menu option
C  selected by the user and then calls Perform Process to process 
C  the screen fields or calls a routine to process the menu option. 
C
        SUBROUTINE Get Screen Fld
        
        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'Hpplot.cmn' 
       
        INTEGER*4      Main Screen
        CHARACTER*10   Main Menu
        CHARACTER*15   Menu Choice
        LOGICAL*1      GetYesNo, Exit

        DATA Main Menu  /'MAINMENU  '/
        DATA Main Screen     /2/

        True Scale = .TRUE.

C *** Display Main menu
  5     CALL Get New Screen (Main Screen)
        CALL Display Flds        

 10     CALL Put Menu (Main Menu)
c        CALL Display Flds        
        
        CALL Get Menu Choice (Main Menu, Menu Choice)
        
C *** Quit - Main menu
        IF (Menu Choice .EQ. 'Quit            ') THEN
           Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N> ')
           IF (Exit)  THEN
              CALL Clear Screen
              RETURN
           ELSE
              GOTO 10
           ENDIF

C *** File - Main menu
        ELSE IF (Menu Choice .EQ. 'File          ') THEN
           CALL Perform Process
           GOTO 10

C *** Execute - Main menu
        ELSE IF (Menu Choice .EQ. 'Execute        ') THEN
           IF (Metacode File .EQ. '              ') THEN
              CALL BEEP
              Text = 'ERROR - Metacode file not specified'
              CALL Flash (20,2,Text)
              GOTO 10
           ELSE
              CALL Perform Process
	      GOTO 5
           ENDIF 

C *** All other Main menu options
        ELSE         
           CALL Perform Process  
           GOTO 10
        ENDIF

        RETURN
        END

C***********************************************************************
C SUBROUTINE PERFORM PROCESS 
C
C Local Variables:
C  Field Name     - Stores the screen field name.
C  Fexist         - Logical variable set to true if the file exists.
C
C This routine identifies which screen field has been selected, performs
C any error checking and then processes the screen field.
C
        SUBROUTINE Perform Process 

        IMPLICIT INTEGER*4 (A-Z)		

$INCLUDE: 'screen.str'
$INCLUDE:'Hpplot.cmn' 

        CHARACTER*3   Stat
        CHARACTER*10  Field Name
        CHARACTER*50  Blanks    
      
        INTEGER*4     Fld Index

	LOGICAL*1     Fexist, Overwrite, GetYesNo

        Overwrite = .TRUE.

 5      CALL Get Field
        Field Name = SC Field Name (Current Field)
       
C *** Identify fields, perform process

C *** enter file prefix 
       IF (Field Name .EQ. 'PREFIX    ') THEN
	   CALL Get Character Value (Field Name, File Prefix) 
           CALL Left Justify (File Prefix)
	   CALL Set Character Value (Field Name, File Prefix)

C *** select type of scaling
       ELSE IF ( Field Name .EQ. 'SCALE     ') THEN
            Position = Toggle Position (Field Name)
            IF (position .EQ. 0) THEN
               True Scale = .FALSE.
            ELSE
               True Scale = .TRUE.
            ENDIF

C *** Get Metcode file name 
       ELSE IF ( Field Name .EQ. 'METACODE  ') THEN
            CALL Get Character Value (Field Name, Metacode File)
	    IF (File Prefix .NE. Blanks) THEN
    	        la = Lenstr(File Prefix)
	        Input File = File Prefix(1:la)//Metacode File
            ELSE
	        Input File  = Metacode File
	    ENDIF
	    INQUIRE (FILE = Input File,  EXIST = Fexist)
            IF (.NOT. Fexist) THEN
               CALL Flash ( 20, 2, 'ERROR - Metacode File not found')
               CALL Erase Field (Field Name)
               Stat = 'NEW'
            ELSE 
               Stat = 'OLD'
               CALL Build File Name (Metacode File, HP File,'.plt')
               CALL Set Character Value('HP FILE   ', HP File)
            ENDIF

C *** Get output file name 
       ELSE IF ( Field Name .EQ. 'HP FILE   ') THEN
              CALL Get Character Value (Field Name, HP File)
	      IF (HP File .EQ. '               ') THEN
                 CALL Set Character Value(Field Name,'Hpgl.Plt')
                 CALL Display One Field (Field Name)
                 Next Field = Fld Index (Field Name)
                 GOTO 5
              ENDIF
	      IF (File Prefix .NE. Blanks) THEN
  	         la = Lenstr(File Prefix)
		 Output File = File Prefix(1:la)//HP File
	      ELSE
		 Output File  = HP File
	      ENDIF
	      INQUIRE (FILE = Output File, EXIST = Fexist)
              IF (Fexist) Overwrite = GetYesNo (20, 2,
     +                      'File Exists, Overwrite?  <Y/N> ')
              IF (.NOT. Overwrite) THEN
                 Next Field = Fld Index (Field Name)
                 Overwrite = .TRUE.
                 GOTO 5
              ENDIF
              CALL Put Str ( 'Preparing output file ', 22, 20, 2, 2)
              CALL MHPPLOT (Input File,Stat, Output File, True Scale)
       ENDIF
       RETURN
       END

