$LARGE
C BlockDat.for
C**********************************************************************
C
C   Screen Access Management (SAM) Utilities  
C
C   This routine builds a block data subroutine from the
C      given screen structure file.  After development is complete,
C      for an application, this routine should be used, and the resulting
C      .BLK file included in the source code and compiled.  This will 
C      eliminate the time and overhead involved in reading a file.
C
C   Programmer:  Allen R. Sparks  (Computer Sciences Corporation)
C
C**********************************************************************
	PROGRAM Build Block

	CHARACTER*80	Screen File, OutPut File
	LOGICAL 	Fexist

	WRITE (*, *) ' This program will build a BLOCK DATA '
	WRITE (*, *) '  from a screen definition file       '
 10	WRITE (*, *)
	WRITE (*, *) 'Enter the name of the screen (.SCR) file '

	READ  (*, '(A)') Screen File
	INQUIRE (FILE = Screen File, EXIST = Fexist)
	IF (.NOT. Fexist) THEN
	   WRITE (*, *) 'Cant find that file ... try again ...'
	   GOTO 10
	ENDIF
 	WRITE (*, *) 'Reading screen structure file '//Screen File
	
	CALL Read Structure (Screen File)

 	WRITE (*, *)
	WRITE (*, *) 'Enter the name of the output file '
	READ  (*, '(A)') Output File
	CALL Block Data (OutPut File)

	END

C----------------------------------------------------------------------
	SUBROUTINE Block Data (OutPut File)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'BLockdat.dec'

	CHARACTER*80  OutPut File

	OPEN (UNIT   = 10,
     +	      FILE   = OutPut File,
     +	      IOSTAT = IO status)

	IF (IO status .NE. 0) THEN
	  WRITE (*, *)
	  WRITE (*, *) 'FATA ERROR - Can not open output file '
	  STOP
	ENDIF

	WRITE (10, 90)
	WRITE (10, 100) Total Number of Screens
	DO 10 I = 1, Total Number of Screens

C----------------------------------------------------------------------
C   WRITE SCREEN FIELDS
C----------------------------------------------------------------------
	 WRITE (10, 375)
	 WRITE (10, 110) I
	 WRITE (10, 120) i, Begin Screen (i)
	 WRITE (10, 125) i, End Screen (i)												
	  DO 20 J = Begin Screen (i), End Screen (i)
	    WRITE (10, 375)
	    WRITE (10, 128) j
     	    WRITE (10, 130) j, SC Field Name (j)
	    WRITE (10, 140) j, SC Pointer (j)	
     	    WRITE (10, 150) j, SC Length (j)
	    WRITE (10, 160) j, SC Row (j)
	    WRITE (10, 170) j, SC Column (j) 
     	    WRITE (10, 180) j, SC Attribute (j)
	    WRITE (10, 190) j, SC Chosen Attribute (j)
     	    WRITE (10, 200) j, SC Field Type (j)
	    IF (SC Next (J)) THEN
	      WRITE (10, 210) j
	    ELSE
	      WRITE (10, 215) j
	    ENDIF
	    WRITE (10, 220) j, SC Carriage Return (j)
     	    WRITE (10, 230) j, SC Up (j)
	    WRITE (10, 240) j, SC Down (j)
	    WRITE (10, 250) j, SC Left (j)
	    WRITE (10, 260) j, SC Right (j)
     	    WRITE (10, 270) j, SC Members (j)
	    WRITE (10, 280) j, SC Position (j)
     	    WRITE (10, 290) j, SC Message (j)
	    WRITE (10, 300) j, SC MPointer (j)
	    WRITE (10, 310) j, SC Mlength (j)

	    IF (SC Field Type (j) .EQ. 5) THEN
	       WRITE (10, 315)
	       Pointer = SC Pointer (j)
	       DO 30 k = 0, SC Members (j)-1 
	         M = Pointer
	         N = M + SC Length (j) - 1
	         IF (SC Members (j) .LT. 48) THEN
	           IF (SC Length (j) .LE. 60) THEN
	             WRITE (10, 330)  M, N, Record (M:N)
	           ELSE
	             WRITE (10, 330)  M, M+59, Record (M:M+59)
	             WRITE (10, 330)  M+60, N, Record (M+60:N)
	           ENDIF
	         ENDIF
	         Pointer = Pointer + SC Length (j)
 30	       CONTINUE	         

	    ELSE IF (SC Field Type (j) .EQ. 4) THEN
	       WRITE (10, 325)		
	       M = SC Pointer (j)
	       N = M + SC Length (j) - 1
	       IF (SC Length (j) .LE. 60) THEN
	           WRITE (10, 330)  M, N, Record (M:N)
	       ELSE
	           WRITE (10, 330)  M, M+59, Record (M:M+59)
	           WRITE (10, 330)  M+60, N, Record (M+60:N)
	       ENDIF

	    ELSE IF (SC Field Type (j) .EQ. 0) THEN
	       WRITE (10, 335)
	       M = SC Pointer (j)
	       N = M + SC Length (j) - 1
	       IF (SC Length (j) .LE. 60) THEN
	           WRITE (10, 330)  M, N, Record (M:N)
	       ELSE
	           WRITE (10, 330)  M, M+59, Record (M:M+59)
	           WRITE (10, 330)  M+60, N, Record (M+60:N)
	       ENDIF

	    ELSE IF (SC Field Type (j) .EQ. 1) THEN
	       WRITE (10, 345)
	       M = SC Pointer (j)
	       N = M + SC Length (j) - 1
	       WRITE (10, 320)  M, N, Record (M:N)

	    ELSE IF (SC Field Type (j) .EQ. 2) THEN
	       WRITE (10, 355)
	       M = SC Pointer (j)
	       N = M + SC Length (j) - 1
	       WRITE (10, 320)  M, N, Record (M:N)
	    END IF 
 
	    IF (SC Message (j) .NE. 0) THEN
	       WRITE (10, 365)
	       Pointer = SC Mpointer (j)
	       DO 40 k = 1, SC Message (j)
	          M = Pointer
	          N = M + SC MLength (j) - 1
	          IF (SC MLength (j) .LE. 60) THEN
	              WRITE (10, 330)  M, N, Record (M:N)
	          ELSE
	              WRITE (10, 330)  M, M+59, Record (M:M+59)
	              WRITE (10, 330)  M+60, N, Record (M+60:N)
	          ENDIF
	          Pointer = Pointer + SC Mlength (j)
 40	       CONTINUE
	    ENDIF
 20	  CONTINUE
C----------------------------------------------------------------------
C   WRITE LABEL FIELDS
C----------------------------------------------------------------------
	  WRITE (10, 375)
	  WRITE (10, 400) i, Begin Label (i)
	  WRITE (10, 410) i, End Label (i)
	  DO 50 j = Begin Label (i), End Label (i)
	     WRITE (10, 420) j, LB Row (j) 
	     WRITE (10, 430) j, LB Column (j)
	     WRITE (10, 440) j, LB Attribute (j)
	     WRITE (10, 450) j, LB Pointer (j)
	     WRITE (10, 460) j, LB Length  (j) 
	     M = LB Pointer (j)
	     N = M + LB Length (j) - 1
	     IF (LB Length (j) .LE. 60) THEN
	         WRITE (10, 330)  M, N, Record (M:N)
	     ELSE
	         WRITE (10, 330)  M, M+59, Record (M:M+59)
	         WRITE (10, 330)  M+60, N, Record (M+60:N)
	     ENDIF
 50	  CONTINUE

C----------------------------------------------------------------------
C   WRITE FRAME FIELDS
C----------------------------------------------------------------------
	  WRITE (10, 375)
	  WRITE (10, 500) i, Begin Frame (i)
	  WRITE (10, 510) i, End Frame (i)
	  DO 70 j = Begin Frame (i), End Frame (i)
	     WRITE (10, 520) j, FR Command (j)
	     WRITE (10, 530) j, FR Type (j)
	     WRITE (10, 540) j, FR Row1 (j)
	     WRITE (10, 550) j, FR Column1 (j)
	     WRITE (10, 560) j, FR Row2 (j)
	     WRITE (10, 570) j, FR Column2 (j)
	     WRITE (10, 580) j, FR Attribute (j)
 70	  CONTINUE
 10	CONTINUE
	WRITE (10, 600)
	CLOSE (10)

C----------------------------------------------------------------------
C FORMAT Statements
C

  90	FORMAT ('$LARGE',/,
     +	        7X,'BLOCK DATA XYZZYX ',/,
     +          7X,'IMPLICIT INTEGER*4 (A-Z)',/,
     +             '$INCLUDE:''Screen.str''',//)
    
 100	FORMAT (7X,'DATA Total Number of Screens /',I2,'/')

 110	FORMAT ('C',6X,'Screen Number: ',I2)
 120    FORMAT (7X,'DATA Begin Screen        (',I3,') /',I10,'/')
 125    FORMAT (7X,'DATA End Screen          (',I3,') /',I10,'/')  									

 128	FORMAT ('C',6X,' Field Number: ',I3)
 130	FORMAT (7X,'DATA SC Field Name       (',I3,') /''',A10,'''/')
 140	FORMAT (7X,'DATA SC Pointer          (',I3,') /',I10,'/') 
 150	FORMAT (7X,'DATA SC Length           (',I3,') /',I10,'/')
 160	FORMAT (7X,'DATA SC Row              (',I3,') /',I10,'/')
 170	FORMAT (7X,'DATA SC Column           (',I3,') /',I10,'/')	
 180	FORMAT (7X,'DATA SC Attribute        (',I3,') /',I10,'/')
 190	FORMAT (7X,'DATA SC Chosen Attribute (',I3,') /',I10,'/')	
 200	FORMAT (7X,'DATA SC Field Type       (',I3,') /',I10,'/')
 215	FORMAT (7X,'DATA SC Next             (',I3,') /   .FALSE./')
 210	FORMAT (7X,'DATA SC Next             (',I3,') /    .TRUE./')
 220	FORMAT (7X,'DATA SC Carriage Return  (',I3,') /',I10,'/')
 230	FORMAT (7X,'DATA SC Up               (',I3,') /',I10,'/')
 240	FORMAT (7X,'DATA SC Down             (',I3,') /',I10,'/')
 250	FORMAT (7X,'DATA SC Left             (',I3,') /',I10,'/')
 260	FORMAT (7X,'DATA SC Right            (',I3,') /',I10,'/')	
 270	FORMAT (7X,'DATA SC Members          (',I3,') /',I10,'/')
 280	FORMAT (7X,'DATA SC Position         (',I3,') /',I10,'/')	
 290	FORMAT (7X,'DATA SC Message          (',I3,') /',I10,'/')
 300	FORMAT (7X,'DATA SC Mpointer         (',I3,') /',I10,'/')	
 310	FORMAT (7X,'DATA SC MLength          (',I3,') /',I10,'/')	

 320	FORMAT (7X,'DATA Record (',I10,':',I10,') /''',A,'''/')

 330	FORMAT (7X,'DATA Record (',I10,':',I10,')',
     +				 /,5X,'+ /''',A,'''/')

 315	FORMAT ('C',6X,'Toggle Values:')
 325	FORMAT ('C',6X,'   Menu Value:')
 335	FORMAT ('C',6X,'String  Value:')
 345	FORMAT ('C',6X,'Integer Value:')
 355	FORMAT ('C',6X,'   Real Value:')
 365	FORMAT ('C',6X,'     Messages:')
 375	FORMAT ('C',71('-'))
C
C Label formats
C
 400    FORMAT (7X,'DATA Begin Label         (',I3,') /',I10,'/')
 410    FORMAT (7X,'DATA End Label           (',I3,') /',I10,'/')  									
 420    FORMAT (7X,'DATA LB Row              (',I3,') /',I10,'/')  									
 430    FORMAT (7X,'DATA LB Column           (',I3,') /',I10,'/')  									
 440    FORMAT (7X,'DATA LB Attribute        (',I3,') /',I10,'/')  									
 450    FORMAT (7X,'DATA LB Pointer          (',I3,') /',I10,'/')  									
 460    FORMAT (7X,'DATA LB Length           (',I3,') /',I10,'/')  									
 470	FORMAT (7X,'DATA Record (',I10,':',I10,')  /''',A,'''/')
C
C Frame formats
C
 500    FORMAT (7X,'DATA Begin Frame         (',I3,') /',I10,'/')
 510    FORMAT (7X,'DATA End Frame           (',I3,') /',I10,'/')  									
 520    FORMAT (7X,'DATA FR Command          (',I3,') /',I10,'/')  									
 530    FORMAT (7X,'DATA FR Type             (',I3,') /',I10,'/')  									
 540    FORMAT (7X,'DATA FR Row1             (',I3,') /',I10,'/')  									
 550    FORMAT (7X,'DATA FR Column1          (',I3,') /',I10,'/')  									
 560    FORMAT (7X,'DATA FR Row2             (',I3,') /',I10,'/')  									
 570    FORMAT (7X,'DATA FR Column2          (',I3,') /',I10,'/')  									
 580    FORMAT (7X,'DATA FR Attribute        (',I3,') /',I10,'/')  									

 600	FORMAT (7X,'END')
	END

C--------------------------------------------------------------------------
	SUBROUTINE Read Structure (Screen File)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'BLockdat.dec'

	CHARACTER*(*) Screen File
	CHARACTER*150 Line, Blanks*50
	CHARACTER*10  Start
	CHARACTER*4   Command
	INTEGER*4     LENSTR, Klen, Ptr1, Ptr2

C	DATA Debug Screen /.FALSE./

	IF (Debug Screen) WRITE (*, *) 'Structure File = ', Screen File

	Record = ' '

	Screen Fields = 1
	OPEN (UNIT   = Screen Fields,
     +	      FILE   = Screen File,
     +	      STATUS = 'OLD',
     +	      IOSTAT = IO status)

	IF (IO status .NE. 0) THEN
	  WRITE (*, *) 'File ', Screen File, ' Not Found.'
	  RETURN
	ENDIF

	End Screen (0) = 0
	End Label  (0) = 0
	End Frame  (0) = 0
	Pointer = 1
	Current Screen = 1

   5	IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	IF (Line(1:7) .EQ. 'ENDFILE') GO TO 70

	i = End Screen (Current Screen - 1)  + 1
	Begin Screen (Current Screen) = i

	READ (Line, '(1X,A10)', ERR=99, END=99) Start
	IF (Debug Screen) WRITE (*, *) 'Start = *', Start, '*'
	Line = ' '

C----------------------------------------------------------------------
C   READ FIELDS.
C----------------------------------------------------------------------

  10	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 100	    FORMAT (1X, A10, I4, 1X, 2(I3, 1X), 4(I2, 1X), 8(I3, 1X))
	    READ (Line, 100, ERR=99, END=99)
     +	          SC Field Name (i),
     +	          SC Length     (i),
     +	          SC Row        (i),
     +	          SC Column     (i),
     +	          SC Attribute  (i),
     +	          SC Chosen Attribute (i),
     +	          SC Field Type (i),
     +	             Next,
     +	          SC Carriage Return (i),
     +	          SC Up         (i),
     +	          SC Down       (i),
     +	          SC Left       (i),
     +	          SC Right      (i),
     +	          SC Members    (i),
     +	          SC Position   (i),
     +	          SC Message    (i)

	    IF (Next .EQ. 0) THEN
	      SC Next (i) = .FALSE.
	    ELSE
	      SC Next (i) = .TRUE.
	    ENDIF

	    SC Pointer (i) = Pointer
	    Record (Pointer : Pointer + SC Length (i) - 1) = ' '

	    IF (Debug Screen) THEN
	      WRITE (*, *) 'Field = ', i
	      WRITE (*, *) 'Field Name = *', SC Field Name (i), '*'
	      WRITE (*, *) 'Before processing, Pointer = ', Pointer
	    ENDIF

	    IF (SC Field Type (i) .EQ. 5) THEN
	      Position = 12
	      IF (Get Line (Screen Fields, line) .NE. 0) GO TO 99
	      DO 20 f = 1, SC Members (i)
	        Record (Pointer:Pointer+SC Length(i)-1) =
     +	          Line(Position:Position+SC Length(i)-1)
	        Position = Position + SC Length(i) + 2
	        Pointer  = Pointer  + SC Length(i)
  20	      CONTINUE

	    ELSE
	      IF (SC Field Type (i) .EQ. 4) THEN
	        Record (Pointer : Pointer + SC Length (i) - 1) =
     +	           Line (70 : 69 + SC Length (i))
	        IF (Debug Screen)
     +	           WRITE(*,*) '*', Line (70:69+SC Length(i)), '*'
	      ENDIF
	      Pointer = Pointer + SC Length (i)
	    ENDIF

	    IF (SC Message (i) .NE. 0) THEN
	      IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	      SC M Length (i) = STR Len (Line) - 11
	      SC M Pointer (i) = Pointer
	      DO 30 m = 1, SC Message (i)
	        Record (Pointer : Pointer + SC M Length (i) - 1) =
     +	          Line (12 : 11+ SC M Length (i))
	        Pointer = Pointer + SC M Length (i)
	        IF (m .LT. SC Message (i)) THEN
	          IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99
	        ENDIF
  30	      CONTINUE
	    ENDIF

	    i = i + 1
	  ENDIF
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'After processing , Pointer = ', Pointer
	  ENDIF

	  GO TO 10
	ENDIF

	End Screen (Current Screen) = i - 1

	IF (Debug Screen) WRITE (*, *) 'Number of Input Fields = ',
     +	    End Screen (Current Screen)

	Starting Field (Current Screen) = Fld Index (Start)
	IF (Starting Field (Current Screen) .EQ. 0) THEN
	  IF (Debug Screen) THEN
	    WRITE (*, *) 'Starting Field Not Found! = *', Start, '*'
	  ENDIF
	  Starting Field (Current Screen) = 1
	ENDIF

	i = End Label (Current Screen - 1) + 1
	Begin Label (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Label ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ LABELS.
C----------------------------------------------------------------------

  40	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Debug Screen) THEN
	      WRITE (*, *) 'Before processing, Pointer = ', Pointer
	      WRITE (*, *) 'I = ', i
	      WRITE (*, *) Line
	  ENDIF
	  IF (Line(1:3) .NE. 'END') THEN
 120	    FORMAT (I4, 2X, 2(I2, 2X))
	    READ (Line, 120, ERR=99, END=99)
     +	          LB Row (i),
     +	          LB Column (i),
     +	          LB Attribute (i)

	    Length = STR Len (Line) - 13

	    Record (Pointer : Pointer+Length-1) = Line (14:13+Length)
	    LB Pointer (i) = Pointer
	    LB Length  (i) = Length

	    Pointer = Pointer + Length

	    i = i + 1
	  ENDIF
	  IF (Debug Screen) THEN
	      WRITE (*, *) 'After processing , Pointer = ', Pointer
	      WRITE (*, *) 'I = ', i
	      WRITE (*, *) Line
	      WRITE (*, *) Record (Pointer-Length : Pointer - 1)
	  ENDIF

	  GO TO 40
	ENDIF

	End Label (Current Screen) = i - 1

	i = End Frame (Current Screen - 1) + 1
	Begin Frame (Current Screen) = i
	IF (Debug Screen) WRITE (*, *) 'Begin Frame ', i
	Line = ' '

C----------------------------------------------------------------------
C   READ FRAMES.
C----------------------------------------------------------------------

  50	IF (Line(1:3) .NE. 'END') THEN

	  IF (Get Line (Screen Fields, Line) .NE. 0) GO TO 99

	  IF (Line(1:3) .NE. 'END') THEN
 130	    FORMAT (A4, 1X, I1, 5(1X, I3))
	    READ (Line, 130, ERR=99, END=99)
     +	          Command,
     +	          FR Type (i),
     +	          FR Row1 (i),
     +	          FR Column1 (i),
     +	          FR Row2 (i),
     +	          FR Column2 (i),
     +	          FR Attribute (i)

	    IF (Debug Screen)
     +	      WRITE (*, *) 'Command = *', Command, '*', ' i = ', i

	    IF (Command .EQ. 'BOX') THEN
	      IF (FR Row1 (i) .EQ. FR Row2 (i)) THEN
	        FR Command (i) = 1
	      ELSE IF (FR Column1 (i) .EQ. FR Column2 (i)) THEN
	        FR Command (i) = 1
	      ELSE
	        FR Command (i) = 0
	      ENDIF

	    ELSE IF (Command .EQ. 'LINE') THEN
	      FR Command (i) = 1

	    ELSE
	      i = i - 1
	    ENDIF

	    i = i + 1

	  ENDIF

	  GO TO 50
	ENDIF

	End Frame (Current Screen) = i - 1

	Current Screen = Current Screen + 1
	GO TO 5

  70	CLOSE (Screen Fields)

	Total Number of Screens = Current Screen - 1
	Current Screen = 1
	Current Field = Starting Field (Current Screen)
	Next Field = Current Field
	Number of Input Fields = End Screen (Current Screen)

	IF (Debug Screen) THEN
	  WRITE (*, *) 'Total Screens = ', Total Number of Screens
	  WRITE (*, *) 'Begin Screen  = ', Begin Screen (1)
	  WRITE (*, *) 'End   Screen  = ', End   Screen (1)
	  WRITE (*, *) 'Begin Label   = ', Begin Label  (1)
	  WRITE (*, *) 'End   Label   = ', End   Label  (1)
	  WRITE (*, *) 'Begin Frame   = ', Begin Frame  (1)
	  WRITE (*, *) 'End   Frame   = ', End   Frame  (1)
	  CALL Get Key (Character)
	ENDIF

	RETURN

  99	WRITE (*, *) '*** ERROR in SCREEN Definition. Field = ', i
	CLOSE (Screen Fields)
	STOP

	END

*********************************************************************

	INTEGER*4 FUNCTION STR Len (Line)
	CHARACTER*(*) Line

	STR Len = 1
	DO 10 i = 150, 1, -1
	  IF (Line(i:i) .EQ. ';') THEN
	    STR Len = i - 1
	    GO TO 90
	  ENDIF
  10	CONTINUE

  90	RETURN
	END

*********************************************************************

	INTEGER*4 FUNCTION Get Line (Screen Fields, Line)
	IMPLICIT INTEGER*4 (A-Z)
	CHARACTER*(*) Line

	Line(1:1) = 'C'
  10	IF (Line .EQ. ' ' .OR.
     +	          Line(1:1) .EQ. 'C' .OR. Line(1:1) .EQ. 'c') THEN
	  READ (Screen Fields, '(A150)', ERR=99, END=99) Line
	  GO TO 10
	ENDIF
	Get Line = 0
	RETURN

  99	Get Line = 1
	RETURN
	END

*********************************************************************

	INTEGER*4 FUNCTION Fld Index (Name)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'BLOCKDAT.DEC'

	CHARACTER*(*) Name

	DO 10 i = 1, End Screen (Total Number of Screens)
	  IF (Name .EQ. SC Field Name (i)) THEN
	    Fld Index = i
	    RETURN
	  ENDIF
  10	CONTINUE

	Fld Index = 0

	RETURN
	END

C------------------------------------------------------------------------
C  Returns the ASCII code for a keystroke
C------------------------------------------------------------------------
	SUBROUTINE Get Key (Character)
	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*2   Scan, Ascii
	Scan Code = 0
	Character = 0
	CALL GETCHA (Scan, Ascii)
	Character = Ascii
	Scan Code = Scan
	IF (Character .EQ. 0) Character = 200 + Scan Code

	RETURN
	END

