$LARGE
C**********************************************************************
C
C   Screen Access Management (SAM) Utilities - Machine Dependent routines
C
C   Programmer:  Suleiman S. Lalani (Sam)
C
C**********************************************************************

        SUBROUTINE Display Frame
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (BOX  = 0)
	PARAMETER (LINE = 1)
	INTEGER*4 Matrix    (0:24, 0:79)

	INTEGER*4 Attribute (0:24, 0:79)

$INCLUDE: 'SCREEN.STR'

      DO 10 i = 0, 24
        DO 10 j = 0, 79
          Matrix    (i, j) = 0
          Attribute (i, j) = 0
  10  CONTINUE

      DO 20 i = Begin Frame (Current Screen),
     +            End Frame (Current Screen)

        IF (FR Command (i) .EQ. BOX) THEN

          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row1(i), FR Column2(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column2(i),
     +                    FR Row2(i), FR Column2(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row2(i), FR Column1(i))
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row2(i), FR Column1(i),
     +                    FR Row2(i), FR Column2(i))

        ELSE
          CALL Draw Line (Matrix, Attribute, i,
     +                    FR Row1(i), FR Column1(i),
     +                    FR Row2(i), FR Column2(i))

        ENDIF

  20  CONTINUE

      RETURN
      END

***********************************************************************

      SUBROUTINE Draw Line (Matrix, Attribute, f,
     +                      Row1, Column1, Row2, Column2)
	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'

	INTEGER*4 Matrix    (0:24, 0:79)
	INTEGER*4 Attribute (0:24, 0:79)
      LOGICAL*1 Double Line

      Double Line = .FALSE.
      att = FR Attribute (f)

      Line Type   = 0

      IF (FR Type (f) .EQ. 2) Double Line = .TRUE.

C*----- Horizontal Line -----*/
      IF (Row1 .EQ. Row2) THEN

        IF (Double Line) Line Type = 16

C*----- Left edge -----------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column1, 1, Line Type, att)

        DO 10 col = Column1+1, Column2-1

C*----- Horizontal edge -----*/

          CALL Draw Char (Matrix, Attribute,
     +                    Row1, col, 3, Line Type, att)

  10    CONTINUE

C*----- Right edge ----------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column2, 2, Line Type, att)

C*----- Vertical Line -------*/

      ELSE

        IF (Double Line) Line Type = 32

C*----- Top edge ------------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row1, Column1, 8, Line Type, att)

        DO 20 row = Row1+1, Row2-1

C*----- Vertical edge -------*/

          CALL Draw Char (Matrix, Attribute,
     +                    row, Column1, 12, Line Type, att)

  20    CONTINUE

C*----- Bottom edge ---------*/

        CALL Draw Char (Matrix, Attribute,
     +                  Row2, Column1, 4, Line Type, att)

      ENDIF

      RETURN
      END

***********************************************************************

      SUBROUTINE Draw Char (Matrix, Attribute,
     +                      row, col, ch, Line Type, att)
	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*4 Matrix    (0:24, 0:79)
	INTEGER*4 Attribute (0:24, 0:79)

      CHARACTER*1 Box Chars (0:63)
      DATA Box Chars /
     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '',

     +     ' ', '', '', '', '', '', '', '',
     +     '', '', '', '', '', '', '', '' /

      ch2 = IOR (ch, Line Type)
      Matrix (row, col) = IOR (Matrix (row, col), ch2)

      Attribute (row, col) = att

	CALL PutStr (Box Chars (Matrix (row, col)),
     +			 1, Row, Col, Attribute (row, col))

C      CALL Locate Cursor (row, col)
C
C      CALL Put Characters
C     +     	(Box Chars (Matrix (row, col)),
C     +			 1, Attribute (row, col))

      RETURN
      END

C------------------------------------------------------------------------
	SUBROUTINE Clear Screen
	IMPLICIT INTEGER*4 (A-Z)
	CALL SETMOD (HFIX(3))
	RETURN
	END

C------------------------------------------------------------------------
C  Returns the ASCII code for a keystroke
C------------------------------------------------------------------------
	SUBROUTINE Get Key (Character)
	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*2   Scan, Ascii
	Scan Code = 0
	Character = 0
	CALL GETCHA (Scan, Ascii)
	Character = Ascii
	Scan Code = Scan
	IF (Character .EQ. 0) Character = 200 + Scan Code

	RETURN
	END

C------------------------------------------------------------------------
C  Put Cursor at the specified Row and Column on the Virtual Display.
C------------------------------------------------------------------------
	SUBROUTINE Locate Cursor (Row, Column)
	IMPLICIT INTEGER*4 (A-Z)
	COMMON /CURSOR/ R, C
	R = Row
	C = Column
	CALL PUTCUR (HFIX(0), HFIX(Row), HFIX(Column))
	RETURN
	END

C------------------------------------------------------------------------
C  Put characters on the screen with the specified attribute.
C  Attributes can be :
C	NORMAL    = 0
C	BOLD      = 1
C	REVERSE   = 2
C	BLINK     = 4
C	UNDERLINE = 8
C------------------------------------------------------------------------
	SUBROUTINE Put Characters (Characters, Nchar, Attribute)
	IMPLICIT INTEGER*4 (A-Z)
	COMMON /Cursor/ R, C
	CHARACTER*(*) Characters
	INTEGER*4     Ch, Attribute, Nchar, Att, BTEST

C Normal
	Att = 7
C Reverse
	IF (BTEST (Attribute, 1)) Att = 112
C Underline
	IF (BTEST (Attribute, 3)) Att = 1
C Bold
	IF (BTEST (Attribute, 0)) Att = Att + 8
C Blink
	IF (BTEST (Attribute, 2)) Att = Att + 128

	Row    = R
	Column = C
	
	DO 10 i = 1, Nchar
	    CALL Locate Cursor (Row, Column + i - 1)
	    Ch = ICHAR (Characters (i:i))
	    CALL PUTVCH (INT2 (0), INT2 (Ch), INT2 (Att), INT2 (1))
   10	CONTINUE
	RETURN
	END

C---------------------------------------------------------------------
C  Send a BEEP to the screen.
C------------------------------------------------------------------------
	SUBROUTINE Beep
	CALL SOUND (INT2(20), INT2(10))
	RETURN
	END

C---------------------------------------------------------------------
	SUBROUTINE Set Up Screen
	IMPLICIT INTEGER*4 (A-Z)
C	WRITE (*, *) 'Setting Up Screen'
	RETURN
	END



