$LARGE
c**********************************************************************
c*** File name: TRANSE.FOR (Source code for the program TRANS)
c**********************************************************************
c	 I n i t  P r e f i x             (subroutine)
c**********************************************************************
      SUBROUTINE Init Prefix
 
c*** This routine initializes the global variable Prefix to blanks.

$INCLUDE:'Trans.dec'

      INTEGER*2 I

c*** set global variable Prefix to blanks ***
      DO 15 I = 1, 55
        Prefix(I:I) = ' '
  15  CONTINUE
 
      RETURN
      END
c**********************************************************************
c	 B u i l d  P r e f i x  S c r a t c h   F i l e (subroutine)
c**********************************************************************
      SUBROUTINE Build Prefix Scratch File (File Name)
 
c*** This routine concatenates a prefix to a filename.	 The filename
c*** is passed as a parameter and the prefix is a global variable.

c*** FORMAL ARGUMENT:
C*** File Name - filename to which Tfprefix is affixed.
c***
c*** VARIABLES:
C*** Prefile  -	global variable that stores the name of the file name
c***            with the Tfprefix affixed.
c*** Tfprefix -	global variable that stores the prefix of the scratch
c***            file.

$INCLUDE:'Trans.dec'
$INCLUDE:'Screen.str'

      CHARACTER  File Name*(*)
      INTEGER*2  I, J, K

c***  initialize Prefile to blanks.
      DO 15 I = 1, 77
        Prefile(I:I) = ' '
  15  CONTINUE
c***  concatenate Tfprefix to Prefile.
      J = LENSTR(Tfprefix)
      Prefile = Tfprefix 
      DO 10 I = 1, 14
	K = J + I
	Prefile(K:K) = File Name(I:I)
  10  CONTINUE

      RETURN
      END
c**********************************************************************
c	 I n i t  T f p r e f i x             (subroutine)
c**********************************************************************
      SUBROUTINE Init Tfprefix
 
c*** This routine initializes the global variable prefix to blanks.

$INCLUDE:'Trans.dec'
$INCLUDE:'Screen.str'

      INTEGER*2 I
c*** set global variable Prefix to blanks ***
      DO 15 I = 1, 55
        Tfprefix(I:I) = ' '
  15  CONTINUE
 
      RETURN
      END

c**********************************************************************
c	 Check Constant Input Overflow             (subroutine)
c**********************************************************************
      SUBROUTINE Check Constant Input Overflow(Choice, Error)
 
c*** A value taken from a screen field is examined to determine if it 
c*** causes numerical overflow.  An internal read statement
c*** is used to check if the value causes overflow.

c*** FORMAL ARGUMENTS:
C*** Choice - name of screen field which stores the value to be 
c***          checked for overflow. 
c*** Error  - returns .TRUE. if the value causes overflow.
c***
c***  VARIABLE:
c***  Tmp Input	- stores the constant value but as a character string.

$INCLUDE:'Trans.dec'
$INCLUDE:'Screen.str'

      CHARACTER    Tmp Input*13, Choice*(*)
      INTEGER*4    K
      REAL*4       Missinpt
      LOGICAL*1    Error

c***  Prompt user for the constant value.
      Error = .FALSE.
      K = 0
      Next Field = FLD Index (Choice)
      CALL Get Field
      CALL Get Character Value (Choice,Tmp Input)
c***  Use an internal read to check if the constant causes numeric overflow.
      READ (Tmp Input,'(G13.0)',IOSTAT=K) Missinpt
c***  Check for overflow in missing value input.
      IF (K .GT. 0) THEN
         CALL Beep
         CALL Flash (20, 2,
     +     'ERROR - on input, possible overflow...(press any key)')
         Error = .TRUE.
      ELSE
         Error = .FALSE.
      ENDIF

      RETURN
      END
C**********************************************************************
C	 Indicator Operation     (subroutine)
C**********************************************************************
      SUBROUTINE Indicator Operation 

c***  This routine provides the prompts that the user requires
c***  to perform the indicator operation.  The indicator operation is
c***  performed in this routine.  The labels required are also displayed
c***  by this program.

c***  VARIABLES:
C***  Ready   - is a local variable that is .true. if the menu 
c***            choice 'Variable' has been selected.
c***  Tmpvnam - is a global variable containing the name of the result
c***            variable assigned earlier.

$INCLUDE:'Trans.dec'
$INCLUDE:'Screen.str'

      CHARACTER*10   Menu, Choice, Menu Choice, Fldchoice
      CHARACTER      Heading1*9, Heading2*35, Equal1*3,Heading3*18
      CHARACTER      Heading4*9, Ch*35
      INTEGER*4      I,J,ToCol,FromCol,Toggle,FLD Index,Nerrors
      REAL*4         CValue, Value, Get Element
      LOGICAL*1      Vmiss, Ready, Error, Passover

c***  Initialize the variable names.
      Menu        = 'INDTMENU  '
      Heading1    = 'Indicator'
      Heading2    = 'Operator    Operand1       Operand2'
      Heading4    = 'Indicator'
      Heading3    = 'Processing data...'
      Equal1      = ' = '
      Ready       =  .FALSE.
      Error       =  .FALSE.
C***********  Place headings into the operation box  ******************
      CALL Put Str (Heading1,  9, 8,  2, 0)
      CALL Put Str (Heading2, 35, 7, 30, 0)
      CALL Put Str (Heading4, 9, 8, 30, 0)
      CALL Put Str (  Equal1,  3, 8, 27, 0)
C**********************************************************************
c*** 4/17/90 Added next call...
      CALL Set Menu Position ( Menu, 1)
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice .EQ. 'Variable  ') THEN
c***  Prompt the user for an indicator variable operand and then get
c***  the cutoff value which is a constant. 
	 Ready = .TRUE.
	 Choice = 'I OPERAND '
	 FromCol = Toggle (Choice) + 1
	 Choice = 'CUTOFF    '
c***     Set and display default value of 0 for cutoff value.
	 Cvalue = 0
	 CALL Set 4 Floating Point Value(Choice, Cvalue, 3)
         CALL Check Constant Input Overflow(Choice, Error)
	 IF (Error) GOTO 10
c***     Get the cutoff value specified by the user. 
	 CALL Get 4 Floating Point Value(Choice, Cvalue)
c*** 4/17/90 Added next call...
         CALL Set Menu Position ( Menu, 2)
      ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
	IF (.NOT. Ready) THEN
	  CALL Beep
	  CALL Flash(20, 2,
     +     'Error - Must first enter operand...(press any key)') 
	ELSE
	  Nerrors = 0
	  IF (.NOT. Error) THEN
c***	  Place 'Processing data...' on message line.
            CALL Put Str (Heading3, 18, 20, 2, 2)
c***        If the result variable is new then set the variable
c***        identifier 'ToCol' as follows else match Tmpvnam to the 
c***        existing variable and assign that column number to 'ToCol'.
	    IF (Newvar) THEN
	      ToCol = Nvar + 1
	    ELSE
	      DO 20 I = 1, Nvar
	        IF (Tmpvnam .EQ. Varnam(I)) THEN
	          ToCol = I
	          GOTO 30
	        ENDIF
  20	      CONTINUE
	    ENDIF
  30        CONTINUE  
c***	    The following Do Loop performs the indicator operation.
	    DO 35 I = 1,Ndata
c***        Examine each sample of the variable in question.
	      Value = Get Element(1,FromCol,I,MAXVAR)
	      IF (Vmiss(Value)) THEN
c***             If sample is a missing value then increment the
c***             missing value counter and assign a missing 
c***             value to the result variable.
	         Nerrors = Nerrors + 1
		 CALL Put Element(1,ToCol,I,MAXVAR,Value,Error)
		 IF (Error) GOTO 799
	      ELSE
		IF (Value .GT. Cvalue) THEN
c***              If the sample is .GT. the cutoff value then assign
c***              a zero to the corresponding sample of the result
c***              variable.
		  Value = 0.0
		  CALL Put Element(1,ToCol,I,MAXVAR,Value,Error)
		  IF (Error) GOTO 799
		ELSE
c***              If the sample is .LE. to the cutoff value then assign
c***              a one to the corresponding sample.
		  Value = 1.0
		  CALL Put Element(1,ToCol,I,MAXVAR,Value,Error)
		  IF (Error) GOTO 799
	        ENDIF
	      ENDIF
  35        CONTINUE
c***        Assign New Name and New Units to new result variable ***
	    IF (Newvar) THEN
	      Nvar = Nvar + 1
	      Varnam(Nvar) = Tmpvnam
	      Units(Nvar)  = Tunits
c***          Load the revised array into the toggle fields ***
              CALL Load New Toggle Values
	      CALL Display Variables
            ENDIF

c***        Issue message regarding number of missing values if applicable.	  
	    IF (Nerrors .GT. 0) THEN
	      Fldchoice = 'NERROR    '
	      CALL Set Integer Value(Fldchoice, Nerrors)
	      CALL Display One Field (Fldchoice)
	      Ch = ' missing values were generated in '''
	      CALL Put Str(Ch, 35, 20, 9, 2)
	      CALL Put Str(Varnam(ToCol), 10, 20, 44, 2)
	      CALL Flash(20, 54,
     +	         ''' (press any key )')
	      CALL Erase(20,2,70)
	    ENDIF

c***        Set FORTRAN output format to G8.1.
c*** 4/17/90 Changed commented line to a F8.6 format
            Formats(ToCol)(1:6) = 'G8.1  '
	    Newdata = .TRUE.
            CALL Flash (20, 2,
     +      ' Processing is complete...(press any key)')
c***        When calculation is performed (calcomp=.true.) then return
c***        to calling subroutine.
  799	    Calcomp = .TRUE.
	    CALL Clear Operation Box
	    RETURN
	  ENDIF
	ENDIF
      ELSE IF (Menu Choice .EQ. 'Quit      ') THEN
	CALL Erase (20, 2, 70)
	CALL Clear Operation Box
	RETURN
      ENDIF
      GOTO 10

      RETURN
      END
C**********************************************************************

