$LARGE
C*********************************************************************
C*** File Name: PLOT.FOR (Source code for the program XYGRAPH)
C*********************************************************************
C SUBROUTINE XYPLOT
C
C This routine opens the metacode file, then calls the routines to 
C determine the graph limits, set the AUTOGRAPH parameters, create 
C the plot and then display the graph.
C
	SUBROUTINE XYPLOT

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

        CHARACTER Blanks*50

        REAL tensn

	LOGICAL   Fexist, Error

        COMMON /intpr/ipau,fpart,tensn,np,small,l1,addlr,addtb,mlline,
     +              iclose
        COMMON /smflag/ ioffs

	Error = .FALSE.
      	Fexist = .FALSE.

C *** Open output Metacode File
	IF (File Prefix .NE. Blanks) Fexist = .TRUE.
	la = Lenstr(File Prefix)
        IF (Fexist) THEN
	   File Name = File Prefix(1:la)//Metacode File
    	ELSE
	   File Name = Metacode File
	ENDIF
        INQUIRE (FILE = File Name, Exist = Fexist)
	IF (Fexist) THEN
           OPEN(UNIT=8,STATUS='OLD',FILE=File Name,FORM='BINARY',
     +          RECL=1440)
        ELSE
           OPEN(UNIT=8,STATUS='NEW',FILE=File Name,FORM='BINARY',
     +	        RECL=1440)
        ENDIF
       
C *** Determine graph limits
        CALL Set Graph Limits

C *** Set AUTOGRAPH parameters
	CALL Set Parms

C *** Final setup and NCAR plot calls
        tensn = 30.
        isoff = 1
  	CALL Plot Curves

C *** Set up Metacode file for View 
        la = Lenstr(File Prefix)
	File Name = File Prefix(1:la)//Metacode File
 	CALL View (File Name,Error,Devcode)

        RETURN     
	END

C***********************************************************************
C SUBROUTINE SET GRAPH LIMITS
C
C This routine determines which data points are to be plotted by checking 
C the graph limit.
C
	SUBROUTINE Set Graph Limits

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE:'xygraph.cmn'
                                           
c        INTEGER*2 Iptr (Maxdata)
        REAL*4    Missing


        Missing = 1.E31


C *** Sort Array for plotting
c        IF (NData .EQ. 0) THEN
c           DO 10 i = 1, Ndatafile
c	      Iptr (i) = i
c 10        CONTINUE
c           CALL Qsort (Xcor, Iptr, Ndatafile)
c        ENDIF
   
        DO 20 j = 1,Num Curves
           DO 30 k = 1,Maxdata
              Xarr(k) = 0.
              Yarr(j,k) = 0.
  30       CONTINUE
 20     CONTINUE
                
        NData = 0        
C *** Determine values to use in plotting
        DO 40 l = 1,Num Curves
           num = 0
           DO 50 m = 1,Ndatafile
              IF ((Xcor(m) .GE. Xmin .AND. Xcor(m) .LE. Xmax) .OR.
     +             Xcor(m) .EQ. Missing) THEN
                 num = num + 1
                 Xarr (num) = Xcor(m)
c                 IF ((Ycor(l,Iptr(m)) .GE. Ymin .AND.
c     +                Ycor(l,Iptr(m)) .LE. Ymax) .OR.
c     +                Ycor(l,Iptr(m)) .EQ. Missing) THEN
c                    Yarr (l,num) = Ycor (l,Iptr(m))
                 IF ((Ycor(l,m) .GE. Ymin .AND.
     +                Ycor(l,m) .LE. Ymax) .OR.
     +                Ycor(l,m) .EQ. Missing) THEN
                    Yarr (l,num) = Ycor (l,m)
                 ELSE
                    Yarr (l,num) = Missing
                 ENDIF
              ENDIF  
  50       CONTINUE
 40     CONTINUE
        
        Ndata = num  
         
        RETURN
	END

C************************************************************************
C SUBROUTINE SET PARAMS
C
C This routine sets the AUTOGRAPH parameters for the graph background
C axes parmeters, titles, and labels. It calls Set Arg to set the
C X and Y axes arguments. 
C
	SUBROUTINE Set Parms

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

	CHARACTER*16  AGDSHN
        CHARACTER*50  Blanks        
        
C *** Set the general arguments(Background, line/max, label control)
	Read (Gen Args(1)(18:18),'(I1)') Iaval
	CALL AGSETI ('BACKGROUND.',Iaval)
	CALL AGSETI ('LINE/MAXIMUM.',60)
	CALL AGSETI ('LABEL/CONTROL.',2)
        CALL AGSETC ('LINE/END.','')

C *** Set the axes arguments
	CALL AGSETF ('X/NICE.',0.)
	CALL AGSETF ('Y/NICE.',0.)
	DO 10  i = 1,7
	   CALL Set Arg(Xaxis Args(i), 'X', i)
	   CALL Set Arg(Yaxis Args(i), 'Y', i)
 10     CONTINUE

C *** Set the minimum number of major tick marks to be placed on the axes
	CALL AGSETF ('AXIS/LEFT/MAJOR/COUNT.',1.)
	CALL AGSETF ('AXIS/BOTTOM/MAJOR/COUNT.',1.)
	CALL AGSETF ('AXIS/TOP/MAJOR/COUNT.',1.)
	CALL AGSETF ('AXIS/RIGHT/MAJOR/COUNT.',1.)

C *** Set tick marks pointing outwards
	CALL AGSETF ('AXIS/LEFT/MAJOR/OUTWARD.',.015)
	CALL AGSETF ('AXIS/BOTTOM/MAJOR/OUTWARD.',.015)
	CALL AGSETF ('AXIS/TOP/MAJOR/OUTWARD.',.015)
	CALL AGSETF ('AXIS/RIGHT/MAJOR/OUTWARD.',.015)
	CALL AGSETF ('AXIS/LEFT/MINOR/OUTWARD.',.010)
	CALL AGSETF ('AXIS/BOTTOM/MINOR/OUTWARD.',.010)
	CALL AGSETF ('AXIS/TOP/MINOR/OUTWARD.',.010)
	CALL AGSETF ('AXIS/RIGHT/MINOR/OUTWARD.',.010)

	CALL AGSETF ('AXIS/LEFT/MAJOR/INWARD.',0.)
	CALL AGSETF ('AXIS/BOTTOM/MAJOR/INWARD.',0.)
	CALL AGSETF ('AXIS/TOP/MAJOR/INWARD.',0.)
	CALL AGSETF ('AXIS/RIGHT/MAJOR/INWARD.',0.)
	CALL AGSETF ('AXIS/LEFT/MINOR/INWARD.',0.)
	CALL AGSETF ('AXIS/BOTTOM/MINOR/INWARD.',0.)
	CALL AGSETF ('AXIS/TOP/MINOR/INWARD.',0.)
	CALL AGSETF ('AXIS/RIGHT/MINOR/INWARD.',0.)


C *** Set the distance of labels from the bottom tickmarks
	CALL AGSETF ('BOTTOM/OF.',0.035)

C *** Set the character size for the numeric labels
	CALL AGSETF ('AXIS/LEFT/WIDTH/MANTISSA.',.03)
	CALL AGSETF ('AXIS/BOTTOM/WIDTH/MANTISSA.',.03)

	CALL AGSETF ('AXIS/LEFT/WIDTH/EXPONENT.',.025)
	CALL AGSETF ('AXIS/BOTTOM/WIDTH/EXPONENT.',.025)

C *** Set the axes scaling
	Read (Xaxis Args(8)(21:21),'(I1)') Xscal
	CALL AGSETI ('X/LOGARITHMIC.',Xscal)

	Read (Yaxis Args(8)(21:21),'(I1)') Yscal
	CALL AGSETI ('Y/LOGARITHMIC.',Yscal)

C *** Set title and axes labels
	CALL AGSETC ('LABEL/NAME.','T')
	CALL AGSETI ('LINE/NUMBER.',50)
	CALL AGSETC ('LINE/TE.',' ')
	
	CALL AGSETI ('LINE/NUMBER.',60)
	CALL AGSETC ('LINE/TE.',' ')

	CALL AGSETI ('LINE/NUMBER.',70)
	CALL AGSETC ('LINE/TE.',' ')

C *** Subtitle 2
	la = Lenstr(Lablin Args(3,3)) - 1
	CALL AGSETI ('LINE/NUMBER.',80)
	CALL AGSETF ('LINE/CHAR.',.04)
	CALL AGSETC ('LINE/TE.',Lablin Args(3,3)(16:la))

C *** Subtitle 1
	la = Lenstr(Lablin Args(2,3)) - 1
	CALL AGSETI ('LINE/NUMBER.',90)
	CALL AGSETF ('LINE/CHAR.',.045)
	CALL AGSETC ('LINE/TE.',Lablin Args(2,3)(16:la))

C *** Title 
	la = Lenstr(Lablin Args(1,3)) - 1
	CALL AGSETI ('LINE/NUMBER.',100)
	CALL AGSETF ('LINE/CHAR.',.05)
	CALL AGSETC ('LINE/TE.',Lablin Args(1,3)(16:la))

C *** X Label
        la = Lenstr(Lablin Args(4,3)) - 1
	CALL AGSETC ('LABEL/NAME.','B')
	CALL AGSETI ('LINE/NUMBER.',-100)
	CALL AGSETF ('LINE/CHAR.',.03)
	CALL AGSETC ('LINE/TE.',Lablin Args(4,3)(16:la))

C *** Y Label
	la = Lenstr(Lablin Args(5,3)) - 1
	CALL AGSETC ('LABEL/NAME.','L')
	CALL AGSETI ('LINE/NUMBER.',100)
	CALL AGSETF ('LINE/CHAR.',.03)
 	CALL AGSETC ('LINE/TE.',Lablin Args(5,3)(16:la))

C *** Set user arguments
c       IF (User Args (1) .NE. Blanks ) THEN
c          DO 20 j = 1,Maxuser
c             CALL Set User Args (User Args (j))
c  20      CONTINUE
c       ENDIF

C *** Set line and symbol pattern array
	CALL Set LinSym Pat

	RETURN
	END

C************************************************************************
C SUBROUTINE SET ARG (ARG, XY, INDEX) 
C
C Formal Arguments:
C  ARG      -  Indicates which AUTOGRAPH axis parameter to set.
C  XY       -  Axis parameters to set.
C  Index    -  Index number of the argument in the array of 
C              axes parameters.
C
C Local Variable:
C  Acid     -  Stores the argument name as a character.
C  Acval    -  Stores the argument value as a character.
C  Afval    -  Stores the argument value as a real number.
C
C This routined sets the AUTOGRAPH axes parameters that were 
C specified by the user and then sets parameters for the top and bottom
C axes.
C
	SUBROUTINE Set Arg (Arg, XY, Index)

	IMPLICIT INTEGER*4   (A-Z)

$INCLUDE:'xygraph.cmn'

        CHARACTER      Fmt*7, Acid*29, Acval*13
	CHARACTER*(*)  Arg

        INTEGER*4       Index 

	REAL*4	        Afval, Type, Base

C *** Determine the length of the argument, the position of the 
C *** comma, and the length of the value
	Larg = Lenstr (Arg)
	Lcma = Lencma (Arg)
	Lval = Larg - Lcma - 1

C *** Extract the argument name and value
	Acid = Arg(5:Lcma-2)
	Acval = Arg(Lcma+1:Larg-1)
        
C *** Set the argument
        IF (Acval .EQ. '1.E36') THEN
	   CALL AGSETF (Acid,1.E36)
           Type = 1.E36
           base = 1.E36
	ELSE
	   WRITE (Fmt, '(A2,I2,A3)') '(F', Lval, '.3)'
	   READ (Acval,Fmt) Afval
	   CALL AGSETF (Acid,Afval)
           Type = Afval
           base = Afval
	ENDIF

       
C ***	Set the top or right axis parameter according to those set for
C ***   the X or Y axis 
        IF (Index .EQ. 3) THEN
           IF (XY .EQ. 'X') THEN
              CALL AGSETF ('AXIS/TOP/MAJOR/TYPE.', type)
           ELSE
              CALL AGSETF ('AXIS/RIGHT/MAJOR/TYPE.', type)
           ENDIF
        ENDIF
      
        IF (Index .EQ. 4) THEN
           IF (XY .EQ. 'X') THEN
	      CALL AGSETF ('AXIS/TOP/MAJOR/BASE.', base)
           ELSE
	      CALL AGSETF ('AXIS/RIGHT/MAJOR/BASE.', base)
           ENDIF
        ENDIF

	RETURN
	END

C************************************************************************
C SUBROUTINE SET USER ARG (ARG) 
C
C Formal Arguments:
C  ARG      -  Indicates which AUTOGRAPH axis parameter to set.
C
C Local Variable:
C  Acid     -  Stores the argument name as a character.
C  Acval    -  Stores the argument value as a character.
C  Afval    -  Stores the argument value as a real number.
C
C This routined sets the AUTOGRAPH parameters that were 
C specified by the user.
C
        SUBROUTINE Set User Args (Arg)

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

	CHARACTER*(*)  Arg
	CHARACTER   Acval*10, Acid*29, Fmt*7
      
        INTEGER*4   Aival

        REAL*4      Afval

C *** Determine the length of the argument, the position of the 
C *** comma, and the length of the value
	Larg = Lenstr (Arg)
	Lcma = Lencma (Arg)
	Lval = Larg - Lcma - 1

C *** Extract the argument name and value
	Acid = Arg(5:Lcma-2)
	Acval = Arg(Lcma+1:Larg-1)
       
C *** Set the argument
        IF (Arg(1:1) .EQ. 'C' ) THEN
           CALL AGSETC (Acid,Acval)
        ELSE IF (Arg(1:1) .EQ. 'I') THEN
	   Write(Fmt,'(A2,I2,A1)') '(I', Lval, ')'
	   Read (Acval,Fmt) Aival
	   CALL AGSETI (Acid,Aival)
        ELSE
	   IF (Acval .EQ. '1.E36') THEN
              CALL AGSETF (Acid,1.E36)
           ELSE
	      Write(Fmt,'(A2,I2,A3)') '(G', Lval, '.3)'
	      Read (Acval,Fmt) Afval
	      CALL AGSETF (Acid,Afval)
	   ENDIF
        ENDIF

        RETURN
        END

C************************************************************************
C SUBROUTINE SET LINSYM PAT
C
C This routine establishes the plot pattern as a function of the user 
C specified combination of line and/or symbol types.

	SUBROUTINE Set LinSym Pat

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

	CHARACTER*16  Ltyp(7)
	CHARACTER*6   Styp(7)

	DATA (Ltyp(i),i=1,7) /'''''''''''''''''',
     +                        '$$$$$$$$$$$$$$$$',
     +                '$''$''$''$''$''$''$''$''',
     +                    '$$$''$$$''$$$''$$$''',
     +               '''''$''''$''''$''''$''''$',
     +                      '$$$$''$$$$''$$$$''',
     +                      '$$$$$$$''$$$$$$$'''/

	DATA (Styp(i),i=1,7) /'#032J%', '#032&%', '#032:%',
     +                     '#032''%','#032?%', '#032B%', '#0322%'/


C *** Get line and symbol types
	DO 10  i = 1,Num Curves
	   Read (Var Args(i,2)(27:27),'(I1)') Nlt
	   Read (Var Args(i,5)(19:22),'(A4)') Scode

	   CALL Set Stype (Scode, Nst)

C ***  Line only
	   IF (Nlt .NE. 0) THEN
	      IF (Nst .EQ. 0) Then
	         Dshp(i) = Ltyp(Nlt+1)
                 Pwr(i) = 0

C *** Line and symbol
	      ELSE
	         Dshp(i) = Ltyp(Nlt+1)
	         Idpc(i) = Styp(Nst+1)
	         Pwr(i) = 2
	      ENDIF
C *** Symbol only
	   ELSE
	      IF (Nst .NE. 0) THEN
	         Idpc(i) = Styp(Nst+1)
	         Pwr(i) = 1 
	      ELSE
	         Dshp(i) = Ltyp(2)
                 Pwr(i) = 0
	      ENDIF
	   ENDIF
 10     CONTINUE

	RETURN
	END


C************************************************************************
C SUBROUTINE PLOT CURVES
C
C This routine issues final setup calls to NCAR to plot the curves
C using PWRIT or AGCURV, depending on the previously determined
C combination of line and symbol types specified. Then calls 
C one on the routines to plot the legend if one is desired.
C
 	SUBROUTINE Plot Curves

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

	CHARACTER AGDSHN*16
               
        REAL*4  Yparr(Maxdata), Missing
c        REAL*4  ubga(4)
         
c      COMMON /AGCONP/ QFRA,QSET,QROW,QIXY,QWND,QBAC , SVAL ,
c     +                XLGF,XRGF,YBGF,YTGF , XLGD,XRGD,YBGD,YTGD , SOGD ,
c     +                MINX,MAXX,QLUX,QOVX,QCEX,XLOW,XHGH ,
c     +                MINY,MAXY,QLUY,QOVY,QCEY,YLOW,YHGH ,
c     +                QDAX(4),QSPA(4),PING(4),PINU(4),FUNS(4),QBTD(4),
c     +                BASD(4),QMJD(4),QJDP(4),WMJL(4),WMJR(4),QMND(4),
c     +                QNDP(4),WMNL(4),WMNR(4),QLTD(4),QLED(4),QLFD(4),
c     +                QLOF(4),QLOS(4),DNLA(4),WCLM(4),WCLE(4) ,
c     +                QODP,QCDP,WOCD,WODQ,QDSH(26) ,
c     +                     QDLB,QBIM,FLLB(10,8),QBAN ,
c     +                QLLN,TCLN,QNIM,FLLN(6,16),QNAN ,
c     +                XLGW,XRGW,YBGW,YTGW , XLUW,XRUW,YBUW,YTUW ,
c     +                XLCW,XRCW,YBCW,YTCW , WCWP,HCWP,SCWP ,
c     +                XBGA(4),YBGA(4),UBGA,XNDA(4),YNDA(4),UNDA,
c     +                QBTP(4),BASE(4),QMNT(4),QLTP(4),QLEX(4),QLFL(4),
c     +                QCIM(4),QCIE(4),RFNL(4),WNLL(4),WNLR(4),WNLB(4),
c     +                WNLE(4),QLUA(4) ,
c     +                RBOX(6),DBOX(6,4),SBOX(6,4)

        Missing = 1.E31
         

C *** Make final settings; plot curves
        CALL AGSETI ('FRAME.',2)  

        IF (Legend Position .EQ. 'Bottom') THEN
           CALL AGSETF ('GRID/LEFT.'  ,.15)
           CALL AGSETF ('GRID/RIGHT.' ,.95)
           CALL AGSETF ('GRID/BOTTOM.',.20)
           CALL AGSETF ('GRID/TOP.'   ,.80)  
        ELSE IF (Legend Position .EQ. 'Right ') THEN
           CALL AGSETF ('GRID/LEFT.'  ,.15)
           CALL AGSETF ('GRID/RIGHT.' ,.77)
           CALL AGSETF ('GRID/BOTTOM.',.10)
           CALL AGSETF ('GRID/TOP.'   ,.80)  
	ELSE
           CALL AGSETF ('GRID/LEFT.'  ,.15)
           CALL AGSETF ('GRID/RIGHT.' ,.95)
           CALL AGSETF ('GRID/BOTTOM.',.15)
           CALL AGSETF ('GRID/TOP.'   ,.80)  
        ENDIF
       
        CALL AGSETI ('DASH/SELECTOR.',6)
        CALL AGSETI ('DASH/LENGTH.',19)
        CALL AGSETF ('DASH/CHARACTER.',.02)
 
	CALL AGSETI ('WINDOW.',1)
	CALL AGSETI ('ROW.',-1)
	CALL AGSTUP (Xarr(1),1,0,NData,1,Yarr(1,1),1,0,
     +               NData,1)
	CALL AGBACK

	CALL Bndary

C *** Determine graph limits
c        XMax = UBGA (4)
c        YMax = UBGA (3)
c        CALL Set Graph Limits
 
	DO 10 i = 1,Num Curves
	   la = Lenstr(Var Args(i,6)) - 2
	   CALL OPTN ('COLOR',Var Args(i,6)(13:la))
	   IF (Pwr(i) .NE. 0) THEN
              CALL DASHD (Dshp(i),16,10,3.) 
              IF (Xarr (1)     .NE. Missing .AND.
     +            Yarr (i,1)   .NE. Missing ) 
     +           CALL PWRIT (Xarr(1),Yarr(i,1),Idpc(i),6,1,0,0)
              DO 15 j = 2,NData
                 IF (Pwr(i) .NE. 1) THEN
                    IF (Xarr (j)     .EQ. Missing .OR.
     +                  Yarr (i,j)   .EQ. Missing ) GOTO 15 
                    CALL PWRIT (Xarr(j),Yarr(i,j),Idpc(i),
     +                          6,11,0,0)
                    IF (Xarr (j)     .EQ. Missing .OR.
     +                  Xarr (j-1)   .EQ. Missing .OR.
     +                  Yarr (i,j)   .EQ. Missing .OR. 
     +                  Yarr (i,j-1) .EQ. Missing     ) GOTO 15
                    CALL LINED (Xarr(j-1),Yarr(i,j-1),Xarr(j),
     +                          Yarr(i,j))
                 ELSE                    
                    IF (Xarr (j)     .EQ. Missing .OR.
     +                  Yarr (i,j)   .EQ. Missing ) GOTO 15 
                    CALL PWRIT (Xarr(j),Yarr(i,j),Idpc(i),
     +   		 	6,1,0,0)
                 ENDIF
   15         CONTINUE
	   ELSE
              CALL DASHD (Dshp(i),16,10,3.)
              DO 16 j = 2,NData
                 IF (Xarr (j)     .EQ. Missing .OR.
     +               Xarr (j-1)   .EQ. Missing .OR.
     +               Yarr (i,j)   .EQ. Missing .OR. 
     +               Yarr (i,j-1) .EQ. Missing     ) GOTO 16
                 CALL LINED (Xarr(j-1),Yarr(i,j-1),Xarr(j),
     +                       Yarr(i,j))
   16         CONTINUE

C*** The following line were taken out because of a problem in the
C*** AUTOGRAPH routine AGCURV
c              write (*,*) dshp(i)
c              CALL AGSETC (AGDSHN(i),Dshp(i))
c              write (*,*) 'called agsetc'
c	      DO 16 j = 1,Maxdata
c	         Yparr(j) = Yarr(i,j)
c                 IF (j .GT. Ndata) Yparr(j) = 1.E36
c   16         CONTINUE
c              write (*,*) 'off to agcurv'
c	      CALL AGCURV (Xarr(1),1,Yparr(1),1,Maxdata,i)
c              write (*,*) 'back from agcurv'

	   ENDIF
  10    CONTINUE
        IF (Regression .EQ. 'Yes') THEN
	    DO 20 j = 1,NData
	       Yparr(j) = Yarr(1,j)
  20        CONTINUE
            CALL Regress(Xarr,Yparr)
        ENDIF

        IF (Legend Position .EQ. 'Bottom') CALL Plot BLegend
        IF (Legend Position .EQ. 'Right ') CALL Plot RLegend


  	CALL FRAME
   
	RETURN
	END

C************************************************************************
C SUBROUTINE PLOT RLEGEND
C
C This routine plots a legend at the right of the graph.
C
       	SUBROUTINE Plot RLegend 

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

       	CHARACTER  Varname*10

        REAL*4  Row, Col
 
        CALL SET(.80,1.,.60,.85,0.,6.,0.,6.,1)
        Row = 5.0
        Col = 4.
        DO 20 i = 1, Num curves
           Varname = VAR ARGS(i,1)
           CALL Left Justify (VarName)
           CALL OPTN ('COLOR',Var Args(i,6)(13:la))
           CALL PWRIT (.1,ROW,Varname,10,15,0,-1)

           IF (Pwr(i) .NE. 0) THEN
              CALL PWRIT (Col,Row,Idpc(i),6,2,0,0)
              IF (Pwr(i) .NE. 1) THEN
                 CALL DASHD (Dshp(i),19,10,3.)                 
                 CALL PWRIT (Col+1.5,Row,Idpc(i),6,2,0,0)
                 CALL LINED (Col,Row,Col+1.5,Row)
              ELSE                    
                 CALL PWRIT (Col,Row,Idpc(i),6,2,0,0)
              ENDIF
           ELSE
              CALL DASHD (Dshp(i),19,10,3.)                 
              CALL LINED (Col,Row,Col+1.5,Row)
           ENDIF
        
           Row = Row - 1.0
  20    CONTINUE
 
        RETURN
        END  

C*********************************************************************
C SUBROUTINE PLOT BLEGEND
C
C This routine plots a legend at the bottom of the graph.
C


	SUBROUTINE Plot BLegend 

	IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'XYGRAPH.CMN'

 	CHARACTER  Varname*10

        REAL*4  Row, Col
 
        CALL SET(.15,.95,0.,.17,0.,6.,0.,6.,1)
        DO 20 i = 1, Num curves
           IF ((i .EQ. 1) .or. (i .EQ. 3) .or. (i .EQ. 5)) THEN
              Row= 3.0
           ELSE
              Row = Row - 1.
           ENDIF
           IF ((i .EQ. 1) .or. (i .EQ. 2)) THEN
              Col=.01
           ELSE IF ((i .EQ. 3) .or. (i .EQ. 4)) THEN
              Col= 2.01
           ELSE 
              Col= 4.01
           ENDIF
        
           Varname = Var Args(i,1)
           CALL Left Justify (Varname)
           CALL OPTN ('COLOR',Var Args(i,6)(13:la))
           CALL PWRIT (Col*1.,Row,Varname,10,15,0,-1)
       	
           IF (Pwr(i) .NE. 0) THEN
              CALL PWRIT (Col+1.,Row,Idpc(i),6,2,0,0)
              IF (Pwr(i) .NE. 1) THEN
                 CALL DASHD (Dshp(i),19,10,3.)                 
                 CALL PWRIT (Col+1.5,Row,Idpc(i),6,2,0,0)
                 CALL LINED (Col+1.,Row,Col+1.5,Row)
              ELSE                    
                 CALL PWRIT (Col+1.,Row,Idpc(i),6,2,0,0)
              ENDIF
     	   ELSE
              CALL DASHD (Dshp(i),19,10,3.)                 
              CALL LINED (Col+1.,Row,Col+1.5,Row)
          ENDIF
  20    CONTINUE

        RETURN
        END  

C***********************************************************************
C SUBROUTINE BNDARY 
C
C This routine draws the frame around the graph.
C
        SUBROUTINE Bndary

	CALL PLOTIT (    0,    0,0)
	CALL PLOTIT (32767,    0,1)
	CALL PLOTIT (32767,32767,1)
	CALL PLOTIT (    0,32767,1)
	CALL PLOTIT (    0,    0,1)

	RETURN
	END

C************************************************************************
C FUNCTION LENCMA (STRING)
C 
C Formal Arguments:
C  STRING  - Character sting. 
C
C This routine returns the location of the right-most comma in a string.
C Used for parsing Autograph arguments.
C 
	INTEGER*4 FUNCTION Lencma (String)
 
	CHARACTER  String*(*)
 
	n = len(String)
 
	DO 10 i = n,1,-1
	   IF (String(i:i) .EQ. ',') Then
	      Lencma = i
	      RETURN
	   ENDIF 
  10    CONTINUE
 
	Lencma = 0
 
	RETURN
	END

C***********************************************************************
C SUBROUTINE QSORT (A,P,N) 
C 
C Formal Arguments:
C  A  - Array that contains sample data.
C  P  - Integer array.
C  N  - Number of samples in A.
C
C This routine sorts the array  A into ascending order.  The original
C position of the sample data is preserved in the array P.  After A is
C sorted the original position of the sample datum contained in  A(1)
C is found in P(1).
C
	SUBROUTINE Qsort (A,P,N)

	IMPLICIT INTEGER*4 (A-Z)
	REAL*4 A(1), T, T1
	INTEGER*2 P(1)
        INTEGER*4 N
	DIMENSION LOWER(100), UPPER(100)

	M	= 1
	I1	= 1
	J1	= N
	I	= I1
	J	= J1

 10	IF (I .GE. J) GOTO 110
 20	K = I
	I2 = INT ((J + I)/2)
C-------------------------------
	T = A(I2)
	TP = P(I2)
C-----------------------
	IF (A(I) .LE. T) GOTO 30
C-----------------------
	A(I2) = A(I)
	P(I2) = P(I)
	A(I) = T
	P(I) = TP
	T = A(I2)
	TP = P(I2)
C-----------------------
 30	L = J
	IF (A(J) .GE. T) GOTO 40
C-----------------------
	A(I2) = A(J)
	P(I2) = P(J)
	A(J) = T
	P(J) = TP
	T = A(I2)
	TP = P(I2)
C-----------------------
	IF (A(I) .LE. T) GOTO 40
C-----------------------
	A(I2) = A(I)
	P(I2) = P(I)
	A(I) = T
	P(I) = TP
	T = A(I2)
	TP = P(I2)
C-----------------------
 40	L = L - 1
	IF (A(L) .GT. T) GOTO 40
C-----------------------
	T1 = A(L)
	TP1 = P(L)
C-----------------------
 50	K = K + 1
	IF (A(K) .LT. T) GOTO 50
	IF (K .GT. L) GOTO 60
C-----------------------
	A(L) = A(K)
	P(L) = P(K)
	A(K) = T1
	P(K) = TP1
C------------------------
	GO TO 40

 60	IF (L-I .LE. J-K) GOTO 70
	LOWER(M) = I
	UPPER(M) = L
	I = K
	M = M+1
	GOTO 80
 70	LOWER(M) = K
	UPPER(M) = J
	J = L
	M = M+1
 80	IF (J-I .GE. I1) GOTO 20
	IF (I .EQ. I1) GOTO 10
	I = I-1
 90	I = I+1
	IF (I .EQ. J) GOTO 110
C-----------------------
	T = A(I+1)
	TP = P(I+1)
C-----------------------
	IF (A(I) .LE. T) GOTO 90
	K = I
C-----------------------
 100	A(K+1) = A(K)
	P(K+1) = P(K)
C-----------------------
	K = K-1
	IF (T .LT. A(K)) GOTO 100
C------------------------
	A(K+1) = T
	P(K+1) = TP
C------------------------
	GOTO 90
 110	M = M - 1
	IF (M .EQ. 0 ) GOTO 999
	I = LOWER(M)
	J = UPPER(M)
	GO TO 80
 
999	RETURN
	END	


