$LARGE
C*********************************************************************
C*** File Name: READDATA.FOR (Source code for the program XYGRAPH)
C*********************************************************************
C SUBROUTINE READ HEADER DATA (ERROR,SET SCREEN)
C
C Formal Arguments:
C  ERROR       - Logical variable set to true if an error occurs.
C  SET SCREEN  - Logical variable set to true if the screen fields are
C                to be set.
C
C This routine reads in the header information from the data file
C and then sets the screen fields. If an error occurs will reading
C the file an error message is displayed.
C
        SUBROUTINE Read Header Data (Error, Set Screen)

        IMPLICIT INTEGER*4 (A-Z)

$INCLUDE: 'SCREEN.STR'
$INCLUDE: 'XYGRAPH.CMN'
         
 	LOGICAL*1 ERROR , Set Screen
          


        CALL Putstr ('Reading Header Data       ',25,20,2,2)

C *** Open Data File
 
	Nunit = 12
	Stat = 'OLD'

	CALL Open File (Nunit, File Name, Stat, Openerr)
        IF (Openerr .ne. 0) THEN
           Text = 'Problem opening data file'
           CALL Flash (20, 2, Text)
           RETURN
        ENDIF

C *** Read header string into default title 

	READ(Nunit,'(A)',ERR = 999, END = 999) Titl

C *** Get number of variables

	READ(Nunit,*, ERR = 999, END = 999) Nvar
	IF (Nvar .LT. 2) THEN
	   Text = 'Too few variables in file (press any key)'
	   CALL Flash ( 20,2, Text)
	   GOTO 999
        ELSE IF (Nvar .GT. Maxvarfile) THEN
	   Text = 'Too many variables in file (press any key)'
	   CALL Flash (20,2,Text)
	   GOTO 999
	ENDIF

C *** Read variables names and units

	DO 10 i = 1,Nvar
	   Read(Nunit,'(2A10)',ERR=999,END=999) Vname(i), Vunit(i)
   10   CONTINUE

C *** Set variable XVAR name toggles for screen
        f = Fld Index ('XVAR      ')
        SC Members (f) = Nvar

        DO 60 i = 1,Nvar
	   CALL Set Toggle Value('XVAR',i-1,Vname(i))
   60   CONTINUE


C *** Set variables YVAR name toggles for screen
	DO 70 i = 1,Maxvar
	   Write(Yvarcod,'(A7,I1)') 'Y VAR C', i
           f = Fld Index (Yvarcod)
	   SC Members (f) = Nvar + 1
	   IF (i .LE. Num Curves .AND. i .LE. Nvar) THEN 
              CALL Set Toggle Position (Yvarcod, i+1)
	   ELSE
              CALL Set Toggle Position (Yvarcod, 0)
           ENDIF   
           DO 75  Position = 1, Nvar
	      CALL Set Toggle Value(Yvarcod,Position,Vname(Position)) 
   75      CONTINUE
 70     CONTINUE
       
C *** Set screen fields
        IF (Set Screen) THEN
           Call Set Character Value ('TITLE     ',Titl)
        ELSE
	   DO 80 i = 1, Num Curves
              WRITE(Yvarcod,'(A7,I1)') 'Y VAR C', i
              DO 85 j=1,Nvar
                 IF (Vname (j) .EQ. Ind Var) 
     +              CALL Set Toggle Position ('XVAR      ',j-1)
                 IF (Vname(j) .EQ. Var args (i,1)(1:10)) 
     +              CALL Set Toggle Position(Yvarcod,j) 
  85          CONTINUE
 80        CONTINUE
        ENDIF

	CLOSE (Nunit)
        CALL Display Flds
        
        RETURN

 999	Error = .TRUE.
        CLOSE (Nunit)
        CALL Beep
	CALL Putstr (' ERROR reading data file ... ',28, 9,49,2)
	CALL Putstr ('An ERROR was encountered in  ',28,11,49,0)
	CALL Putstr ('the header section of the    ',28,12,49,0)
	CALL Putstr ('data file.  Check the file   ',28,13,49,0)
	CALL Putstr ('name, and that the file named',28,14,49,0)
	CALL Putstr ('had the standard data file   ',28,15,49,0)
        CALL Putstr ('format.  Consult the Users   ',28,16,49,0)
	CALL Putstr ('Manual for information about ',28,17,49,0)
	CALL Putstr ('file format.                 ',28,18,49,0)
	CALL Flash (20,2, 'Press any key to exit')
	CALL Erase Field ('DATA FILE ')
        CALL Erase Message(9,47,31)
	Nvar = 0
	 
        RETURN
	END

C***********************************************************************
C SUBROUTINE GET DATA (SET SCREEN)
C
C Formal Arguments:
C  SET SCREEN  - Logical variable set to true if the screen fields are
C                to be set.
C
C This routine reads in the values for the variables selected and 
C determines the minimum/maximum values.
C
        SUBROUTINE Get Data (Set Screen)

	IMPLICIT INTEGER*4  (A-Z)

$INCLUDE:'xygraph.cmn'

        CHARACTER    Blanks*50, Dummy*75
	INTEGER*4    Yvar Pos (Maxvar)
        
        REAL*4       Missing, Dvalue(Maxvarfile)
      
        LOGICAL*1    Set Screen
	CALL Putstr ('Reading Data Values ...  ',25,20,2,2)

        Xlog = .TRUE.

C *** Blank variable work arrays

	DO 5  i = 1,Maxvar
           Ylog(i) = .TRUE.
  5     CONTINUE

C *** Identify selected X variable

	Xpos  = Toggle Position ('XVAR      ') + 1

C *** Identify selected Y-variables.

        Nsel = 0
        j = 1 
	DO 10  i = 1,Maxvar
	   Write(Yvarcod,'(A7,I1)') 'Y VAR C', i
 	   Ypos = Toggle Position (Yvarcod)
           IF (Ypos .NE. 0) THEN
              NSel = NSel + 1
              Yvar pos (j) = Ypos 
              j = j + 1
           ENDIF
   10   CONTINUE

C *** Check number of Yvar selected; must = num curves
        IF (Nsel .ne. Num Curves) THEN
           Num Curves = Nsel
        ENDIF

C *** Get File Name
        IF (File Prefix .NE. Blanks) THEN
	   la = Lenstr(File Prefix)
	   File Name = File Prefix(1:la)//Data File
	ELSE
	   File Name = Data File
        ENDIF

C *** Open input file
        Nunit = 10
	Stat = 'OLD'

	CALL Open File (Nunit, File Name, Stat, Openerr)
	IF (Openerr .NE. 0 ) THEN
	   Text = 'Problem opening data file'
	   CALL Flash (20,2,Text)
	   RETURN
	ENDIF

C *** Read Header string
        READ (Nunit, '(A)',ERR= 999, END =999) Dummy

C *** Get number of variables in file
        READ (Nunit, *, ERR= 999, END = 999) Nvar

C *** Get variable names
        DO 30 i = 1, Nvar
	   READ (Nunit,'(2A10)',ERR=999,END=999) Dummy, Dummy
  30    CONTINUE

C *** Read variable values
        Ndata = 0
        Ndatafile = 0
        Missing = 1.E31
   
        Xmin = 1.E30
	Xmax = -1.E30

	Ymin = 1.E30
	Ymax = -1.E30

        DO 40 j = 1, Maxdata
   	   READ (Nunit,*,END = 900,ERR=999) (Dvalue(i),i=1,Nvar)
	   DO 50 k = 1,Num Curves
C	      IF (Dvalue (Xpos) .LT. Missing .AND.
C     +	          Dvalue (Yvar Pos(k)) .LT. Missing) THEN
                 IF ( k .EQ. 1) Ndatafile = Ndatafile+1
                 IF (Dvalue (Xpos) .LE. 0 ) Xlog = .FALSE.
                 IF (Dvalue (Yvar Pos (k)) .LE. 0) Ylog(k) = .FALSE.
                 Xcor(Ndatafile) = Dvalue(Xpos)
	         Ycor(k,Ndatafile) = Dvalue(Yvar Pos(k))
	         IF (Xcor (Ndatafile) .LT. Missing .AND.
     +               Ycor (k,Ndatafile) .LT. Missing) THEN
                    Xmin = AMIN1(Xcor(Ndatafile), Xmin)
	            Ymin = AMIN1(Ycor(k,Ndatafile), Ymin)

	            Xmax = AMAX1(Xcor(Ndatafile), Xmax)
	            Ymax = AMAX1(Ycor(k,Ndatafile), Ymax)
                 ENDIF
C	      ENDIF
  50       CONTINUE
 40     CONTINUE

C *** Check if more than Maxdata records
        READ (Nunit,*,END=900,ERR=999) (Dvalue(i), i=1,Nvar)
	CALL Beep
	CALL Putstr('The number of records in ',25,11,49,0)
	CALL Putstr('the data file exceeds the',25,12,49,0)
	CALL Putstr('program limits.  Only the',25,13,49,0)
	CALL Putstr('maximum number of allowed',25,14,49,0)
        CALL Putstr('of coordinate values have',25,15,49,0)
	CALL Putstr('been stored in memory,   ',25,16,49,0)
	CALL Putstr('the rest will not be used.',26,17,49,0)
	CALL Flash (20,2, 'Press any key to continue ')
	CALL Erase Message (10,47,31)
 900    CLOSE (Nunit)

C *** Set screen defaults
        IF (Set Screen) THEN
           IF (XMax .EQ. -1E30 .OR. Ymax .EQ. -1E30) GOTO 999     
           CALL Set 4 Floating Point Value ('MIN X     ',Xmin,3)
	   CALL Set 4 Floating Point Value ('MAX X     ',Xmax,3)

	   CALL Set 4 Floating Point Value ('MIN Y     ',Ymin,3)
	   CALL Set 4 Floating Point Value ('MAX Y     ',Ymax,3)
        ENDIF

        CALL Display Flds
        RETURN

 999    CLOSE (Nunit)
        CALL Beep
	CALL Putstr (' ERROR reading data file ... ',28, 9,49,2)
	CALL Putstr ('An ERROR was encountered in  ',28,11,49,0)
	CALL Putstr ('the data section of the  data',28,12,49,0)
	CALL Putstr ('file.  Check the file name,  ',28,13,49,0)
	CALL Putstr ('and that the file named had  ',28,14,49,0)
	CALL Putstr ('the standard data file format',28,15,49,0)
        CALL Putstr ('Consult the Users Manual for ',28,16,49,0)
	CALL Putstr ('information about file format.',29,17,49,0)
	CALL Flash (20,2, 'Press any key to exit')
 	CALL Erase Field ('DATA FILE ')
	CALL Erase Message(9,47,31)
        Nvar = 0
        Ndatafile = 0
        Ndata = 0
        RETURN
	END


 
 



