#!/bin/sh

if test $# -eq 0
then
	cat << \end_of_usage

	Usage:	bin/setup.sh -write

	This will write the necessary variables to the .cshrc and .kshrc
files.  You should only run this from the directory where the stuff is
installed: otherwise you'll be in trouble!

end_of_usage
	exit 1
elif test $1 != -write
then
	cat << end_of_usage

	Unknown option: $1

	Usage:	setup.sh -write

end_of_usage
	exit 2
fi

geodir=`pwd`

if test -d vario && test -d xvalid
then
	echo "okay, vario and xvalid exist anyway..."
	echo "GEO_EAS home is set at: "$geodir
else
	echo "Sorry: vario and/or xvalid aren't here: aborting..."
	exit 3
fi

cat << end_of_csh_change >> $HOME/.cshrc
setenv GEO_EAS $geodir
alias geoeas \$GEO_EAS/bin/geoeas
end_of_csh_change

cat << end_of_ksh_change >> $HOME/.kshrc
typeset -x GEO_EAS=$geodir
alias -x geoeas=\$GEO_EAS/bin/geoeas
end_of_ksh_change


