#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include "theIcon"

extern Display *theDisplay;
extern int theScreen;
extern int theDepth;

#define BORDER_WIDTH 2

Window openWindow(x,y,width,height,flag)
{
  XSetWindowAttributes theWindowAttributes;
  XSizeHints theSizeHints;
  unsigned long theWindowMask;
  Window theNewWindow;
  Pixmap theIconPixmap;
  XWMHints theWMHints;

  theWindowAttributes.border_pixel=
    BlackPixel(theDisplay,theScreen);
  theWindowAttributes.background_pixel=
    WhitePixel(theDisplay,theScreen);
  theWindowAttributes.override_redirect=True;
  theWindowMask=CWBackPixel | CWBorderPixel | CWOverrideRedirect;

  theNewWindow=
    XCreateWindow(theDisplay,
		  RootWindow(theDisplay,theScreen),
		  x,y,
		  width,height,
		  BORDER_WIDTH,
		  theDepth,
		  InputOutput,
		  CopyFromParent,
		  theWindowMask,
		  &theWindowAttributes);

  theIconPixmap=
    XCreateBitmapFromData(theDisplay,
			  theNewWindow,
			  theIcon_bits,
			  theIcon_width,
			  theIcon_height);
  theWMHints.icon_pixmap=theIconPixmap;
  theWMHints.initial_state=NormalState;
  theWMHints.flags=IconPixmapHint | StateHint;
  
  XSetWMHints(theDisplay, theNewWindow, &theWMHints);

  theSizeHints.flags=PPosition|PSize;
  theSizeHints.x=x;
  theSizeHints.y=y;
  theSizeHints.width=2*width;
  theSizeHints.height=2*height;
  XSetNormalHints(theDisplay,  theNewWindow, &theSizeHints);
  XMapWindow(theDisplay, theNewWindow);
  XFlush(theDisplay);
  return(theNewWindow);
}

	
