
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xproto.h>
#include <X11/keysym.h>
#include <X11/keysymdef.h>

#define CHUNK	128
#define PI	3.141529

static float xincr;
static float yincr;

int colr;
float hsize,vsize;
float xdiff, ydiff;
float xshift, yshift;
float CURX, CURY;
float worldxmin, worldxmax, worldymin, worldymax;
int xi, yi;
static int t=0, b, l=0, r;
static int xxpost,yypost;
char theCurrentColor[64];
char theCurrentFont[64];
FILE *infile;
FILE *outfile;
int ps_on=0;

Window          theWindow, openWindow();
GC              theGC;
Display         *theDisplay;


XWindowAttributes theAttribs;
XFontStruct     *fontStruct;
XConfigureEvent theConfigureEvent;
Colormap        theColormap;
int             theScreen;
int             theDepth;
unsigned long   theBlackPixel;
unsigned long   theWhitePixel;
char            theDisplayName[128];
char            theGeometry[128];
char            theTitle[128];
char            theFontName[128];
int             theFontNameOverride=0;
int             geometryStatus;
int	        theGeometryOverride=0;
int             iconicState;
int             xpost,ypost,width,height;
float           label_angle;
#define			maxPixels	66
unsigned long		thePixels[ maxPixels ];
char			*theColorNames[ maxPixels ];
int argc;
char *argv[10];

unsigned int line_width = 0;
int line_style = LineSolid;
int cap_style = CapButt;
int join_style = JoinMiter;


void init_(argnum,argvlen,argvname,argvsize)
     int *argnum, *argvlen[10], argvsize;
     char *argvname;
{


  int i, j, col_length;
  int errorHandler();
  char *ptr;

  argc=*argnum;
  col_length = (int)argvname;
  argv[0] = col_length;
  j = 0;
  for (i=0;i<argc;i++)
    {
      j = (int)argvlen[i];
      col_length = col_length + j;
      ptr = col_length;
      *ptr =  (char) NULL;
      argv[i+1] = ptr+1;
      col_length++;
    }

  theGeometryOverride = 0;
  XSetErrorHandler( errorHandler);
  iconicState=getArguments(argc, argv,
			   theDisplayName,
			   theGeometry,
			   theFontName,
			   theTitle);

  initX(theDisplayName);

  geometryStatus=XParseGeometry(theGeometry,&xpost,&ypost,&width,&height);
  if (theGeometryOverride)
    {
      if(!(geometryStatus&WidthValue)) 	  {if (!r) r=800;}
      else	  r= width;
      if(!(geometryStatus&HeightValue))	  {if (!b) b=600;}
      else  b=height;
      xxpost = xpost;
      yypost = ypost;
    }
  else if (!r || !b) 
	{
	  r=width;
	  b=height;
	  xxpost = xpost;
	  yypost = ypost;
	}
/* 6/28/93 */

  theWindow=openWindow
    (xxpost,yypost,r,b,0,theTitle,iconicState,theFontName,&theGC); 

  initDefaultColors();  
  strcpy(theCurrentColor,"black");  

  initEvents(theWindow);

  /*  system("sleep 5"); */
}

init_size()
{
  XWindowChanges changes;
  unsigned int changemask;
  int xggx, xggy;
  unsigned int xggd, xggw, xggh, xggbw;

  XGetGeometry
    (theDisplay, theWindow, &theWindow, xggx, xggy, xggw, xggh, xggbw, xggd);
  printf("%d %d %d %d %d %d \n", xggx, xggy, xggw, xggh, xggbw, xggd);
  changemask = 0;
  changes.x = xggx - 10;
  changemask |= CWX;
  XConfigureWindow(theDisplay, theWindow, changemask, &changes);
}


z_window_report_(rback)
int *rback;
{
  *rback = r;
}

zclear_()
{
  unsigned int nwide, nhigh;
  int i;

  refresherWindow( theWindow);

  if (ps_on) 
    fprintf(outfile,"/Courier-Bold findfont 14 scalefont setfont \n");
  if ( ! theFontNameOverride) 
    {
      if (r < 400) i = 8;
      else if (r < 500) i = 10;
      else if (r < 700) i = 12;
      else if (r < 800) i = 14;
      else if (r < 900) i = 17;
      else if (r < 1000) i = 18;
      else  i = 20;
      zfontnumber_(&i);
    }
  else fontStruct = initFont( theGC, theFontName);
  setColorWithName( theGC,"black");  

  nwide=r-l;
  nhigh=b-t;
  XFillRectangle(theDisplay,theWindow,theGC,l,t,nwide,nhigh);
  XFlush(theDisplay);

  setColorWithName( theGC,theCurrentColor);  
  XFlush(theDisplay);
}


zscale_(xmin,xmax,ymin,ymax) 
float *xmin,*xmax,*ymin,*ymax;
{
  worldxmin=*xmin;
  worldxmax=*xmax;
  worldymin=*ymin;
  worldymax=*ymax;
  xdiff = *xmax - *xmin;
  ydiff = *ymax - *ymin;
  xincr = 0;
  yincr = 0;
  if (xdiff != 0.0) xincr = (float)(r-l) / xdiff;
  if (ydiff != 0.0) yincr = (float)(t-b) / ydiff;
  xshift = (float)l - xincr * *xmin;
  yshift = (float)b - yincr * *ymin;

  hsize = 1.0;
  vsize = 1.0 * (float)b / (float)r;

}

zgetworld_(xmin,xmax,ymin,ymax) 
float *xmin,*xmax,*ymin,*ymax;
{
  *xmin=worldxmin;
  *xmax=worldxmax;
  *ymin=worldymin;
  *ymax=worldymax;
}


size_(x,y)
float *x, *y;
{
  int i, j;
  hsize = *x;
  vsize = *y;
}


zmove_(x,y)
float *x,*y; 
{
  int i;

  CURX = *x;
  CURY = *y;
  xi = (int)(CURX * xincr + xshift);
  yi = (int)(CURY * yincr + yshift);
  if (ps_on) 
    {
      i = 1.5*b - yi;
      fprintf(outfile,"s\nn\n%d %d m\n",xi,i);
    }
}


zplot_(x,y)
float *x,*y;
{
  float from_x,from_y;
  float to_x,to_y;
  int from_xi, from_yi;
  int to_xi, to_yi;

  from_x = CURX;
  from_y = CURY;
  to_x = *x;
  to_y = *y;
  from_xi = (int)(from_x * xincr + xshift);
  from_yi = (int)(from_y * yincr + yshift);
  to_xi = (int)(to_x * xincr + xshift);
  to_yi = (int)(to_y * yincr + yshift);
  drawLine(theWindow,theGC,from_xi,from_yi,to_xi,to_yi);
  CURX = *x;
  CURY = *y;
  xi = to_xi;
  yi = to_yi;
  if (ps_on) 
    {
      to_yi = 1.5*b - to_yi;
      fprintf(outfile,"%d %d l\n",to_xi,to_yi);
    }
}


zsplot_(x,y,ink,splottype)
float *x,*y;
int *ink,*splottype;
{
  float from_x,from_y;
  int from_xi, from_yi, from_wide, from_type;

  from_wide = *ink;
  from_type = *splottype;
  from_x = CURX;
  from_y = CURY;
  from_xi = (int)(from_x * xincr + xshift);
  from_yi = (int)(from_y * yincr + yshift);
  if (from_type == 1) 
    {
      XFillArc (theDisplay,theWindow,theGC,
		from_xi,from_yi,from_wide,from_wide,0,360*64);
    }
  else 
    {
      XFillRectangle (theDisplay,theWindow,theGC,
	     from_xi,from_yi,from_wide,from_wide);
    }
  if (ps_on) 
    {
/*
      fprintf(outfile,"zsplot \n");
*/
      from_yi = 1.5*b - from_yi;
      from_wide = *ink-1;
      if (from_wide < 7 && from_wide > 0) 
	{
	  fprintf(outfile,"%d %d %dbullet \n s \n n \n"
		  ,from_xi,from_yi,from_wide);
	}
      else 
	{
	  fprintf(outfile,"%d %d 1bullet \n s \n n \n",from_xi,from_yi);
	}
    }
  zmove_(x,y);
}


colornumber_(num)
int *num;
{
  int color_num;

  color_num = *num;
  while (color_num > maxPixels) color_num = color_num - maxPixels;
  setColor( theGC, color_num);  
  XFlush(theDisplay);
}


/* 
color_(col,col_length)
char *col;
int  col_length;
{
  char temp,colr[maxPixels];

  temp = col[col_length];
  col[col_length] = NULL;
  sscanf(col,"%s",colr);
  sscanf(col,"%s",theCurrentColor); 
  setColorWithName( theGC, colr);  
  col[col_length] = temp;
  XFlush(theDisplay);
}
*/

color_(col,col_length)
char *col;
int  col_length;
{
  char temp,colr[maxPixels];
  char *ptr_r,*ptr_l;

  andyf("color in");
  for (ptr_r=&col[col_length-1]; *ptr_r == ' '; ptr_r--);
  andyf("c2");
  ptr_r++;
  ptr_l = col;
  if (ptr_r > col) 
    {
      andyf("c3");
      temp = *ptr_r;
      ptr_r = NULL; 
      sscanf(ptr_l,"%s",colr);
      sscanf(col,"%s",theCurrentColor); 
      setColorWithName( theGC, colr);  
      XFlush(theDisplay);
      ptr_r = &temp; 
    }
  andyf("color out");
}

andyf(label)
     char *label;
{
  /*
  printf(label);
  printf("\n");
  */
}

zlabelold_(label,label_length)
char *label;
int  label_length;
{
  float spacing;
  char temp, *ptr_r;
  int i;
  if (!label_angle)
    {
      XDrawString(theDisplay,theWindow,theGC,xi,yi,label,label_length);
      XFlush(theDisplay);
      if (ps_on)
	{
	  for( ptr_r=&label[label_length-1]; *ptr_r == ' '; ptr_r--);
	  ptr_r++;
	  if (ptr_r > label) 
	    {
	      temp = *ptr_r;
	      /* *ptr_r = (char) NULL; */
	      ptr_r = NULL; 
	      fprintf(outfile,"(%s) ltext \n",label);
	      /* *ptr_r = temp; */
	      ptr_r = &temp; 
	    }
	}
    }
  else
    {
      spacing=0.0;
      dir_text_(&label_angle,&spacing,label,label_length);
    }
}

zlabel_(label,label_length)
char *label;
int  label_length;
{
  float spacing;
  char temp, *ptr_r;
  int i;
  if (!label_angle)
    {
      XDrawString(theDisplay,theWindow,theGC,xi,yi,label,label_length);
      XFlush(theDisplay);
      if (ps_on)
	{
	  ptr_r=&label[label_length];
	  temp = *ptr_r;
	  label[label_length]=NULL;
	  fprintf(outfile,"(%s) ltext \n",label);
	  label[label_length]=temp;
	}
    }
  else
    {
      spacing=0.0;
      dir_text_(&label_angle,&spacing,label,label_length);
    }
}

zcenterlabel_(label,label_length)
     char *label;
     int  label_length;
{
  int i;
  float shift;
  i = label_length;
  shift = -.5;
  zshiftlabel_(&shift,label,i);
}


zrightlabel_(label,label_length)
     char *label;
     int  label_length;
{
  int i;
  float shift;
  i = label_length;
  shift = -1.0;
  zshiftlabel_(&shift,label,i);
}


zshiftlabel_(shift,label,label_length)
     float *shift;
     char *label;
     int  label_length;
{
  double x,y,cos(),sin(),xbump,ybump,angle;
  float xl;
  char temp;
  char *ptr_r,*ptr_l;
  int i, lablen, textwidth;

  for(ptr_r=&label[label_length-1]; *ptr_r == ' '; ptr_r--);
  ptr_r++;
  ptr_l = label;
  for(; *ptr_l == ' '; ptr_l++); 
  lablen = ptr_r - ptr_l;
  if (lablen > 0) /* then string contains characters other than spaces */
    {
      temp = *ptr_r;
      ptr_r = NULL; 
      textwidth = XTextWidth(fontStruct,ptr_l,lablen);

      xl = *shift*textwidth;
      i = (int)xl;
      xi = xi + i;
      if (ps_on)
	{
	  i = 1.5*b-yi;
	  fprintf(outfile,"s\nn\n%d %d m\n",xi,i);
	}
      zlabel_(ptr_l,lablen);

      xi = xi - i;
      /* *ptr_r = temp; */ /* ael Yeaha! */
      ptr_r = &temp;
      XFlush(theDisplay);
    }
  /*  else string contains no printable characters */
}



hori_center_label_(ylevel,label,label_length)
float *ylevel;
char *label;
int  label_length;
{
  float x;
  char temp;
  char *ptr_r,*ptr_l;
  int i,j;

  for(ptr_r=&label[label_length-1]; *ptr_r == ' '; ptr_r--);
  temp = *ptr_r;
  /* XR6 */
  /* *ptr_r = (char) NULL; */
  ptr_r = NULL; 
  /* XR6 */
  ptr_l = label;
  for(; *ptr_l == ' '; ptr_l++); 
  x = hsize*(ptr_r - ptr_l);
  x = ((100. - x)*.5);
  i = (int)(x/100.*(float)(r-l));
  j = (int)(*ylevel * yincr + yshift);
  XDrawString(theDisplay,theWindow,theGC,i,j,ptr_l,strlen(ptr_l));
  /* XR6 */
  /* *ptr_r = temp; */
  ptr_r = temp; 
  /* XR6 */
  zmove_(&CURX,&CURY);
  XFlush(theDisplay);
}



verti_center_label_(xlevel,label,label_length)
float *xlevel;
char *label;
int  label_length;
{
  float y,angle;
  char temp, temper[1];
  char *ptr_r,*ptr_l;
  int i,j,k;

  for(ptr_r=&label[label_length-1]; *ptr_r == ' '; ptr_r--);
  temp = *ptr_r;
  /* *ptr_r = (char) NULL; */
  ptr_r = NULL; 
  /* XR6 */
  ptr_l = label;
  for(; *ptr_l == ' '; ptr_l++); 
  y = vsize*(ptr_r - ptr_l);
  y = ((100. - y)*.5);
  i = (int)(*xlevel * xincr + xshift);
  j = (int)(y/100.*(float)(b-t));
  fprintf(stderr,"%f %f \n",*xlevel,y);
  temper[1] = (char) NULL;
  y = (vsize/100.)*(b-t);
  fprintf(stderr,"%d %d \n",i,j);
  fprintf(stderr,"%d %f %f \n",i,*xlevel,y);
  fprintf(stderr,"%f \n",y); 
  for(;ptr_l<=ptr_r;ptr_l++) 
    {
      temper[0] = *ptr_l;
      XDrawString(theDisplay,theWindow,theGC,i,j,temper,strlen(temper));
      j = j+(int)(y);
    }
  XFlush(theDisplay);
}

nogolabel_(label,label_length)
char *label;
int  label_length;
{
  char temp;
  char *ptr;

  temp = label[label_length];
  label[label_length] = (char) NULL; 
  for( ptr=label; *ptr != (char) NULL; ptr++);
  *ptr = (char) NULL;
  ptr = label;
  for(; *ptr == ' '; ptr++);
  XDrawString(theDisplay,theWindow,theGC,xi,yi,label,label_length);
  label[label_length] = temp;  
  XFlush(theDisplay);
}


dir_text_(theta,spacing,label,label_len)
char *label;
int  label_len;
float *theta,*spacing;
{
  double x,y,cos(),sin(),xbump,ybump,angle;
  float xf, yf;
  int i;
  int xii,yii;
  char tmp, temp[1], *ptr;
  float d1,d2;

  angle = (double)*theta*PI/180.;
  x = (double)CURX;
  y = (double)CURY;
  xf=(float)(r-l)/50.;
  yf=(float)(t-b)/50.; 
  temp[1] = (char) NULL;
  xbump=cos(angle) * (double)(xf/xincr);
  ybump=sin(angle) * (double)(yf/yincr); 
  for(i=0;i<label_len;i++) 
    {
      xf = (float)(x + (double)i * xbump);
      yf = (float)(y + (double)i * ybump);
      xii = (int)(xf * xincr + xshift);
      yii = (int)(yf * yincr + yshift);
      temp[0] = label[i];
      XDrawString(theDisplay,theWindow,theGC,xii,yii,temp,strlen(temp));
    }
  XFlush(theDisplay);
  if (ps_on)
    {
/*
      fprintf(outfile,"dir_text\n");
*/
      for( ptr=&label[label_len-1]; *ptr == ' '; ptr--);
      ptr++;
      if (ptr > label) 
	{
	  xii = xi;
	  yii = 1.5*b - yi;
	  fprintf(outfile,"%d %d translate\n", xii, yii);
	  d1 = *theta;
	  fprintf(outfile,"%f rotate\n", -d1);
	  fprintf(outfile,"0000 0000 m\n");
	  tmp = *ptr;
	  *ptr = (char) NULL; 
	  fprintf(outfile,"(%s) rtext \n",label);
	  *ptr = tmp; 
	  fprintf(outfile,"%f rotate\n", d1);
	  fprintf(outfile,"%d %d translate\n", -xii, -yii);
	  label[i+1]=temp[1];
	}
    }
  label_angle=0.0;
}

zlbdir_(angle)
float *angle;
{
  label_angle=*angle;
}


icon_(buff)
char *buff;
{
  double CURX, CURY;
  char type;
  int size;
  int ix, iy;
}

char *
poly_(buff, infile)
char *buff;
FILE *infile;
{
  int num;
  char origcmd[64];
  /*	float CURX, CURY; */
  char *fgets();
  char *to_return;
}


zwhere_(x,y)
float *x,*y;
{
  if (xincr != 0.0) *x = (xi - xshift)/xincr;
  if (yincr != 0.0) *y = (yi - yshift)/yincr;
}



/* zxtick_ - plot a vertical tick w/o moving the current location */
void zxtick_()
{
  float pm,pp, px, py;
  pm = CURY- (vsize * (worldymax-worldymin)/100.);
  pp = CURY+ (vsize * (worldymax-worldymin)/100.);
  zline_(&CURX,&pm,&CURX,&pp);
  zmove_(&CURX,&CURY);
}



/* zxline_ - draw a horizontal line. 
   if the routines were only to be used in c this would be better to 
   implement as a macro.
*/
void zxline_(x1,x2,y)
float *x1,*x2,*y;
{
  zline_(x1,y,x2,y);
}



/* zxaxis_ - draw an xaxis line from xmin to xmax at yint placing tics
            every ticspc interval
*/
void zxaxis_(xmin,xmax,y,ticspc)
float *xmin,*xmax,*y,*ticspc;
{
  float xx;
  int i=2;

  zxline_(xmin,xmax,y);
  i=0;
  for(xx=(*xmin);xx<=(*xmax);xx+=(*ticspc)) {
    zmove_(&xx,y);
    zxtick_();
  }/* for */
  zmove_(&CURX,&CURY);
  XFlush(theDisplay);
}



/* 
zytick_ - plot a horizontal tick w/o moving the current location
*/
void zytick_()
{
  float pm,pp;
  pm = CURX- (hsize * (worldxmax-worldxmin)/100.);
  pp = CURX+ (hsize * (worldxmax-worldxmin)/100.);
  zline_(&pm,&CURY,&pp,&CURY);
  zmove_(&CURX,&CURY);
}



/* zyline_ - draw a vertical line. 
   if the routines were only to be used in c this would be better to 
   implement as a macro.
*/
void zyline_(y1,y2,x)
float *y1,*y2,*x;
{
  zline_(x,y1,x,y2);
}



/* zyaxis_ - draw a yaxis line from ymin to ymax at x placing tics
            every ticspc interval
*/
void zyaxis_(ymin,ymax,x,ticspc)
float *ymin,*ymax,*x,*ticspc;
{
  float yy;
  int i=2;

  zyline_(ymin,ymax,x); 
  i=0;
  for(yy=(*ymin);yy<=(*ymax);yy+=(*ticspc)) {
    zmove_(x,&yy);
    zytick_();
  }
  zmove_(&CURX,&CURY);
  XFlush(theDisplay);
}



zline_(x1,y1,x2,y2)
float *x1,*y1,*x2,*y2;
{
  zmove_(x1,y1);
  zplot_(x2,y2);
  XFlush(theDisplay);
}



void grwait_()
{
  char keychar;
  keychar = getchar();
  putchar(keychar);
}



/* 

  getkey - Gets a character from the Window: 

*/
void getkey_(keynum)
int  *keynum;
{
  int i;
  initEvents(theWindow);
  while(eventLoop(theWindow, theGC, keynum)); 
  i = *keynum;
  if (i==401 || i==402 || i==403) 
    {
      b=theAttribs.height;
      r=theAttribs.width;
      xincr = 0;
      yincr = 0;
      if (xdiff != 0.0) xincr = (float)(r-l) / xdiff;
      if (ydiff != 0.0) yincr = (float)(t-b) / ydiff;
      xshift = (float)l - xincr * worldxmin;
      yshift = (float)b - yincr * worldymin;
      hsize = 1.0;
      vsize = 1.0 * (float)b / (float)r;
    }
  if (ps_on) 
    {
      fprintf(outfile,"showpage\n");
      fclose(outfile);
      ps_on=0;
    }
}
/* getkey */


void getstring_(label,label_length)
char *label;
int  label_length;
{
  int i, j;
  char abc;
  int nbytes_return;
  char * bytes_return;
  j=-1;
  i=50; /* initialize i, to get into the loop */
  while(((i >= 32) && (i <= 126)) || i == 16 || i==27) 
    {
      getkey_(&i);
      if (abs(i - 4000) < 32) 
	{
	  i = i-4000;
	  if (i == 8) i=16;/* this sets  to backspace (a personal thing) */
	  else /* force getstring to take the character, and get out: */
	    {
	      j++;
	      abc = (char) i;
	      label[j] = abc;
	      fprintf(stderr,"%s",&abc);
	      i = 10;
	    }
	}
      if (j == label_length-2) break;
      if ((i >= 32) && (i <= 126)) 
	{
	  j++;
	  abc = (char) i;
	  label[j] = abc;
	  fprintf(stderr,"%s",&abc);
	}
      else
	{
	  if (i == 16) 
	    {
	      label[j] = (char) NULL;
	      fprintf(stderr,"\n%s",label);
	      j--;
	      /* 6/27/93 replaced by the line below
		 if (j < 0) { j=0;break;} 
		 I'm wondering whether it should be <, or whether =.
		 */
	      if (j < -1)  j=-1;
	    }
	  else if (i == 27) 
	    {
	      bytes_return = XFetchBytes(theDisplay,&nbytes_return);
	      if (bytes_return) 
		{
		  j++;
		  /* okay, I don't have it yet...
		     but I'm close! variable */
		  i = 0;
/*		  while((i < label_length) && (i < nbytes_return)) */
		  while((j+i < label_length) && (i < nbytes_return))
		    {
		      label[j+i] = bytes_return[i];
		      i++;
		    }
		  j = j+nbytes_return-1;
                  XFree(bytes_return);
		  if (label[j]==10) 
		    {
		      label[j]=' ';
		      break;
		    }
		  else 
		    {
		      label[j+1] = (char) NULL;
		      fprintf(stderr,"\n%s",label);
		      i = 27; /* just to stay inside the loop */
		    }
		}
	    }
	  else if (i == 10) 
	    {
	      j++;
	      label[j] = ' ';
	    }
	  else
	    {
	      notice_(); 
	      i = 50;
	    }
	}
    }
  for (i=j+1;i<label_length;i++)
    {
      label[i] = ' ';
    }
  label[label_length] = (char) NULL;
  printf("\n");
}



reset_()
{
  XFlush(theDisplay);
}



quitx_()
{
  quitX(); 
}



zdump_(coloring,coloring_length)
char *coloring;     
int coloring_length;
{
  XFlush(theDisplay);
  setColorWithName( theGC,theCurrentColor);  
  XFlush(theDisplay);
}

zzdump_()
{
  XFlush(theDisplay);
  setColorWithName( theGC,theCurrentColor);  
  XFlush(theDisplay);
}



/*  Doesn't work! */
make_color_(red,grn,blu)
char *red,*grn,*blu;
{
}


zbox_(x1,y1,x2,y2)
float *x1, *y1, *x2, *y2;
{
  int xx1, yy1, xx2, yy2;
  unsigned int xlen, ylen;
  xx1 = (int)(*x1 * xincr + xshift);
  yy2 = (int)(*y1 * yincr + yshift);
  xx2 = (int)(*x2 * xincr + xshift);
  yy1 = (int)(*y2 * yincr + yshift);
  xlen = xx2-xx1;
  ylen = yy2-yy1;
  XDrawRectangle( theDisplay, theWindow, theGC, xx1, yy1, xlen, ylen ); 
  XFlush(theDisplay);
}

zfont_(font,font_length)
char *font;     
int font_length;
{
  char temp, fawnt[128];

  theFontNameOverride = 1;
  releaseFont( theGC, theFontName);
  temp = font[font_length];
  font[font_length] = (char) NULL;
  sscanf(font,"%s",theFontName);
  fontStruct = initFont( theGC, theFontName);
  if (fontStruct) theFontNameOverride = 1;
  else theFontNameOverride = 0;
  font[font_length] = temp;
  XFlush(theDisplay);
}


zfontnumber_(num)
int *num;
{
  int i;
  i = *num;
  if (i <= 8) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--8*");
  else if (i <= 10 ) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--10*");
  else if (i <= 12) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--12*");
  else if (i <= 14) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--14*");
  else if (i <= 17) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--17*");
  else if (i <= 19) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--18*");
  else if (i <= 22) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--20*");
  else if (i <= 30) 
    strcpy(theFontName,"-adobe-courier-bold-r-normal--25*");
  else
    strcpy(theFontName,"-adobe-courier-bold-r-normal--34*");
  fontStruct = initFont( theGC, theFontName);
}


/*
  The following four routines were created following a read of 
  Introduction to the X Window System,
  by Oliver Jones. See p. 164.
*                                     *Andy Long 6/27/93*            *
*/

zlinewidth_(pwide)
     int *pwide;
{
  int i;
  line_width = *pwide;
  XSetLineAttributes
    (theDisplay, theGC, line_width, line_style, cap_style, join_style);
  XFlush(theDisplay);
  if (ps_on)
    {
/*
      fprintf(outfile,"zlinewidth\n");
*/
      i = *pwide;
      if (!i) i=1;
      fprintf(outfile,"%d setlinewidth\n",i);
    }
}

zlinetype_(ptype)
     int *ptype;
{
  int i;
  i = *ptype;
  if ( i == 2 ) line_style = LineDoubleDash;
  else if ( i == 1 ) line_style = LineOnOffDash;
  else line_style = LineSolid;
    
  XSetLineAttributes
    (theDisplay, theGC, line_width, line_style, cap_style, join_style);
  XFlush(theDisplay);
}

zcaptype_(ptype)
     int *ptype;
{
  int i;

  i = *ptype;
  if ( i == 1 ) cap_style = CapRound;
  else if ( i == 2 ) cap_style = CapProjecting;
  else if ( i == 3 ) cap_style = CapNotLast;
  else cap_style = CapButt;
    
  XSetLineAttributes
    (theDisplay, theGC, line_width, line_style, cap_style, join_style);
  XFlush(theDisplay);
}

zjointype_(ptype)
     int *ptype;
{
  int i;

  i = *ptype;
  if ( i == 1 ) join_style = JoinBevel;
  else if ( i == 2 ) join_style = JoinRound;
  else join_style = JoinMiter;
    
  XSetLineAttributes
    (theDisplay, theGC, line_width, line_style, cap_style, join_style);
  XFlush(theDisplay);
}
/*
Above suggested by  Introduction to the X Window System,by Oliver Jones. 
*/


random_(x)
     float *x;
{
  double drand48();
  *x = ((float) drand48() -.5)*2.0;
}

seed_()
{
  long seedval;
  seedval = 178587;
  srand48(seedval);
}


refresherWindow(theExposedWindow)
     Window theExposedWindow;
{

  XGetWindowAttributes(theDisplay, theExposedWindow, &theAttribs);
  b=theAttribs.height;
  r=theAttribs.width;
/*
  xxpost = xi;
  xxpost = yi;
*/
  xincr = 0;
  yincr = 0;
  if (xdiff != 0.0) xincr = (float)(r-l) / xdiff;
  if (ydiff != 0.0) yincr = (float)(t-b) / ydiff;
  xshift = (float)l - xincr * worldxmin;
  yshift = (float)b - yincr * worldymin;
  hsize = 1.0;
  vsize = 1.0 * (float)b / (float)r;

}


/*
  Some stuff that didn't work with refresh, but that might work someday!
*/
/*
  XImage *theImage;
  int rex, rey;
  unsigned int rewidth, reheight;
  unsigned long thePlaneMask = -1;
  int theFormat = ZPixmap;
  unsigned int nwide, nhigh;
*/
  
/*
  Window rootwindow;
  int rex, rey;
  unsigned int rewidth, reheight;
  unsigned int reborder_width, redepth;
  rootwindow = XDefaultRootWindow( theDisplay );
  XGetGeometry(theDisplay, theExposedWindow, &rootwindow
	       ,&rex, &rey, &rewidth, &reheight, &reborder_width, &redepth);
  xxpost=rex;
  yypost=rey;
  printf("%d %d %d %d \n",b,r,xxpost,yypost);
*/
/*
  rex=theAttribs.x;
  rey=theAttribs.y;
  rewidth=theAttribs.width;
  reheight=theAttribs.height;

  theImage = XGetSubImage (theDisplay, theExposedWindow, 
			   rex, rey, rewidth, reheight, 
			   thePlaneMask, theFormat, 0, 0);
  nwide=r-l;
  nhigh=b-t;
  XFillRectangle(theDisplay,theWindow,theGC,l,t,nwide,nhigh);
  XFlush(theDisplay);
  system("sleep 5");
  printf("putting image...\n");
  XPutImage (theDisplay, theExposedWindow, theImage, theGC, theImage,
	     rex, rey, rex, rey, rewidth, reheight);
  system("sleep 5");
  printf("image put.\n");
  system("sleep 5");
*/



turn_ps_on_(infile_name,infile_length)
     char *infile_name;
     int  infile_length;
{
  char *ptr, tmp;

  ps_on=1;
  for( ptr=&infile_name[infile_length-1]; *ptr == ' '; ptr--);
  ptr++;
  if (ptr > infile_name) 
    {
      tmp = *ptr;
      *ptr = (char) NULL; 
      write_ps(infile_name);
      *ptr = tmp; 
    }
  else write_ps("fake_x.ps.output");
}

write_ps(file_name)
     char *file_name;
{
  float xper, yper;
  if ((outfile = fopen(file_name,"w")) == NULL)
    {
      printf("\n Cannot open input data file \n");
      ps_on = 0;
    }
  else header_ps();
}  


header_ps()
{
  float xper, yper;
  int i,j;

  fprintf(outfile,"%%!PS \n");
  i = 1.5*b;
  j = .5*b;
/*  fprintf(outfile,"%%%%BoundingBox: %d %d %d %d\n\n", l, t, b, r); */
  fprintf(outfile,"%%%%BoundingBox: %d %d %d %d\n\n", l, j, r, i);
  fprintf(outfile,"/m \{moveto\} def \n");
  fprintf(outfile,"/l \{lineto\} def \n");
  fprintf(outfile,"/r \{rlineto\} def \n");
  fprintf(outfile,"/s \{stroke\} def \n");
  fprintf(outfile,"/n \{newpath\} def \n");
  fprintf(outfile,"/c \{closepath\} def \n");
  fprintf(outfile,"2 setlinejoin  \n");
  fprintf(outfile,"/rtext\{ dup stringwidth pop -1 div 0  rmoveto show \} def \n");
  fprintf(outfile,"/ltext\{show\} def \n");
  fprintf(outfile,"/ctext\{ dup stringwidth pop -2 div 0  rmoveto show \} def \n");
  fprintf(outfile,"/1bullet\{ 1 0 360 arc c fill \} def \n");
  fprintf(outfile,"/2bullet\{ 2 0 360 arc c fill \} def \n");
  fprintf(outfile,"/3bullet\{ 3 0 360 arc c fill \} def \n");
  fprintf(outfile,"/4bullet\{ 4 0 360 arc c fill \} def \n");
  fprintf(outfile,"/5bullet\{ 5 0 360 arc c fill \} def \n");
  fprintf(outfile,"/6bullet\{ 6 0 360 arc c fill \} def \n");
  xper = .5 * 1100./ (float) r;
  yper = .5 * 900. / (float) b;
  fprintf(outfile,"%f %f scale \n",xper, yper);
}  

notice_()
{
  char name[40];
  float xcen, ycen, zcen;
  int i;

  zclear_();

  xcen = 0.0;
  ycen = 1.0;
  zscale_(&xcen,&ycen,&xcen,&ycen);

  xcen = .5;
  ycen = .7;
  zcen = .2;
  zmove_(&xcen,&xcen);
  yinyang_(&xcen,&ycen,&zcen);
  
      if (r < 400) i = 8;
      else if (r < 500) i = 10;
      else if (r < 700) i = 12;
      else if (r < 800) i = 14;
      else if (r < 900) i = 17;
      else if (r < 1000) i = 18;
      else  i = 20;
      zfontnumber_(&i);


  i = 6;
  strcpy(name,"yellow");  
  color_(name,i);
  
  ycen = .3;
  zmove_(&xcen,&ycen);
  strcpy(name,"Use this Xwindow for all keyboard input.");  
  i = 40;
  zcenterlabel_(name,i);
  ycen = .2;
  zmove_(&xcen,&ycen);
  strcpy(name,"Keep your mouse here!");
  i = 21;
  zcenterlabel_(name,i);
}


yinyang_(xcen, ycen, rad)
float *xcen, *ycen, *rad;
{

  int ixcen, iycen;
  unsigned short ixrad, iyrad, nwide, nhigh;

  ixcen = (int)(*xcen* xincr + xshift);
  iycen = (int)(*ycen * yincr + yshift);
  ixrad = (int)(*rad * (r-l));
  iyrad = (int)(*rad * (b-t));

  setColorWithName( theGC,"yellow");  
  XFillArc(theDisplay,theWindow, theGC, ixcen-ixrad, iycen-iyrad, 2*ixrad, 2*iyrad, -90*64, 180*64);
  setColorWithName( theGC,"blue");  
  XFillArc(theDisplay,theWindow, theGC, ixcen-ixrad, iycen-iyrad, 2*ixrad, 2*iyrad, 90*64, 180*64);

  setColorWithName( theGC,"yellow");  
  XFillArc
    (theDisplay,theWindow, theGC, ixcen-ixrad/2, iycen-iyrad, ixrad
     , iyrad, 0, 360*64);
  setColorWithName( theGC,"blue");  
  XFillArc
    (theDisplay,theWindow, theGC, ixcen-ixrad/8, iycen-(5*iyrad)/8, ixrad/4
     , iyrad/4, 0, 360*64);
  XFillArc
    (theDisplay,theWindow, theGC, ixcen-ixrad/2, iycen, ixrad
     , iyrad, 0, 360*64);
  setColorWithName( theGC,"yellow");  
  XFillArc
    (theDisplay,theWindow, theGC, ixcen-ixrad/8, iycen+(3*iyrad)/8, ixrad/4
     , iyrad/4, 0, 360*64);

  XFlush(theDisplay);

}


void checkkey_(keynum)
int  *keynum;
{
  int i;
  while(XPending(theDisplay))
    {
      getkey_(&i);
    }
  *keynum = i;
}
/* checkkey */


