C*********************************************************************
C SUBROUTINE Calc SuppVar
C 
C This routine computes the coordinates and the relative contributions
C for the supplementary variables in the space determined by the
C factors.
C
C*********************************************************************
      SUBROUTINE Calc SuppVar
C*********************************************************************
      
      IMPLICIT INTEGER*4   (A-Z)
      INCLUDE 'corres.inc'
      REAL*8  PSJ (MaxSuppVar), D, C, temp, tempi, tempj
      
C     *** Initialize work array
      DO 5 j = 1, NSuppVar
         temp = 0.0
         DO 10 i = 1, NSamples
            temp = temp + PSIJ(i,j)      
 10      continue
         PSJ(j) = temp
 5    continue
      
C     *** Compute coordinates for the supplementary variables
      DO 15 i = 1, NSuppVar
         tempi = PSJ(i)
         DO 20 j = 1, NVar - 1
            tempj = dSQRT( Valpr(j+1) )
            temp = 0.
            DO 30 k = 1, NSamples
               temp = temp + PSIJ(k,i) * COORI(k,j) / tempi
               temp = temp / tempj
 30         continue
            COORJS(i,j) = temp 
 20      continue
 15   continue
      
C     *** Compute relative contributions 
      DO 40 i = 1, NSuppVar
         D = 0.0
         DO 50 j = 1, NVar - 1
            temp=COORJS(i,j)
            D = D+temp*temp
 50      continue
         DO 60 j = 1, NVar - 1
            temp=COORJS(i,j)
            C = 100.*temp*temp
            CRJS (i,j) = C / D
 60      continue
         CRJS (i,j) = C / D
 40   CONTINUE

      RETURN
      END
C*********************************************************************
