cc      SUBROUTINE HOW(JMAX,JUM,SJJ,VALPR,VECPR)
      SUBROUTINE HOW(JMAX,JUM,SJJ,VALPR,VECPR,e,d,index)
cclong
cc
C***********************************************************************
C
C          THIS SUBROUTINE ACTS AS AN INTERFACE BETWEEN THE MAIN
C          PROGRAM, AND THE EIGENVALUE-EIGENVECTOR SUBROUTINES
C          TRED2 AND TQLI. THOSE SUBROUTINES MAY BE CHANGED, BUT           
C          THE HOUSEHOLDER METHOD HAS BEEN FOUND TO BE APPROPIATE.
C
C          DESCRIPTION OF CALLING PARAMETERS:
C          JMAX=NUMBER OF VARIABLES
C          JUM=MAXIMUM NUMBER OF VARIABLES
C          SJJ=MATRIX TO BE DIAGONALIZED
C          VALPR=EIGENVALUES
C          VECPR=EIGENVECTORS
C
C***********************************************************************

cclong
cc      DIMENSION INDEX(200)
cc      REAL*8 E(200),D(200),VALPR(200)
cc      real*8 VECPR(200,200),SJJ(200,200),AMAX
      integer index(jum)
      REAL*8 E(jum),D(jum),VALPR(jum)
      real*8 VECPR(jum,jum),SJJ(jum,jum),AMAX
cclong

C***********************************************************************
C
C          CALLING SUBROUTINES THAT COMPUTE THE EIGENVALUES
C          AND EIGENVECTORS OF A SYMMETRIC MATRIX
C
C***********************************************************************

      CALL TRED2(SJJ,JMAX,JUM,D,E)
      CALL TQLI(D,E,JMAX,JUM,SJJ)

      DO 10 I=1,JMAX
      VALPR(I)=D(I)
10    CONTINUE
      DO 20 I=1,JMAX
      AMAX=0.0
      DO 15 J=1,JMAX
      IF(VALPR(J).LT.AMAX)GO TO 12
      AMAX=VALPR(J)
      INDEX(I)=J
12    CONTINUE
15    CONTINUE
20    VALPR(INDEX(I))=0.0
      DO 40 J=1,JMAX
      K=INDEX(J)
      VALPR(J)=D(K)     
      DO 40 I=1,JMAX
C***********************************************************************
C
C          EIGENVECTORS ARE MULTIPLIED BY "-1" TO CORRELATE
C          WITH DIRECTIONS IN FOX HILL TEST OF DAVID, ET AL.(77)
C          EIGENVECTORS ARE NORMALIZED
C
C***********************************************************************
40    VECPR(I,J)=SJJ(I,K)          
      RETURN
      END
