C Lowlevel.for - lower-level machine dependant screen mgt. routines
C**********************************************************************
C
C   Screen Access Management (SAM) Utilities miscellaneous routines.
C
C**********************************************************************

	SUBROUTINE Display Frame

	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (BOX  = 0)
	PARAMETER (LINE = 1)

	logical status, SMG$DRAW_RECTANGLE, SMG$DRAW_LINE

	INCLUDE 'screen.str'

	COMMON /Screen/ Page, PBID, KBID

	DO 60 i = BG Frame (Current Screen),
     +	         End Frame (Current Screen)

	  IF (FR Command (i) .EQ. BOX) THEN
	    r1 = FR RW1    (i)
	    c1 = FR Cl1 (i)
	    r2 = FR RW2    (i)
	    c2 = FR Cl2 (i)
	    Status = SMG$DRAW_RECTANGLE (Page, r1, c1, r2, c2)
c	    IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))
	  ELSE
	    r1 = FR RW1    (i)
	    c1 = FR Cl1 (i)
	    r2 = FR RW2    (i)
	    c2 = FR Cl2 (i)
	    Status = SMG$DRAW_LINE (Page, r1, c1, r2, c2)
c	    IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))
	  ENDIF
  60	CONTINUE

	RETURN
	END


C------------------------------------------------------------------------
C  Clear Screen - Clears the Screen.
C------------------------------------------------------------------------
	SUBROUTINE Clear Screen
	IMPLICIT INTEGER*4 (A-Z)
	logical status, SMG$ERASE_DISPLAY

	COMMON /Screen/ Page, PBID, KBID

	Status = SMG$ERASE_DISPLAY (Page)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


C------------------------------------------------------------------------
C  Get Key - Returns the ASCII code for a keystroke

	SUBROUTINE Get Key (Character)
	IMPLICIT INTEGER*4 (A-Z)
	logical status, SMG$READ_KEYSTROKE

	COMMON /Screen/ Page, PBID, KBID

	STATUS = SMG$READ_KEYSTROKE (KBID, Character)
c        print *, KBID, Character
c	IF (.NOT. STATUS) CALL LIB$SIGNAL (%VAL(STATUS))

	RETURN
	END

C------------------------------------------------------------------------
C  Locate Cursor - Put Cursor at the specified Row and Column 

	SUBROUTINE Locate Cursor (Row, Column)
	IMPLICIT INTEGER*4 (A-Z)
	INTEGER*4 Row, Column
	logical status, SMG$SET_CURSOR_ABS

	COMMON /Screen/ Page, PBID, KBID

	R = Row
	C = Column
	Status = SMG$SET_CURSOR_ABS (Page, R, C)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END

C------------------------------------------------------------------------
C  Put characters on the screen with the specified attribute.
C  Attributes can be :
C	NORMAL    = 0
C	BOLD      = 1
C	REVERSE   = 2
C	BLINK     = 4
C	UNDERLINE = 8

      SUBROUTINE Put Characters (Characters, Length, Attribute)
      IMPLICIT INTEGER*4 (A-Z)
      CHARACTER*(*) Characters, hold*80
      logical status, SMG$PUT_CHARS
      
      COMMON /Screen/ Page, PBID, KBID
      
cclong	pithing this by making it 22 rather than 2
      if (attribute .eq. 22) then
         do i = 1, length
            j = ichar(characters(i:i)) + 128
            if (j .gt. 255) then
               print *, 'characters:',characters
               print *, 'hold:', hold
               print *, 'j is too big! ',j, characters(i:i)
               call system('sleep 1')
               return
            end if
            hold(i:i) = char(j)
         enddo
         Status = SMG$PUT_CHARS (Page, hold, length,i,i,Attribute)
      else
         Status = SMG$PUT_CHARS (Page, Characters ,length,i,i,Attribute)
      end if
c     IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))
      RETURN
      END

C------------------------------------------------------------------------
C  Send a BEEP to the screen.

	SUBROUTINE Beep

	INTEGER*4 Beep_Attribute /0/
	CALL Put Characters (CHAR(7), 1, Beep_Attribute)
	RETURN
	END


C------------------------------------------------------------------------
C   Set Up Screen - Initialize VAX screen, create pasteboard, virtual 
C   display and virtual keyboard.  Paste virtual display to pasteboard.
C
C   Page = Virtual Display ID
C   PBID = Pasteboard ID
C   KBID = Virtual Keyboard ID

	SUBROUTINE Set Up Screen
	IMPLICIT INTEGER*4 (A-Z)
	logical status, SMG$CREATE_VIRTUAL_KEYBOARD
     &	  , SMG$CREATE_PASTEBOARD, SMG$CREATE_VIRTUAL_DISPLAY
     &	  , SMG$PASTE_VIRTUAL_DISPLAY

	COMMON /Screen/ Page, PBID, KBID

C------------------------------------------------------------------------
C   Create Virtual Keyboard
C------------------------------------------------------------------------
	Status = SMG$CREATE_VIRTUAL_KEYBOARD (KBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Set up SYS$OUTPUT for screen management and get the number of rows
C   and columns on the screen.
C------------------------------------------------------------------------
	Status = SMG$CREATE_PASTEBOARD (PBID,'SYS$OUTPUT',Rows,Columns)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Create Virtual Display to paste to the full screen.
C------------------------------------------------------------------------
	Rows = 24
	Columns = 80
	Status = SMG$CREATE_VIRTUAL_DISPLAY (Rows, Columns, Page,i,i)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Paste Virtual Display to Pasteboard.
C------------------------------------------------------------------------
	Status = SMG$PASTE_VIRTUAL_DISPLAY (Page, PBID, 1, 1)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


C------------------------------------------------------------------------
C   Reset Screen - Returns VAX keyboard to its initial state by 
C   deleting the pasteboard, virtual display, and virtual keyboard
C
C   Page = Virtual Display ID
C   PBID = Pasteboard ID
C   KBID = Virtual Keyboard ID

	SUBROUTINE Reset Screen
	IMPLICIT INTEGER*4 (A-Z)
	logical status, SMG$DELETE_PASTEBOARD
     &	   , SMG$DELETE_VIRTUAL_DISPLAY, SMG$DELETE_VIRTUAL_KEYBOARD
	COMMON /Screen/ Page, PBID, KBID

C------------------------------------------------------------------------
C   Delete Pasteboard
C------------------------------------------------------------------------
	Status = SMG$DELETE_PASTEBOARD (PBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Delete Virtual Display
C------------------------------------------------------------------------
	Status = SMG$DELETE_VIRTUAL_DISPLAY (Page)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

C------------------------------------------------------------------------
C   Delete Virtual Keyboard
C------------------------------------------------------------------------
	Status = SMG$DELETE_VIRTUAL_KEYBOARD (KBID)
c	IF (.NOT. Status) CALL LIB$SIGNAL (%VAL(Status))

	RETURN
	END


