clarge
c**********************************************************************
c*** File name: PREP12.FOR (Source code for the program DATAPREP)
c**********************************************************************
c        P r e f i x  O p e r a t i o n       (subroutine)
c**********************************************************************
      SUBROUTINE Prefix Operation

c***  This routine prompts the user for two prefixes, a file prefix
c***  and a scratch file prefix.  The scratch file prefix is tested
c***  for validity and displays any error messages.
c***  
c***  VARIABLES:
c***  File Name   - contains the name of the scratch file.
c***  Choice      - contains the field name of a screen field.
c***  Prefix	  - global variable that contains the name of the
c***                file name prefix.
c***  Tfprefix	  - global variable that contains the name of the
c***                scratch file prefix.
c***  Prefile     - global variable that contains the prefix plus
c***                the name of the file.  This applies to both
c***                the Prefix and the Tfprefix.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER   Choice*10, File Name*14
      CHARACTER   Writemess*24
      INTEGER*4	  I,J
 

      Writemess	  = ' Opening scratch file...'
c***  Prompt user for prefix  ***
      Choice = 'PREFIX    '
      Next Field = FLD Index (Choice)
      CALL Get Field
      CALL Get Character Value (Choice, Prefix)
      Choice = 'TFPREFIX  '
      Next Field = FLD Index (Choice)
      CALL Get Field
      CALL Get Character Value (Choice, Tfprefix)
c***  Determine if the 'scratch files' can be generated with the provided
c***  path.
      CALL Put Str (Writemess, 24, 20, 2, 2)
      File Name = 'ZZSCTCH1.FIL  '
      CALL Build Prefix Scratch Filename(File Name)
c***  Open scratch file to contain 'Data1' 'structure'. ***
      OPEN (UNIT=1,FILE=Prefile,ACCESS='DIRECT',RECL=4,
     +     FORM='unformatted',IOSTAT=I)
ccc   +     FORM='BINARY',IOSTAT=I)
      File Name = 'ZZSCTCH2.FIL  '
      CALL Build Prefix Scratch Filename(File Name)
c***  Open scratch file to contain 'Data2' 'structure'. ***
      OPEN (UNIT=2,FILE=Prefile,ACCESS='DIRECT',RECL=4,
     +     FORM='unformatted',IOSTAT=J)
ccc     +      FORM='BINARY',IOSTAT=J)
c***  Close scratch file that contains 'Data1' 'structure'. ***
      CLOSE(1, STATUS='DELETE')
c***  Close scratch file that contains 'Data2' 'structure'. ***
      CLOSE(2, STATUS='DELETE')
c***  If error in opening scratch file then display an error message 
c***  and set the scratch file prefix to blanks.
      IF ((I .GE. 1).OR.(J .GE. 1)) THEN
	 CALL Flash(20, 2, 
     + 'ERROR - Scratch files cannot use this prefix...(press any key)')
	 CALL Erase (3, 24, 55)
         CALL Init Tfprefix
	 Choice = 'TFPREFIX  '
	 CALL Set Character Value (Choice, Tfprefix)
      ENDIF
c***  Erase message line.
      CALL Erase (20, 2, 30)
      RETURN
      END
C**********************************************************************
C        D i s p l a y   P r e f i x   L a b e l s      (subroutine)
C**********************************************************************
      SUBROUTINE Display Prefix Labels

c***  This routine constructs the prefix box and displays the file name
c***  and scratch file prefixes if any.
c***  
c***  VARIABLES:
c***  Prefix	  - global variable that contains the name of the
c***                file name prefix.
c***  Tfprefix	  - global variable that contains the name of the
c***                scratch file prefix.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER   Label1*20, Label2*20

c***  Initialize and insert labels.
      Label1 = 'Data File Prefix   :'
      Label2 = 'Scratch File Prefix:'
      CALL Put Str (Label1, 20, 2,  2, 0)
      CALL Put Str (Label2, 20, 3,  2, 0)
      CALL Draw Middle Horizontal Line(4)
c***  Display the fields for this menu.
      CALL Put Str (Prefix,   55, 2, 24, 0)
      CALL Put Str (Tfprefix, 55, 3, 24, 0)


      RETURN
      END
c**********************************************************************
c	 B u i l d  P r e f i x  F i l e n a m e     (subroutine)
c**********************************************************************
      SUBROUTINE Build Prefix Filename (File Name)
 
c*** This routine concatenates a prefix to a filename.	 The filename
c*** is passed as a parameter and the prefix is a global variable.
c***
c*** VARIABLES:
c*** File Name - name of the file to which the prefix is affixed. 
c*** Prefix    - global variable that contains the name of prefix to be 
c***             affixed to the file name.
c*** Prefile   - global variable that contains the prefix + file name.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER  File Name*(*)
      INTEGER*4  I, J, K

c***  Clear any existing prefix by setting 'Prefix' to blanks.
      DO 15 I = 1, 77
        Prefile(I:I) = ' '
  15  CONTINUE
      J = LENSTR(Prefix)
c***  Assign the prefix to the global variable 'Prefile'.
      Prefile = Prefix 
c***  Append the file name to the prefix and assign to 'Prefile'.
      DO 10 I = 1, 14
	K = J + I
	Prefile(K:K) = File Name(I:I)
  10  CONTINUE

      RETURN
      END
c**********************************************************************
c	 I n i t  P r e f i x             (subroutine)
c**********************************************************************
      SUBROUTINE Init Prefix
 
c*** This routine initializes the global variable prefix to blanks.

c*** VARIABLES:
c*** Prefix    - global variable that contains the name of prefix to be 
c***             affixed to the file name.

       include 'dataprep.dec'
       include '../common/screen.str'

      INTEGER*4 I
c***  Set global variable Prefix to blanks.
      DO 15 I = 1, 55
        Prefix(I:I) = ' '
  15  CONTINUE
 
      RETURN
      END
c**********************************************************************
c        C r e a t e  I D   P r o m p t s     (subroutine)
c**********************************************************************
      SUBROUTINE Create ID Prompts

c***  This routine constructs the ID Variable screen and displays
c***  the ID Variable menu.  The user is prompted for a menu 
c***  selection which is then processed.  
c***
c***  VARIABLES:
c***  Menu        - contains the field name of the Compress menu. 
c***  Menu Choice - contains the user's menu selection.
c***  Infil       - global variable that contains the name of the Geo-EAS
c***                input data file.
c***  Outfil	  - global variable that contains the name of the Geo-EAS
c***                output data file.
c***  Error	  - logical variable set to .true. if a fatal error occurs 
c***                during processing.
c***  IDvarnam    - contains the ID variable name 'Sequence #'.
c***  Unit        - contains the ID variable's measurements description.
c***  Iformat     - contains the output format forthe ID variable.

       include 'dataprep.dec'
       include '../common/screen.str'
		   
      CHARACTER     Menu Choice*20, File*8, Label8*22
      CHARACTER*14  Blank, Label7*17
      CHARACTER     Label1*11,Label2*12,Label3*30,Iformat*5
      CHARACTER     Readmess*17, Label6*20
      CHARACTER*10  Choice, Unit, IDvarnam, Menu
      INTEGER*4     FLD Index
      LOGICAL     Error

      CALL Erase Message Divider
      CALL ClearRows(1,18)
      CALL Draw Middle Horizontal Line(4)
      CALL Draw Middle Horizontal Line(6)
      CALL Draw Middle Horizontal Line(9)
cccc      CALL Display One Field('INFILE1 ')
cccc      CALL Display One Field('OUTFILE1')
      Blank = '              '
      Menu  = 'ID MENU   '
      IDvarnam = 'Sequence #'
      Error = .TRUE.
      Iformat = 'F7.0'
c***  Initialize and insert labels.
      Readmess = ' Processing data '
      Label1 = 'Input File:'
      Label2 = 'Output File:'
      Label3 = 'ID Variable name: ''Sequence #'''
      Label6 = 'ID VARIABLE FUNCTION'
      Label7 = 'Data File Prefix:'
      Label8 = 'Input\Output Variables'
      CALL Put Str (Label1, 11,  5,  2, 0)
      CALL Put Str (Label2, 12,  5, 39, 0)
      CALL Put Str (Label3, 30,  7,  2, 0)
      CALL Put Str (Label6, 20,  2, 30, 0)
      CALL Put Str (Label7, 17,  3,  2, 0)
      CALL Put Str (Prefix, 55,  3, 20, 0)
      CALL Set Character Value ('INFILE1 ', Infil)
      CALL Set Character Value ('OUTFILE1 ', Outfil)
cccc      CALL Display One Field('INFILE1 ')
cccc      CALL Display One Field('OUTFILE1 ')
      CALL Put Str (Label8, 22, 10, 28, 0)
c***  Display Create ID Variable menu and prompt user for choice.
      CALL Put Menu (Menu)
  10  CALL Get Menu Choice (Menu, Menu Choice)
      IF (Menu Choice      .EQ. 'Quit                ') THEN
	Choice = 'UNITS     '
	CALL Set Character Value (Choice, Blank)
	CALL Erase Middle Horizontal Line(4)
	CALL Erase Middle Horizontal Line(6)
	CALL Erase Middle Horizontal Line(9)
	CALL Clear Rows(1,18)
c***    Erase the variables heading.
  	RETURN
      ELSE IF (Menu Choice .EQ. 'Files               ') THEN
	CALL Erase Variable List
c***    Prompt user for input file.
  	File = 'INFILE1 '
	CALL Get Name of File(File,Infil,Error,1)
c***    If error return to menu.
	IF (Error) GOTO 10
c***    Prompt user for outfile.
	File = 'OUTFILE1'
	CALL Get Name of File(File, Outfil, Error,2)
c***    If error return to menu.
	IF (Error) GOTO 10
	CALL File Set Up (Error, Nvar)
        CALL Erase(20,  1, 45)
	Recskip = Nvar + 3
c***    If not error then display variables of input file.
	IF (.NOT. Error) CALL Display Variables(Nvar)
      ELSE IF (Menu Choice .EQ. 'Execute             ') THEN
	IF (Error) THEN
c***    If filenames have not been entered then inform the user 
c***    and return to the menu.
	  CALL Beep
	  CALL Flash(20, 2, 
     +       'ERROR - Filenames must be entered...(press any key)')
	ELSE
          CALL Put Str (Readmess, 17, 20, 2, 2)
	  CALL Open Scratch Files
	  IF (.NOT. Error)
     +      CALL Read Numerical Data(1,Infil,Nvar,Nvar+1,Error,Recskip)
	  IF (.NOT. Error) THEN
            CALL Put Str (Readmess, 17, 20, 2, 2)
     	    CALL ID Var(Outfil, Unit, IDvarnam,	Iformat, Error)
	  ENDIF
	  CALL Close Scratch Files
        ENDIF
      ENDIF

      GOTO 10
      RETURN
      END
c**********************************************************************
c        I D   V a r 			    (subroutine)
c**********************************************************************
      SUBROUTINE ID Var (Outfile, Unit, IDvarnam,
     +                   Iformat, Error)

c***  This subroutine performs the following:
c***    1.) a new variable is inserted into the outfile along with all
c***        the other variables from the input file.  This new variable
c***        is given the name specified in 'IDvarnam' which is 
c***        'Sequence #'.  The new variable occupies the last position 
c***        with all related samples occupying the last column.  
c***    2.) if this ID variable exceeds the maximum number of variables
c***        specified by the constant 'MAXVAR' then 'Error' is set to
c***        true and an error message is to that effect is displayed.
c***	3.) if the input file already has an 'Sequence #' then an error
c***        message is displayed and processing is discontinued.  It
c***        is assumed that files containing an ID variable have them
c***        occupy the last position.  
c***    4.) the ID variable samples are initialized with values representing
c***        each record number, ie., sample 1 = 1, sample 2 = 2 and so on
c***        until the last sample is reached which is equal to the value
c***        stored in 'Ndata', the last record.
c***    5.) the resulting data is then written to the file whose name is
c***        stored in 'Outfile'.

c***  To use this subroutine the following requirements must have
c***  have been satisfied:
c***    1.) 'Outfile' has been entered  and is not blank.
c***    2.) 'Unit' has already been entered, may be blank.
c***    3.) 'Iformat' has been entered and error checking performed.
c***
c***  VARIABLES:
c***  Outfile  - global variable contains the name of the Geo-EAS output 
c***             data file.
c***  IDvarnam - contains the name of the ID variable ie., 'Sequence #'.
c***  Unit     - contains the measurement description for the IDvarnam.
c***  Iformat  - contains the FORTRAN output format for the ID variable.
c***  Error    - logical is set to true if an error occurs during 
c***             processing.


       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER*14  Outfile
      CHARACTER*10  Unit, IDvarnam
      CHARACTER*5   Iformat
      LOGICAL     Error
      REAL*4        Get Element, Value
      INTEGER*4	    I, J

      Error = .FALSE.
c***  Check if adding the ID variable will exceed the maximum number
c***  of variables permitted, else continue with processing.
      IF (Nvar+1 .GT. MAXVAR) THEN
        Error = .TRUE.
	CALL Beep
        CALL Flash (20, 2,
     +  'ERROR--ID not created, exceeds variable max...(Press any key)')
	RETURN
      ENDIF
c***  Check if input file already has an ID variable, if so then issue
c***  an error.
      DO 40 I = 1, Nvar
        IF (Varnam(I) .EQ. IDvarnam) Error = .TRUE.
  40  CONTINUE
      IF (Error) THEN
	CALL Beep
        CALL Flash (20, 2,
     +'ERROR - Input file already has an ID Variable...(Press any key)')
      ELSE
c***    Insert the ID variable into the last position.
	Varnam(Nvar + 1)  = IDvarnam
	Units(Nvar + 1)   = Unit
	Formats(Nvar + 1) = Iformat
c***    Initialize the ID variable data column with the values 1..Ndata.
c***    the integer will be forced to real as the array 'Data' is type real.
	DO 20 I = 1, Ndata
	  Value = I
	  CALL Put Element(1,Nvar+1,I,Nvar+1,Value)
  20    CONTINUE
c***    Increment the global variable 'Nvar' to reflect the additional
c***    variable 'ID Var'.
	Nvar = Nvar + 1

c***    The resulting data will now be written to the specified data file.
c***    Set the global variable Outfil to name of the specified output file.
	Outfil = Outfile
	CALL Display Variables(Nvar)
        CALL Write to Output File 
      ENDIF

      RETURN
      END
c**********************************************************************
c	 B u i l d  P r e f i x  S c r a t c h   F i l e (subroutine)
c**********************************************************************
      SUBROUTINE Build Prefix Scratch Filename (File Name)
 
c*** This routine concatenates a prefix to a filename.	 The filename
c*** is passed as a parameter and the prefix is a global variable.
c***
c*** VARIABLES:
c*** File Name - Name of scratch file. 
c*** Prefile   - Global variable that contains the scratch file prefix +
c***             file name(scratch).
c*** Tfprefix  - Global variable that contains the name of scratch file 
c***             prefix.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER  File Name*(*)
      INTEGER*4  I, J, K

c***  Clear any previous prefix name by setting 'Prefile' to blanks.
      DO 15 I = 1, 77
        Prefile(I:I) = ' '
  15  CONTINUE
      J = LENSTR(Tfprefix)
c***  Set 'Prefile' to scratch file prefix. 
      Prefile = Tfprefix 
c***  Append the scratch file name to the scratch file prefix.
      DO 10 I = 1, 14
	K = J + I
	Prefile(K:K) = File Name(I:I)
  10  CONTINUE

      RETURN
      END
c**********************************************************************
c	 I n i t  T f p r e f i x             (subroutine)
c**********************************************************************
      SUBROUTINE Init Tfprefix
 
c*** This routine initializes the global variable prefix to blanks.
c***
c*** VARIABLES:
c*** Tfprefix  - global variable that contains the name of prefix to be 
c***             affixed to the scratch file name.

       include 'dataprep.dec'
       include '../common/screen.str'

      INTEGER*4 I
c***  Set global variable Prefix to blanks ***
      DO 15 I = 1, 55
        Tfprefix(I:I) = ' '
  15  CONTINUE
 
      RETURN
      END
C**********************************************************************

