clarge
c**********************************************************************
c*** File name: PREP14.FOR (Source code for the program DATAPREP)
c**********************************************************************
c interface for Delete - delete file
c
ccc      	INTERFACE TO INTEGER*4 FUNCTION DELETE [C,ALIAS:'_remove']
      INTEGER*4 FUNCTION DELETE (NAME)
      character*(*) NAME
      call system ('rm '//name)
      END
c----------------------------------------------------------------------
c interface for Rename - rename file
c
ccc      	INTERFACE TO INTEGER*4 FUNCTION RENAME [C,ALIAS:'_rename']
      INTEGER*4 FUNCTION RENAME (OLDNAME, NEWNAME)
      integer lenstr
      character*(*) OLDNAME, NEWNAME, line*512
      line = 'mv '//oldname(1:lenstr(oldname))//' '//newname
      call system (line(1:lenstr(line)))
      END
c----------------------------------------------------------------------
c interface for System call
c
ccc      	INTERFACE TO INTEGER*4 FUNCTION SYSTEM [C,ALIAS:'_system']
      INTEGER*4 FUNCTION SYSTM (COMMAND)
      character*(*) COMMAND
      call system (command)
      END

c**********************************************************************
c        D e l e t e  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Delete File(Filename, Returncode)

c***  This routine executes the DOS command 'Delete' via a 'C' procedure
c***  called DELETE. 
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to be deleted.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.

       include 'dataprep.dec'

      CHARACTER	 Filename*(*)
      INTEGER*4	 DELETE, Returncode


      CALL Build Prefix Filename (Filename)
      Prefile(77:77) = CHAR (0)
      Returncode = DELETE (Prefile)

      RETURN
      END

c**********************************************************************
c        R e n a m e  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Rename File(Oldname, Newname, Returncode)

c***  This routine executes the DOS command 'Rename' via a 'C' procedure
c***  called RENAME. 
c***
c***  VARIABLES:
c***  Oldname	 - contains the name of the file to be renamed.
c***  Newname	 - contains the new file name.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Oldname then
c***               contains the Prefix + the Newname.

       include 'dataprep.dec'

      CHARACTER	 Oldname*(*), Newname*(*), Oldfile*77
      INTEGER*4	 RENAME, Returncode


      CALL Build Prefix Filename (Oldname)
      Oldfile = Prefile
      CALL Build Prefix Filename (Newname)
      Prefile(77:77) = CHAR (0)
      Returncode = RENAME (Oldfile, Prefile)
      returncode = 0

      RETURN
      END
c**********************************************************************
c        C o p y  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Copy File(Oldfile, Newfile, Returncode)

c***  This routine executes the DOS command 'Copy' via a 'C' procedure
c***  called SYSTM.  The copy command along with the old and new file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Oldfile	 - contains the name of the file from which to copy.
c***  Newfile    - contains the name of the file to copy to.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER	 Oldfile*(*), Newfile*(*)
      INTEGER*4	 Returncode, I, J

      Returncode = 0
      I = LENSTR(newfile)
      J = LENSTR(Oldfile)
      CALL Build Prefix Filename (Newfile)
ccc      call system('echo "cp '//oldfile(1:J)//' '//newfile(1:I)//'"')
      call system('cp '//oldfile(1:J)//' '//newfile)

      RETURN
      END

c**********************************************************************
c        P r i n t  F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE Print File(Filename, Returncode)

c***  This routine executes the DOS command 'Print' via a 'C' procedure
c***  called SYSTM.  The Print command along with the file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to print.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER	 Filename*(*)
      INTEGER*4	 SYSTM, Returncode

      Returncode = 0
      CALL Build Prefix Filename (Filename)
      call system ('lpr '//filename)

      RETURN
      END

c**********************************************************************
c        L i s t   F i l e     (subroutine)
c**********************************************************************
      SUBROUTINE List File(Filename, Returncode)

c***  This routine executes the DOS command 'More' via a 'C' procedure
c***  called SYSTM.  The More command along with the file
c***  name is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Filename	 - contains the name of the file to list.
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Prefile	 - contains the global variable Prefix + the Filename.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.

       include 'dataprep.dec'
       include '../common/screen.str'

      CHARACTER	 Filename*(*)
      INTEGER*4	 SYSTM, Returncode

      Returncode = 0
      CALL Build Prefix Filename (Filename)
      Progrm = 'less  '
      call system ('xterm -rv -e less '//filename//' &')
      call clear screen()

      RETURN
      END

c**********************************************************************
c        L i s t   D i r e c t o r y     (subroutine)
c**********************************************************************
      SUBROUTINE List Directory(Returncode)

c***  This routine executes the DOS command 'Dir' via a 'C' procedure
c***  called SYSTM.  The Directory command along with the directory
c***  is entered into a character array called Progrm.
c***
c***  VARIABLES:
c***  Returncode - contains an integer value indicating if the command
c***               was properly executed.
c***  Doscom	 - global variable which contains the directory.
c***  Progrm     - a character array that contains the actual command
c***               line for DOS to execute.



       include 'dataprep.dec'
       include '../common/screen.str'

      INTEGER*4	 SYSTM, Returncode

      Returncode = 0
      call system('rm -f $HOME/.dataprep;echo -n ls "'
     &     //doscom(1:lenstr(doscom))//'" >> $HOME/.dataprep;
     &     echo  "|less" >> $HOME/.dataprep;
     &     chmod +x $HOME/.dataprep;
     &     xterm -rv -e $HOME/.dataprep;
     &     rm -f $HOME/.dataprep')
      call clear screen()
 
      RETURN
      END

c**********************************************************************
c        S y s t e m  C o m m a n d     (subroutine)
c**********************************************************************
      SUBROUTINE System Command

c***  This routine executes the command 'Command' via a 'C' procedure
c***  called SYSTM.  Once this command is executed, the user is in DOS.
c***  The user can return to DATAPREP by entering 'exit'. 

       include 'dataprep.dec'
       include '../common/screen.str'

      call system('xterm -rv -e sh &')
      call clear screen()

      RETURN
      END
c**********************************************************************
 

