C Debug.for
C----------------------------------------------------------------------
C Show Neighbors - display neighbors found by subroutine Search (XVALID)
C
        SUBROUTINE Show Neighbors (X0, Y0, Neighbors, N)

	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE  'krige.dec'

        REAL*4     X0, Y0, X, Y, Dx, Dy, Hx, Hy, D
        REAL*4     Cosa, Sina, Ratio, Dtr
        INTEGER*4  Neighbors (1), N, Ptr, I, Quad, OcT
	INTEGER*4  Key 
        CHARACTER  Output*75
	
        DATA Dtr    /0.0174533/
	
	CALL Clear Screen
        IF (N. EQ. 0) WRITE (Output, '(A)') 'No Neighbors '
        Cosa   = COS (SrAngle*Dtr)
        Sina   = SIN (SrAngle*Dtr)
        Ratio = SrMajor / SrMinor

        IF (Nsector .EQ. 4) THEN
           WRITE (Output, 100)
        ELSE IF (Nsector .EQ. 8) THEN
           WRITE (Output, 110)
        ELSE
           WRITE (Output, 120)
        ENDIF
	CALL Locate Cursor (2, 0)
	CALL Put Characters (Output, 75, NORMAL)
        WRITE (Output, 105)
	CALL Locate Cursor (3, 0)
	CALL Put Characters (Output, 75, NORMAL)
        
        DO 10 I = 1, N
           Ptr = Neighbors (I)
           X   = xData (Ptr)
           Y   = yData (Ptr)
           Dx  = X - X0
           Dy  = Y - Y0
           D   = SQRT (Dx*Dx + Dy*Dy)
           Call Sector (Dx, Dy, Quad, Oct)
           IF (Nsector .EQ. 4) THEN
              WRITE (Output, 200) Ptr, Quad, X, Y, D
           ELSE IF (Nsector .EQ. 8) THEN
              WRITE (Output, 200) Ptr, Oct, X, Y, D
           ELSE
              WRITE (Output, 210) Ptr, X, Y, D
           ENDIF
	   IF (I.LT.20)	THEN
	      CALL Locate Cursor (4+I, 0)
	   ELSE
              CALL Locate Cursor (24, 0)
	   ENDIF	  
	   CALL Put Characters (Output, 75, NORMAL)
 10     CONTINUE

	RETURN

 100    FORMAT ('  #   Quad            X           Y       Distance')
 105    FORMAT ('--------------------------------------------------')
 110    FORMAT ('  #   Octant          X           Y       Distance')
 120    FORMAT ('  #                   X           Y       Distance')
 200    FORMAT (I4,4X,I1,3X,3(1X,F12.3))
 210    FORMAT (I4,8X,3(1X,F12.3))
        END           

C--------------------------------------------------------------------
C Show System - display system of equations for program KRIGE

        SUBROUTINE Show System (X0, Y0, N, Index)
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'
        
        INTEGER*4       Index, Ptr
        REAL*4          Vk, Sk, SumWeight, X0, Y0, X, Y, V, Wt
        REAL*4          Dx, Dy, D
	INTEGER*4       Key , outneq
        character*80 output

        SumWeight 	= 0.0
        Var 		= Index
	Neq		= N + Ktype

	CALL Clear Screen

        WRITE (output, 100) VarNam (KrigVar (Index))
	CALL Locate Cursor (1, 0)
	CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 110) X0, Y0
	CALL Locate Cursor (2, 0)
	CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 155)
	CALL Locate Cursor (4, 0)
	CALL Put Characters (Output, 80, NORMAL)
        outneq = min(neq,7)
        DO 50 I = 1, Neq
           if (i .le. 20) then
              WRITE (output,300) B(I), (W (I,J), J = 1, outneq)
              CALL Locate Cursor (4+i, 0)
              CALL Put Characters (Output, 80, NORMAL)
           else
              goto 60
           end if
 50     continue

 60     CALL getthekey (Key)
        if (char(key) .eq. 'q' .or. char(key) .eq. 'Q') keep = .false.
	RETURN

 100   FORMAT ('  Debug results for variable :',A10)
 110   FORMAT ('             Point kriged is :','(',F10.3,',',F10.3,')')
 155   FORMAT ('R.H.S.      Left hand Matrix')
 300   FORMAT (F8.3,3X,18(1X,F7.3))
       END

C--------------------------------------------------------------------
C Show Weights - display weights for program KRIGE

        SUBROUTINE Show Weights (X0, Y0, Neighbors, N, Vk, Sk, Index)
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'
        
        INTEGER*4       Neighbors (1), N, Index, Ptr
        REAL*4          Vk, Sk, SumWeight, X0, Y0, X, Y, V, Wt
        REAL*4          Dx, Dy, D, Sum
	INTEGER*4       Key 
        character*80 output

        SumWeight = 0.0
	CALL Clear Screen

        WRITE (output, 100) VarNam (KrigVar (Index))
	CALL Locate Cursor (2, 0)
	CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 110) X0, Y0
	CALL Locate Cursor (3, 0)
	CALL Put Characters (Output, 80, NORMAL)

        IF (Ktype .EQ. 0) THEN
           WRITE (output, 130)
        ELSE
           WRITE (output, 140)
        ENDIF
	CALL Locate Cursor (4, 0)
	CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 145)
	CALL Locate Cursor (5, 0)
	CALL Put Characters (Output, 80, NORMAL)

	Sum 		= 0.0
	SumWeight 	= 0.0
        DO 10 I = 1, N
          Ptr = Neighbors (I)
          X   = Xdata (Ptr)
          Y   = Ydata (Ptr)
          V   = Data (Ptr, Index) - Mglobal (Index)
          Wt  = B (I)
          Dx  = X - X0
          Dy  = Y - Y0
          D   = SQRT (Dx*Dx+Dy*Dy)
          SumWeight = SumWeight + Wt
	  Sum = Sum + B (I) * B2 (I)  
          if (i .le. 14) then
             WRITE (output, 150) X, Y, V, D, B (I), B2 (I)
             CALL Locate Cursor (5+i, 0)
             CALL Put Characters (Output, 80, NORMAL)
          end if
 10     CONTINUE

        
        i = int(min(i+5.,19.))
        WRITE (output, 160) N, SumWeight
        CALL Locate Cursor (i, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 170) Vk, CVV (Index)
        CALL Locate Cursor (1+i, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 180) Sk, Sum
        CALL Locate Cursor (2+i, 0)
        CALL Put Characters (Output, 80, NORMAL)
	WRITE (output, 190) CVV (Index) - Sum - B (N+1), B(N+1)
        CALL Locate Cursor (3+i, 0)
        CALL Put Characters (Output, 80, NORMAL)

	IF (Sk .LT. 0.0) then
           WRITE (output, 230)
           CALL Locate Cursor (4+i, 0)
           CALL Put Characters (Output, 80, NORMAL)
        end if           

	CALL getthekey (Key)
        if (char(key) .eq. 'q' .or. char(key) .eq. 'Q') keep = .false.
	RETURN

 100   FORMAT ('  Debug results for variable :',A10)
 110   FORMAT ('             Point kriged is :',
     +  '(',F10.3,',',F10.3,')')
 130   FORMAT ('        X(i)        Y(i)      V(i)-m     Distance',
     +         '      W(i)        B2(i)')
 140   FORMAT ('        X(i)        Y(i)        V(i)     Distance',
     +         '      W(i)        B2(i)')
 145   format ('----------------------------------------------------')
 150   FORMAT (6G12.3)
 160   FORMAT ('# Neighbors:',I12  ,'       Weights:',F12.3)
 170   FORMAT ('   Estimate:',G12.3,'            CVV:',F12.3)
 180   FORMAT ('          k:',G12.3,'          WiB2i:',F12.3) 
 190   FORMAT ('          k:',G12.3,'               :',F12.3) 
 230   FORMAT ('*** ERROR *** (Variance is <= 0)')
       END

               
           




