cc$LARGE
C DispGrid.for
C----------------------------------------------------------------------
C Plot Kriging Grid - display and update kriging grid for program KRIGE
C                uses graphics to draw and display grid
C
        SUBROUTINE Plot Kriging Grid (Row, Column)
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)
	PARAMETER (DRAW  = 0)

        INCLUDE 'krige.dec'

        REAL*4      Xfudge, Yfudge
	REAL*4	    Txmin, Txmax, Tymin, Tymax, Txtinc, Tytinc
	REAL*4	    XticL, YTicl
	REAL*4      X, Y, Z, Dx, Dy, Mx, My, Tmin, Tmax
	REAL*4	    Tx, Ty, Fx, Fy, Factor, Ratio
	REAL*4	    TopMargin, BottomMargin, YoffSet
cclong
	real*4	    scaling
cclong
	INTEGER*4   Tnxtic, Tnytic, Row, Column
	INTEGER*4   I, J, N, Type Flag, LENSTR, L
	INTEGER*4   DevMinX, DevMinY, DevMaxX, DevMaxY
	INTEGER*4   IByte
cclong
	integer*4   int4
cc
	CHARACTER   Plot Title*70, Xlabel*40, Ylabel*40, message*60
cclong added message

C ***	Set up scaling

        TXmin  = Xorigin - Xcellsize/2.0
        TXmax  = TXmin + NxCells * XcellSize
        TYmin  = Yorigin - Ycellsize/2.0
        tYmax  = TYmin + NyCells * YcellSize

	Dx 	= ABS (TXmax-TXmin)
	Dy 	= ABS (TYmax-TYmin)
	Ratio	= Dx / Dy
	Tmax 	= AMAX1 (Dx, Dy)
	Minx 	= TXmin - Tmax * .1
ccc	MaxX	= TXmin + Tmax * 1.25
	MaxX	= TXmin + Tmax * 1.4
	MinY 	= TYmin - Tmax * .1
	Maxy 	= TYmin + Tmax * 1.25
	XticL	= (MaxY-MinY) * .01
	YticL	= (MaxX-MinX) * .01
	Mx 	= AMIN1 (XcellSize, YCellSize) * .10
	My 	= Mx

C Shift vertically to center of the screen (for horizontal rectangles)
	IF (Ratio .GT. 1.0) THEN
 10	  TopMargin 	= MaxY - TYmax
	  BottomMargin	= TYmin - Miny
	  IF (TopMargin .GT. BottomMargin) THEN
	     Ty		= AMIN1 (TopMargin, BottomMargin) * .1
	     IF (MaxY - Ty .GT. TYmax) THEN
	       MaxY 	= MaxY - Ty
	       MinY 	= MinY - Ty
	       GOTO 10
	     ENDIF
	  ENDIF
	ENDIF

C Compute SQUARE Device space (corrected by device pixel aspect ratio)
        YoffSet     	= My * 2.0
        DevMinX		= 0
	DevMinY		= 20
	DevMaxY		= YmaxDev
	IF (DevCode .EQ. OTHER) THEN
	   RETURN
	ELSE IF (DevCode .EQ. HERC) THEN
	   Factor 	= 29./45.
ccc	   YoffSet	= My * 5.0
	ELSE IF (DevCode .EQ. CGA) THEN
	   Factor 	= 5./12.
	ELSE IF (DevCode .EQ. EGA) THEN
	   Factor 	= 35./48.
	ENDIF
	DevMaxX = FLOAT (DevMaxY) / Factor

C Set up labels
	IF (.NOT. Point) THEN
          Plot Title  = 'Block kriging: '//VarNam (KrigVar(1))
	ELSE
          Plot Title  = 'Point kriging: '//VarNam (KrigVar(1))
	ENDIF

C graphics setup
 	CALL Zsetup (INT2 (Gmode), Ierr)
	CALL Zlbdir (0.0)
	CALL Zlocat (INT2 (XminDev), INT2 (XmaxDev),
     +		     INT2 (YminDev), INT2 (YmaxDev))
	CALL Zscale (0.0, 1.0, 0.0, 1.0)

c Plot Legend
        CALL Legend

C graphics setup for gridplot
	CALL Zlocat (INT2 (DevMinX), INT2 (DevMaxX),
     +		     INT2 (DevMinY), INT2 (DevMaxY))
	CALL Zscale (Minx, Maxx, Miny, Maxy)
        call grframe(1,1,blue)
	CALL Zcolor (INT2 (White))

C Draw grid outline and grid cell tickmarks
	CALL Zmove (TXmin, TYmin)
	CALL Zplot (TXmin, TYmax)
	CALL Zplot (TXmax, TYmax)
	CALL Zplot (TXmax, TYmin)
	CALL Zplot (TXmin, TYmin)
        DO 15 I = 1, NxCells+1
           X = (Xorigin - Xcellsize*.5) + (I-1) * XcellSize
	   CALL Zmove (X, TyMin)
	   CALL Zplot (X, TyMin-Xticl)
 15	CONTINUE
        DO 25 J = 1, NyCells+1
           Y = (Yorigin - Ycellsize*.5) + (J-1) * YcellSize
	   CALL Zmove (TxMin, Y)
	   CALL Zplot (TxMin-Yticl, Y)
 25	CONTINUE
	
C Title	
	CALL Zmove  (minx + (maxx-minx)/4.0, (TYMax+maxy)/2.0)
	CALL Zlabel (Plot Title)

C Plot original data
	Tx = (MaxX - MinX) * .004
	Ty = (MaxY - MinY) * .004
	DO 5 I = 1, Ndata
	   X = Xdata (I)
	   Y = Ydata (I)
	   IF (Data (I, 1) .LT. Q1) THEN
             IByte = 1
	   ELSEIF (Data (I, 1).GE.Q1.AND.Data (I, 1).LT.Q2) THEN   
             IByte = 2
	   ELSEIF (Data (I, 1).GE.Q2.AND.Data (I, 1).LT.Q3) THEN   
             IByte = 3
	   ELSEIF (Data (I, 1) .GT. Q3) THEN
             IByte = 4
	   ENDIF
	   IF (Data (I, 1) .LT. Missing .AND.
     +	         X .GE. TxMin .AND. X .LE. TxMax .AND.
     +	         Y .GE. TyMin .AND. Y .LE. TyMax)
     +		 CALL Plot Value (X, Y, Tx, Ty, Ibyte)
 5	CONTINUE

C Check for first time call
	IF (Row .EQ. 0 .OR. Column .EQ. 0) RETURN

C Plot all grid cells
        DO 20 I = 1, Row
           X = Xorigin + (I-1) * XcellSize
           DO 20 J = 1, NyCells
	     IF (I .EQ. Row .AND. J .GT. Column) GOTO 20
             Y = Yorigin + (J-1) * YcellSize
cclong Replaced the missing int4 routine with simple int
	     int4 = int(KrigVal(I,J))

             CALL Plot Cell (X, Y, int4,
     +                         XcellSize, YCellSize)
 20	CONTINUE
	RETURN
	END

C----------------------------------------------------------------------
C Put Out Legend for Quartile map
C								     
	SUBROUTINE Legend 
	IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'krige.dec'

        REAL*4          Mx, My, Tx, Tx2, Ty, Inc
	REAL*4		Tmaxy, Dx, Dy, TxMax, TyMax
	CHARACTER	Str*12, Rfmt*7, scratch*15

	DATA Rfmt /'(F12.3)'/

	DATA 	Mx, 	My, 	Tx, 	Tx2, 	Tmaxy, 	Inc
     +	      /.03,	.04,	.80,	.85,	.7,	.05/
ccc     +	      /.03,	.04,	.75,	.80,	.7,	.05/

	Ty	= TmaxY
	CALL Zcolor (INT2 (White))
	CALL ZMove  (Tx2, Ty)
cc	CALL Zlabel (VarNam (KrigVar (1))//'\')
	scratch = VarNam (KrigVar (1))
	CALL Zlabel (scratch)
cc

	Ty = Ty - Inc
	CALL Plot Cell (Tx, Ty, 1, Mx, My)
	WRITE (Str, Rfmt) Q1
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
cc	CALL Zlabel (' < '//Str (1:N) //'\')
	scratch = ' < '//Str (1:N) 
	CALL Zlabel (scratch)
cc

	Ty = Ty - Inc
	CALL Plot Cell (Tx, Ty,  2, Mx, My)
	WRITE (Str,  Rfmt) Q2
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
cc	CALL Zlabel (' < '//Str (1:N)//'\')
	scratch = ' < '//Str (1:N)
	CALL Zlabel (scratch)
cc

	Ty = Ty - Inc
	CALL Plot Cell (Tx, Ty,  3, Mx, My)
	WRITE (Str, Rfmt) Q3
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
cc	CALL Zlabel (' < '//Str (1:N) //'\')
	scratch = ' < '//Str (1:N) 
	CALL Zlabel (scratch)
cc

	Ty = Ty - Inc
 	CALL Plot Cell (Tx, Ty,  4, Mx, My)
	CALL Zmove  (Tx2, Ty)
cc	CALL Zlabel (' >='//Str (1:N) //'\')
	scratch = ' >='//Str (1:N)
	CALL Zlabel (scratch)
cc

	Ty = Ty - Inc
 	CALL Plot Cell (Tx, Ty,  0, Mx, My)
	CALL Zmove  (Tx2, Ty)
cc	CALL Zlabel (' - Missing\')
	scratch = ' - Missing'
	CALL Zlabel (scratch)
cc

	RETURN
	END


C----------------------------------------------------------------------
	SUBROUTINE Plot Value (X, Y, Mx, My, Z)
	REAL*4		X, Y, Mx, My
	INTEGER*4	Color1, Color2, Z

        INCLUDE  'krige.dec'

	Color2 = White
	Color1 = White
	IF (Z .EQ.-1) THEN 
	   Color1 = White
	ELSEIF (Z .EQ. 1) THEN   
	   Color1 = Blue
	ELSEIF (Z .EQ. 2) THEN   
	   Color1 = Green
	ELSEIF (Z .EQ. 3) THEN   
	   Color1 = Yellow
	ELSEIF (Z .EQ. 4) THEN   
	   Color1 = Red
	ENDIF
	CALL Cross (X, Y, Mx, My, Color1, Color2)
	RETURN
	END

C----------------------------------------------------------------------
	SUBROUTINE Plot Cell (X, Y, Z, Xwidth, Ywidth)
	IMPLICIT INTEGER*4 (A-Z)

	REAL*4		X, Y, X1, Y1, Xwidth, Ywidth
	REAL*4		X0, Y0, X2, Y2, Mx, My, Dx, Dy, Tx, Ty
	INTEGER*4	Color1, Color2,  Z

        INCLUDE 'krige.dec'

	Color2 = White
	IF (Z .EQ. 0) THEN 
	   Mx 	= AMIN1 (Xwidth, YWidth)*.35
	   My 	= Mx
	   Color1 = White
	   CALL Cross (X, Y, Mx, My, Color1,Color2)
	   RETURN
	ELSEIF (Z .LT. 0) THEN
	   RETURN   
	ELSEIF (Z .EQ. 1) THEN   
	   Color1 = Blue
	ELSEIF (Z .EQ. 2) THEN   
	   Color1 = Green
	ELSEIF (Z .EQ. 3) THEN   
	   Color1 = Yellow
	ELSEIF (Z .EQ. 4) THEN
	   Color1 = Red
	ENDIF
	Mx = AMIN1 (Xwidth, YWidth) * .04
	My = Mx
	X1 = X - Xwidth*.5
	Y1 = Y - Ywidth*.5
	Dx = Xwidth / FLOAT (Z)
	Dy = Ywidth / FLOAT (Z)
	Tx = Dx*.5
	Ty = Dy*.5
	DO 10 I = 1, Z
	   X0 = X1 + (I-1) * Dx + Tx
	   DO 10 J = 1, Z
	      Y0 = Y1 + (J-1) * Dy + Ty
	      CALL box (X0, Y0, Mx, My, Color1, Color2)
 10	CONTINUE	
	RETURN
	END


