cc$LARGE
C Kriger.for - main kriging subroutine for program KRIGE
C
C----------------------------------------------------------------------
C Kriger  - Performs kriging for each block in a grid for program KRIGE
C
        SUBROUTINE Kriger (Quit, Error)
	IMPLICIT INTEGER*4 (A-Z)

	character	shift status, message*60

	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)
	PARAMETER (DRAW  = 0)

        INCLUDE 'krige.dec'

        INTEGER*4       Neighbors (MAXNEIGHBOR), N
        INTEGER*4       TNeighbors (MAXNEIGHBOR), TN
        INTEGER*4       I, J, K, Estfile, Ptr
	INTEGER*4	Num Missing, Num Excluded, Num Kriged, Numcells 
cclong
	integer*4	int4
cc
        REAL*4          X0, Y0, Min, Max
	REAL*4		Zstar (MAXVARK), Zstd (MAXVARK)
        CHARACTER       Ch*1, Str*10, Line*60, Blanks*70, File Name*65
	CHARACTER	Ifmt*4, Fmt*7, Header*72
        LOGICAL         Error, Failed, MissExist, Quit
	LOGICAL  	Debug Mode, SysError

cclong 11/30/93
        character menu choice*10
cclong 11/30/93
        integer destination

        DATA Estfile /10/, Ifmt /'(I5)'/, Fmt /'(G10.3)'/

	Header =  '    #        X           Y           Z*'//
     +    '          k           N'
	Error = .FALSE.
	Quit  = .FALSE.
C Initialize Kriging quartile values to 0 (Missing)
	CALL Erase (23, 1, 77)
	DO 2 I = 1, NxCells
	   DO 2 J = 1, NyCells
	      IF (Excluded (I, J)) THEN
	         KrigVal (I, J) = -1
	      ELSE
	         KrigVal (I, J) = 0
	      ENDIF 
 2	CONTINUE
	
C calculate relative offsets from discretization points to block centers        
        CALL Digitize

C calculate the average block covariance using digitized coordinates
cc	CALL PutStr ('Computing average block covariance ',36,20,2,2)
	CALL PutStr (
     &       '"n", neighbors; "w", weights; "s", system; "q", quit.'
     &       ,53,23,2,2)
cc
        CALL CalcCvv

C calculate quartiles of KrigVar (1)
	CALL Quartiles (Data, 1, Ndata, Q1, Q2, Q3)

C Open output files and write header information to files
	CALL Get File Name (File Name, File Prefix, OutFile, Fexist)
ccsow  i added status='unknown, in open statement       
        OPEN (Unit = EstFile, File = File Name, STATUS ='unknown',
     +         ERR = 999)

C Headers
        WRITE (EstFile, 100, ERR = 999) Title

C Number of variables
        WRITE (EstFile, '(I3)', ERR = 999) NkVar*2+2

C Coordinate variables
        WRITE (EstFile, 300, ERR = 999) VarNam(Xvar), Units (Xvar)
        WRITE (EstFile, 300, ERR = 999) VarNam(Yvar), Units (Yvar)

C Kriged variables and Kstd
        DO 5 I = 1, NkVar
            WRITE (EstFile, 300, ERR = 999)
     +	 '*'//VarNam(KrigVar(I))(1:9), Units(KrigVar(I))
            WRITE (EstFile, 300, ERR = 999)
     +	 'KSD'//VarNam(KrigVar(I))(1:7), '          '
 5      CONTINUE  

C initialize debug states 
        Debug System    = .FALSE.
        Debug Weights   = .FALSE. 
        Debug Neighbors = .FALSE. 
        Debug Mode = .FALSE. 
        
        CALL Erase (20, 0, 79)
        CALL Put Str('To initialize debug states, type the letter now '
     &       //'(else return):', 62, 20, 2, 2)
        CALL Put Str('System - Type "s", Weights - Type "w", Search'
     &       //' - Type "n", Print - "p"',69, 23,2,2)
        call getthekey(ikey)
        shift status = ''
        if (ikey .lt. 127 .and. ikey .gt. 31) then
           shift status = char(ikey)
           if (shift status .eq. 's') then
              Debug System = .TRUE.
              keep = .true.
           else IF (shift status .eq. 'w') then
              Debug Weights = .TRUE. 
              keep = .true.
           else IF (shift status .eq. 'n') then
              Debug Neighbors = .TRUE. 
              keep = .true.
           else IF (shift status .eq. 'p') then
cclong 11/30/93              call turn_ps_on('krige.ps')

              message='krige.ps'
              call post script(message,destination)
              if (destination .eq. 1) goto 1

              i = lenstr(message)
              call putstr(message(1:60),60,5,10,2)
              j = lenstr(fileprefix)
              call turn_ps_on(fileprefix(1:j)//message(1:i))
cclong 11/30/93
              keep = .true.
           else IF (shift status .eq. 'q') then
              goto 999
           end if
        end if

 1      IF (Debug Weights .OR. Debug System .OR. Debug Neighbors) THEN
           DebugMode = .TRUE.
           keep = .TRUE.
	ELSE
C     Write out headings for the default display
           IF (Graphics) THEN
              CALL Plot Kriging Grid (0, 0)
           ELSE
              CALL Erase (23, 0, 79)
              CALL Erase (24, 0, 79)
              CALL Put Str ('Kriging Estimates ...', 21, 20, 2, 2)
           ENDIF
           IF (DevCode .NE. HERC) THEN
              CALL Locate Cursor (22, 5)
              CALL Put Characters (Header, 72, 0)
           ENDIF
	ENDIF
        
C     perform kriging for each block or node in grid
        Num Missing  = 0
        Num Excluded = 0
        Num Kriged   = 0
	NumCells     = 0
        DO 10 I = 1, NxCells
           X0   = Xorigin + (I-1) * XcellSize 
           DO 20 J = 1, NyCells
              Y0 = Yorigin + (J-1) * YcellSize
	      IF (Quit) GOTO 888
	      NumCells = NumCells + 1
	      MissExist = .False.
C     check if point has been explicitly excluded
	      IF (.NOT. Excluded (I, J)) THEN
C     search neighborhood
	         N = 0	
                 CALL Search (X0, Y0, Neighbors, N, 1, Failed)
                 IF (Debug Neighbors .AND. .NOT. Failed) THEN 
                    IF (Graphics) THEN
                       CALL Show Neighbors (X0, Y0, Neighbors, N) 
                       CALL Plot Neighbors (X0, Y0, Neighbors, N) 
                    ELSE
                       CALL Show Neighbors (X0, Y0, Neighbors, N) 
                    ENDIF
                 ENDIF
                        
C     for each variable, set up kriging system and solve
                 DO 30 K = 1, Nkvar
                    IF (Quit) GOTO 888
                    Zstar (K) = Missing
                    Zstd  (K) = Missing
                    Estimate  = Missing
                    Variance  = Missing
                    Var 	= K 
                    MissExist   = .FALSE.
                    IF (.NOT. Euclidean .AND. K .GT. 1) THEN
                       N = 0
                       CALL Search (X0, Y0, Neighbors, N, K, Failed)
                       IF (Debug Neighbors .AND..NOT. Failed) 
     +                      CALL Show Neighbors (X0, Y0, Neighbors, N)
                    ENDIF
                    
                    IF ((N .EQ. 0) .OR. Failed) THEN
	               MissExist = .TRUE. 
                    ELSE
                       CALL Build System (X0, Y0, Neighbors, N,
     +                      Tneighbors, TN, K)
C     TN is the number of neighbors with non-missing sample values
C     TNeighbors holds the pointers to such samples
                       IF (TN .LE. 0) THEN
                          MissExist = .TRUE.
                          GOTO 35
                       ENDIF
                       
                       IF (Debug System) 
     +                      CALL Show System (X0, Y0, TN, K) 
                       
C     Special check added for neighbor coinciding with kriged point
                       Ptr = Tneighbors (1)
                       IF (ABS (Xdata (Ptr) - X0) .LE. Tiny .AND.
     +                      ABS (Ydata (Ptr) - Y0) .LE. Tiny .AND.
     +                      Point) THEN
                          Estimate = Data (Ptr, K)
                          Variance = 0.0 
                       ELSE
C     Solve the system of equations    
                          CALL Solve System (TNeighbors,TN, Estimate, 
     +                         Variance, K, SysError) 
                       ENDIF    
                       
                       IF (Debug Weights .AND. .NOT. SysError)
     +                      CALL Show Weights (X0, Y0, TNeighbors, TN,
     +                      Estimate, Variance, K)
                       
C   accumulate stats, assign krigval (-1=excluded, 0=missing, else=quartile)
                       IF (Estimate .LT. Missing) THEN       
                          Zstar (K) = Estimate
                          Zstd  (K) = Variance
                          IF (K .EQ. 1) THEN 
                             IF (Estimate .LT. Q1) THEN
                                KrigVal (I, J) = 1
                      ELSEIF (Estimate.GE.Q1.AND.Estimate.LT.Q2) THEN   
                                KrigVal (I, J) = 2
                      ELSEIF (Estimate.GE.Q2.AND.Estimate.LT.Q3) THEN   
                                KrigVal (I, J) = 3
                             ELSEIF (Estimate .GT. Q3) THEN
                                KrigVal (I, J) = 4
                             ENDIF
                          ENDIF
                       ENDIF
                    END IF
 35		    CONTINUE
                    
C initialize debug states 
ccc
                    if (.not. keep) then
                       Debug System    = .FALSE.
                       Debug Weights   = .FALSE. 
                       Debug Neighbors = .FALSE. 

                       ikey = -666
                       call checkkey(ikey)
                       shift status = ''
                       if (ikey .lt. 127 .and. ikey .gt. 31)
     &                      shift status = char(ikey)

                       if (shift status .eq. 's') then
                          Debug System = .TRUE.
                       else IF (shift status .eq. 'w') then
                          Debug Weights = .TRUE. 
                       else IF (shift status .eq. 'n') then
                          Debug Neighbors = .TRUE. 
                       else IF (shift status .eq. 'q') then
                          goto 888
                       end if
                    end if
                    
        IF (Debug Weights .OR. Debug System .OR. Debug Neighbors) THEN
                       DebugMode = .TRUE.
                       keep = .TRUE.
                    ELSE
	               IF (DebugMode) THEN
                          IF (Graphics) THEN
                             CALL Plot Kriging Grid (I, J)
                          ELSE 
                             CALL NewScreen (3)
                          ENDIF
                          IF (DevCode .NE. HERC) THEN
                             CALL Locate Cursor (22, 5)
                             CALL Put Characters (Header, 72, 0)
                          ENDIF
          	       ENDIF  
          	       DebugMode = .FALSE.
                    ENDIF
	            IF (Quit) GOTO 888
                    
C     Write out cell results
ccc	            IF (.NOT. DebugMode) THEN
	            IF (.NOT. Debug Neighbors) THEN
cc    
cclongAdded int4 to take the place of a missing function
                       int4 = int(KrigVal (I,J))
                       IF (Graphics)
     +                      CALL Plot Cell (X0, Y0, 
     +                      int4,
     +                      XcellSize, YCellSize)  
                    ENDIF
 30           CONTINUE
           ENDIF
           
C     Accumulate counts
           IF (Excluded (I, J)) THEN
              Num Excluded = Num Excluded + 1
           ELSE IF (MissExist) THEN
              Num Missing = Num Missing + 1
           ELSE
              Num Kriged = Num Kriged + 1 
           ENDIF
           
C     Write estimates and estimation error to output file
           WRITE (EstFile, 400, ERR = 999) X0, Y0,
     +          (Zstar (K), Zstd (K),  K = 1, NkVar)
 20     CONTINUE
 10   CONTINUE
      
C     Grid has been kriged - close file 
      CLOSE (Estfile)
      IF (DevCode .NE. HERC) THEN
         CALL Erase (22, 2, 75)
         CALL Erase (23, 2, 75)
      ENDIF
      
C     Normal Exit
      IF (Debug Mode) THEN
         GOTO 888
      ELSE
         CALL Finish Beep
      ENDIF
      call reset()
      RETURN
      
C     Stop kriging exit 
 888  CLOSE (EstFile)
      CALL Beep
      Quit = .TRUE.
      RETURN
      
C     file error exit
 999  CLOSE (EstFile)
      CALL Beep
      Error = .TRUE.
      RETURN
      
C     formats for output
 100  FORMAT ('Kriging estimates produced from data file ',A14)
 300  FORMAT (2A10)
 400  FORMAT (12(E14.7,1X))        
      END
      
C---------------------------------------------------------------------
      
