cc...$LARGE
C Levels.for - sets up lag cutoffs for VARIO
C
C----------------------------------------------------------------------
C  Set Up Lags - set lags for VARIO

	SUBROUTINE Set Up Lags
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'krige.dec'
	INCLUDE '../common/screen.str'

	CHARACTER*10		Field Name, Scratch*13 
	REAL*4			TCutoff
	INTEGER*4		Field, Fld Index, K
	DATA			Field Name /'LAGDIST   '/

C set levels
	K = Fld Index ('LAGMENU   ')
	Tcutoff    = LagMinDist + LagIncDist
	DO 10 I = 1, MAXLAG
	   SC Down (K+I) = 1
	   SC Up   (K+I) = -1
	   WRITE (Field Name (9:10), '(I2)') I
           Field = Fld Index (Field Name) 
	   IF (I .EQ. 1 ) THEN
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) =  1
	     SC Up              (Field) = -13
	   ELSEIF (I .EQ. MAXLAG) THEN
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) = -36
	     SC Up              (Field) = -1
	   ELSE
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) =  1
	     SC Up              (Field) = -1
	   ENDIF
	   IF (Tcutoff .LE. LagMaxDist) THEN
	      Nlag = I
	      LagCutoff (I) = Tcutoff
	      CALL Set 4Floating Point Value (Field Name, Tcutoff, 3)
	   ELSE
	      CALL Set Character Value (Field Name, '             ')
	   ENDIF
	   Tcutoff = Tcutoff + LagIncDist
 10	CONTINUE 	

C Set Field links for last lag distance
	WRITE (Field Name (9:10), '(I2)') Nlag
	Field			   = Fld Index (Field Name)
	SC Carriage Return (Field) = - (12+Nlag)
	SC Down            (Field) = - (12+Nlag)
	SC Up              (Field) = -1

C fix lag menu links
	K = Fld Index ('LAGMENU   ')
	SC Up    (K+1) 		=    Nlag-1
	SC Down  (K+Nlag) 	=  - Nlag+1
	
 	RETURN
	END

C----------------------------------------------------------------------
C Display Lag Cutoffs

	SUBROUTINE Display Lag Cutoffs

	INCLUDE 'krige.dec'

	CHARACTER*10  Field Name
	
	DATA	Field Name /'LAGDIST   '/

 	DO 10 I = 1, MAXLAG
	   WRITE (Field Name (9:10), '(I2)') I
	   IF (I .LE. Nlag) THEN
	      CALL Display One Field (Field Name)
	   ELSE
	      CALL Erase Field (Field Name)
	   ENDIF
  10	CONTINUE  	
	RETURN
	END

C----------------------------------------------------------------------
C Reset Lags - erase the lag levels
	
	SUBROUTINE Reset Lags
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'krige.dec'
	INCLUDE '../common/screen.str'

	CHARACTER*10	Field Name
	INTEGER*4	Field, Fld Index

	DATA		Field Name /'LAGDIST   '/

	K = Fld Index ('LAGMENU') + 1
	SC Up (K) = 23

C reset lags
	DO 10 I = 1, MAXLAG
	   WRITE (Field Name (9:10), '(I2)') I
           Field = Fld Index (Field Name) 
	   IF (I .EQ. 1 ) THEN
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) =  1
	     SC Up              (Field) = -13
	   ELSEIF (I .EQ. MAXLAG) THEN
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) =  1
	     SC Up              (Field) = -1
	   ELSE
	     SC Carriage Return (Field) =  1
	     SC Down            (Field) = -36
	     SC Up              (Field) = -1
	   ENDIF
	   Pairs     (I) = 0
	   LagCutoff (I) = 0.0
	   CALL Set Character Value (Field Name, '             ')
	   CALL Erase Field   (Field Name)
	   SC Down (K + I) = 1
  10	CONTINUE  	
	Nlag = 0
	END

C----------------------------------------------------------------------
C Arrange Lags - arrange the lag levels in increasing distance
	
	SUBROUTINE Arrange Lags
	IMPLICIT INTEGER*4 (A-Z)

	INCLUDE 'krige.dec'

	CHARACTER*10	Field Name
	DATA		Field Name /'LAGDIST   '/

C sort lags
	IF (Nlag .LE. 0) RETURN
	CALL Rank (LagCutoff, Nlag)
	DO 10 I = 1, Nlag
	   WRITE (Field Name (9:10), '(I2)') I
	   CALL Set 4Floating Point Value 
     +		(Field Name, LagCutoff (I), 3) 
	   CALL Display One Field (Field Name)
  10	CONTINUE  	

  	RETURN
	END


C*************************************************************************
C SUBROUTINE RANK - RANKS A VECTOR IN ASCENDING ORDER
C
C   VARIABLES       A - THE VECTOR TO BE SORTED
C                   N - NUMBER OF ELEMENTS IN VECTOR
C
      SUBROUTINE RANK (A, N)
      DIMENSION	 A (1)
      INTEGER*4	 N, I, J

      M=N
   20 M=M/2
      IF(M) 30,40,30
   30 K=N-M
      J=1
   41 I=J
   49 L=I+M
      IF(A(I)-A(L)) 60,60,50
   50 B=A(I)
      A(I)=A(L)
      A(L)=B
      I=I-M
      IF(I-1) 60,49,49
   60 J=J+1
      IF(J-K) 41,41,20
   40 RETURN
      END


