cc$LARGE
C Readdata.for - file input routines for STATS
C
C----------------------------------------------------------------------
C ***  Read Header Data - get data from input file 

	SUBROUTINE Read Header Data  (File Name, Error)
	IMPLICIT INTEGER*4 (A-Z)
 	
        INCLUDE 'krige.dec'

	LOGICAL		Error
	CHARACTER	Blanks*10, Scratch*5, File Name*(*)
	CHARACTER	Dummy*10

	DATA Blanks /'          '/

C Open File for input
	CALL PutStr ('Reading Header Data ',20, 20, 2, 2)
	Error 	= .FALSE.

cclong	OPEN(UNIT = 10, FILE =File Name, FORM ='unformatted',
cc     +        STATUS ='unknown', ERR = 999)
	OPEN(UNIT = 10, FILE =File Name,
     +        STATUS ='unknown', ERR = 999)

C Read header string into header character variable
	READ (10, '(A)', ERR = 999, END = 999) Dummy

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) Nvar
	IF (Nvar .LT. 3) THEN 
	   CALL Flash (20, 2, 
     +              'Too few variables in file  (press any key)') 
	   GOTO 999
	ELSEIF (Nvar .GT. MAXVAR) THEN
	   CALL Flash (20, 2, 
     +              'Too many variables in file  (press any key)') 
	   GOTO 999
	ENDIF

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999)
     +                        Varnam (i), Units (i)
 20     CONTINUE        

C Load variable names into toggle fields for screen processing
	CALL Load Toggle Values  ('GR XVAR   ',10, Nvar, VarNam, 0)
	CALL Load Toggle Values  ('GR YVAR   ',10, Nvar, VarNam, 1)
	CALL Load Toggle Values  ('KRIGEVAR  ',10, Nvar, VarNam, 2)
	CALL Set Toggle Position ('GR XVAR   ', Xvar-1)
	CALL Set Toggle Position ('GR YVAR   ', Yvar-1)
	CALL Set Toggle Position ('KRIGEVAR  ', KrigVar (1)-1)
	CLOSE (10)
	RETURN

C error has been found in data of file
 999	Error = .TRUE.
	CLOSE (10)
	CALL Beep
	CALL Erase Field ('GR XVAR   ')
	CALL Erase Field ('GR YVAR   ')
	CALL Flash (20, 2, ' Press any key to exit ')
	Ndata = 0
	Nvar  = 0
	Nkvar = 0
	RETURN
	END

C----------------------------------------------------------------------
C Read Coordinate Values - read coordinates into memory

	SUBROUTINE Read Coordinate Values (Error)
	IMPLICIT INTEGER*4 (A-Z)
	
        INCLUDE 'krige.dec'

	CHARACTER 	Dummy*75, Scratch*5, File Name*65
	LOGICAL		Error, Fexist
	REAL*4		DataRec (MAXVAR), Dx, Dy, DistMax
	REAL*4		TxMax, Txmin, Tymax, Tymin, Txtinc, Tytinc
	INTEGER*4	TnXTic, TnYtic

C Initialize Variables

	CALL PutStr ('Reading Coordinates ...  ', 25, 20, 2, 2)

	CALL Get File Name (File Name, File Prefix, Data File, Fexist)

	IF (.NOT. Fexist) THEN
	   Error = .TRUE.
	   GOTO 999
	ENDIF

C Open File for input
	Error 	= .FALSE.
cc	OPEN(UNIT = 10, FILE =File Name, FORM ='unformatted', 
cc     +       STATUS ='unknown', ERR = 999)
	OPEN(UNIT = 10, FILE =File Name,
     +       STATUS ='unknown', ERR = 999)

C Read header string 
	READ(10, '(A)', ERR = 999, END = 999) Dummy

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) Nvar

	IF (Nvar .LT. 1 .OR. Nvar .GT. MAXVAR) GOTO 999

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999) Dummy, Dummy
 20     CONTINUE        

	Ndata  		= 0
	Xmin		= 1.E30
	Xmax		= -1.E30
	Ymin		= Xmin
	Ymax		= Xmax
	DO 30 Nrec = 1, MAXDATA
	   READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	   IF (Datarec (XVar) .LT. Missing .AND.
     +        Datarec (YVar) .LT. Missing) THEN
	      Ndata 		= Ndata + 1
	      Xdata (Ndata)	= DataRec (Xvar)
	      Ydata (Ndata)	= DataRec (Yvar)
	      Yvalues (Ndata)  	= Ydata (Ndata) 
	      YvalPtr (Ndata) 	= Ndata
	      Xmax = AMAX1 (Xdata (Ndata), Xmax)
	      Ymax = AMAX1 (Ydata (Ndata), Ymax)
	      Xmin = AMIN1 (Xdata (Ndata), Xmin)
	      Ymin = AMIN1 (Ydata (Ndata), Ymin)
	   ENDIF
 30	CONTINUE

C check if more than MAXDATA records
	READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	CALL Flash (20, 2, 'Only MAXDATA samples used (Press a Key)')

 900	IF (Ndata .LE. 1) GOTO 999
 	CLOSE (10)

C Sort YData values
	CALL PutStr ('Sorting Y Coordinates... ', 25, 20, 2, 2)
	CALL qsort  (Yvalues, YvalPtr, Ndata)

C Calculate a default grid
	IF (NxCells .EQ. 0 .OR. NyCells .EQ. 0) THEN
	  Xorigin	= Xmin
	  Yorigin 	= Ymin
	  XcellSize 	= (Xmax-Xmin)/9.0
	  YcellSize 	= (Ymax-Ymin)/9.0
	  NxCells 	= 10
	  NyCells 	= 10
	  CALL Set 4 Floating Point Value ('GR XORG   ', Xorigin, 3)
	  CALL Set 4 Floating Point Value ('GR YORG   ', Yorigin, 3)
	  CALL Set 4 Floating Point Value ('GR XCSIZE ', XcellSize, 3)
	  CALL Set 4 Floating Point Value ('GR YCSIZE ', YcellSize, 3)
	  CALL Set Integer Value          ('GR XNCELL ', NxCells)
	  CALL Set Integer Value          ('GR YNCELL ', NyCells)
	ENDIF

C Calculate Defaults for the Variogram model and search parameters
	IF (SrMajor .EQ. 0.0 .OR. SrMinor .EQ. 0.0) THEN
    	  Dx = ABS (Xmax - Xmin)
    	  Dy = ABS (Ymax - Ymin)
    	  SrMajor = AMAX1 (Dx, Dy) * .25
     	  SrMinor = SrMajor
    	  SrAngle = 0.0
    	  CALL Set 4Floating Point Value ('SE RMAJOR ', SrMajor, 3)
    	  CALL Set 4Floating Point Value ('SE RMINOR ', SrMinor, 3)
    	  CALL Set 4Floating Point Value ('SE ANGLE  ', SrAngle, 3)
	ENDIF	    
	CALL Erase (20, 2, 75)
	RETURN

C error has been found in data
 999	Error 		= .TRUE.
	CLOSE (10)

        call flash(20,2,'An error has been found in the data file.')
        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        end if

	CALL Erase Field ('GR XVAR   ')
	CALL Erase Field ('GR YVAR   ')
	Ndata = 0
	Nvar  = 0
	NXcells = 0
	NyCells = 0
	RETURN
	END

C----------------------------------------------------------------------
C Read Data - read data into memory

	SUBROUTINE Read Data (Error)
	IMPLICIT INTEGER*4 (A-Z)
	
        INCLUDE  'krige.dec'

	CHARACTER 	Dummy*75, Scratch*5, File Name*65, Ifmt*4
	LOGICAL		Error, Fexist
	REAL*4		DataRec (MAXVAR), Dx, Dy, DistMax

C Initialize Variables
	DATA Ifmt /'(I5)'/

	CALL PutStr ('Reading Data Values ...  ', 25, 20, 2, 2)

C Build File name
	CALL Get File Name (File Name, File Prefix, Data File, Fexist)

C Open File for input
	Error 	= .FALSE.
cclong	OPEN(UNIT = 10, FILE =File Name, FORM ='unformatted',
cc     +        STATUS ='unknown', ERR = 999)
	OPEN(UNIT = 10, FILE =File Name,
     +        STATUS ='unknown', ERR = 999)
cc

C Read header string 
	READ(10, '(A)', ERR = 999, END = 999) Dummy

C Get number of variables in file
	READ(10, *, ERR = 999, END = 999) Nvar

	IF (Nvar .LT. 1 .OR. Nvar .GT. MAXVAR) GOTO 999

C Get variable names for each variable in file
  	DO 20 I = 1,  Nvar
 	  READ (10,'(2A10)', ERR = 999, END = 999) Dummy, Dummy
 20     CONTINUE        

	Ndata  		= 0
	DO 30 Nrec = 1, MAXDATA
	   READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	   Nrecord		= Nrecord + 1
	   IF (Datarec (XVar) .LT. Missing .AND.
     +        Datarec (YVar) .LT. Missing) THEN
	      Ndata = Ndata + 1
	      DO 35 J = 1, NkVar
	         Data (Ndata, J) = DataRec (KrigVar (J))
 35	      CONTINUE
	   ENDIF
 30	CONTINUE

C check if more than MAXDATA records
	READ (10, *, END = 900, ERR = 999) (DataRec (i), i=1, Nvar)
	CALL Beep
	CALL Flash (20, 2, '# data exceeds limits, only MAXDATA used')

 900	IF (Ndata .LE. 1) GOTO 999
 	CLOSE (10)
	CALL Erase (20, 2, 75)
	RETURN

C error has been found in data
 999	Error 		= .TRUE.
	CLOSE (10)

        call flash(20,2,'An error has been found in the data file.')
        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        end if

	CALL Erase Field ('GR XVAR   ')
	CALL Erase Field ('GR YVAR   ')
	Ndata = 0
	Nvar  = 0
	NxCells = 0
	NyCells = 0
	CALL Erase (20, 2, 75)
	RETURN
	END


