C------------------------------------------------------------------------
        PROGRAM COKRIG
        IMPLICIT INTEGER*4 (a-z)

		include 'cokrig.inc'
		include '../common/screen.str'

        LOGICAL         Exists, Readstruc
        LOGICAL	        GetYesNo
        character*80    geoeas_home

        call get_geoeas_dir(10,geoeas_home)
C Initialize graphics variables
ccc        CALL GrafInit
cclong  added this to make graphics true (noticed it in the Vario on the tape)
        graphics = .true.
        CALL set up screen()
cclong  added this as in test.for
        CALL Clear Screen
        CALL Read Structure (geoeas_home(1:lenstr(geoeas_home))
     &       //'/rn/cokrig.scr')

        CALL Initialize
        CALL Read System Defaults
cclong
        if (intro) CALL Intro Screen
cc
        CALL Get Screen Fields
        CALL Write System Defaults
C        CALL SetMod (INT2 (StartMode))

  10     FORMAT (' KRIGE cannot operate without the file krige.scr',
     +  /,/,    '   This file could not be located in the default',
     +  /,      ' directory.  Please copy this file into the current',
     +  /,      ' directory and try again.',//)
        END

C----------------------------------------------------------------------
C Initialize - initializes GLOBAL variables for program COKRIGE

        SUBROUTINE Initialize

        IMPLICIT INTEGER*4 (A-Z)

		include 'cokrig.inc'

        INTEGER*4       I, J

        DO 10 I = 1, MAXG
           NEST(I)   = 1
           NESTP(I)  = (I-1)*maxn
           SILL(I)   = 0.0
           NTYPCS(I) = 0
 10     CONTINUE

        DO 20 I = 1,MAXGN
           NVTYPE(I) = 1
           NSIGN(I)  = 1
           C(I)      = 0.0
           AAXIS(I)  = 0.0
           BAXIS(I)  = 0.0
           CAXIS(I)  = 0.0
           THETA(I)  = 0.0
           BETA(I)   = 0.0
           AFAOB(I)  = 0.0
           AFAOC(I)  = 0.0
           STHETA(I) = 0.0
           CTHETA(I) = 0.0
           SBETA(I)  = 0.0
           CBETA(I)  = 0.0
 20     CONTINUE

        NPX    = 1
        NPY    = 1
        NPZ    = 1
        NDP    = 1
        XLBL   = 0.0
        YLBL   = 0.0
        ZLBL   = 0.0
        XEAST  = 0.0
        YNORTH = 0.0
        ZELEV  = 0.0
        NSE    = 1
        NFE    = 1
        NSN    = 1
        NFN    = 1
        NSB    = 1
        NFB    = 1
        AZMUTH = 0.0
        DIP    = 0.0
        RADIIA = 0.0
        RADIIB = 0.0
        RADIIC = 0.0
        MINHOL = 0
        MAXHOL = 0
        NVA   = 0
        MVAR   = 0
        DIMEN  = 0
        NSAMP  = 0
        NUMHOL = 0
        IPKRIG = 0
        IDUAL  = 0
        ILIST  = 0
        ZER0   = 1.E-6
        ICX    = 1
        ICY    = 2
        ICZ    = 3
        IOUT   = 1
        INPUT  = 2
        IPCH   = 3
        ITEMP  = 4
        IDBUG  = 0
        NXCOL  = 0
        ITH    = 0
        NP     = 0 
cclong should be 1e31        Missing= 1.E+30
        Missing= 1.E+31
        Local  = 0                    

        DO 30 I = 1,MAXV
          NTERM(I) = 1
          NTERMP(I) = (I-1)*mterm
cclong          TEST(I)   = 1.E+30
          TEST(I)   = 1.E+31
          WGT(I)    = 1.0
          ICV(I)    = 0
 30     CONTINUE

        DO 40 I = 1,MTERM
           EX(I) = 0.0
           EY(I) = 0.0
           EZ(I) = 0.0
 40     CONTINUE

        DO 50 I = 1,MAXNUM
          X(I) = 0.0
          Y(I) = 0.0
          Z(I) = 0.0
 50      CONTINUE

        DO 60 I = 1,INHOLE
          GRADE(I) = 0.0
 60     CONTINUE

        DO 70 I = 1,NTS
          NHOL(I) = 0
          NATR(I) = 0
 70     CONTINUE


c       Minimum  = -1.E30
c       Maximum  = +1.E30
        PchFile  = ' '
        OutFile  = ' '
        IparFile = ' '
        OparFile = ' '
        CALL DIAG (NDG,NTS)
        RETURN
        END

C----------------------------------------------------------------------
C ReInitialize - initializes GLOBAL variables for program KRIGE

        SUBROUTINE ReInitialize
        IMPLICIT INTEGER*4 (A-Z)

		include 'cokrig.inc'

        CHARACTER*10    Scratch
        INTEGER*4       Fld Index, Field, Pos
        DATA Scratch /'             '/

        CALL Initialize

C----------------------------------------------------------------------
C init variable names

        CALL Load Toggle Values ('GR XVAR   ', 10, 10, Blanks, ICX-1)
        CALL Load Toggle Values ('GR YVAR   ', 10, 10, Blanks, ICY-1)
        CALL Load Toggle Values ('GR ZVAR   ', 10, 10, Blanks, ICZ-1)
        CALL Load Toggle Values ('VRM VARIA ', 10, 10, Blanks,
     +          ICV (1)-1)

C----------------------------------------------------------------------
C init search stuff
        CALL Set Character Value ('SE RADIIA  ', Scratch)
        CALL Set Character Value ('SE RADIIB  ', Scratch)
        CALL Set Character Value ('SE RADIIC  ', Scratch)
        CALL Set Character Value ('SE AZMUTH  ', Scratch)
        CALL Set Character Value ('SE DIP     ', Scratch)
        CALL Set Character Value ('SE MINHOL  ', Scratch)
        CALL Set Character Value ('SE MAXHOL  ', Scratch)

C        Pos = 1
C        IF (Euclidean) Pos = 0
C        CALL Set Toggle Position  ('SE DTYPE  ', Pos)
C        CALL Set Toggle Position  ('SE MAXPO  ', MaxPs-1)
C        CALL Set Toggle Position  ('SE MINPT  ', MinP-1)
C        CALL Set Toggle Position  ('SE ETYPE  ', Nsector/4)
c        CALL Set Toggle Position  ('SE MAXEMPT', MaxEmpty)
C
C----------------------------------------------------------------------
C init grid stuff
        CALL Set Character Value ('GR XORG   ', Scratch)
        CALL Set Character Value ('GR YORG   ', Scratch)
        CALL Set Character Value ('GR ZORG   ', Scratch)
        CALL Set Character Value ('GR ZCSIZE ', Scratch)
        CALL Set Character Value ('GR XCSIZE ', Scratch)
        CALL Set Character Value ('GR YCSIZE ', Scratch)
        CALL Set Character Value ('GR NSE    ', Scratch)
        CALL Set Character Value ('GR NSN    ', Scratch)
        CALL Set Character Value ('GR NSB    ', Scratch)
        CALL Set Character Value ('GR NFE    ', Scratch)
        CALL Set Character Value ('GR NFN    ', Scratch)
        CALL Set Character Value ('GR NFB    ', Scratch)

C----------------------------------------------------------------------
C init kriging type
        CALL Set Toggle Position      ('TY KRIGE  ', 1)
        CALL Set Toggle Position      ('TY PTBLOCK', 1)
        CALL Set Character Value ('TY NPX    ', Scratch)
        CALL Set Character Value ('TY NPY    ', Scratch)
        CALL Set Character Value ('TY NPZ    ', Scratch)
        CALL Set Character Value ('PCHFILE  ', PchFile)
        CALL Set Character Value ('OUTFILE   ', OutFile)
        CALL Set Character Value ('IPARFILE  ', IparFile)
        CALL Set Character Value ('OPARFILE  ', OparFile)

C Variogram Fields
        CALL Set Character Value ('VRM ENTRY ', Scratch)
        CALL Set Character Value ('VRM CROSS ', Scratch)
        CALL Set Character Value ('VRM NEST  ', Scratch)
        CALL Set Character Value ('VRM SILL  ', Scratch)
        CALL Set Character Value ('VRM NUM   ', Scratch)
        CALL Set Character Value ('VRM TYPE  ', Scratch)
        CALL Set Character Value ('VRM SIGN  ', Scratch)
        CALL Set Character Value ('VRM CILL  ', Scratch)
        CALL Set Character Value ('VRM RANGEA', Scratch)
        CALL Set Character Value ('VRM RANGEB', Scratch)
        CALL Set Character Value ('VRM RANGEC', Scratch)
        CALL Set Character Value ('VRM AZMUTH', Scratch) 
        CALL Set Character Value ('VRM DIP   ', Scratch)

        RETURN
        END

C----------------------------------------------------------------------
C Get Field Group - get a group of fields, perform processes

        SUBROUTINE Get Field Group
        IMPLICIT INTEGER*4 (A-Z)

        PARAMETER (Main Menu Field = 3)
        PARAMETER (Menu Field      = 4)

		include'../common/screen.str'

        LOGICAL         Error, Repaint, Quit

 10     CALL Get Field
        CALL Perform Process (SC Field Name (Current Field),
     +                     Error, Repaint)

        IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +      SC Field Type (Next Field) .NE. Menu Field) GOTO 10

        IF (Repaint) THEN
           CALL New Screen (Current Screen)
        ENDIF

        RETURN
        END

C----------------------------------------------------------------------
C Get Screen Fields -   displays screen frame/label/fields
C                       gets the screen fields for the current screen

        SUBROUTINE Get Screen Fields
        IMPLICIT INTEGER*4 (A-Z)

        PARAMETER (MAINSCR = 2, OSCREEN = 3, DSCREEN = 4)
        PARAMETER (VRMSCREEN = 5)
        PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

		include'cokrig.inc'
		include'../common/screen.str'

        CHARACTER*10    Main Menu, O Menu, DMenu, TESTN, testm,
     +                  File Name*65, VRM Menu, stuff*60
        CHARACTER*25    VTYPE, FILNAM
        CHARACTER       Menu Choice*10, Number*6, Dummy*14
        INTEGER*4       Fld Index,ICOL,IROW
        LOGICAL       GetYesNo, Exit
        LOGICAL         Error, Quit, Fexist

        DATA Main Menu /'MAINMENU  '/
cc        DATA VM Menu   /'VRM MENU  '/
        DATA O Menu    /'OPTIONS   '/
        DATA DMenu     /'DF MENU   '/
        DATA VRM Menu  /'VRM MENU  '/

C Put out default parameter file names
        Dummy = Data File
        IF (Dummy (1:1) .NE. ' ') THEN
           K = Index (Dummy, '.')
           IF (K .NE. 0) THEN
              K = AMIN0 (K, 9)
           ELSE
              L = LENSTR (Dummy)
              K = AMIN0 (L, 9)
           ENDIF
           IparFile = Dummy (1:K-1)//'.cpf'
           OparFile = IparFile
        ENDIF

C Paint Screen
  5     CALL New Screen (MAINSCR)
        CALL Set Character Value ('IPARFILE  ', IparFile)
        CALL Set Character Value ('OPARFILE  ', OparFile)

C Main screen
 10     CALL Put Menu (Main Menu)

 20     CALL Get Menu Choice (Main Menu, Menu Choice)
        IF      (Menu Choice .EQ. 'Quit     ') THEN
          Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N>')
          IF (Exit) then
		call clear screen	   
		call reset screen	   
		RETURN
	  end if


C----------------------------------------------------------------------
        ELSE IF (Menu Choice .EQ. 'Read Param') THEN
           CALL Get Field Group
           IF (Nva .GT. 0) GOTO 25

C----------------------------------------------------------------------
        ELSE IF (Menu Choice .EQ. 'Save Param') THEN
            IF (Nva    .LT. 0    .OR. MVar   .LE. 0   .OR.
     +           XLBL    .LE. 0    .OR. YLBL    .LE. 0   .OR.
     +           RADIIA  .LE. 0.0  .OR. RADIIB  .LE. 0.0     ) THEN
               CALL Beep
               CALL Flash (20, 2,
     +  'ERROR - you must first choose parameter values (press a key)')
            ELSE
                CALL Get Field Group
             ENDIF

C----------------------------------------------------------------------
C Options screen
        ELSE IF (Menu Choice .EQ. 'Options/Ex') THEN
 25       CALL New Screen (OSCREEN)
          CALL Set Character Value ('DATAFILE  ', Data File)
 30       CALL Put Menu   (O Menu)
 35       CALL Get Menu Choice (O Menu, Menu Choice)
          IF      (Menu Choice .EQ. 'Quit      ') THEN
             GOTO 5

C-NAB-
        Else if (Menu choice .EQ. 'Search' .OR.
     +           Menu Choice .EQ. 'Grid')  Then
           If (Nva .LT. 1) Then
              call Beep
           Else
              call Get Field Group
           End if
           Goto 30

C--NAB-- VARIOGRAM ENTRIES
          ELSE IF (Menu Choice .EQ. 'Variograms' ) Then
             If (NVA .LT. 3 .OR. Mvar .LT. 1) Then
                Call Beep
                Goto 30
             ELse
                Call New Screen (VRMSCREEN)
                Call Put Menu (VRM Menu)
  37            Call Get Menu Choice (VRM Menu, Menu Choice)
                If (Menu Choice .EQ. 'Quit      ') Then
                   Goto 25
c                ELSEIF (Menu Choice .EQ. 'Oldvar    ') Then
c                   Flag = .TRUE.
c                   Call Get Field Group
c                   Flag = .False.
                Else if (Menu Choice .EQ. 'Select    ') Then
                   Call Get Field Group
                   CALL FLASH
     +               (20,2,'EDIT PARAMETERS FOR ENTRY CHOSEN')                 
                   CALL SET MENU POSITION (VRM Menu, 3)
                 Else If (Menu Choice .EQ. 'Add       ') Then
                   If (ITH .EQ. 0) Then
                     Call Beep
                     Call Flash (20,2,'Select The matrix entry first .
     + (Press a key)')
                     Goto 37
                   Else
                     Call Get Field Group
                   End if
                Else If (Menu Choice .EQ. 'Edit      ') Then
                   If (ITH .EQ. 0) Then
                     Call Beep
                     Call Flash (20,2,'Select The matrix entry first .
     + (Press a key)')
                     Goto 37
                   Else
                     Call Get Field Group
                     K = NP - NESTP(ITH)
                     IF (K .LT. NEST(ITH)) THEN
                       CALL FLASH (20,2,'  ENTER NEXT MODEL  ')
                     ELSE
                      If (ITH .LT. (NDG(MVAR)+MVAR)) Then
                       CALL FLASH
     +               (20,2,' SELECT NEXT MATRIX ENTRY   ')
                       CALL SET MENU POSITION(VRM Menu, 1)
                      ENDIF
                     ENDIF
                   End if
                Else if (Menu Choice .EQ. 'Variable  ' ) Then
                    Call Get Field Group
                End if
             End if
             Goto 37

C----------------------------------------------------------------------
C variables and drifts selection screen/menu
C  RENDUO
          ELSEIF (Menu Choice .EQ. 'Drift     ') THEN
             CALL New Screen (DSCREEN)
             CALL Put Menu (DMenu)
 55          CALL Get Menu Choice(DMenu,Menu Choice)
             IF  (Menu Choice.EQ.'Quit ') THEN
                GOTO 25
             ELSE
               CALL DRIFTS(DMenu)
               GOTO  25
             ENDIF

C----------------------------------------------------------------------
C kriging choice
          ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
            CALL Set Menu Position (O Menu, 1)

C final error checks on parameters
            IF (Mvar  .LT. 1) THEN
                CALL Beep
                CALL Flash (20, 2, 'No variables or models entered ')
                GOTO 30
cclong            ELSEIF (XLBL    .LT. 1 .OR. YLBL    .LT. 1) THEN
cclong Why 1?
             ELSEIF (XLBL    .LE. 0 .OR. YLBL    .LE. 0) THEN
               CALL Beep
                CALL Flash (20, 2, 'No grid parameters specified')
                GOTO 30
            ELSEIF (RADIIA  .LE. 0..OR. RADIIB  .LE. 0.) THEN
                CALL Beep
                CALL Flash (20, 2, 'No search parameters specified')
                GOTO 30
           ENDIF

C read data into internal matrix of (Ndata x NkVar) samples
cclong            CALL Flash(20, 2, 'about to read data')
            CALL Read Data (Error)
cclong            CALL Flash(20, 2, 'read data')
            IF (Error) THEN
              CALL Flash
     +        (20, 2, 'ERROR in '//Data File//' (press any key)')
            ELSE

C process polygon file (if any)
c              CALL InitGrid
c              CALL Get File Name (File Name, File Prefix,
c     +                  PolyFile, Fexist)
c              IF (.NOT. Fexist) THEN
c                CALL Blank File ('POLYFILE  ', Poly File)
c                CALL Display One Field ('POLYFILE  ')
c              ELSE
c                CALL Read Polygon File (File Name, Error)
c                IF (Error) THEN
c                   CALL Beep
c                   CALL Flash (20, 2, 'Error reading '//Polyfile//
c     +                     ' press any key to continue kriging')
c                   CALL InitGrid
c                ENDIF
c              ENDIF
c
C Begin kriging the grid of estimates
              NXCOL = 0
              DO 71 J = 1, Mvar
                 DO 72 K = 1, NTERM(J)
                     NXCOL = NXCOL + 1
 72              CONTINUE
 71           CONTINUE

              iout = 1
              ipch = 3
              OPEN (IOUT, FILE = OutFile,status='unknown')
              OPEN (IPCH, FILE = PchFile,status='unknown')
ccc              call clear screen
              WRITE (IPCH, '(A80)')TITLE
              WRITE (IPCH, '(I4)') (2*Mvar+3)
              DO 101 I= 1, Dimen
cclong                WRITE (IPCH ,103) Name(I),Units(I)
                WRITE (IPCH ,103) Name(I)
cclong
 101          CONTINUE
              IF(DIMEN.EQ.2)THEN
                TESTN = 'Elevation'
cclong                WRITE(IPCH,103) TESTN,UNITS(2)
                WRITE(IPCH,103) TESTN
cclong
              ENDIF
              IF (DIMEN .EQ. 2) ICZ = 0
cclong              DO 63 J = 1, (Nva - Dimen)
              DO 63 J = 1, mvar
                 NAME(J) = NAME(ICV(J))
 63           CONTINUE
              DO 102 I= 1, Mvar
cclong                WRITE (IPCH ,103) Name(I),Units(I)
                WRITE (IPCH ,103) Name(I)
                WRITE (IPCH ,103) Name(I)(1:lenstr(name(i)))//'_std'
cclong
 102          CONTINUE
cclong 103          FORMAT (2A10)     
 103          FORMAT (A)     
C     
C     Echo input to output file.
C     
 110  WRITE(IOUT,115) TITLE
 115  FORMAT('1',//,' Echo of the cokriging parameter file!',//,
     1 ' Title of run is ',A80)
      WRITE(IOUT,120) IPKRIG,MVAR,IDBUG,ILIST,IDUAL
 120  FORMAT(//,
     1 ' Point/block kriging switch =======> ',I5,/,
     2 '      Point kriging if = 0',/,
     3 '      Block kriging if = 1',/,
     4 ' Number of krige variables ========> ',I5,/,
     5 ' Debug output switch ==============> ',I5,/,
     6 '      No debug output if = 0',/,
     7 '         Debug output if = 1',/,
     7 ' Listing of results data switch ===> ',I5,/,
     7 '      No listing of results if = 0 ',/,
     7 '         Listing of results if = 1 ',/,
     7 '         Listing of results        ',/,
     7 '             and input data if = 2 ',/,
     8 ' Dual cokriging switch ============> ',I5,/,
     9 '     Non-dual cokriging if = 0',/,
     1 '         Dual cokriging if = 1')
      WRITE(IOUT,125) ICX,ICY,ICZ
 125  FORMAT(//,
     1 ' Easting in column ===========================> ',I5,/,
     2 ' Northing in column ==========================> ',I5,/,
     3 ' Elevation in column =========================> ',I5,/,
     4 '      2d kriging if elevation column = 0')
      DO 135 I = 1,MVAR
        WRITE(IOUT,130) NAME(I),I,ICV(I)
 130    FORMAT(1X,
     1  A15,' is variable ',I2,' in column ====> ',I5)
 135  CONTINUE
C     
      WRITE(IOUT,140) XEAST,XLBL,YNORTH,YLBL
 140  FORMAT('1',//,' Echo of 2d-3d Grid parameters',//,
     1 ' Easting of south-west corner ===============> ',E15.7,/,
     2 ' Easting distance between points/blocks =====> ',E15.7,/,
     3 ' Northing of south-west corner ==============> ',E15.7,/,
     4 ' Northing distance between points/blocks ====> ',E15.7)
      IF(ICZ.NE.0)THEN
        WRITE(IOUT,145) ZELEV,ZLBL
 145    FORMAT(
     1 ' Elevation of upper bench crest =============> ',E15.7,/,
     2 ' Elevation distance between points/blocks ===> ',E15.7)
      ENDIF
C     
      WRITE(IOUT,150) MINHOL,MAXHOL,NSE,NFE,NSN,NFN
 150  FORMAT(//,' Echo of cokrige NBHD description card!',//,
     1 ' Minimum number of data in cokrige NBHD ==> ',I15,/,
     1 ' Maximum number of data in cokrige NBHD ==> ',I15,/,
     2 ' Starting easting cokrige column =========> ',I15,/,
     3 ' Ending easting cokrige column ===========> ',I15,/,
     4 ' Starting northing cokrige row ===========> ',I15,/,
     5 ' Ending northing cokrige row =============> ',I15)
      IF(ICZ.NE.0)THEN
        WRITE(IOUT,155) NSB,NFB
 155    FORMAT(
     1 ' Starting elevation bench ================> ',I15,/,
     2 ' Ending elevation bench ==================> ',I15)
      ENDIF
      IF(IPKRIG.EQ.1)THEN
        WRITE(IOUT,160) NPX,NPY,NPZ
 160    FORMAT(
     1 ' Number of easting discrete points =======> ',I15,/,
     2 ' Number of northing discrete points ======> ',I15,/,
     3 ' Number of elevation discrete points =====> ',I15)
      ENDIF
      WRITE(IOUT,165) AZMUTH,DIP,RADIIA,RADIIB,RADIIC
 165  FORMAT(//,' Search ellipsoid parameters!',//,
     1 ' Azimuth angle of major ellipsoid axis ===> ',E15.7,/,
     2 ' Dip angle of major ellipsoid axis =======> ',E15.7,/,
     3 ' Major ellipsoid axis length, a ==========> ',E15.7,/,
     4 ' Minor ellipsoid axis length, b ==========> ',E15.7,/,
     5 ' Minor ellipsoid axis length, c ==========> ',E15.7)
C     
      WRITE(IOUT,170)
 170  FORMAT('1',//,' Echo of krige variable parameters!',//,
     1 '   Variable     Variable            Missing    Weight',/,
     2 '     Number     Name                  Value     Value',/)
      DO 180 I = 1,MVAR
        WRITE(IOUT,175) I,NAME(I),TEST(I),WGT(I)
 175    FORMAT(1X,I10,5X,A15,G12.4,F10.2)
 180  CONTINUE
C*****List drift parameters.
      WRITE(IOUT,185)
 185  FORMAT(//,' Echo of drift parameters!')
      DO 205 I = 1,MVAR
        WRITE(IOUT,190) NAME(I),NTERM(I)
 190    FORMAT(//,' Variable ',A15,' has ',I5,' basis functions!',//,
     1  '  Term   X coordinate   Y coordinate   Z coordinate',/,
     2  '          exponential    exponential    exponential',/)
        DO 200 J = 1,NTERM(I)
          NP = NTERMP(I) + J
          WRITE(IOUT,195) J,EX(NP),EY(NP),EZ(NP)
 195      FORMAT(1X,I5,3E15.7)
 200    CONTINUE
 205  CONTINUE
C*****List variogram parameters.
      DO 240 IROW = 1,MVAR
      DO 235 ICOL = 1,IROW
        I = NDG(IROW) + ICOL
        IF(IROW.EQ.ICOL)THEN
          WRITE(IOUT,210) ICOL,NAME(ICOL)
 210      FORMAT('1',//,' Echo of variogram parameters!',//,
     1    ' For variable ',I2,' which is ',A15)
        ELSE
          WRITE(IOUT,215) ICOL,NAME(ICOL),IROW,NAME(IROW)
 215      FORMAT('1',//,' Echo of cross variogram parameters!',//,
     1    ' Between variable ',I2,' which is ',A15,/,
     2    ' and for variable ',I2,' which is ',A15)
        ENDIF
        IF(NTYPCS(I).EQ.0) FILNAM = 'Not relevant             '
        IF(NTYPCS(I).EQ.1) FILNAM = 'Sum variable             '
        IF(NTYPCS(I).EQ.2) FILNAM = 'Difference variable      '
        IF(NTYPCS(I).EQ.3) FILNAM = 'Signed nested model      '
        IF(NTYPCS(I).EQ.4) FILNAM = 'Sum - difference variable'
        WRITE(IOUT,220) NEST(I),SILL(I),FILNAM
 220    FORMAT(/,
     1 ' Number of nested variograms =============> ',I5,/,
     2 ' Total sill of nested variogram ==========> ',E15.7,/,
     3 ' Type of cross variogram =================> ',A25,/,
     4 '        Listing of nested variogram models ',/)
        DO 230 J = 1,NEST(I)
          NP = NESTP(I) + J
          CALL CVTYPE(NVTYPE(NP),VTYPE)
          WRITE(IOUT,225) VTYPE,NSIGN(NP),C(NP),AAXIS(NP),
     1                    BAXIS(NP),CAXIS(NP),THETA(NP),BETA(NP)
 225      FORMAT(/,
     1    ' Model type                  : ',A25,/,
     2    ' Sign on nested model        : ',I5,/,
     3    ' Sill                        : ',E15.7,/,
     4    ' Major axis range, a         : ',E15.7,/,
     5    ' Minor axis range, b         : ',E15.7,/,
     6    ' Minor axis range, c         : ',E15.7,/,
     7    ' Azimuth angle of major axis : ',E15.7,/,
     8    ' Dip angle of major axis     : ',E15.7,/)
 230    CONTINUE
 235  CONTINUE
 240  CONTINUE
ccc      stuff = 'Finished reading parameters: echoed to the outfile.'
ccc      call flash(20,2,stuff)
C*****Data is read in so list input DDH data.
      IF(ILIST.EQ.2)THEN
        WRITE(IOUT,305) NUMHOL,(NAME(I),I=1,MVAR)
 305    FORMAT('1',//,' Echo of ',I5,' input data points!',//,
     1  '    Easting  Northing Elevation  ',5A15)
        WRITE(IOUT,310)
 310    FORMAT(1X)
        NCOUNT = 1
        DO 320 I = 1,NUMHOL
           WRITE(IOUT,315) X(I),Y(I),Z(I),
     1                     (GRADE(J),J=NCOUNT,NCOUNT+MVAR-1)
           NCOUNT = NCOUNT + MVAR 
 315       FORMAT(1X,3F10.2,5E15.7)
 320    CONTINUE
      ENDIF
ccc      stuff = 'Finished reading in data: echoed to the outfile.'
ccc      call flash(20,2,stuff)
C*****Call subroutine to conduct the kriging.
              
              CALL ESTCOK 
              CALL NEW SCREEN (OSCREEN)
              close(iout)
              close(ipch)

c              IF (DevCode .NE. HERC .OR. .NOT. Graphics)
c    +           CALL NewScreen (OSCREEN)
C Messages
c              IF (Quit) THEN
c                 CALL Flash
c     +           (20, 2,'Kriging cancelled, Press any key')
c              ELSE IF (Error) THEN
c                 CALL Flash
c     +           (20, 2, 'Error occurred writing to '//OutFile//
c     +                   ' (Press any key)')
c              ELSE
c                 CALL Flash (20, 2,
c     + 'Results have been written to '//OutFile//' (Press any key)')
c              ENDIF
c              GOTO 30
            ENDIF

C----------------------------------------------------------------------
C Screen field processing for options screen
          ELSE
            CALL Get Field Group
          ENDIF
          GOTO 30
C----------------------------------------------------------------------
C Screen field processing for read and save parameter files
        ELSE
          CALL Get Field Group
        ENDIF

        GOTO 20
        END

C----------------------------------------------------------------------
C Select Variable
C
C        SUBROUTINE Select Variable (VarNum)
C        IMPLICIT INTEGER*4 (A-Z)C

C		include'cokrig.inc'
C		include'../common/screen.str'

C        CHARACTER*10    Menu Choice, MenuName
C        INTEGER*4       VarNum, Fld Index, Field

C        DATA MenuName /'VSELECT'/

C Check for no items in list, or just one
c       IF (NkVar .LT. 1) THEN
c          RETURN
c       ELSEIF (NkVar .EQ. 1) THEN
C           VarNum = 1
C           RETURN
c       ENDIF

C Put out message for use of menu

c       CALL PutStr (
c     + 'Select Variable (Use , or , to position, <enter> to  select)'
c     + , 61, 20, 2, 2)
c
C Set up arrow key links so that only NkVar elements are used
c       Field = Fld Index (Menu Name)
c       DO  5 I = 2, NkVar-1
c         SC Up   (Field+I) =  -1
c         SC Down (Field+I) =   1
c 5     CONTINUE
c       SC Up   (Field+1)     =  NkVar - 1
c       SC Down (Field+NkVar) = -(NkVar - 1)
c
C Get Menu Choice
C 10     CALL Get Menu Choice (Menu Name, Menu Choice)
C        READ (Menu Choice (1:2), '(I2)', ERR = 10) VarNum
C        CALL Erase (20, 2, 75)
C        RETURN
C        END

C----------------------------------------------------------------------
C Select Variable/Drift
C RENDUO

        SUBROUTINE DRIFTS(Drift Menu)

        PARAMETER (DCSREEN = 5)
        CHARACTER*10   Field Name, Drift Menu, chr*60
        CHARACTER*5    Menu Choice
        LOGICAL      GetYesNo,YorN

		include 'cokrig.inc'
		include '../common/screen.str'

         IIvar = 0
12       CALL Get Field Group
         YorN= GetYesNo(18,2,'Is input of the variables DONE? <Y/N>')
             IF (YorN) THEN
               IIvar=Mvar+1
               IF (IIvar.LE.Mvar) THEN
                 CALL Clear Fields
                 chr='Select a new variable and its drift parameters'
                 CALL Put Str (chr,60,18,2,0)
                 CALL Put Menu (Drift Menu)
10               CALL Get Menu Choice(Drift Menu,Menu Choice)
15                 IF (Menu Choice.EQ.'Quit ') THEN
                     CALL Beep
                     CALL Get Menu Choice(Drift Menu,Menu Choice)
                     GOTO 15
                   ELSE
                     GOTO 12
                   ENDIF
               ELSE
                 chr = 'Then the job is done: please quit.'
                 CALL Put Str (chr,60,18,2,0)
                 CALL Get Menu Choice(Drift Menu,Menu Choice)
20               IF  (Menu Choice.EQ.'Edit ') THEN
                   CALL Beep
                   CALL Get Menu Choice(Drift Menu,Menu Choice)
                   GOTO 20
                 ELSE
                    RETURN
                ENDIF
               ENDIF
             ELSE
                chr='Input/Edit the parameters'
                CALL Put Str (chr,60,18,2,0)
                CALL Get Menu Choice(Drift Menu,Menu Choice)
30              IF  (Menu Choice.EQ.'Quit ') THEN
                  CALL Beep
                  CALL Get Menu Choice(Drift Menu,Menu Choice)
                  GOTO 30
                ELSE
                  GOTO 12
                ENDIF
             ENDIF
             RETURN
             END
C-------------------------------------------------------------------------
        SUBROUTINE Finish Beep
        INTEGER*4       I, One
        DATA One /1/

        DO 10 I = 100,500,50
cc           CALL SOUND (I, One)
 10     CONTINUE
        RETURN
        END
