cc$LARGE
C***********************************************************************
C*** File Name: READDATA.FOR (Source code for the program SCATTER)
C*********************************************************************
C SUBROUTINE READ HEADER DATA (ERROR)
C
C Formal Arguments:
C  ERROR       - Logical variable set to true if an error occurs.
C
C This routine reads in the header information from the data file
C and then sets the screen fields. If an error occurs will reading
C the file an error message is displayed.
C
        SUBROUTINE Read Header Data (Error)

        IMPLICIT INTEGER*4 (A-Z)

        INCLUDE '../common/screen.str'
        INCLUDE 'scatter.cmn'
 
	LOGICAL  Error

        CALL Putstr ('Reading Header Data ',20,20,2,2)

C *** Open input file
	Nunit = 10
	Stat = 'OLD'

cc        CALL Open File (Nunit, File Name, Stat, Openerr)
	open (unit = nunit, file = file name,
     +          status = 'old',err = 999)
cc
        IF (Openerr .NE. 0) THEN
           Text = 'Problem opening data file'
           CALL Flash (20, 2, Text)
           GOTO 999
        ENDIF

C *** Read header string into default title
	READ (Nunit, '(A)', ERR = 999, END = 999) Text

C *** Get Number of variables in file
   	READ (Nunit, *, ERR= 999, END = 999) Nvar
        IF (Nvar .LT. 3) THEN
           Text = 'Too few variables in file (press any key)'
           CALL Flash ( 20, 2, Text)
           GOTO 999
	ELSE IF (Nvar .GT. Maxvar) THEN
           Text = 'Too many variables in file (press any key)'
           CALL Flash ( 20, 2, Text)
           GOTO 999
        ENDIF
        
C *** Get variable names for each variable in file
	DO 20 i = 1, Nvar
           READ (Nunit,'(2A10)', ERR = 999, END = 999) 
     +  		 Varnam(i), Units(i)
  20    CONTINUE

C *** Load variable names into toggle fields 
	CALL Load Toggle Values ('XVARIABLE ', 10, Nvar, Varnam, 0)
	CALL Load Toggle Values ('YVARIABLE ', 10, Nvar, Varnam, 1)

C *** Display screen fields
	CALL Display Flds

	CLOSE (Nunit)
	
        RETURN
   
  999   Error = .TRUE.
        CLOSE (Nunit)
        CALL Beep
	CALL Putstr ('     ERROR reading data file ... ',33,9,43,2)
	CALL Putstr ('An ERROR was encountered in the  ',33,11,43,0)
	CALL Putstr ('header section of the data file. ',33,12,43,0)
	CALL Putstr ('Check the file name, and that the',33,13,43,0)
	CALL Putstr ('file named has the standard data ',33,14,43,0)
	CALL Putstr ('file format.                     ',33,15,43,0)
	CALL Putstr ('Consult the Users Manual for more',33,16,43,0)
	CALL Putstr ('information about file format.   ',33,17,43,0)
	CALL Erase Field ('XVARIABLE ') 
	CALL Erase Field ('YVARIABLE ')
        CALL Erase Field ('DATA FILE ')
	CALL Flash (20,2, ' Press and key to exit')
	CALL Erase (20,2,75)
	Ndatafile = 0
	Nvar  = 0
	Ndata = 0
	CALL Erase Message

	RETURN
	END

C***********************************************************************
C SUBROUTINE GET XY DATA
C
C This routine reads in the values for the variables selected and 
C determines the minimum/maximum values.
C
        SUBROUTINE Get XY Data

        IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'scatter.cmn'


        CHARACTER   Blanks*50, Dummy*75, Scratch*5, Ifmt*4

	REAL*4      Data(Maxvar), Missing
        logical force
        DATA Ifmt /'(I5)'/


        CALL Putstr ('Reading Data Values ...  ',25,20,2,2)

C *** Determine postion of variables
        Xpos =  Toggle Position ('X LOG      ') 
        Ypos =  Toggle Position ('Y LOG      ') 

        IF (xpos .EQ. 0) THEN
           Xlog = .TRUE.
        ELSE
           Xlog = .FALSE.
        ENDIF
        IF (ypos .EQ. 0) THEN
           Ylog = .TRUE.
        ELSE
           Ylog = .FALSE.
        ENDIF

        Xpos = Toggle Position ('XVARIABLE ') + 1
        Ypos = Toggle Position ('YVARIABLE ') + 1

C Get File Name
	IF (File Prefix .NE. Blanks) THEN
    	   la = Lenstr(File Prefix)
	   File Name = File Prefix(1:la)//Data File
        ELSE
	   File Name = Data File
	ENDIF
	  
C *** Open input file
	Nunit = 10
	Stat = 'OLD'

cc        CALL Open File (Nunit, File Name, Stat, Openerr)
        open(unit = 10, file = file name, status = 'old',err = 999)
cclong

        IF (Openerr .NE. 0) THEN
           Text = 'Problem opening data file'
           CALL Flash (20, 2, Text)
           GOTO 999
        ENDIF

C *** Read header string into default title
      	READ (Nunit, '(A)', ERR = 999, END = 999) Dummy

C *** Get Number of variables in file
   	READ (Nunit, *, ERR= 999, END = 999) Nvar

C *** Get variable names for each variable in file
	DO 20 i = 1, Nvar
           READ (Nunit,'(2A10)', ERR = 999, END = 999) Dummy, Dummy 
  20    CONTINUE


C *** Read variable values
        Ndata = 0
        Nrecords  = 0

        Nmissing = 0
        Missing   = 1.E31

        Xmin = 1.E30
        Xmax = -1.E30

        Ymin = 1.E30
        Ymax = -1.E30

	DO 30 j = 1, MaxData
	   READ (Nunit, *,ERR=999,END = 900) (Data(i), i=1,Nvar)
           Nrecords = Nrecords + 1
	   IF (Data(Xpos) .LT. Missing .AND.
     +         Data(Ypos) .LT. Missing ) THEN
	      Ndata = Ndata + 1
	      IF (Xlog) THEN
                 IF (Data(Xpos) .LE. 0.0 ) THEN
                    Xarr(Ndata) = Missing
                 ELSE 
                    Xarr(Ndata) = ALOG(Data(Xpos))
                 ENDIF
              ELSE
                 Xarr(Ndata) = Data(Xpos)
              ENDIF
    	      IF (Ylog) THEN
                 IF (Data(Ypos) .LE. 0.0) THEN
                    Yarr(Ndata) = Missing
                 ELSE 
                    Yarr(Ndata) = ALOG(Data(Ypos))
                 ENDIF
              ELSE
                 Yarr(Ndata) = Data(Ypos)
              ENDIF
              IF (Xarr (Ndata) .LT. Missing) THEN
                 Xmin = AMIN1 (Xarr(Ndata), Xmin)
                 Xmax = AMAX1 (Xarr(Ndata), Xmax)
              ENDIF
              IF (Yarr (Ndata) .LT. Missing) THEN
                 Ymin = AMIN1 (Yarr(Ndata), Ymin)
                 Ymax = AMAX1 (Yarr(Ndata), Ymax)
              ENDIF
           ELSE
              Nmissing = Nmissing + 1
   	   ENDIF
 30     CONTINUE
        write (*,*) Xmin, Xmax, Ymin,Ymax    
C *** Check if more then MaxData records
        READ (Nunit, *, ERR = 999, END = 900) (Data(i), i=1,Nvar)
	CALL Beep
	CALL Putstr(' The number of records in the data ',35,10,42,2)
	CALL Putstr(' file exceeds the program limits.  ',35,11,42,2)
	CALL Putstr(' Only the maximum number of allowed',35,12,42,0)
	CALL Putstr(' of coordinate values have been    ',35,13,42,0)
	CALL Putstr(' stored in memory, the rest will   ',35,14,42,0)
	CALL Putstr(' not be used...                    ',35,15,42,0)
	CALL Flash (20,2, 'Press any key to continue ')
	CALL Erase Message


 900    CLOSE (Nunit)

C *** Display screen values
        WRITE (Scratch, Ifmt) Nrecords
        CALL Putstr (Scratch, 5, 6, 58, 0)

        DO 40 i = 1, Ndata
           IF (Xarr(i) .EQ. Missing .OR. Yarr(i) .EQ. Missing) THEN
              Nmissing = Nmissing + 1
              Ndata = Ndata - 1
            ENDIF
 40     CONTINUE
        
        WRITE (Scratch, Ifmt) Nmissing
        CALL Putstr (Scratch, 6, 7, 58, 0)

	RETURN

 999    if (force) goto 900
        CLOSE (Nunit)
        CALL Beep
	CALL Putstr ('     ERROR reading data file ... ',33,9,43,2)
	CALL Putstr ('An ERROR was encountered while   ',33,11,43,0)
	CALL Putstr ('reading the data file.           ',33,12,43,0)
	CALL Putstr ('Check the file name, and that the',33,13,43,0)
	CALL Putstr ('file named has the standard data ',33,14,43,0)
	CALL Putstr ('file format.                     ',33,15,43,0)
	CALL Putstr ('Consult the Users Manual for more',33,16,43,0)
	CALL Putstr ('information about file format.   ',33,17,43,0)
	CALL Erase Field ('XVARIABLE ') 
	CALL Erase Field ('YVARIABLE ')
cc	CALL Flash (20,2, ' Press any key to exit')
        CALL Erase (20,2,75)

        CALL putstr ('Type "c" to continue anyway:     ',33,20, 2,0)
        call getthekey(i)
        if (char(i) .eq. 'c' .or. char(i) .eq. 'C') then
           CALL putstr ('Type "f" to suppress error report:',33,20, 2,0)
           call getthekey(i)
           if (char(i) .eq. 'f' .or. char(i) .eq. 'F') force = .true.
           error = .false.
           CALL Erase (20, 2, 75)
           goto 900
        end if

	Nrecords = 0
	Nvar  = 0
	Ndata = 0
        Nmissing = 0
        CALL Erase Message
	
        RETURN
        END


