cc $LARGE
C
C Display.for - screen output routines for STATS
C
C----------------------------------------------------------------------
C Display Header - displays file, variable, and limits info top screen
C----------------------------------------------------------------------

	SUBROUTINE Display Header
	IMPLICIT INTEGER*4 (A-Z)

          INCLUDE 'stats.dec'
          INCLUDE '../common/screen.str'

cclong  characters declarations changed in accordance with prevar
	CHARACTER*60	File Name
	CHARACTER*15	Vname
	CHARACTER*13 	Scratch
	CHARACTER*8 	RFmt
	INTEGER*4	LENSTR

	DATA Rfmt /'(F13.3)'/

C File name
	N = LENSTR (File Prefix)
	IF (N .GT. 0) THEN 
	  File Name = File Prefix (1:N) // Data File
	ELSE
	  File Name = Data File
	ENDIF
	CALL PutStr (File Name, 60, 2, 16, 0)

C Variable name
	IF (LOG) THEN
	   Vname = 'LN ('//VarNam (Var)//')'
	ELSE
	   Vname = VarNam (Var)
	ENDIF
	CALL PutStr (Vname, 15, 3, 16, 0)

C Weight variable
	IF (Weighted) THEN
	   File Name = 'Weight Variable: '//VarNam (WVar)
	   CALL PutStr (File Name, 27, 3, 39, 0)
	ENDIF

C Histogram Frequency Type
	IF (Current Screen .EQ. 6) THEN
	   WRITE (Scratch, Rfmt) ClassMin
	   CALL PutStr (Scratch, 13, 4, 56, 0)
	   WRITE (Scratch, Rfmt) ClassInc
	   CALL PutStr (Scratch, 13, 5, 56, 0)
	ENDIF

C Subsetting limits
	WRITE (Scratch, Rfmt) MinValue
	CALL PutStr (Scratch, 13, 4, 16, 0)
	WRITE (Scratch, Rfmt) MaxValue
	CALL PutStr (Scratch, 13, 5, 16, 0)

	RETURN
	END

C----------------------------------------------------------------------
C Display Stats - displays statistics for program STATS
C----------------------------------------------------------------------

	SUBROUTINE Display Stats
	IMPLICIT INTEGER*4 (A-Z)

          INCLUDE 'stats.dec'

cclong  characters declarations changed in accordance with prevar
	CHARACTER*65	File Name
	CHARACTER*15	Vname
	CHARACTER*13 	Scratch
	CHARACTER*7 	RFmt
	CHARACTER*5     Inum 	
	CHARACTER*4 	Ifmt
	INTEGER*4	LENSTR

	DATA Rfmt /'(F13.4)'/, Ifmt /'(I5)'/

C Tallys
	WRITE (INum, Ifmt) Ndata
	CALL PutStr (Inum, 5, 7, 20, 0)
	WRITE (INum, Ifmt) NMiss
	CALL PutStr (Inum, 5, 8, 20, 0)
	WRITE (INum, Ifmt) NKept
	CALL PutStr (Inum, 5, 9, 20, 0)

C Mean, etc
	WRITE (Scratch, Rfmt) Mean
	CALL PutStr (Scratch, 13, 11, 20, 0)
	WRITE (Scratch, Rfmt) Variance
	CALL PutStr (Scratch, 13, 12, 20, 0)
	WRITE (Scratch, Rfmt) StDev
	CALL PutStr (Scratch, 13, 13, 20, 0)
	WRITE (Scratch, Rfmt) CoefVar
	CALL PutStr (Scratch, 13, 14, 20, 0)

	WRITE (Scratch, Rfmt) Skewness
	CALL PutStr (Scratch, 13, 16, 20, 0)
	WRITE (Scratch, Rfmt) Kurtosis
	CALL PutStr (Scratch, 13, 17, 20, 0)

C Sum of Weights
	WRITE (Scratch, Rfmt) WeightSum
	CALL PutStr (Scratch, 13,  9, 60, 0)

C Quartiles, limits
	WRITE (Scratch, Rfmt) Min
	CALL PutStr (Scratch, 13, 11, 60, 0)
	WRITE (Scratch, Rfmt) Q1
	CALL PutStr (Scratch, 13, 12, 60, 0)
	WRITE (Scratch, Rfmt) Median
	CALL PutStr (Scratch, 13, 13, 60, 0)
	WRITE (Scratch, Rfmt) Q3
	CALL PutStr (Scratch, 13, 14, 60, 0)
	WRITE (Scratch, Rfmt) Max
	CALL PutStr (Scratch, 13, 15, 60, 0)


	RETURN
	END

