cc $LARGE
C Histo.for	- histogram subroutines
C
C----------------------------------------------------------------------
C Default histogram - calculate and plot default histogram for STATS
C

	SUBROUTINE Default Histogram
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'

cclong  In accordance with Prevar, I changed the 
cc      following character delarations:
	CHARACTER*20 	Unitts
	CHARACTER*9 	Weightch
	REAL*4		Tinc
	INTEGER*4	Ninc

C default titles and labels
        L               = Lenstr (Varnam (Var))
        L2              = Lenstr (Units  (Var))
  
	Title2   = 'Data file: '//Data File (1:14)
        Unitts = ' '
        IF (L2 .NE. 0) Unitts = ' ('//Units (Var)(1:L2)//')'
        Weightch = ' '
        IF (Weighted) WeightCh = 'Weighted'
	L3 = LenStr (WeightCh)

        IF (Log) THEN
	   Title3 = 'LN('//Varnam (Var) (1:L) //')'//Unitts
        ELSE
	   Title3 = Varnam(Var)(1:L)//Unitts
        END IF
        IF (Relative) THEN
           Title1   = WeightCh(1:L3)//' Relative Histogram '
           Title4   = 'Relative Frequency'
        ELSE
           Title1   = WeightCh(1:L3)//' Histogram '
           Title4       = 'Frequency'
        END IF

	CALL Set Character Value	('TITLE1    ', Title1  )
	CALL Set Character Value	('TITLE2    ', Title2  )
	CALL Set Character Value	('TITLE3    ', Title3  )
	CALL Set Character Value	('TITLE4    ', Title4  )

C Calculate default class limits and scaling parameters
	ClassMin	= MinValue
	ClassMax	= MaxValue
	CALL Neatax (ClassMin, ClassMax, Tinc, Ninc)
        ClassInc = Tinc * 0.25
        NClass = INT (ABS (ClassMax - ClassMin)  / ClassInc +.5)
	IF (Nclass .GT. MAXCLASS-1) NClass = MAXCLASS-1
	CALL Set 4 Floating Point Value	('CLASSMIN  ', ClassMin,3)
	CALL Set 4 Floating Point Value	('CLASSINC  ', ClassInc,3)
	CALL Set Integer Value		('NCLASS    ', Nclass)

C Compute Histogram Results
	CALL Calc Histogram

C Compute Axis Defaults
	CALL Calc Hist Defaults
	RETURN
	END        	

C----------------------------------------------------------------------
	SUBROUTINE Calc Hist Defaults
        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'

	REAL*4		RMax
	INTEGER*4	Dummy (1)

C Calculate class maximum for graph scaling
	ClassMax = ClassMin + ClassInc
	DO 10 I = 2, Nclass 
	   ClassMax = ClassMax + ClassInc	
 10	CONTINUE

C Calculate default graph limits
        Xmin = ClassMin
        Xmax = ClassMax
	CALL NeatAx (Xmin, Xmax, Xtinc, NxTic)
	Ymin = 0.0

C Get maximum frequency
	IF (Relative) THEN
	   Ymax = Rmax (Rfreq, NClass)
	ELSE
	   Ymax = Rmax (SumWClass, NClass)
	ENDIF
        IF (YMAX .EQ. 0.0) Ymax = 1.0
        CALL Neatax (Ymin, Ymax, Ytinc,  Nytic)
	Ymax = Ymax + Ytinc*.25

C Load defaults into screen fields
	CALL Set 4 Floating Point Value	('AXISXMAX  ', Xmax    ,3)
	CALL Set 4 Floating Point Value	('AXISXMIN  ', Xmin    ,3)
	CALL Set 4 Floating Point Value	('AXISXINC  ', Xtinc   ,3)
	CALL Set 4 Floating Point Value	('AXISYMIN  ', Ymin    ,3)
	CALL Set 4 Floating Point Value	('AXISYMAX  ', Ymax    ,3)
	CALL Set 4 Floating Point Value	('AXISYINC  ', Ytinc   ,3)

	RETURN
	END        	

C----------------------------------------------------------------------
	SUBROUTINE Show Axis Fields
	CALL Display One Field	('AXISXMAX  ')
	CALL Display One Field	('AXISYMAX  ')
	CALL Display One Field	('AXISXMIN  ')
	CALL Display One Field	('AXISYMAX  ')
	CALL Display One Field	('AXISXINC  ')
	CALL Display One Field	('AXISYINC  ')
	RETURN
	END

C----------------------------------------------------------------------
C Calc Histogram - calculate frequency distribution for STATS
C
	SUBROUTINE Calc Histogram

        IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'
        	
	REAL*4	   W, Dw
	INTEGER*4  NumClass

C Initialize classes and frequencies to zero
	DO 10 I = 1, MAXCLASS
	   Cutoff (I)   = 0.0
	   Rfreq (I)    = 0.0
	   Freq (I)	= 0
	   SumClass (I) = 0.0
	   SumWClass (I)= 0.0
	   ClassAvg (I) = 0.0
 10	CONTINUE

	IF (Nclass .EQ. 0) RETURN
	IF (NClass .GE. MAXCLASS) Nclass = MAXCLASS - 1

C Calculate class cutoff values
	NumClass   = Nclass
	Cutoff (1) = ClassMin + ClassInc	
 	DO 20 I = 2, Nclass
           Cutoff (I) = Cutoff (I-1) + ClassInc
 20	CONTINUE
	IF (Cutoff (Nclass) .LT. MaxValue) THEN
	    NumClass = Nclass + 1
	    Cutoff (NumClass) = MaxValue 
	ENDIF
   
C Calculate Frequencies
	J = FirstPtr 
	DO 30 I = 1, NumClass
  35  	   IF (Data (J) .LE. Cutoff (I)) THEN
	       W   	     = Weights (Ptr (J))
	       Dw	     = Data (J)      * W
	       Freq 	 (I) = Freq (I)      + 1
	       SumClass  (I) = SumClass (I)  + Dw
	       SumWClass (I) = SumWClass (I) + W
	       MaxClassV (I) = Data (J)
	       IF (J .GE. LastPtr) GOTO 40
	       J = J + 1
	       GOTO 35
	   ENDIF
 30	CONTINUE

C Calculate Relative Frequencies and Weighted class averages	
 40	DO 50 I = 1, NumClass
	   IF (WeightSum .NE. 0.)
     +		Rfreq (I) = SumWClass (I) / WeightSum
	   IF (SumWClass (I) .NE. 0.) 
     +		ClassAvg (I) = SumClass (I) / SumWClass (I)
 50	CONTINUE
	RETURN
	END



