cc $LARGE
C---------------------------------------------------------------------
C  Probability Plot - program STATS
C
      SUBROUTINE Probability Plot
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'stats.dec'
      
c ***	local variables
        	
      REAL*4		Xfudge, Yfudge, Xstart, tiny, Z
      REAL*4		Xc, Yc, X, Y, Dx, Dy, Tx, Ty, Mx, My
      REAL*4          Ginv, Width
      
      INTEGER*4	Color
      
cclong character declarations conform to prevar changes
      CHARACTER 	Xlabel*18, NumLeft*5, numstr*12, ylabel*35
      CHARACTER*60 	Plot Title, Title, message
      CHARACTER*8 	Rfmt, Ifmt, Gfmt
      
      character menu choice*10
      integer destination
 
      IF (Nkept .EQ. 0 .OR. DevCode .EQ. 0) RETURN
      
 1    if (ps_or_no .eq. 0) call pre post script('probplot')
      
C build labels
      IF (Log) THEN
         L  = Lenstr (Varnam (Var))
         Ylabel = 'LN('//Varnam (Var) (1:L)//')'
      ELSE
         Ylabel = Varnam(Var) 
      END IF
      Title = 'Data file: '//Data File
      IF (Weighted) THEN
         Plot Title = 'Weighted Normal Probability Plot for '//Ylabel
      ELSE
         Plot Title = 'Normal Probability Plot for '//Ylabel
      ENDIF
      Xlabel       = 'Cumulative Percent'
      
      Rfmt            = '(F12.3)'
      Gfmt            = '(E12.3)'
      Ifmt            = '(I12)'

C Calculate ticmark and max axis values for Y
      Ymax = Max
      Ymin = Min
      CALL Neatax (Ymin, Ymax, Ytinc, Nytic)
     
C Calculate X axis values
      Xmin    = Ginv (0.0001)
      Xmax    = Ginv (0.9999)

C Determine the rest of the scaling information
      dx = xmax - xmin
      dy = ymax - ymin
      mx = (dx * .013)/aspect
      my = dy * .013
      xfudge = dx * 0.15
      yfudge = dy * 0.2
      minx = xmin - (xfudge*1.6)
      maxx = xmax + (xfudge*4.1)
      miny = ymin - yfudge
      maxy = ymax + yfudge*1.5

C Start graphics mode
      CALL Zsetup (Gmode, Ierr)

C Set text attributes (8x8, white on black border)
      CALL Zlbdir (0.0)
      CALL Zlocat (0, Xmaxdev, 0, Ymaxdev)
	
C Set scaling window
      Tx = (Maxx - Minx) * .005
      Ty = (Maxy - Miny) * .007
      CALL Zscale (Minx, Maxx, Miny, Maxy)

C Draw graph frame
      CALL Grframe (Xmaxdev, Ymaxdev, Blue)

C Draw Axes
      CALL Zcolor (White)
      CALL Paxes (Plot Title, Title, Xlabel, Ylabel)

C Plot Points
      DO 30 I = FirstPtr, LastPtr
         Y = Data (I)
         X = Ginv (Cpercent (I))
         CALL Plus (X, Y, Mx, My, Green, White)
 30   CONTINUE
      
C Draw box plot for selected variable 
      Width = (Dx *.035) 
      CALL Boxplot (Min, Q1, Median, Mean, Q3, Max, .FALSE.,
     +     Xmax+Width*.75, Width, Dy*.007)
      CALL PlotStat

      if (ps_or_no .eq. 0) call post script(message, destination)
      if (destination .eq. 1) goto 1

 666  call reset()

      RETURN
      END        

C----------------------------------------------------------------------
C ***	Paxes - draw and label axes for probability plot
	
	Subroutine Paxes (Type, TTitle, xlabel, ylabel)
        IMPLICIT INTEGER*4 (A-Z)
        PARAMETER (NPROB  = 13)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

		INCLUDE 'stats.dec'

	character   TTitle*(*), xlabel*(*), ylabel*(*), Type*(*)

c ***	local variables
	real*4		xc, yc, xticl, yticl, dx, dy, tx, ty, x, y
	real*4		ysiz, xsiz, xlxoff, xlyoff, ylxoff, ylyoff
	real*4		bx, by, tx1, tx2, ty1, ty2, Prob(NPROB), Ginv
	REAL*4		Factor

cclong character declarations conform to prevar changes
	character*8	xfmt, yfmt, xtlab
	character*13	ytlab
	character*1	ch
	character*65	Tlabel
	character*8	Blanks
cclong
	character       message*50
cc
	integer*4	xwidth, ywidth, Percent

        DATA Prob   /.01,.05,.1,.2,.3,.4,.5,.6,.7,.8,.9,.95,.99/
	DATA Blanks /'        '/
	DATA  Xfmt /'(I2)'/
cclong
	DATA  Yfmt /'(I8)'/
cclong
	xwidth	= 1
	ywidth	= 8	

	IF (DevCode .EQ. OTHER) THEN
	   RETURN
	ELSE IF (DevCode .EQ. HERC) THEN
	   Factor 	= 29./45.
	ELSE IF (DevCode .EQ. CGA) THEN
	   Factor 	= 5./12.
	ELSE IF (DevCode .EQ. EGA) THEN
	   Factor 	= 35./48.
	ENDIF

c ***	calculate y label format
	CALL SetFmt2 (Ytinc, Yfmt, Ywidth)

c *** calculate ticlengths, label sizes and offsets
	dx = xmax - xmin
	dy = ymax - ymin
	xc = xmin + (dx / 2.0)
	yc = ymin + (dy / 2.0)
	yticl = dy * .02
	xticl = dx * .01
	bx = dx * .01
	by = dy * .01

c ***	draw box around data window
	CALL Zmove (xmin,ymin)	
	CALL Zplot (xmin,ymax)
	CALL Zplot (xmax,ymax)
	CALL Zplot (xmax,ymin)
	CALL Zplot (xmin,ymin)

C ***	Draw ticmarks, and labels for x axis

	DO 10 I = 1, Nprob
          IF (MOD (I, 2) .EQ. 1.0) THEN
            X 		= Ginv (Prob (I))
	    CALL 	Zmove (X, Ymax)
	    CALL 	Zplot (X, Ymin - Yticl)
            Xtlab 	= Blanks
            Percent 	= IFIX((Prob(I) * 100.0)+.5)
	    WRITE (Xtlab, Xfmt) Percent
	    CALL 	Left Justify (XtLab)
	    L = 	LENSTR (Xtlab)
            CALL 	Zmove (x - 2*L*xticl, ymin-4*yticl-by)
            CALL 	Zlabel (Xtlab)
	  ENDIF
 10	CONTINUE

C ***	Draw ticmarks, and labels for y axis

	DO 20 Y = Ymin, Ymax, Ytinc
          CALL 	Zmove (Xmax, Y)
	  CALL 	Zplot (Xmin - XticL, Y)
          Ytlab = Blanks
 	  WRITE (Ytlab, Yfmt) Y
	  CALL 	Left Justify (YtLab)
	  L = 	LENSTR (Ytlab)
 	  CALL 	Zmove (Xmin - 3.2*L*XticL - Bx , Y-yticl)
 	  CALL 	Zlabel (Ytlab)
 20	CONTINUE

c ***	Plot First Title
	IF (DevCode .EQ. CGA) THEN
	  Tx = .335*Factor
	ELSE
	  Tx = .255*Factor
	ENDIF
        L = LENSTR (Type)
	IF (L .GT. 0) THEN

	  CALL Zmove  	(Xc-.5*L*xticl, Ymax + ((Ymax-Ymin)*Tx))
          Tlabel 	= Type (1:L)
          CALL Zlabel 	(Tlabel)
	ENDIF

c ***	Plot Second Title
	Tx = .175*Factor
        L = LENSTR (Ttitle)
	IF (L .GT. 0) THEN

	  CALL Zmove 	(Xc-.5*L*xticl, Ymax + ((Ymax-Ymin)*Tx))
          Tlabel 	= TTitle (1:L)
          CALL Zlabel 	(Tlabel)
	ENDIF
	
C ***	Label X axis
	IF (DevCode .EQ. CGA) THEN
	  Tx = .235*Factor
	ELSE
	  Tx = .175*Factor
	ENDIF
	L = LENSTR (Xlabel)
	IF (L .GT. 0) THEN

ccc          CALL Zmove (Xc-1.5*L*xticl, Ymin - 2*((Ymax - Ymin)*Tx))
          CALL Zmove(Xc-1.5*L*xticl, (Ymin+3*miny)/4.0)
          Tlabel 	= Xlabel (1:L)
          CALL Zlabel 	(Tlabel)
	ENDIF

C ***	Label Y axis
	L = LENSTR (Ylabel)
	IF (L .GT. 0) THEN
          CALL Zlbdir 	(-90.0)

ccc          CALL Zmove 	(MinX-Bx*8.0, Yc+1.1*L*yticl)
          CALL Zmove((xmin+3*MinX)/4.0, Yc+1.1*L*yticl)
          Tlabel 	= Ylabel (1:L)
          CALL Zlabel 	(Tlabel)
          CALL Zlbdir 	(0.0)
	ENDIF

	RETURN
	END


