cc $LARGE
C
C Process.for
C----------------------------------------------------------------------
C Perform Process - perform application-specific functions for STATS
C
	SUBROUTINE Perform Process (Field Name, Error, Repaint)
	IMPLICIT INTEGER*4 (A-Z)
 
		INCLUDE 'stats.dec'
		INCLUDE '../common/screen.str'

cclong character changes made in accordance with prevar
	CHARACTER*75	Message
	CHARACTER*14	Blanks, OldFile
	CHARACTER*65	FileName
	CHARACTER*10	Field Name,  MainMenu, Dummy, Return Field
	INTEGER*4	Fld Index, Index of Field
	INTEGER*4	LENSTR, Position, I, J, OldNclass
	LOGICAL		Error, Exit, Repaint, PutMessage, FExist
	LOGICAL		OldFlag, Started
        LOGICAL         GetYesNo, OverWrite, ReadXY
	REAL*4		Temp, Tmin, Tmax, Tinc
	REAL*4		OldMin, OldInc

	DATA MainMenu   /'MAINMENU  '/
	DATA Started	/.FALSE./

C initialize flags
	Error		= .FALSE.
	Repaint		= .FALSE.	
	PutMessage	= .FALSE.
	FExist		= .FALSE.
	Index of Field	= Fld Index (Field Name)
	Return Field	= SC Field Name (Next Field)

C open data file, read in header information
	IF     (Field Name .EQ. 'FILEPREFIX') THEN
	  CALL Get Character Value (Field Name, File Prefix)
	  CALL Left Justify (File Prefix)
	  CALL Set Character Value (Field Name, File Prefix)

	ELSEIF (Field Name .EQ. 'DATAFILE  ') THEN
	  IF (Started) OldFile = Data File
	  CALL Get Character Value (Field Name, Data File)
	  IF (OldFile .NE. Data File) THEN
	     CALL Get File Name (File Name, File Prefix,
     +			          Data File, Fexist)
	     Old File = Data File
	     CALL ReInitialize
	     Data File = Old File
	     CALL Set Character Value (Field Name, Data File) 
	     CALL Display Fields
	     CALL Erase (20, 2, 76) 
	     IF (.NOT. Fexist) THEN
	        Error = .TRUE.
	        Message = 'ERROR - data file not found'
                Return Field = Main Menu 
	        CALL Blank File (Field Name, Data File)
	     ELSE
	       CALL Read Header Data (Error)
	       IF (Error) THEN
	         Error = .FALSE. 
                 CALL ReInitialize
                 Return Field = Main Menu
	       ELSE
	         Old File = Data File
	         Return Field = 'VARIABLE  '
	         Started = .TRUE.
               ENDIF
	    ENDIF
	  ENDIF

C Get the Variables
	ELSEIF (Field Name .EQ. 'VARIABLE  ') THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
           Var = Position + 1

C Get the weight variable, check that not the same
	ELSEIF (Field Name .EQ. 'WVARIABLE ') THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
           Wvar 	= Position + 1
	   Weighted 	= .FALSE.
	   IF (Wvar .EQ. Var) THEN
              Error   = .TRUE.
	      Message = 'ERROR - Weight variable must be different '
              CALL Set Toggle Position (Field Name, Nvar)
              Return Field = 'MAINMENU '
	   ELSE 
	      IF (Wvar .LT. (Nvar + 1)) Weighted = .TRUE.
	   ENDIF 

C Get the log option
	ELSEIF (Field Name .EQ. 'LOGOPTION ') THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
	   Log = (Position .EQ. 1)
	   CALL Read Data (Error)
	   IF (Error) THEN
	      Error = .FALSE.
	      CALL ReInitialize
              Return Field = Main Menu 
	   ELSE
	      CALL Set Menu Position (Main Menu, 5)
           ENDIF

C limits
	ELSE IF (Field Name .EQ. 'MINVALUE  ') THEN
       	    CALL Get 4 Floating Point Value (Field Name, MinValue)
	ELSE IF (Field Name .EQ. 'MAXVALUE  ') THEN
       	    CALL Get 4 Floating Point Value (Field Name, MaxValue)

C Histogram Type
	ELSE IF (Field Name .EQ. 'HISTOTYPE ') THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
	   OldFlag  = Relative
	   Relative = (Position .EQ. 1)
	   IF (OldFlag .NEQV. Relative) THEN
	      IF (Relative) THEN
	         Title4 = 'Relative Frequency'
	      ELSE
	         Title4 = 'Frequency'
	      ENDIF
	      CALL Calc Hist Defaults
	      CALL Set Character Value ('TITLE4    ', Title4)
	      CALL Display One Field   ('TITLE4    ')    
	      CALL Show Axis Fields
	   ENDIF	

C Histogram Class Limits
	ELSE IF (Field Name .EQ. 'CLASSMIN  ') THEN
	   OldMin = ClassMin
       	   CALL Get 4 Floating Point Value (Field Name, ClassMin)

	ELSE IF (Field Name .EQ. 'CLASSINC  ') THEN
	   OldInc = ClassInc
       	   CALL Get 4 Floating Point Value (Field Name, Temp)
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'Class increment must be .GT. 0.0 '
	      CALL Set 4 Floating Point Value (Field Name, ClassInc, 3)
	      Return Field = 'CLASSMIN  ' 
	   ELSE
	      ClassInc = Temp
	   ENDIF

	ELSE IF (Field Name .EQ. 'NCLASS    ') THEN
	   OldNclass = Nclass
       	   CALL Get Integer Value (Field Name, Nclass)
	   IF (OldNClass .NE. NClass .OR. OldInc .NE. ClassInc
     +				     .OR. OldMin .NE. ClassMin) THEN 
	      IF (Nclass .LE. 0) THEN
	         Error = .TRUE.
 	         Message = 'NCLASS must be .GT. 0, try again '
	         Return Field = 'NCLASS     '			
	         CALL Set Integer Value (Field Name, Nclass)
	      ELSE
	         IF (Nclass .GE. MaxClass) THEN
	            Error = .TRUE.
	            Message = 'NCLASS truncated to program limit'
	            Nclass  = MAXCLASS - 1
	            CALL Set Integer Value (Field Name, Nclass)
	            CALL Display One Field (Field Name)
	         ENDIF
	         CALL Calc Histogram 
	         CALL Calc Hist Defaults
	         CALL Show Axis Fields
	      ENDIF
	   ENDIF

C Histogram Axes Parameters
	ELSE IF (Field Name .EQ. 'AXISXMIN  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Xmin)

	ELSE IF (Field Name .EQ. 'AXISXMAX  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Temp)
	   IF (Temp .LE. Xmin) THEN
	      Error = .TRUE.
	      Message = 'Axis maximum must be .GT. minimum'
	      CALL Set 4 Floating Point Value (Field Name, Xmax, 3)
	      Return Field = Field Name
	   ELSE
	      Xmax = Temp
	   ENDIF

	ELSE IF (Field Name .EQ. 'AXISXINC  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Temp)
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'Axis tic increment must be .GT. 0.0 '
	      CALL Set 4 Floating Point Value (Field Name, Xtinc, 3)
	   ELSE
	      Xtinc = Temp
	   ENDIF

	ELSE IF (Field Name .EQ. 'AXISYMIN  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Ymin)

	ELSE IF (Field Name .EQ. 'AXISYMAX  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Temp)
	   IF (Temp .LE. Ymin) THEN
	      Error = .TRUE.
	      Message = 'Axis maximum must be .GT. minimum'
	      CALL Set 4 Floating Point Value (Field Name, Ymax, 3)
	      Return Field = Field Name
	   ELSE
	      Ymax = Temp
	   ENDIF

	ELSE IF (Field Name .EQ. 'AXISYINC  ') THEN
       	   CALL Get 4 Floating Point Value (Field Name, Temp)
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'Axis tic increment must be .GT. 0.0 '
	      CALL Set 4 Floating Point Value (Field Name, Ytinc, 3)
	   ELSE
	      Ytinc = Temp
	   ENDIF

C Titles
	ELSE IF (Field Name .EQ. 'TITLE1    ') THEN
       	   CALL Get Character Value (Field Name, Title1)
	ELSE IF (Field Name .EQ. 'TITLE2    ') THEN
       	   CALL Get Character Value (Field Name, Title2)
	ELSE IF (Field Name .EQ. 'TITLE3    ') THEN
       	   CALL Get Character Value (Field Name, Title3)
	ELSE IF (Field Name .EQ. 'TITLE4    ') THEN
       	   CALL Get Character Value (Field Name, Title4)

	ENDIF
C if an error occurred, put out the message
	IF (Error) CALL Flash (20, 2, Message)

C write out field, in case an error caused it to be blanked out
	CALL Display One Field (Field Name)

C Set up Next Field to be processed
	Next Field = Fld Index (Return Field)

C Erase screen message area
	IF (Current Screen .EQ. 1) THEN
 	   DO 444 I = 11, 18
	     CALL Erase (I, 42, 35)
 444 	   CONTINUE
	ENDIF

	RETURN
	END


