
C Stats.for - basic descriptive statistics
C
C----------------------------------------------------------------------
C Main +- Read Structure
C      |- Initialize ----------+- Set _______ Value
C      |                       +- Load Toggle Fields 
C      |		
C      |- Get Screen Fields ---+- Put Menu
C      | 		       |- Get Menu Choice
C      | 		       |- Get Field Group ------>
C      | 		       |- Set Menu Position 		
C      +- Clear Screen	       |- Batch	----------------+- Read Data
C                              |                        +- Calculate Stats		       
C    			       |- Calculate Stats    
C    			       |- Display Header
C    			       |- Display Stats
C    			       |- Probability Plot  ----+- Paxes
C                              |                        +- Ginv      					 
C    			       |- Default histogram ---->
C    			       |- Calc Histogram
C    			       |- Plot Histogram -------- Graphlib, Graflib
C                              |- Examine Histogram ----+- Put Hrecord
C                              |                        +- Scroll Window
C                              |                       
C			       |- Percentile -----------+- Put Pscreen
C                              |                        |- Put Precord
C                              |                        +- Scroll Window      			 
C    			       +- New Screen
C    
C -> Get Field Group -+- Get Field
C	              |- Perform Process +- Read Header Data 
C	              +- New Screen	 |- Read Data - Qsort
C	    	      		  	 |- Display Fields
C	    	      		         |- Reinitialize - Initialize
C	    	      		         |- Show Axis Fields
C	    	      		         |- Calc Histogram
C	    	      		         |- Calc Hist Defaults
C	    	      		         |- Display One Field 
C	    	      		         |- Get ________ Value/Position
C	    	      		         +- Set ________ Value/Position
C
C -> Default Histogram --+- Calc Histogram
C			 |- Calc Hist Defaults
C			 +- Plot Histogram ----+- Axes
C                                              +- Hbox 
      PROGRAM STAT1
      IMPLICIT INTEGER*4 (a-z)
      
      INCLUDE 'stats.dec'
      INCLUDE '../common/screen.str'
      
      LOGICAL Exists
      LOGICAL GetYesno
      character*80    geoeas_home
      
      include '../common/color.dec'

cc Note that the get_geoeas_home line needs to come first, or there
cc will be problems on some terminals.
cc    The program will speed up if this is your private copy, and you
cc want to replace the call by the following example:
cc    My geoeas_dir is
cc             /aplm3/ael/dmyers/dgeoeas/unix_version
cc so I could replace the lines below by 
cc        CALL Read Structure ('/aplm3/ael/dmyers/dgeoeas/unix_version'
cc     &     //'/stat1/stat1.scr')
cc
      call graphics_in
      call get_geoeas_dir(10,geoeas_home)
      CALL Read Structure (geoeas_home(1:lenstr(geoeas_home))
     &     //'/stat1/stat1.scr')
cc
ccc replaces old grafinit:
        graphics = .true.
        aspect     = 1
        DevCode    = 1
ccc
      CALL Set up Screen()
      CALL Clear Screen

      CALL Initialize
      CALL Read System Defaults
      IF (Intro) CALL Intro Screen
      CALL Get Screen Fields
      CALL Write System Defaults
      CALL SetMod (INT2 (StartMode))
      END

C----------------------------------------------------------------------
C Intro Screen - 	displays screen frame/label/fields
C			for the introductory screen

	SUBROUTINE Intro Screen
	CALL Clear Screen
	CALL Set Screen (1)
	CALL Display Frame
	CALL Display Labels
	CALL Locate Cursor (23,0)
CC we changed in call locate cursor (25,0) to (23,0)
	CALL Flash (20, 2, 'Press any key to begin the program ')
	RETURN
	END

C----------------------------------------------------------------------
C Initialize - initialize STAT1 global values
C
	SUBROUTINE Initialize 
	IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'

	DO 10 I = 1, MAXVAR
	   VarNam (I) = '          '
 10	CONTINUE

	CALL Load Toggle Values  ('VARIABLE  ',10,MAXVAR,VarNam, 0)
	CALL Load Toggle Values  ('WVARIABLE ',10,MAXVAR,VarNam, 0)
	CALL Set Character Value ('DATAFILE  ', Data File)
	CALL Set Character Value ('MINVALUE  ',	'         MIN')
	CALL Set Character Value ('MAXVALUE  ',	'         MAX')
	CALL Set Toggle Position ('LOGOPTION ', 0)	
	CALL Set Toggle Position ('VARIABLE  ', 0)
	CALL Set Toggle Position ('WVARIABLE ', 0)

	Ndata 		= 0
	Nvar  		= 0
	NMiss 		= 0
	Nkept 		= 0
	NumNeg 		= 0
	Weighted	= .FALSE.
	Missing  	= 1.E31
	MinValue	= +1.E30
	MaxValue	= -1.E30
	Data File 	= '              '
	Log		= .FALSE.
	Weighted	= .FALSE.
	Relative	= .FALSE.

C Erase screen message area
 	   DO 444 I = 11, 18
	     CALL Erase (I, 42, 35)
 444 	   CONTINUE

C Set menu position to first
	CALL Set Menu Position ('MAINMENU  ', 1)

C erase message line
	CALL Erase (20, 2, 76)
	RETURN
	END

C----------------------------------------------------------------------
C ReInitialize - Reinitialize STAT1 global values
C
	SUBROUTINE ReInitialize 
	IMPLICIT INTEGER*4 (A-Z)

		INCLUDE 'stats.dec'
		INCLUDE '../common/screen.str'

 	CHARACTER*10	Blanks
	INTEGER*4	Fld Index, Field

	CALL Initialize

	CALL Display One Field  ('VARIABLE  ')
	CALL Display One Field  ('WVARIABLE ')
	CALL Display One Field  ('LOGOPTION ')
	CALL Display One Field  ('DATAFILE  ')
	CALL Display One Field  ('MINVALUE  ')
	CALL Display One Field  ('MAXVALUE  ')

	RETURN
	END

C----------------------------------------------------------------------
C Get Screen Fields - 	displays screen frame/label/fields
C			gets the screen fields for the current screen

	SUBROUTINE Get Screen Fields 

	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (MAINSCR  = 2, RSCREEN = 3, PSCREEN = 4,
     +		   HSCREEN = 5, HRSCREEN = 6)
 
 		INCLUDE '../common/screen.str'
		INCLUDE 'stats.dec'

	CHARACTER*10	Main Menu, R Menu, P Menu
	CHARACTER*10	H Menu,   HR Menu
	CHARACTER*10 	Menu Choice, Scratch
	CHARACTER*6 	Number
	LOGICAL 	GetYesNo, Exit
	LOGICAL		Error


	DATA Main Menu/'MAINMENU  '/
	DATA R Menu   /'RESULTS   '/, P Menu  /'PERCENTILE'/ 
	DATA H Menu   /'HISTOGRAM '/, HR Menu /'HISTRESULT'/

C Paint Screen
  5	CALL New Screen (MAINSCR)
	CALL Set Character Value ('DATAFILE  ', Data File)
	
C Main screen
 10 	CALL Put Menu (Main Menu)

 20	CALL Get Menu Choice (Main Menu, Menu Choice)	
 	IF      (Menu Choice .EQ. 'Quit     ') THEN
	  Exit = GetYesNo (20, 2, 'Do you really want to QUIT? <Y/N>')
	  IF (Exit) THEN 
cclong
	    call clear screen
	    call reset screen
cc
            RETURN
	  ELSE
	    CALL Set Menu Position (Main Menu, 2)
	    GOTO 10
	  ENDIF

	ELSE IF (Menu Choice .EQ. 'Variable  ') THEN
	  IF (Nvar .EQ. 0) THEN
	     CALL Beep
	  ELSE
	     CALL Get Field Group
	     CALL Set Menu Position (Main Menu, 5)
	     GOTO 10
	  ENDIF

	ELSE IF (Menu Choice .EQ. 'Limits   ') THEN
	  IF (Ndata .EQ. 0) THEN
	     CALL Beep
	  ELSE
	     CALL Get Field Group
	     CALL Set Menu Position (Main Menu, 5)
	     GOTO 10
	  ENDIF

	ELSE IF (Menu Choice .EQ. 'Batch Stat') THEN
	  IF (Nvar .LE. 0) THEN
	     CALL Beep
	  ELSE
 	     CALL Batch
	     CALL Set Menu Position (Main Menu, 3)
	     GOTO 5
	  ENDIF
  
C----------------------------------------------------------------------
C Results Screen
	ELSE IF (Menu Choice .EQ. 'Execute   ') THEN
	  IF (Nvar .EQ. 0 .OR. Ndata .EQ. 0) THEN
	    CALL Beep
	    GOTO 20
	  ENDIF
	  CALL Set Menu Position (Main Menu, 3)
	  CALL Calculate Stats

C Write out number of samples <=0 when log option is set
          IF (Log .AND. NumNeg .GT. 0) THEN
             Write (Number,'(I4)') NumNeg
             CALL Flash (20, 2, Number//
     +          ' Samples <= 0 could not be used with LOG')
          ENDIF

 25  	  CALL New Screen (RSCREEN)
	  CALL Display Header
	  CALL Display Stats
 30	  CALL Put Menu   (R Menu)
	  CALL Set Menu Position (R Menu, 1)
 35	  CALL Get Menu Choice (R Menu, Menu Choice)
	  IF     (Menu Choice .EQ. 'Quit      ') THEN
	    GOTO 5 

	  ELSE IF (Menu Choice .EQ. 'Probabilit') THEN
	    IF (Nkept .GT. 0) THEN
	        IF (Graphics) THEN
                    ActivePlot=2
                    CALL Probability Plot
                    GOTO 25
                 ELSE
                    CALL Beep
                    CALL Flash (20, 2,
     +	        'No supported graphics hardware found (press any key)')
	        ENDIF
	        GOTO 30
	    ENDIF

C----------------------------------------------------------------------
C  Histogram Screen          

   	  ELSE IF (Menu Choice .EQ. 'Histogram ') THEN
     	    CALL Default HistoGram
	    IF (Graphics) then
               ActivePlot=1
               CALL Plot HistoGram
            end if
 40	    CALL New Screen (HSCREEN)
     	    CALL Display Header 
 45	    CALL Put Menu   (H Menu) 
 50	    CALL Get Menu Choice (H Menu, Menu Choice)
     	    IF      (Menu Choice .EQ. 'Quit      ') THEN
              GOTO 25 
     	    ELSE IF (Menu Choice .EQ. 'Results   ') THEN
              IF (Nclass .GT. 0) THEN
                 CALL Examine HistoGram
                 GOTO 40
              ELSE
                 CALL Beep
              ENDIF
            ELSE IF (Menu Choice .EQ. 'View Graph') THEN
              IF (Nclass .GT. 0) THEN
 	        CALL Calc HistoGram
	        IF (Graphics) THEN
                   ActivePlot=1
                   CALL Plot HistoGram
                   GOTO 40
	        ELSE
                   CALL Beep
                   CALL Flash (20, 2,
     +          'No supported graphics hardware found (press any key)')
	        ENDIF
              ELSE
                CALL Beep
              ENDIF
     	    ELSE 
              CALL Get Field Group
            ENDIF
     	    GOTO 50
 
C----------------------------------------------------------------------
C Percentiles display
	  ELSE IF (Menu Choice .EQ. 'Examine   ') THEN
	    CALL New Screen (Pscreen)
	    CALL Percentile
            GOTO 25    
	  ENDIF
          GOTO 35

	ELSE
          CALL Get Field Group
	ENDIF

	GOTO 20
	END	

C----------------------------------------------------------------------
C Get Field Group - get a group of fields, perform processes

	SUBROUTINE Get Field Group 
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

		INCLUDE '../common/screen.str'
	
	LOGICAL		Error, Repaint

 10	CALL Get Field	
	CALL Perform Process (SC Field Name (Current Field),
     +                     Error, Repaint) 
	IF (SC Field Type (Next Field) .NE. Main Menu Field .AND.
     +	    SC Field Type (Next Field) .NE. Menu Field) GOTO 10

	IF (Repaint) THEN
	   CALL New Screen (Current Screen)
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------
C New Screen (Screen number) - sets up a new screen
C
	SUBROUTINE New Screen (Screen Number)
	IMPLICIT INTEGER*4 (A-Z)

 		INCLUDE '../common/screen.str'

	PARAMETER (Main Menu Field = 3)
	PARAMETER (Menu Field      = 4)

	CALL Clear Screen
	CALL Set Screen (Screen Number)
	CALL Display Frame
	CALL Display Labels

	DO 10 I = Begin Screen (Current Screen),
     +	         End Screen (Current Screen)
	  IF (SC Field Type (I) .NE. Main Menu Field .AND.
     +	      SC Field Type (I) .NE. Menu Field)
     +	      CALL Write Field (i, SC Attribute (i))

  10	CONTINUE
	
	CALL Erase (20, 2, 76)
	RETURN
	END

C----------------------------------------------------------------------
C Read System Defaults

	SUBROUTINE Read System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
		INCLUDE 'stats.dec'

	CHARACTER*20  String

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'OLD',
     +			 ERR=999)
	READ (10, '(A)', ERR=999,END=999) File Prefix
	READ (10, '(A)', ERR=999,END=999) Data File
	READ (10, '(A)', ERR=999,END=999) String
	Intro = (String (7:8) .EQ. 'ON' .OR.
     +           String (7:8) .EQ. 'on')
	CALL Set Character Value ('FILEPREFIX', File Prefix)
	CLOSE (10)
	RETURN

 999	CLOSE (10)
	INTRO = .TRUE.
	RETURN
	END

C----------------------------------------------------------------------
C Write System Defaults

	SUBROUTINE Write System Defaults
	IMPLICIT INTEGER*4 (A-Z)
 
		INCLUDE 'stats.dec'

	OPEN (UNIT = 10, FILE = 'geoeas.def', STATUS = 'UNKNOWN',
     +			ERR=999)
	WRITE (10, '(A)', ERR = 999) File Prefix
	WRITE (10, '(A)', ERR = 999) Data File
	IF (Intro) THEN
	  WRITE (10, '(A)', ERR = 999) 'INTRO=ON'
	ELSE
	  WRITE (10, '(A)', ERR = 999) 'INTRO=OFF'
	ENDIF
 999	CLOSE (10)
	RETURN
	END

