cc    $LARGE
C     BoxVplot.for - variogram boxplot for VARIO
C----------------------------------------------------------------------
C     Box Vplot - BoxPlot for VARIO
      
      SUBROUTINE Box Vplot
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'vario.dec'
      
      REAL*4	    TxMin, TxMax, TyMin, TyMax, TxTinc, TyTinc
      REAL*4	    TMinx, TMaxx, TMiny, TMaxy
      REAL*4      Dx, Dy, Mx, My, Tx, Ty, RMIN, RMAX
      REAL*4	    Xfudge, YFudge, Width
      INTEGER*4   I, J, N, LENSTR, L, TnX, TnY
      CHARACTER   TTitle*70, Vlabel*30, Xlabel*40, Ylabel*40
      character*72 message
      integer destination
      
C     check for no data
      IF (Nkept .LT. 1) RETURN
      
 1    if (ps_or_no .eq. 0) call pre post script('boxplot')

C     Compute axis boundry and tic interval parameters
      TXmin	=  RMIN (AvgDist,  Nlag)
      TXmax	=  RMAX (AvgDist,  NLag)
      TYmin	=  RMIN (Vmin,     Nlag)
      TYmax   =  RMAX (Vmax,     Nlag)
      CALL NeatAx (TXmin, TXmax, TXtinc, TNx)
      CALL NeatAx (TYmin, TYmax, TYtinc, TNy)
      
C     Compute symbol sizes, and scaling stuff
      Dx 	= ABS (TXmax - TXmin)
      Dy 	= ABS (TYmax - TYmin)
      Xfudge  = Dx * 0.15
      Yfudge  = Dy * 0.2
      TMinx 	= TXmin - (Xfudge*1.9)
      TMiny 	= TYmin -  Yfudge
      TMaxx 	= TXmax + (Xfudge*3.8)
      TMaxy 	= TYmax + (Yfudge*1.5)
      Mx 	= Dx * .01 / Aspect 
      My 	= Dy * .01
      
C     Set up labels
      IF (Log) THEN
         L = LENSTR (Varnam (Var))
         Vlabel = 'LN'//Varnam (Var) (1:L) //')'
      ELSE
         Vlabel = VarNam (Var)
      ENDIF
      TTitle = 'Boxplot for '//Vlabel
      Xlabel = 'Distance '
      Ylabel = 'Difference squared'
      
C     graphics setup 
      CALL Zsetup (INT2 (Gmode), Ierr)
      CALL Zcolor (INT2 (White))
      CALL Zlbdir (0.0)
      CALL Zlocat (XMinDev, XmaxDev, YminDev, YmaxDev)
      CALL Zscale (TMinx, TMaxx, TMiny, TMaxy)
      CALL Grframe (Xmaxdev, Ymaxdev, Blue) 
      
C     Draw and label the axes
      CALL Axes (TTitle, Xlabel, Ylabel, ' ',
     +     TXmin, TXmax, TYmin, TYmax, TXtinc, TYtinc, DevCode)
      
C     Plot variogram Values
      Width = Dx *.035
      DO 10 I = 1, Nlag
         CALL Boxplot (VMin (I), VQ1 (I), VMedian (I), 
     +        Vmean (I), VQ3 (I), Vmax (I), 
     +        .FALSE., AvgDist (I), Width, (Dy*.007))
 10   CONTINUE
      
      CALL Plot Vstats (tXmin, tXmax, tYmin, tYmax)
      
      if (ps_or_no .eq. 0) call post script(message, destination)
      if (destination .eq. 1) goto 1
      
 666  call reset()
      RETURN
      END

