
C Parmfile.for - parameter file read and write routines
C----------------------------------------------------------------------
C Read Parameters - Reads parameter file for program vario
C
        SUBROUTINE Read Parameters (Filenm, Error, num) 
        IMPLICIT INTEGER*4 (A-Z)
        
        INCLUDE 'vario.dec'

        LOGICAL         Error
        CHARACTER       Filenm*(*), Signature*13, outfile*80
        INTEGER*4         Struc, Jvar, LUN, intjunk, num
        real*4          realjunk
        DATA               LUN /10/

        Error = .FALSE.

 15     format(a)
        outfile = file prefix(1:lenstr(file prefix))//filenm
        i = lenstr(outfile)

C Open File
        OPEN (FILE = Outfile(1:i), UNIT = 10,
     +              STATUS = 'old', ERR = 100)

C Check if valid
        READ  (LUN,15, ERR = 100) Signature
        IF (Signature(5:9) .NE. 'KRIGE') GOTO 100
        
C File Names Record
        READ (LUN,15, ERR = 100) outfile
        READ (LUN,15, ERR = 100) outfile
        READ (LUN,15, ERR = 100) outfile        

C Title Record
        READ (LUN,15, ERR = 100) Title(1)

C Grid Parameters Records
        READ (LUN,*, ERR = 100)
     +       intjunk, realjunk, realjunk, intjunk
     +       , intjunk, realjunk, realjunk, intjunk

C Search Parameters Records
        READ (LUN,*, ERR = 100)
     +       realjunk, realjunk, realjunk
     +       , intjunk, intjunk, intjunk, intjunk, intjunk

C Kriging Type Record
        READ (LUN,*, ERR = 100) intjunk, intjunk

C Number of Variables Record, Variables and Variogram Structure Records
        READ (LUN,*, ERR = 100) NkVar
        DO 10 JVar = 1, NkVar
           if (jvar .eq. num) then
              READ (LUN,*, ERR = 100) 
     +             intjunk, Nugget, intjunk, intjunk
              DO 20 struc = 1, maxstruc
                 READ (LUN,*, ERR = 100) 
     +                Mtype   (Struc),
     +                Sill    (Struc),
     +                range (Struc),
     +                (realjunk,i=1,2)
 20           CONTINUE          
              goto 9
           else
              READ (LUN,*, ERR = 100) (intjunk,i=1,4)
              DO Struc = 1, maxstruc
                 READ (LUN,*, ERR = 100) intjunk, (realjunk,i=1,4)
              enddo
           end if
 10     CONTINUE
 9      CLOSE (10)
        RETURN

C Error Encountered Reading Parameter File
 100    Error = .TRUE.
        CALL Flash (20, 2, 'READ error during parameter load')
        CLOSE (10)
        RETURN
        END

C----------------------------------------------------------------------
C Save Parameters - Writes parameter file for program KRIGE
C
        SUBROUTINE Save Parameters (Filenm, Error, num) 
        IMPLICIT INTEGER*4 (A-Z)

        INCLUDE 'vario.dec'

        LOGICAL         Error
        INTEGER*4         Jvar, num
        CHARACTER*80       Filenm*(*), Signature*13, newfile
        DATA               LUN /10/
        DATA               Signature /'    KRIGE    '/

        Error = .FALSE.

 15     format(a)
        newfile = file prefix(1:lenstr(file prefix))//filenm
        i = lenstr(newfile)

C Open File
        OPEN (FILE = Newfile(1:i), UNIT = LUN,
     +       STATUS = 'unknown', ERR = 100)

        WRITE  (LUN,15, ERR = 100) Signature
        Error = .FALSE.

C File Names Record

        call Build File Name (data file, newfile,'.grd')
        WRITE (LUN,15, ERR = 100) Data File
        WRITE (LUN,15, ERR = 100) newfile
        WRITE (LUN,*, ERR = 100) 

C Title Record
        WRITE (LUN,15, ERR = 100) Title(1)

C Grid Parameters Records
        WRITE (LUN,*, ERR = 100) Xvar, Xcmin, (Xcmax-xcmin)/39, 40
     +       , yvar, ycmin, (ycmax-ycmin)/39, 40

C Search Parameters Records
        WRITE (LUN,*, ERR = 100) Xcmax-xcmin, ycmax-ycmin, 0
     +       , 0, 1 , 2, 8, 2

C Kriging Type Record
        WRITE (LUN,*, ERR = 100) 1, 0

C Number of Variables Record, Variables and Variogram Structure Records
        WRITE (LUN,*, ERR = 100) 1
        WRITE (LUN,*, ERR = 100) num, nugget, mean, 0
        DO 20 jvar = 1, maxstruc
           WRITE (LUN,*, ERR = 100) Mtype   (Jvar), Sill    (Jvar),
     +          range (Jvar), range (Jvar), 0
 20     CONTINUE          
        CLOSE (10)
        RETURN

C Error Encountered Writing Parameter File
 100    Error = .TRUE.
        CALL Flash (20, 2, 'WRITE error during parameter save')
        CLOSE (10)
        RETURN
        END
