C PlotStat.for  - Plots legends and statistics for VARIO graphs
C----------------------------------------------------------------------
C Plot Vstats - plot variogram legend info for VARIO

	SUBROUTINE Plot VStats (Txmin, Txmax, TyMin, Tymax)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

	INCLUDE 'vario.dec' 

	INTEGER*4	Row, Col, L, LENSTR
	CHARACTER	Ifmt*8, Rfmt*8, Gfmt*8, NumStr*13, NULCH*1
	CHARACTER   	Vlabel*15
	REAL*4		X, Y, My, Txmin, Txmax, Tymin, Tymax 
cclong
        character   ich*20, scratch*8, stuff*15, name*14, junk*40
	
	DATA	Ifmt /'(I13)'  /
	DATA	Rfmt /'(F13.3)'/
	DATA	Gfmt /'(G13.5)'/
	NULCH 	= '0'
	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	L = LENSTR (Vlabel)

        X    = TXmax + ABS (TXmax - TXmin) * .05
        My   = ABS (TYmax - TYmin) * .075
        Y    = TYmax-My

        CALL Zmove (X, Y)
        ich = 'P a r a m e t e r s:'
        CALL zlabel(ich)
        Y = Y - My*1.5

        CALL Zmove (X, Y)
        scratch = 'File :  '
        junk = scratch(1:lenstr(scratch))//' '//pair file
        CALL Zlabel (junk)
        Y = Y - My * 1.5

        WRITE (Numstr,Ifmt) TotalPairs
        CALL Zmove (X, Y)
          scratch = 'Pairs  :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My * 1.5

        WRITE (Numstr,Rfmt) Direction
        CALL Zmove (X, Y)
          scratch = 'Direct.:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) Tolerance
        CALL Zmove (X, Y)
          scratch = 'Tol.   :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        CALL Zmove (X, Y)
cc This crashed on me, presumably because the thing couldn't write the 
cc asterix tested for in the following lines. My idea is to change the order
cc of the test:
cc        WRITE (Numstr,Rfmt) BandWidth
cc        IF (Numstr (1:1) .EQ. '*') NumStr = '          n/a'
cc
        NumStr =  '          n/a'
        IF (bandwidth  .ne. 1.E30) WRITE (Numstr,Rfmt) bandwidth
          scratch = 'MaxBand:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My * 1.5

        CALL Zmove (X, Y)
          stuff = Vlabel(1:L)
          scratch = ' Limits'
          junk = stuff(1:L)//scratch
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) VarMin   
        CALL Zmove (X, Y)
          scratch = 'Minimum:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) VarMax   
        CALL Zmove (X, Y)
          scratch = 'Maximum:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My * 1.5

        WRITE (Numstr,Rfmt) Mean     
        CALL Zmove (X, Y)
          scratch = 'Mean   :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Gfmt) Variance 
        CALL Zmove (X, Y)
        CALL Right Justify (NumStr, 13)
          scratch = 'Var.   :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
      RETURN
      END

C----------------------------------------------------------------------
C Plot Lstats - plot lag stats info for VARIO Lag-scattergram

	SUBROUTINE Plot LStats (LagNum, Txmin, Txmax, TyMin, Tymax)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

	INCLUDE 'vario.dec' 

	INTEGER*4	Row, Col
	CHARACTER	Ifmt*8, Rfmt*8, Gfmt*8
	CHARACTER   Vlabel*15, NumStr*13, NULCH*1, junk*40

        character   itch*20, scratch*8, stuff*15 
	REAL*4		X, Y, My, Txmin, Txmax, Tymin, Tymax
	INTEGER*4   LagNum, L, LENSTR
	
	DATA	Ifmt /'(I13)'  /
	DATA	Rfmt /'(F13.3)'/
cc	NULCH 	= 0
	NULCH = '0'

	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	L = LENSTR (Vlabel)

        X    = TXmax + ABS (TXmax - TXmin) * .05
        My   = ABS (TYmax - TYmin) * .075
        Y    = TYmax 

        CALL Zmove (X, Y)
        call zlbdir(0.0)
        itch = 'P a r a m e t e r s:'
        CALL zlabel(itch)
        Y = Y - My*1.5
        WRITE (Numstr,Ifmt) LagNum
        CALL Zmove (X, Y)
        scratch = 'Lag #  :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        Write (Numstr,Ifmt) Pairs (LagNum)
        CALL Zmove (X, Y)
        scratch ='Pairs  :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My * 1.5

        WRITE (Numstr,Rfmt) GamPower2 (LagNum)
        CALL Zmove (X, Y)
        scratch = 'Vario. :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)

        Y = Y - My * 1.5
        IF (LagNum .GT. 1) THEN
          WRITE (Numstr,Rfmt) LagCutoff (I-1)
          CALL Zmove (X, Y)
          scratch = 'MinDist:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        ENDIF

        Y = Y - My

        WRITE (Numstr,Rfmt) LagCutoff (LagNum)
        CALL Zmove (X, Y)
          scratch = 'MaxDist:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) Direction
        CALL Zmove (X, Y)
          scratch = 'Direct.:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) Tolerance
        CALL Zmove (X, Y)
          scratch = 'Tol.   :'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        CALL Zmove (X, Y)
cc This crashed on me, presumably because the thing couldn't write the 
cc asterix tested for in the following lines. My idea is to change the order
cc of the test:
cc        WRITE (Numstr,Rfmt) BandWidth
cc        IF (Numstr (1:1) .EQ. '*') NumStr = '          n/a'
cc
        NumStr =  '          n/a'
        IF (bandwidth  .ne. 1.E30) WRITE (Numstr,Rfmt) bandwidth

          scratch = 'MaxBand:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My * 1.5

        CALL Zmove (X, Y)
          stuff = Vlabel(1:L)
          scratch = 'Limits'
          junk = vlabel(1:L)//' Limits  :'
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) VarMin   
        CALL Zmove (X, Y)
          scratch = 'Minimum:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

        WRITE (Numstr,Rfmt) VarMax   
        CALL Zmove (X, Y)
          scratch = 'Maximum:'
          junk = scratch(1:lenstr(scratch))//numstr
          CALL Zlabel (junk)
        Y = Y - My

      RETURN
	END


