C     Postplot.for 
C----------------------------------------------------------------------
C     Post Plot - display post plot for program VARIO
C     
      SUBROUTINE PostPlot
      IMPLICIT INTEGER*4 (A-Z)
      PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)
      
      INCLUDE 'vario.dec'
      
      REAL*4	    TxMax, TxMin, Tymax, TyMin, TxTinc, TyTinc
      REAL*4	    Tmaxx, Tmaxy, Tminx, Tminy
      REAL*4      Dx, Dy, Mx, My, Tx, Ty 
      REAL*4	    Factor, Ratio, Yoffset, Tmin, Tmax
      REAL*4	    TopMargin, BottomMargin
      INTEGER*4   I, J, N, LENSTR, L, TnX, TnY
      INTEGER*4   DevMinX, DevMinY, DevMaxX, DevMaxY
      CHARACTER   Plot Title*70, Xlabel*40, Ylabel*40
cclongI introduced these variables, for scaling and centering
      integer     ptl
      character*72 message, menu choice
cc    
C     check for no data
      IF (Nkept .LT. 1) RETURN
      
 1    if (ps_or_no .eq. 0) call pre post script('postplot')

C     Compute axis boundry and tic interval parameters
      TXmin	= XcMin
      TXmax	= XcMax
      TYmin	= YcMin
      TYmax	= YcMax
      CALL NeatAx (TXmin, TXmax, TXtinc, TNx)
      CALL NeatAx (TYmin, TYmax, TYtinc, TNy)
      
C     Compute symbol sizes, and scaling stuff
      Dx 	= ABS (TXmax-TXmin)
      Dy 	= ABS (TYmax-TYmin)
      Ratio	= Dx / Dy
      Tmax 	= AMAX1 (Dx, Dy)
      TMinx 	= TXmin - Tmax * .265
      TMaxX	= TXmin + Tmax * 1.1
      TMinY 	= TYmin - Tmax * .265
      TMaxy 	= TYmin + Tmax * 1.1
      Mx 	= Tmax * .008 / Aspect 
      My 	= Tmax * .008
      
C     Shift plot vertically to center (for horizontal rectangles)
      IF (Ratio .GT. 1.0) THEN
 10      TopMargin 	= TMaxY - TYMax
         BottomMargin	= TYMin - TMiny
         IF (TopMargin .GT. BottomMargin) THEN
            Ty		= AMIN1 (TopMargin, BottomMargin) * .1
            IF (TMaxY - Ty .GT. TYMax) THEN
	       TMaxY 	= TMaxY - Ty
	       TMinY 	= TMinY - Ty
	       GOTO 10
            ENDIF
         ENDIF
      ENDIF
      
C     Compute SQUARE Device space (corrected by device pixel aspect ratio)
      YoffSet     	= My * 2.0
      DevMinX		= 0
      DevMinY		= 0
      DevMaxY		= YmaxDev
      Factor 	= 29./45.
      YoffSet  = My * 5.0
      DevMaxX = FLOAT (DevMaxY) / Factor
      
C     Set up labels
      L = LENSTR (VarNam (Var))
      Plot Title  = 'Plot of sample locations'
      ptl = lenstr(plot title)
      Xlabel = Varnam (XVar)
      Ylabel = Varnam (YVar)
      
C     graphics setup
      CALL Zsetup (INT2 (Gmode), Ierr)
      CALL Zcolor (INT2 (White))
      CALL Zlbdir (0.0)
      CALL Zlocat (DevMinX, DevMaxX, DevMinY, DevMaxY)
      CALL Zscale (TMinx, TMaxx,TMiny, TMaxy)
      CALL Grframe (Xmaxdev, Ymaxdev, Blue) 
      
C     Draw and label the axes
      CALL Axes (' ', Xlabel, Ylabel, ' ',
     +     txmin, txmax, TYmin, TYmax, txtinc,
     +     TYtinc, DevCode)
      
C     Plot Title
      CALL Zmove  (TXmin+(48-ptl)*(TXmax-TXmin)/96.0,
     +     TYMax+Yoffset)
      CALL Zlabel (Plot Title)
      
C     Plot sample locations, use Plus symbol
      call zcolor(green)
      DO 30 I = 1, NKept
         CALL justPlus (xdata(I), Ydata (I), Mx, My)
 30   CONTINUE						     
      call zcolor(white)
      CALL Zmove  (TXmin-yoffset, TYMin-2*Yoffset)

      if (ps_or_no .eq. 0) call post script(message, destination)
      if (destination .eq. 1) goto 1

 666  call reset()
      RETURN
      END


