cc    $LARGE
C
C Process.for
C----------------------------------------------------------------------
C Perform Process - perform application-specific functions for VARIO
C
	SUBROUTINE Perform Process (Field Name, Error, Repaint)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (Alpha Field     = 0)
	PARAMETER (Integer Field   = 1)
	PARAMETER (Real Field      = 2)
	PARAMETER (Toggle Field    = 5)

                INCLUDE 'vario.dec'
                INCLUDE '../common/screen.str'

	CHARACTER	Message*75, Blanks*14, Tname*14
	CHARACTER	OldFile*65, Scratch*13
	CHARACTER*10	Field Name,  MainMenu, Dummy, Return Field
	INTEGER*4	Fld Index, Index of Field, Field Type
	INTEGER*4	LENSTR, Position, I, J
	INTEGER*4	Field1, Field2, Field3, Pos, Oldtype
	LOGICAL		Error, Exit, Repaint, PutMessage, FExist
        LOGICAL       GetYesNo, OverWrite
	REAL*4		Temp, OldTemp

	DATA MainMenu   /'MAINMENU  '/
	DATA Blanks	/'              '/

C initialize
	Error		= .FALSE.
	Repaint		= .FALSE.	
	PutMessage	= .FALSE.
	FExist		= .FALSE.
	Index of Field	= Fld Index (Field Name)
	Return Field	= SC Field Name (Next Field)
	Field Type	= SC Field Type (Index of Field)
	Pos		= 0

C Get a real value, or toggle position
	IF (Field Type .EQ. Real Field) THEN
	   CALL Get Character Value (Field Name, Scratch)
	   IF      (Scratch .EQ. '          MAX') THEN
	      Temp =  1.E30
	   ELSE IF (Scratch .EQ. '          MIN') THEN
	      Temp = -1.E30
	   ELSE
	      READ (Scratch, '(G13.0)') Temp
	   ENDIF
	ELSE IF (Field Type .EQ. Toggle Field) THEN
           CALL Get Toggle Value (Field Name, Position, Dummy)
	ENDIF

C----------------------------------------------------------------------
C file prefix
	IF     (Field Name .EQ. 'FILEPREFIX') THEN
	  CALL Get Character Value (Field Name, File Prefix)
	  CALL Left Justify (File Prefix)
	  CALL Set Character Value (Field Name, File Prefix)

C----------------------------------------------------------------------
C open data file, read in header information
	ELSEIF (Field Name .EQ. 'PAIRFILE  ') THEN
          OldFile = File Name
	  CALL Get Character Value (Field Name, Pair File)
	  N = LENSTR (File Prefix)
	  IF (N .GT. 0) THEN 
	     File Name = File Prefix (1:N) // Pair File
	  ELSE
	     File Name = Pair File
	  ENDIF
	  IF (OldFile .NE. File Name) THEN
 6           CALL ReInitialize
	     CALL Set Character Value (Field Name, Pair File) 
	     CALL Display One Field   (Field Name)
cc 6           INQUIRE (FILE = File Name, EXIST = Fexist)  
             INQUIRE (FILE = File Name, EXIST = Fexist)  
	     IF (.NOT. Fexist) THEN
	        Error = .TRUE.
	        Message = 'ERROR - pair comparison file not found'
                call flash(20,2,message)
                call putstr('If you want to call prevar, type "p" now:'
     &               ,40,20,2,2)
                call getthekey(i)
                if (char(i) .eq. 'p' .or. char(i) .eq. 'P') then
                   CALL Reset Screen
                   call zclear()
                   call color('white')
                   call zmove(.5,.5)
                   call zcenterlabel
     &                  ('Input to prevar goes through the xterm.')

                   call system('$GEO_EAS/bin/geoeas -x prevar')

                   Error = .false.

                   CALL New Screen (2)
                   CALL Put Menu ('MAINMENU')
                   CALL graphics_message()
                   goto 6
                endif
                Return Field = Main Menu 
	        Pair File = ' '
                CALL Set Character Value (Field Name, Pair File)   
	     ELSE
	       CALL Read Header Data (Error)
	       IF (Error) THEN
	         Error = .FALSE. 
                 CALL ReInitialize
                 Return Field = Main Menu
	       ELSE
	         Old File = File Name
	         Return Field = 'ZVARIABLE '
               ENDIF
	    ENDIF
	  ENDIF

C----------------------------------------------------------------------
C Get the Variable for variogram calculation
	ELSEIF (Field Name .EQ. 'ZVARIABLE ') THEN
           Var 	= Position + 1

C----------------------------------------------------------------------
C Get the log option, Read in data and pair links
	ELSEIF (Field Name .EQ. 'LOGOPTION ') THEN
	   Log = (Position .EQ. 1)
	   CALL Read Data (Error)
	   IF (Error) THEN
	      Error = .FALSE.
	      CALL ReInitialize
              Return Field = MainMenu 
           ENDIF

C----------------------------------------------------------------------
C Minimums and Maximums for Variable
	ELSEIF (Field Name .EQ. 'MINZ      ') THEN
	   VarMin = Temp
 
	ELSEIF (Field Name .EQ. 'MAXZ      ') THEN
	   IF (Temp .LE. VarMin) THEN
	        Error = .TRUE.
	        Message = 'ERROR - Max must be .GE. Min'
                Return Field = Field Name
	   ELSE
	        VarMax = Temp
	   ENDIF
		
C----------------------------------------------------------------------
C Variogram Type Flag
	ELSE IF (Field Name .EQ. 'VARIOTYPE ') THEN
         OldType = GammaType
	   GammaType = Position
         IF (Log .AND. 
     +    (Position .EQ. GAMREL .OR. Position .EQ. GAMERGO)) THEN
           CALL Set Toggle Position (Field Name, 0)
           CALL Flash (20, 2,
     +  'This estimator not appropriate with LOG data.. (press a key)')
           GammaType = GAMABS2
           CALL Set Toggle Position (Field Name, GAMABS2)
         ELSE
           CALL Load Results
           CALL Display Results
           CALL Vplot Defaults
         ENDIF
C----------------------------------------------------------------------
C Direction parameters
	ELSE IF (Field Name .EQ. 'DIRECTION ') THEN
	  IF (Temp .LT. 0.0 .OR. Temp .GE. 180.0) THEN
	     Error 	= .TRUE.
	     Message 	=
     +        'This parameter must be in [0 - 180[ ... (press any key)'
	     Temp 	= 0.0
	     Return Field = Field Name
	  ELSE
	     Direction = Temp
	  ENDIF 
	ELSE IF (Field Name .EQ. 'TOLERANCE ') THEN
	  IF (Temp .LE. 0.0 .OR. Temp .GT. 90.0) THEN
	     Error 	= .TRUE.
	     Message 	=
     +        'This parameter must be in ]0 - 90] ... (press any key)'
	     Temp 	= 90.0
	     Return Field = Field Name
	  ELSE
	     Tolerance = Temp
	  ENDIF 

	ELSE IF (Field Name .EQ. 'BANDWIDTH ') THEN
	   IF (Temp .LE. 0) THEN
	      Error = .TRUE.
	      Message = 'This parameter must be > 0.0 '
	      Temp  = MaxDist
	      Return Field = Field Name
	      CALL Set Character Value (Field Name, '          MAX')
	      GOTO 85
	   ELSE
	      LagMaxDist = Temp
	      GOTO 85
	   ENDIF

C----------------------------------------------------------------------
C Lag Spacing Parameters
        ELSE IF (Field Name  .EQ. 'LAGMINDIST') THEN
	   LagMinDist = Temp	     
	ELSE IF (Field Name  .EQ. 'LAGMAXDIST') THEN
	   IF (Temp .LE. LagMinDist) THEN
	      Error = .TRUE.
	      Message = 'This parameter must be > Lag Min Distance'  
	      Temp  = MaxDist
	      Return Field = Field Name
	   ELSE
	      LagMaxDist = Temp
	   ENDIF
	ELSE IF (Field Name  .EQ. 'LAGINCDIST') THEN
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'This parameter must be > 0.0'  
	      Temp  = LagIncDist
	      Return Field = Field Name
	   ELSE
	      LagIncDist = Temp
	      CALL Set Up Lags
	      CALL Display Lag Cutoffs
	   ENDIF

	ELSE IF (Field Name (1:7)  .EQ. 'LAGDIST') THEN
	   READ (FieldName (9:10), '(I2)') Position
	   LagCutoff (Position) = Temp
	   IF (Character .EQ. 13) THEN
	      CALL Arrange Lags
		  GOTO 90
	   ENDIF

C----------------------------------------------------------------------
C Variogram Parameters
        ELSE IF (Field Name .EQ. 'NUGGET    ') THEN
           IF (Temp .LT. 0.0) THEN
              Error = .TRUE.
              Message = 'The Nugget parameter must be >= 0.0'  
              Temp  = Nugget
              Return Field = Field Name
           ELSE
              Nugget = Temp
           ENDIF

        ELSE IF (Field Name (1:2) .EQ. 'MO') THEN
	  READ (Field Name (9:10), '(I2)') Pos
	  IF (Field Name (3:6) .NE. 'TYPE' .AND. Mtype (Pos).EQ. 0)THEN
             CALL Erase Field (Field Name)
	     CALL Set Character Value (Field Name, Blanks (1:13))
	     GOTO 85
	  ELSE    
	    IF     (Field Name (3:7) .EQ. 'TYPE ') THEN
	       Mtype (Pos) = Position
               if (position .eq. 0) then
                  if (pos .ne. maxstruc) then
                     Return Field = Field Name
                     write(Return Field(10:10),'(i1)') pos+1
                  else if (pos .eq. maxstruc) then
                     Return Field = 'MDEL2'
                  end if
               end if

	    ELSEIF (Field Name (3:7) .EQ. 'PARMA') THEN
	      IF (Temp .LE. 0.0) THEN
	        Error = .TRUE.
	        Message = 'This parameter must be > 0.0'  
	        Temp  = Sill (Pos)
	        Return Field = Field Name
	      ELSE
	        Sill (Pos) = Temp
	      ENDIF
	    ELSEIF (Field Name (3:7) .EQ. 'PARMB') THEN
	      IF (Temp .LE. 0.0) THEN
	        Error = .TRUE.
	        Message = 'This parameter must be > 0.0'  
	        Temp  = Range (Pos)
	        Return Field = Field Name
	      ELSE
	        Range (Pos) = Temp
	      ENDIF
	    ENDIF
	    IF (Mtype (Pos) .EQ. 0) CALL Erase Model (Pos) 
	  ENDIF
C----------------------------------------------------------------------
C graph parameters for modeling
	ELSE IF (Field Name (1:5) .EQ. 'TITLE') THEN
	   READ (Field Name (6:6), '(I1)') Pos
	   CALL Get Character Value (Field Name, Title (Pos))
	ELSE IF (Field Name .EQ. 'XTICSPACE ') THEN
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'This parameter must be > 0.0'  
	      Temp  = Xtinc
	      Return Field = Field Name
	   ELSE
	      Xtinc = Temp
	   ENDIF
	ELSE IF (Field Name .EQ. 'YTICSPACE ') THEN
	   IF (Temp .LE. 0.0) THEN
	      Error = .TRUE.
	      Message = 'This parameter must be > 0.0'  
	      Temp  = Ytinc
	      Return Field = Field Name
	   ELSE
	      Ytinc = Temp
	   ENDIF
	ELSE IF (Field Name .EQ. 'GMINX     ') THEN
	   Xmin = Temp
	ELSE IF (Field Name .EQ. 'GMAXX     ') THEN
	   IF (Temp .LE. Xmin) THEN
	      Error = .TRUE.
	      Message = 'Max must be > Min'  
	      Temp  = Xmax
	      Return Field = 'GMINX     '
	   ELSE
	      Xmax = Temp
           ENDIF
	ELSE IF (Field Name .EQ. 'GMINY     ') THEN
	   Ymin = Temp
	ELSE IF (Field Name .EQ. 'GMAXY     ') THEN
	   IF (Temp .LE. Ymin) THEN
	      Error = .TRUE.
	      Message = 'Max must be > Min'  
	      Temp  = Ymax
	      Return Field = 'GMINY     '
	   ELSE
	      Ymax = Temp
	   ENDIF

C lag results file name (write option)
        ELSEIF (Field Name .EQ. 'LAGFILE   ') THEN
	  CALL Erase (20, 2, 75)
	  CALL Get Character Value (Field Name, Tname)
	  IF (Tname .EQ. Blanks) THEN
	     Error = .TRUE.
	     Message = 'Blank file name given - option cancelled '
	     GOTO 90
	  ENDIF 
	  N = LENSTR (File Prefix)
	  IF (N .GT. 0) THEN 
	     File Name = File Prefix (1:N) // Tname
	  ELSE
	     File Name = Tname
	  ENDIF
	  INQUIRE (FILE = File Name, EXIST = Fexist)  
	  Overwrite = .TRUE.
	  IF (Fexist) Overwrite = 
     +		GetYesNo (20, 2, 'Overwrite existing file? <Y/N>')
	  IF (OverWrite) THEN
	     CALL Save Lag Results (File Name, Error)
	     IF (Error) THEN
	      Message='Error writing lag results ... (press any key)'
	     ELSE
	      CALL Flash(20,2,'Lag results stored ... (press a key)')
	     ENDIF
	  ENDIF
	ELSE
	  CONTINUE  
	ENDIF

C Set the real value at 3 decimal places
 80	IF (Field Type .EQ. Real Field) THEN
	   CALL Set 4 Floating Point Value (Field Name, Temp, 3)
	   IF (Pos .NE. 0 .AND. Mtype (Pos) .EQ. 0) GOTO 90
	ENDIF

C write out field, in case an error caused it to be blanked out
 85	CALL Display One Field (Field Name)

C if an error occurred, put out the message
 90	IF (Error) CALL Flash (20, 2, Message)

C Set up Next Field to be processed
	Next Field = Fld Index (Return Field)

C Erase screen message area
 1001	IF (Current Screen .EQ. 1) THEN
 	   DO 444 I = 11, 18
	     CALL Erase (I, 42, 35)
 444 	   CONTINUE
	ENDIF
	CALL Erase (20, 2, 75)
	RETURN
	END

C----------------------------------------------------------------------
C Erase Model - erase a model with no model type
C
	SUBROUTINE Erase Model (Number)
	IMPLICIT INTEGER*4 (A-Z)

	INTEGER*4	Number
	CHARACTER	Field*10, Num*1, Fmt*4, Scratch*13

                  INCLUDE 'vario.dec'

	DATA Fmt 	/'(I1)'/
	DATA Scratch 	/'             '/
	WRITE (Num, Fmt) Number

	Field = 'MOPARMA  '//Num
	Sill (Number) = 0.0
	CALL Set Character Value (Field, Scratch)
	CALL Erase Field (Field)

	Field = 'MOPARMB  '//Num
	Range (Number) = 0.0
	CALL Set Character Value (Field, Scratch)
	CALL Erase Field (Field)
	RETURN
	END	

