cc $LARGE
C Scatter.for 
C----------------------------------------------------------------------
C Scatter - display scatter plot for program VARIO
C
      SUBROUTINE Scatter (LagNum)
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)

	INCLUDE 'vario.dec'

	REAL*4	    TxMax, TxMin, Tymax, TyMin, TxTinc, TyTinc
	REAL*4	    Tmaxx, Tmaxy, Tminx, Tminy, Factor
        REAL*4      Dx, Dy, Mx, My, Tx, Ty, X, Y 
	REAL*4	    Xfudge, Yfudge
        INTEGER*4   I, J, N, LENSTR, L, TnX, TnY, LagNum, Ptr
	INTEGER*4   DevMinX, DevMinY, DevMaxX, DevMaxY
        CHARACTER   Plot Title*70, Xlabel*40, Ylabel*40, Vlabel*15
        character*72 message, menu choice*10

cclong 11/30/93
        CALL New Screen (9)
        call put menu ('POSTSCR')
        call set character value('PSFILEN','scatter.ps')
cclong 11/30/93

C check for no data
	IF (Pairs (LagNum) .LT. 1) RETURN

C Compute axis boundry and tic interval parameters
 1      message = 'Computing Scatterplot... '
        CALL PutStr (message,lenstr(message), 20, 2, 2)
        TxMin = Data (From (DiffPtr (1)))
      TyMin = Data (To   (DiffPtr (1)))
      TxMax = TxMin
      TyMax = TyMin
      DO 5 I = 1, Pairs (LagNum)
        TXmin	= AMIN1 (TxMin, Data (From (DiffPtr (I))))
        TXmax = AMAX1 (TxMax, Data (From (DiffPtr (I))))
	  TYmin	= AMIN1 (TyMin, Data (To   (DiffPtr (I))))
	  TYmax	= AMAX1 (TyMax, Data (To   (DiffPtr (I))))
 5    CONTINUE
      Txmin = AMIN1 (Tymin, TxMin)
      Txmax = AMAX1 (Tymax, TxMax)
      CALL NeatAx (TXmin, TXmax, TXtinc, TNx)
      Tymin = TxMin
      TyMax = TxMax
      TyTinc = TxTinc

C Compute symbol sizes, and scaling stuff
        Dx 	= TXmax - TXmin
	Dy 	= TYmax - TYmin
	Xfudge  = Dx * 0.15
	Yfudge  = Dy * 0.2
	TMinx 	= TXmin - (Xfudge*1.75)
	TMiny 	= TYmin -  Yfudge
	TMaxx 	= TXmax + (Xfudge*3.8)
	TMaxy 	= TYmax + (Yfudge*1.5)
	Mx 	= Dx * .01 / Aspect 
	My 	= Dy * .01

C Set up labels
	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
      Plot Title  = 'Lag Scatter Plot for '//Vlabel
      Xlabel = '1st Point in pair'
      Ylabel = '2nd Point in pair'

C graphics setup
	CALL Zsetup (INT2 (Gmode), Ierr)
	CALL Zcolor (INT2 (White))
	CALL Zlbdir (0.0)
	CALL Zlocat (INT2 (XminDev), INT2 (Xmaxdev),
     +             INT2 (YminDev), INT2 (YmaxDev))
	CALL Zscale (TMinx, TMaxx, TMiny, TMaxy)
	CALL Grframe (Xmaxdev, Ymaxdev, Blue) 

C Draw and label the axes
	CALL Axes (Plot Title, Xlabel, Ylabel, ' ',
     +		   TXmin, TXmax, TYmin, TYmax, TXtinc, TYtinc, DevCode)

C 45 degree line
      CALL Zmove (TxMin, TyMin)
      CALL Zplot (TxMax, TyMax)

C Plot sample locations, use Plus symbol
ccc
      call zcolor(green)
      DO 30 I = 1, Pairs (LagNum)
          X = Data (From (DiffPtr (I)))
          Y = Data (To   (DiffPtr (I)))
          CALL justPlus (X, Y, Mx, My)
 30   CONTINUE						     
      call zcolor(white)
ccc
      CALL Plot Lstats (LagNum, TXmin, TxMax, TyMin, TyMax)

cclong 11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message = 
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF 
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
cclong 11/30/93
      
 666  call reset()

      RETURN
      END


