cc $LARGE
C Write.for - write lag results for VARIO
C----------------------------------------------------------------------
	SUBROUTINE Save Lag Results (File, Error)
	IMPLICIT INTEGER*4 (A-Z)
	CHARACTER*65	File, Header*80, Vlabel*15
	LOGICAL		Error

	INCLUDE 'vario.dec'

	INTEGER*4   Ptr, I, L, LENSTR
	REAL*4      Z1, Z2, Angl, Dist, Incr, Incr2
	REAL*4      Zfrom,  Zto, Dmax, Dmin
        real*8 real8
	LOGICAL     Retain

C build labels
	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	L = LENSTR (Vlabel)

C open file, write header info
	CALL PutStr (' Writing lag results ...      ', 30, 20, 2, 2)
	Error = .FALSE.

	OPEN (FILE = File, UNIT = 10, Status = 'UNKNOWN', ERR = 999)
	WRITE (Header, 555) Current Lag, Vlabel(1:L)  
 555	FORMAT ('VARIO Results for lag ',I2,' for variable: ',A)
	WRITE (10, '(A80)', ERR = 999) Header
	WRITE (10, '(I5)',  ERR = 999) 6
	WRITE (10, '(2A10)', ERR = 999)
     +	   'From'//Varnam(Var)(1:6),Units (var)
	WRITE (10, '(2A10)', ERR = 999)
     +	   'To'//Varnam(Var)(1:8),Units (var)
	WRITE (10, '(2A10)', ERR = 999) 'Distance  ',Units (Xvar)
	WRITE (10, '(2A10)', ERR = 999) 'Direction ','Trig Deg.  '
	WRITE (10, '(2A10)', ERR = 999) 'Difference','           '
	WRITE (10, '(2A10)', ERR = 999) 'Diff. ^2  ','           '

C access data, compute differences, write to file
	NumPair = 0
	Ptr   	= 0
	I	= Current Lag
	Dmax = LagCutoff (I)
	IF (I .EQ. 1) THEN
	   Dmin = LagMinDist 
	ELSE
	   Dmin = LagCutoff (I-1)
	   IF (I .GT. Nlag) Dmax = MaxDist
	ENDIF

	CALL SearchB (Distance, Npair, Dmin, Ptr)
	IF (Ptr .EQ. 0) Ptr = 1
 5	IF (Distance (Ptr) .LE. Dmin .AND. Ptr .LT. Npair) THEN
	   	Ptr = Ptr + 1
          GOTO 5
	ENDIF	
	IF (Ptr .GE. Npair) GOTO 888

10   	IF (Distance (Ptr) .LE. Dmax .AND. Ptr .LT. Npair) THEN
 	   Z1 = Data (From (Ptr))
	   Z2 = Data (To   (Ptr))
	   Angl = ABS (Direct (Ptr) - Direction) * 0.0174533
           real8 = Angl
	   Dist	= ABS (Distance (Ptr) * dSIN (real8))
	   IF (Retain (Angl, Dist, Z1, Z2)) THEN
	     Incr  = ABS (Z1-Z2)
	     Incr2 = Incr * Incr
	     IF (dCOS (real8) .LT. 0.0) THEN
	         Zfrom =  Z2
	         Zto   =  Z1
	     ELSE
	         Zfrom =  Z1
	         Zto   =  Z2
           ENDIF
	     WRITE (10, *, ERR = 999) 
     +		Zfrom, Zto, Distance (Ptr), Direct (Ptr),Incr, Incr2
	   ENDIF
	   Ptr = Ptr + 1
	   GOTO 10
	ENDIF
 888	CLOSE (10)
	CALL Erase (20, 2, 75)
 	RETURN
 999	CLOSE (10)
	Error = .TRUE.
	CALL Erase (20, 2, 75)
 	RETURN
	END
