
C Debug.for
C--------------------------------------------------------------------
C Show Weights - display weights for program XVALID

        SUBROUTINE Show Weights (K, Neighbors, N, Quit)

		include 'xvalid.dec'
        
        INTEGER*4       Neighbors (1), N, Ptr
        REAL*4          SumWeight, X0, Y0, X, Y, V, Wt
        REAL*4          Dx, Dy, D, Sum, Value
	LOGICAL		Quit
	INTEGER*4       K, Key 
        character*80    output

        SumWeight = 0.0
	
        Value = Variable (K)
	X0    = Xdata (K)
	Y0    = Ydata (K)

	CALL Clear Screen

        WRITE (output, 100) VarNam (Var)
        CALL Locate Cursor (1, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 110) X0, Y0
        CALL Locate Cursor (2, 0)
        CALL Put Characters (Output, 80, NORMAL)
	WRITE (output, 115) K, Variable (K)
        CALL Locate Cursor (3, 0)
        CALL Put Characters (Output, 80, NORMAL)

        IF (Ktype .EQ. 1) THEN
ccc why? long	   Mglobal = 0.0
           WRITE (output, 130)
        ELSE
           WRITE (output, 140)
        ENDIF
        CALL Locate Cursor (4, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 145)
        CALL Locate Cursor (5, 0)
        CALL Put Characters (Output, 80, NORMAL)

	Sum 		= 0.0
	SumWeight 	= 0.0
        DO 10 I = 1, N
          Ptr = Neighbors (I)
          X   = XData (Ptr)
          Y   = YData (Ptr)
          V   = Data  (Ptr) - Mglobal 
          Wt  = B (I)
          Dx  = X - X0
          Dy  = Y - Y0
          D   = SQRT (Dx*Dx+Dy*Dy)
          SumWeight = SumWeight + Wt
	  Sum = Sum + B (I) * B2 (I)  
          if (i .le. 14) then
             WRITE (output, 150) X, Y, V, D, B (I), B2 (I)
             CALL Locate Cursor (5+i, 0)
             CALL Put Characters (Output, 80, NORMAL)
          end if
 10     CONTINUE

        i = int(min(i+5.,19.))
        WRITE (output, 160) N, SumWeight
        CALL Locate Cursor (i, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 170) Vk,  Data (K)
        CALL Locate Cursor (1+i, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 180) Sk, Sum
        CALL Locate Cursor (2+i, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (output, 190) GamMax - Sum - B (N+1), B(N+1)
        CALL Locate Cursor (3+i, 0)
        CALL Put Characters (Output, 80, NORMAL)
 
        IF (Sk .LT. 0.0) then
           WRITE (output, 230)
           CALL Locate Cursor (4+i, 0)
           CALL Put Characters (Output, 80, NORMAL)
        end if

        CALL Getthekey(Key)
        if (char(key) .eq. 'q' .or. char(key) .eq. 'Q') keep = .false.

	RETURN

 100   FORMAT ('  Debug results for variable :',A10)
 110   FORMAT ('             Point kriged is :',
     +  '(',F10.3,',',F10.3,')')
 115   FORMAT ('		Datum #, Value :', I10,F13.3)
 130   FORMAT ('        X(i)        Y(i)      V(i)-m     Distance',
     +         '      W(i)        B2(i)')
 140   FORMAT ('        X(i)        Y(i)        V(i)     Distance',
     +         '      W(i)        B2(i)')
 145   format ('----------------------------------------------------')
 150   FORMAT (6F12.3)
 160   FORMAT ('# Neighbors:',I9,'          Weights:',G13.3)
 170   FORMAT ('   Estimate:',G13.3,'   True Value:',G13.3)
 180   FORMAT ('          k:',G13.3,'        WiB2i:',G13.3) 
 190   FORMAT ('          k:',G13.3,'             :',G13.3) 
 230   FORMAT ('*** ERROR *** (Variance is <= 0')
       END

C----------------------------------------------------------------------
C Show Neighbors - display neighbors found by subroutine Search (XVALID)
C
        SUBROUTINE Show Neighbors (X0, Y0, Neighbors, N, Quit)
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'

        REAL*4     X0, Y0, X, Y, Dx, Dy, Hx, Hy, D
        REAL*4     Cosa, Sina, Ratio, Dtr
        INTEGER*4  Neighbors (1), N, Ptr, I, Quad, Oct, Ch, Key 
	LOGICAL	   Quit
        CHARACTER  Output*75

        DATA Dtr    /0.0174533/
	
	CALL Clear Screen

        Cosa   = COS (SrAngle*Dtr)
        Sina   = SIN (SrAngle*Dtr)
        Ratio = SrMajor / SrMinor

        IF (Nsector .EQ. 4) THEN
           WRITE (Output, 100)
        ELSE IF (Nsector .EQ. 8) THEN
           WRITE (Output, 110)
        ELSE
           WRITE (Output, 120)
        ENDIF
	CALL Locate Cursor (2, 0)
	CALL Put Characters (Output, 75, NORMAL)
        WRITE (Output, 105)
	CALL Locate Cursor (3, 0)
	CALL Put Characters (Output, 75, NORMAL)
        
        DO 10 I = 1, N
           Ptr = Neighbors (I)
           X   = XData (I)
           Y   = YData (I)
           Dx  = X - X0
           Dy  = Y - Y0
           Hx  = Dx * Cosa - Dy * Sina
           Hy  = Ratio * (Dy * Cosa + Dy * Sina)
           D   = SQRT (Dx*Dx + Dy*Dy)
           Call Sector (Dx, Dy, Quad, Oct)
           IF (Nsector .EQ. 4) THEN
              WRITE (Output, 200) Ptr, Quad, X, Y, D
           ELSE IF (Nsector .EQ. 8) THEN
              WRITE (Output, 200) Ptr, Oct, X, Y, D
           ELSE
              WRITE (Output, 210) Ptr, X, Y, D
           ENDIF
	   IF (I.LT.20)	THEN
	      CALL Locate Cursor (4+I, 0)
	   ELSE
              CALL Locate Cursor (24, 0)
	   ENDIF	  
	   CALL Put Characters (Output, 75, NORMAL)
 10     CONTINUE
	RETURN

 100    FORMAT ('  #   Quad            X           Y       Distance')
 105    FORMAT ('--------------------------------------------------')
 110    FORMAT ('  #   Octant          X           Y       Distance')
 120    FORMAT ('  #                   X           Y       Distance')
 200    FORMAT (I3,4X,I1,3X,3(1X,F12.3))
 210    FORMAT (I3,8X,3(1X,F12.3))
        END           

C--------------------------------------------------------------------
C Show System - display system of equations for program XVALID

        SUBROUTINE Show System (X0, Y0, N, Quit)
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'
        
        INTEGER*4       Neq, N, Key
        REAL*4          SumWeight, X0, Y0, X, Y, V, Wt
        REAL*4          Dx, Dy, D
	LOGICAL		Quit
	character*80  	Output

	CALL Clear Screen
	IF (Ktype .EQ. 0) THEN
	   Neq = N + 1
	ELSE
	   Neq = N
	ENDIF

        WRITE (Output, 100) VarNam (Var)
        CALL Locate Cursor (1, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (Output, 110) X0, Y0
        CALL Locate Cursor (2, 0)
        CALL Put Characters (Output, 80, NORMAL)
        WRITE (Output, 155)
        CALL Locate Cursor (4, 0)
        CALL Put Characters (Output, 80, NORMAL)
        outneq = min(neq,7)
        DO 50 I = 1, Neq
           if (i .le. 20) then
              WRITE (output,300) B(I), (W (I,J), J = 1, outneq)
              CALL Locate Cursor (4+i, 0)
              CALL Put Characters (Output, 80, NORMAL)
           else
              goto 60
           end if
 50	CONTINUE 

 60     CALL Getthekey(Key)
        if (char(key) .eq. 'q' .or. char(key) .eq. 'Q') keep = .false.
	RETURN

 100    FORMAT ('  Debug results for variable :',A10)
 110   FORMAT ('             Point kriged is :','(',F10.3,',',F10.3,')')
 155    FORMAT ('R.H.S.      Left hand Matrix')
 300    FORMAT (F8.3,3X,18(1X,F7.3))
       END


