
C
C Histo.for for XVALID
c----------------------------------------------------------------------
c ***   Histogram -  Histogram plot for program STATS

	SUBROUTINE Histogram 
	IMPLICIT INTEGER*4 (A-Z)
	PARAMETER (HMAXCLASS = 250)

		include 'xvalid.dec'

c ***	local variables
	REAL*4		HistFreq (HMAXCLASS), Class (HMAXCLASS)
      REAL*4      Width, Tmax, Tmin, ClassInt
	REAL*4		Xc, Yc, X, Y, Dx, Dy, Tx, Ty, Mx, My
	REAL*4		TxMin, TxMax, TyMin, TyMax, TxTinc, TyTinc
	REAL*4		TMinx, Tmaxx, Tminy, TmaxY, tXfudge, tYfudge

	INTEGER*4	NclassHist, I, J, TN, L, LENSTR
	CHARACTER 	Xlabel*50, Ylabel*50, Plot Title*50, Title2*50
        CHARACTER   Vlabel*15, message*70, menu choice*10

cclong 11/30/93
        CALL New Screen (6)
        call put menu ('POSTSCR')
        call set character value('PSFILEN','histogram.ps')
cclong 11/30/93
 
 1    IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF

	TN = DN
	IF (TN .EQ. 0) RETURN

        message = 'Computing Histogram...type "q" to quit.'
        CALL PutStr (message,lenstr(message), 20, 2, 2)

        Xlabel 	    = 'Difference: Estimate-'//Vlabel
	Title2	    = 'Estimated Variable: '//Vlabel
        Plot Title  = 'Histogram '
        Ylabel 	    = 'Frequency '

C Initialize classes and frequencies to zero
	DO 10 I = 1, HMAXCLASS
	   Class (I) = 0.0
	   HistFreq (I) = 0.0
 10	CONTINUE
        
C Scale axes tickmarks to 'neat' values
        Txmin  = Dmin
        TxMax  = Dmax
      CALL NeatAx (TxMin, TxMax, TxTinc, K)

      	Classint 	= TxTinc * .25
      	NClassHist 	= INT (ABS (TxMin - TxMax)  / ClassInt +.5)
	IF (NclassHist .LE. 0) NclassHist = 1
	IF (NclassHist .GE. HMAXCLASS) NclassHist = HMAXCLASS-1

C Calculate class cutoff values
	Class (1) = TxMin
	DO 20 I = 2, NclassHist
	   Class (I) = Class (I-1) + ClassInt
 20	CONTINUE

C Calculate frequencies
        I = 1
        DO 30 J = 1, NclassHist
 40        IF (I .LE. TN .AND. Difference (I) .LE. Class (J)) THEN
	      IF (Difference (I) .LT. Missing) THEN
                 HistFreq (J) = HistFreq (J) + 1.0
                 I = I + 1
                 GOTO 40
	      ENDIF 
           ENDIF
 30     CONTINUE
 35     IF (I .LE. TN .AND. Zscore (I) .LT. Missing) THEN
           HistFreq (NclassHist+1) = 
     +              HistFreq (NclassHist+1) + 1.0
           I = I + 1
           GOTO 35
        ENDIF 

C Calculate maximum y axis value
	Tymin = 0.0
	Tymax = HistFreq (1)
	DO 50 I = 2, NclassHist+1	
 	  IF (HistFreq (I) .GT. TYmax) Tymax = HistFreq (I)
 50     CONTINUE        

C Scale axes tickmarks to 'neat' values
	CALL Neatax (Tymin, Tymax, Tytinc,  K)
	TyMax = TyMax + TyTinc * .1

C Determine the rest of the scaling information
	dx 	= txmax - txmin
	dy 	= tymax - tymin
	txfudge = dx * 0.15
	tyfudge = dy * 0.2
	tminx 	= txmin - (txfudge*1.75)
	tmaxx 	= txmax + (txfudge*3.8)
	tminy 	= tymin - tyfudge
	tmaxy 	= tymax + tyfudge*1.5
	Tx 	= (tMaxx - tMinx) * .005
	Ty 	= (tMaxy - tMiny) * .007
	mx 	= (dx * .013)/aspect
	my 	= dy * .013

C Start graphics mode
 100	CALL Zsetup (Gmode, Ierr)

C Clear the screen
        call zclear()

C Set text attributes (8x8, white on black border)
	CALL Zlbdir (0.0)
	CALL Zlocat (0, Xmaxdev, 0, Ymaxdev)
	
C Draw graph frame
	CALL Grframe (Xmaxdev, Ymaxdev, Blue)

C Set scaling window
cc	CALL Zscale (tMinx, tMaxx, tMiny, tMaxy)
	CALL Zscale (tMinx, 1.1*tMaxx, tMiny, tMaxy)
	CALL Zcolor (INT2 (White))

C Draw and label the axes
	CALL Axes (Plot Title, Xlabel, Ylabel, Title2, Txmin
     +       , Txmax+classint, Tymin, Tymax, TxTinc, TyTinc, DevCode)

C Plot boxplot above graph area
        Width   = Dy *.04
        CALL Boxplot (DMin, DQ1, DMedian, DMean, DQ3, Dmax, .TRUE.,
     +                tYmax+Width*.7, Width, Dx*.01)

C Plot histogram
	CALL Zcolor (INT2 (Green))
	DO 60 I = 1,  NclassHist
	   Tx = AMIN1 (Class (I) - Classint, TxMax)
	   X  = AMIN1 (Class (I), TxMax)
	   Y  = HistFreq (I)
	   IF (Y .NE. 0.) CALL Hbox (Tx, X, 0.0, Y)	   
 60	CONTINUE
	IF (HistFreq (NclassHist+1) .GT. 0.0)
     +	   CALL Hbox (TxMax, TxMax+classint, 
     +		      0.0, HistFreq (NclassHist+1))

	CALL Zcolor (INT2 (White))
        CALL PlotStat (DevCode, Txmin, Txmax+classint, TyMin, TyMax, 
     +			Ndata, DNmiss, DN, Dmean, Dstd,
     +			Dmin, DQ1, Dmedian, DQ3, Dmax)

ccc
cclong 11/30/93
      CALL Erase(20,2,76)
      call get character value('PSFILEN',message)
      CALL Erase(5,10,60)
      call putstr(message(1:60),60,5,10,2)
      CALL Get Menu Choice ('POSTSCR',Menu choice)
      if (menu choice .eq. 'File') then
         CALL Get Field
         call get character value('PSFILEN',message)
         IF (lenstr(message) .EQ. 0) THEN
            Message =
     &           'Blank file name given - no can do!'
            CALL Erase (20, 2, 76)
            CALL Flash (20, 2,message)
            goto 1
         ENDIF
      else if (menu choice .eq. 'Quit') then
         goto 666
      end if
      i = lenstr(message)
      call putstr(message(1:60),60,5,10,2)
      j = lenstr(fileprefix)
      call turn_ps_on(fileprefix(1:j)//message(1:i))
      goto 1
cclong 11/30/93
 
 666  call reset()
 
      RETURN
      END        

