C Parmfile.for - parameter file read and write routines
C----------------------------------------------------------------------
C Read Parameters - Reads parameter file for program XVALID
C
      SUBROUTINE Read Parameters (File Name, Error, krigvar) 
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'xvalid.dec'
      
      LOGICAL           Error
      CHARACTER         File Name*(*), Signature*13, dummy
      INTEGER*4           IntVal, Struc, LUN, krigvar
      DATA                   LUN /10/
      
      Error = .FALSE.
      
      OPEN (UNIT=LUN, FILE = file prefix(1:lenstr(file prefix))
     +     //File Name, STATUS = 'old', ERR = 200)
      
C     Check if valid
      READ  (LUN,15, ERR = 200) Signature
      IF (Signature(5:9) .NE. 'KRIGE') GOTO 200
      
C     File Names Record
      READ (LUN,15, ERR = 200) Data File
      READ (LUN,15, ERR = 200) Output File
      READ (LUN,15, ERR = 200) dummy
      
C     Title Record
      READ (LUN,15, ERR = 200) Title
      
C     Grid Parameters Records
      READ (LUN,*, ERR = 200)
     +     Xvar, Xorigin, XcellSize, Nxcells,
     +     Yvar, Yorigin, YcellSize, Nycells 
      
C     Search Parameters Records
      READ (LUN,*, ERR = 200) SrMajor, SrMinor, SrAngle,
     +     IntVal, Nsector, Minp, Maxps, Maxempty
      Euclidean = (IntVal .EQ. 0)
      
C     Kriging Type Record
      READ (LUN,*, ERR = 200) Ktype, IntVal
      Point = (IntVal .EQ. 0)
      Ndiscr = IntVal + 1
      
C     Number of Variables Record, Variables and Variogram Structure Records
      READ (LUN,*, ERR = 200) NkVar
      READ (LUN,*, ERR = 200) KrigVar, Nugget, Mglobal, intval
      DO Struc = 1, maxstruc
         READ (LUN,*, ERR = 200) 
     +        Mtype   (Struc),
     +        Sill    (Struc),
     +        VrMajor (Struc),
     +        VrMinor (Struc),
     +        VrAngle (Struc)
      enddo
      Current Var = 1
      CLOSE (10)
      RETURN
      
C     Error Encountered Reading Parameter File
 200  Error = .TRUE.
      CLOSE (10)
      CALL Flash (20, 2, 'Read error during parameter load.')
 15   format(a)
      RETURN
      END
      
C----------------------------------------------------------------------
C     Save Parameters - Writes parameter file for program XVALID
C     
      SUBROUTINE Save Parameters (File Name, Error, krigvar) 
      IMPLICIT INTEGER*4 (A-Z)
      
      INCLUDE 'xvalid.dec'
      
      LOGICAL           Error
      INTEGER*4           IntVal, Struc, krigvar
      CHARACTER         File Name*(*), Signature*13
      DATA                   LUN /10/
      DATA                   Signature /'    KRIGE    '/
      
      Error = .FALSE.
      
 15   format(a)
C     Open File
      OPEN (unit = lun, FILE = file prefix(1:lenstr(file prefix))
     +     //File Name, STATUS = 'unknown', ERR = 100)
      
      WRITE  (LUN,15, ERR = 100) Signature
      Error = .FALSE.
      
C     File Names Record
      WRITE (LUN,15, ERR = 100) Data File
      WRITE (LUN,15, ERR = 100) Output File
      WRITE (LUN,15, ERR = 100) 
      
C     Title Record
      WRITE (LUN,15, ERR = 100) Title
      
C     Grid Parameters Records
      WRITE (LUN,*, ERR = 100)
     +     Xvar, Xorigin, XcellSize, Nxcells,
     +     Yvar, Yorigin, YcellSize, Nycells 
      
C     Search Parameters Records
      IntVal = 1
      IF (Euclidean) IntVal = 0
      WRITE (LUN,*, ERR = 100) SrMajor, SrMinor, SrAngle,
     +     IntVal, Nsector, Minp, Maxps, Maxempty
      
C     Kriging Type Record
      WRITE (LUN,*, ERR = 100) Ktype, Ndiscr-1 
      
C     Number of Variables Record, Variables and Variogram Structure Records
      WRITE (LUN,*, ERR = 100) NkVar
      WRITE (LUN,*, ERR = 100) 
     +     KrigVar, Nugget,
     +     Mglobal, intval
      DO 20 Struc = 1, maxstruc
         WRITE (LUN,*, ERR = 100) 
     +        Mtype   (Struc),
     +        Sill    (Struc),
     +        VrMajor (Struc),
     +        VrMinor (Struc),
     +        VrAngle (Struc)
 20   CONTINUE          
      CLOSE (10)
      RETURN
      
C     Error Encountered Writing Parameter File
 100  Error = .TRUE.
      CALL Flash (20, 2, 'WRITE error during parameter save')
      CLOSE (10)
      RETURN
      END

