
C Plotdata.for
C----------------------------------------------------------------------
C Plot Data - display data for program XVALID
C
        SUBROUTINE Plot Data (StartPoint, TypeFlag)
	IMPLICIT INTEGER*4 (A-Z)

	PARAMETER (OTHER = 0, HERC = 1, CGA = 2, EGA = 3)
	PARAMETER (DRAW  = 0)

		include 'xvalid.dec'

	REAL*4      X, Y, Z, Dx, Dy, Mx, My, Tmin, Tmax
	REAL*4	    Tx, Ty, Fx, Fy, Factor, Ratio
	REAL*4	    TopMargin, BottomMargin, YoffSet
	INTEGER*4   I, J, N, Type Flag, LENSTR, L
	INTEGER*4   DevMinX, DevMinY, DevMaxX, DevMaxY
	INTEGER*4   StartPoint, Tptr
	CHARACTER   Str*12, Rfmt*7, message*70, menu choice*10
	CHARACTER   Plot Title*70, Xlabel*40, Ylabel*40, Vlabel*15

	DATA Rfmt /'(F12.3)'/

C ***	Set up scaling
 1      message = 'Computing Error map...type "q" to quit. '
  	IF (TypeFlag .ne. 0) then
           CALL PutStr (message,lenstr(message), 20, 2, 2)
           CALL New Screen (6)
           call put menu ('POSTSCR')
           call set character value('PSFILEN','error.ps')
        end if

        Dx 	= ABS (Xmax-Xmin)
	Dy 	= ABS (Ymax-Ymin)

        tmax = 1

	Minx 	= Xmin - dx * .265
	MaxX	= Xmin + dx * 1.55
	MinY 	= Ymin - dy * .265
	Maxy 	= Ymin + dy * 1.3
	Mx 	= dx * .008
	My 	= dy * .008
	Fx 	= dx * .065 
	Fy 	= dy * .065  

	DevMaxX = 1

C Set up labels
	IF (Log) THEN
	  L = LENSTR (Varnam (Var))
	  Vlabel = 'LN ('//Varnam (Var) (1:L) //')'
	ELSE
	  Vlabel = VarNam (Var)
	ENDIF
	L = LENSTR (Vlabel)
  	IF (TypeFlag .EQ. 0) THEN			     
             Plot Title  = 'XVALID (Cross validation)'
	ELSE 
	   IF (EN .EQ. 0) RETURN
           Plot Title  = 'Plot of Error: (z* - '//
     +		Vlabel (1:L) //')'
	ENDIF
        Xlabel = Varnam (XVar)
        Ylabel = Varnam (YVar)

C graphics setup
	CALL Zsetup (INT2 (Gmode), Ierr)
        call zclear()
	CALL Zcolor (INT2 (White))
	CALL Zlbdir (0.0)
	CALL Zlocat (INT2 (DevMinX), INT2 (DevMaxX),
     +		     INT2 (DevMinY), INT2 (DevMaxY))
	IF (TypeFlag .EQ. 1) CALL Grframe (Xmaxdev, Ymaxdev, Blue) 
cclong I multiplied maxx by 2 in order to scale the data window so that the
cc labels are correctly placed.
cc	CALL Zscale (Minx, 2*Maxx, Miny, Maxy)
	CALL Zscale (Minx, Maxx, Miny, Maxy)
cclong 11/17/93
	CALL Zcolor (INT2 (White))

C Draw and label the axes
ccc	CALL Axes (' ', Xlabel, Ylabel, ' ',
	CALL Axes (Plot Title, Xlabel, Ylabel, ' ',
     +		   Xmin, Xmax, Ymin, Ymax, Xtinc, Ytinc, DevCode)

C Title

cclong altered the coordinates below so as to center the title
	L = lenstr(plot title)
	CALL Zmove ((Xmin+Xmax)/2.0 - 1.5*L*Abs(xmax-xmin)*.01,
     +                    Ymax + Yoffset)
ccc	CALL Zlabel (Plot Title)

C if some estimates have been computed, plot computed value, else
C plot original value (see sister code in Kriger.for - CALL Plot Value)
C
        DO 30 I = 1, NData
	   IF (TypeFlag .EQ. 0) THEN
	      X = Xdata (I)
	      Y = Ydata (I)
	      IF (I .LE. StartPoint) THEN
	        IF (Estimate (I) .LT. Missing)
     +	           CALL Plot Value (X, Y, Mx, My, Estimate (I), DRAW)   
	      ELSE
	        IF (Data (I) .LT. Missing)
     +	            CALL Plot Value (X, Y, Mx, My, Data (I), DRAW)   
	      ENDIF
	   ELSE
	      Tptr = Zptr (I)
	      IF (Estimate (Tptr) .LT. Missing .AND.
     +		  Zscore   (Tptr) .LT. Missing) 
     +	      	  CALL Plot Error 
     +			(Xdata (Tptr), Ydata (Tptr), Fx, Fy, I)   
	   ENDIF
 30     CONTINUE						     
	CALL Zcolor (INT2 (White))

C If type is 0 call legend subroutine
	IF (TypeFlag .EQ. 0) THEN
           CALL Legend (xmax, ymax, Mx, My)
	ELSE
C Plot the stats
	   CALL PlotStat (DevCode, Xmin, Xmax, Ymin, Ymax,
     +			  Ndata, DNmiss, DN, Dmean, Dstd,
     +			  Dmin, DQ1, Dmedian, DQ3, Dmax)
	ENDIF
 
cclong 11/30/93
  	IF (TypeFlag .ne. 0) then
           CALL Erase(20,2,76)
           call get character value('PSFILEN',message)
           CALL Erase(5,10,60)
           call putstr(message(1:60),60,5,10,2)
           CALL Get Menu Choice ('POSTSCR',Menu choice)
           if (menu choice .eq. 'File') then
              CALL Get Field
              call get character value('PSFILEN',message)
              IF (lenstr(message) .EQ. 0) THEN
                 Message =
     &                'Blank file name given - no can do !'
                 CALL Erase (20, 2, 76)
                 CALL Flash (20, 2,message)
                 goto 1
              ENDIF
           else if (menu choice .eq. 'Quit') then
              goto 666
           end if
           i = lenstr(message)
           call putstr(message(1:60),60,5,10,2)
           j = lenstr(fileprefix)
           call turn_ps_on(fileprefix(1:j)//message(1:i))
           goto 1
 666       call reset()
        end if
cclong11/30/93
      
      RETURN
      END

C----------------------------------------------------------------------
C Put Out Legend for Quartile map
C								     
	SUBROUTINE Legend (X, Y, Mx, My)
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'

        REAL*4          X, Y, Mx, My, Tx, Tx2, Ty, Inc
	CHARACTER	Str*12, Rfmt*7
	character	scratch*14

	DATA Rfmt /'(F12.3)'/

	Inc 	= 5*Mx
	Tx 	= X + Inc
	Tx2 	= Tx + Inc

	Inc 	= My * 8.0
	Ty	= Y - 5*Inc
 
	CALL Zcolor (INT2 (White))

	CALL ZMove (Tx2 + Mx*4.0, Ty)
	CALL Zlabel (VarNam (Var))


	Ty = Ty - Inc
	CALL Plus  (Tx, Ty, Mx*2.0, My*1.5, Blue, White)
	WRITE (Str, Rfmt) Q1
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
	scratch = ' < '//Str (1:N) 
	CALL Zlabel (scratch)

	Ty = Ty - Inc
	CALL Cross (Tx, Ty, Mx*2.0, My*1.5, Green, White)
	WRITE (Str,  Rfmt) Q2
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
	scratch = ' < '//Str (1:N)
	call zlabel (scratch)

	Ty = Ty - Inc
	CALL Box   (Tx, Ty, Mx*2.0, My*1.5, Yellow, White)
	WRITE (Str, Rfmt) Q3
	CALL Left Justify (Str)
	N = LENSTR (Str)
	CALL Zmove  (Tx2, Ty)
	scratch = ' < '//Str (1:N) 
	call zlabel (scratch)

	Ty = Ty - Inc
	CALL Cross (Tx, Ty, Mx*2.0, My*1.5, Red, White)
	CALL Plus  (Tx, Ty, Mx*2.0, My*1.5, Red, White)
	CALL Zmove  (Tx2, Ty)
	scratch = ' >='//Str (1:N) 
	call zlabel (scratch)

	Ty = Ty - Inc
	CALL Circle (Tx, Ty, Mx*2.0, White, White)
	CALL Zmove  (Tx2, Ty)
	scratch = ' - Missing'
	call zlabel (scratch)
	END

C----------------------------------------------------------------------

	SUBROUTINE Plot Value (X, Y, Mx, My, Z, Erase)
	REAL*4		X, Y, Z, Mx, My
	INTEGER*4	Erase, Black

		include 'xvalid.dec'

	DATA Black /0/
	
	IF (Erase .EQ. 1) THEN
	   IF (Z .LT. Q1) THEN
	      CALL Plus  (X, Y, Mx, My, Black, White)
	   ELSEIF (Z .GE. Q1 .AND. Z .LT. Q2) THEN   
	      CALL Cross (X, Y, Mx, My, Black, White)
	   ELSEIF (Z .GE. Q2 .AND. Z .LT. Q3) THEN   
	      CALL Box   (X, Y, Mx, My, Black, White)
	   ELSEIF (Z .GE. Q3) THEN
	      CALL Plus  (X, Y, Mx, My, Black, White)
	      CALL Cross (X, Y, Mx, My, Black, White)
	   ENDIF
	ELSE
	   IF (Z .LT. Q1) THEN
	      CALL Plus  (X, Y, Mx, My, Blue, White)
	   ELSEIF (Z .GE. Q1 .AND. Z .LT. Q2) THEN   
	      CALL Cross (X, Y, Mx, My, Green, White)
	   ELSEIF (Z .GE. Q2 .AND. Z .LT. Q3) THEN   
	      CALL Box   (X, Y, Mx, My, Yellow, White)
	   ELSEIF (Z .GE. Q3) THEN
	      CALL Plus  (X, Y, Mx, My, Red, White)
	      CALL Cross (X, Y, Mx, My, Red, White)
	   ENDIF
	ENDIF
	RETURN
	END

C----------------------------------------------------------------------
	SUBROUTINE Plot Error (X, Y, Dx, Dy, I)
	IMPLICIT INTEGER*4 (A-Z)

		include 'xvalid.dec'
	REAL*4		X, Y,  D, Dx, Dy, Mx, My, Range, Scale
	INTEGER*4	I

	Range 	= AMAX1 (Dmax, ABS (Dmin))
	IF (Range .GT. 0.) Scale = ABS (Difference (I)) / Range
	IF (Difference (I) .NE. 0.0) THEN
	   Mx 	= Dx * Scale
	   My 	= Dy * Scale
	ELSE
	   Mx   = .1 * Dx
	   My   = .1 * Dy
	ENDIF
	IF 	(ABS (Difference (I)) .LT. Range/1000.0) THEN
	  CALL Minus   (X, Y-My/2., Mx, Green, White)
	  CALL Minus   (X, Y+My/2., Mx, Green, White)
	ELSEIF 	(Difference (I) .GT. 0) THEN
	  CALL Plus    (X, Y, Mx, My, Red, White)
	ELSEIF 	(Difference (I) .LT. 0) THEN
	  CALL Cross   (X, Y, Mx, My, Blue, White)
	ENDIF

	RETURN
	END

C----------------------------------------------------------------------

	SUBROUTINE Circle (X, Y, R, Color1, Color2)
	REAL*4		X, Y, R, DTR, Tx, Ty, Tangle
	INTEGER*4	Color1, Color2, Angle


        DATA Dtr 	/0.0174533/

	CALL Zcolor (INT2 (Color1))
	CALL Zmove  (X+R, Y)
	DO 10 Angle = 0,360,45
	  Tangle = FLOAT (Angle) * Dtr
	  Tx = R * COS (Tangle) + X
	  Ty = R * SIN (Tangle) + Y
	  CALL Zplot (Tx, Ty) 
 10	CONTINUE
	CALL Zcolor (INT2 (Color2))
	RETURN
	END 


